/**
 */
package it.unibo.cmdb.archimate.model.transformationUtil;

import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EOperation;
import org.eclipse.emf.ecore.EPackage;

/**
 * <!-- begin-user-doc -->
 * The <b>Package</b> for the model.
 * It contains accessors for the meta objects to represent
 * <ul>
 *   <li>each class,</li>
 *   <li>each feature of each class,</li>
 *   <li>each operation of each class,</li>
 *   <li>each enum,</li>
 *   <li>and each data type</li>
 * </ul>
 * <!-- end-user-doc -->
 * @see it.unibo.cmdb.archimate.model.transformationUtil.TransformationUtilFactory
 * @model kind="package"
 * @generated
 */
public interface TransformationUtilPackage extends EPackage {
	/**
	 * The package name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNAME = "transformationUtil";

	/**
	 * The package namespace URI.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_URI = "http://www.unibo.it/cmdb/archimate/transformation";

	/**
	 * The package namespace name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_PREFIX = "util";

	/**
	 * The singleton instance of the package.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	TransformationUtilPackage eINSTANCE = it.unibo.cmdb.archimate.model.transformationUtil.impl.TransformationUtilPackageImpl.init();

	/**
	 * The meta object id for the '{@link it.unibo.cmdb.archimate.model.transformationUtil.impl.TransformationUtilImpl <em>Transformation Util</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see it.unibo.cmdb.archimate.model.transformationUtil.impl.TransformationUtilImpl
	 * @see it.unibo.cmdb.archimate.model.transformationUtil.impl.TransformationUtilPackageImpl#getTransformationUtil()
	 * @generated
	 */
	int TRANSFORMATION_UTIL = 0;

	/**
	 * The feature id for the '<em><b>Cmdbf Client</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRANSFORMATION_UTIL__CMDBF_CLIENT = 0;

	/**
	 * The feature id for the '<em><b>Diagram Serializer</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRANSFORMATION_UTIL__DIAGRAM_SERIALIZER = 1;

	/**
	 * The number of structural features of the '<em>Transformation Util</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRANSFORMATION_UTIL_FEATURE_COUNT = 2;

	/**
	 * The operation id for the '<em>Serialize</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRANSFORMATION_UTIL___SERIALIZE__IDIAGRAMMODEL_RECORDTYPE_STRING = 0;

	/**
	 * The operation id for the '<em>Deserialize</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRANSFORMATION_UTIL___DESERIALIZE__IDIAGRAMMODEL_RECORDTYPE_STRING = 1;

	/**
	 * The operation id for the '<em>Create Image</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRANSFORMATION_UTIL___CREATE_IMAGE__IDIAGRAMMODEL = 2;

	/**
	 * The operation id for the '<em>Normalize Filename</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRANSFORMATION_UTIL___NORMALIZE_FILENAME__STRING = 3;

	/**
	 * The operation id for the '<em>Is Deleted</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRANSFORMATION_UTIL___IS_DELETED__IARCHIMATEMODELELEMENT = 4;

	/**
	 * The operation id for the '<em>Is Derived</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRANSFORMATION_UTIL___IS_DERIVED__IRELATIONSHIP = 5;

	/**
	 * The operation id for the '<em>Instance Of</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRANSFORMATION_UTIL___INSTANCE_OF__STRING_STRING_STRING_STRING = 6;

	/**
	 * The operation id for the '<em>Set Folder</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRANSFORMATION_UTIL___SET_FOLDER__IARCHIMATEMODEL_EOBJECT_STRING = 7;

	/**
	 * The operation id for the '<em>Get Folder</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRANSFORMATION_UTIL___GET_FOLDER__EOBJECT = 8;

	/**
	 * The operation id for the '<em>Get Folder From Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRANSFORMATION_UTIL___GET_FOLDER_FROM_TYPE__MODELRECORDTYPE_INT = 9;

	/**
	 * The operation id for the '<em>Get Property</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRANSFORMATION_UTIL___GET_PROPERTY__IPROPERTIES_STRING = 10;

	/**
	 * The operation id for the '<em>Set Property</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRANSFORMATION_UTIL___SET_PROPERTY__IPROPERTIES_STRING_STRING = 11;

	/**
	 * The number of operations of the '<em>Transformation Util</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int TRANSFORMATION_UTIL_OPERATION_COUNT = 12;


	/**
	 * Returns the meta object for class '{@link it.unibo.cmdb.archimate.model.transformationUtil.TransformationUtil <em>Transformation Util</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Transformation Util</em>'.
	 * @see it.unibo.cmdb.archimate.model.transformationUtil.TransformationUtil
	 * @generated
	 */
	EClass getTransformationUtil();

	/**
	 * Returns the meta object for the attribute '{@link it.unibo.cmdb.archimate.model.transformationUtil.TransformationUtil#getCmdbfClient <em>Cmdbf Client</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Cmdbf Client</em>'.
	 * @see it.unibo.cmdb.archimate.model.transformationUtil.TransformationUtil#getCmdbfClient()
	 * @see #getTransformationUtil()
	 * @generated
	 */
	EAttribute getTransformationUtil_CmdbfClient();

	/**
	 * Returns the meta object for the attribute '{@link it.unibo.cmdb.archimate.model.transformationUtil.TransformationUtil#getDiagramSerializer <em>Diagram Serializer</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Diagram Serializer</em>'.
	 * @see it.unibo.cmdb.archimate.model.transformationUtil.TransformationUtil#getDiagramSerializer()
	 * @see #getTransformationUtil()
	 * @generated
	 */
	EAttribute getTransformationUtil_DiagramSerializer();

	/**
	 * Returns the meta object for the '{@link it.unibo.cmdb.archimate.model.transformationUtil.TransformationUtil#serialize(com.archimatetool.model.IDiagramModel, it.unibo.cmdb.cmdbf.client.model.cmdbf.RecordType, java.lang.String) <em>Serialize</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Serialize</em>' operation.
	 * @see it.unibo.cmdb.archimate.model.transformationUtil.TransformationUtil#serialize(com.archimatetool.model.IDiagramModel, it.unibo.cmdb.cmdbf.client.model.cmdbf.RecordType, java.lang.String)
	 * @generated
	 */
	EOperation getTransformationUtil__Serialize__IDiagramModel_RecordType_String();

	/**
	 * Returns the meta object for the '{@link it.unibo.cmdb.archimate.model.transformationUtil.TransformationUtil#deserialize(com.archimatetool.model.IDiagramModel, it.unibo.cmdb.cmdbf.client.model.cmdbf.RecordType, java.lang.String) <em>Deserialize</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Deserialize</em>' operation.
	 * @see it.unibo.cmdb.archimate.model.transformationUtil.TransformationUtil#deserialize(com.archimatetool.model.IDiagramModel, it.unibo.cmdb.cmdbf.client.model.cmdbf.RecordType, java.lang.String)
	 * @generated
	 */
	EOperation getTransformationUtil__Deserialize__IDiagramModel_RecordType_String();

	/**
	 * Returns the meta object for the '{@link it.unibo.cmdb.archimate.model.transformationUtil.TransformationUtil#createImage(com.archimatetool.model.IDiagramModel) <em>Create Image</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Create Image</em>' operation.
	 * @see it.unibo.cmdb.archimate.model.transformationUtil.TransformationUtil#createImage(com.archimatetool.model.IDiagramModel)
	 * @generated
	 */
	EOperation getTransformationUtil__CreateImage__IDiagramModel();

	/**
	 * Returns the meta object for the '{@link it.unibo.cmdb.archimate.model.transformationUtil.TransformationUtil#normalizeFilename(java.lang.String) <em>Normalize Filename</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Normalize Filename</em>' operation.
	 * @see it.unibo.cmdb.archimate.model.transformationUtil.TransformationUtil#normalizeFilename(java.lang.String)
	 * @generated
	 */
	EOperation getTransformationUtil__NormalizeFilename__String();

	/**
	 * Returns the meta object for the '{@link it.unibo.cmdb.archimate.model.transformationUtil.TransformationUtil#isDeleted(com.archimatetool.model.IArchimateModelElement) <em>Is Deleted</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Is Deleted</em>' operation.
	 * @see it.unibo.cmdb.archimate.model.transformationUtil.TransformationUtil#isDeleted(com.archimatetool.model.IArchimateModelElement)
	 * @generated
	 */
	EOperation getTransformationUtil__IsDeleted__IArchimateModelElement();

	/**
	 * Returns the meta object for the '{@link it.unibo.cmdb.archimate.model.transformationUtil.TransformationUtil#isDerived(com.archimatetool.model.IRelationship) <em>Is Derived</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Is Derived</em>' operation.
	 * @see it.unibo.cmdb.archimate.model.transformationUtil.TransformationUtil#isDerived(com.archimatetool.model.IRelationship)
	 * @generated
	 */
	EOperation getTransformationUtil__IsDerived__IRelationship();

	/**
	 * Returns the meta object for the '{@link it.unibo.cmdb.archimate.model.transformationUtil.TransformationUtil#instanceOf(java.lang.String, java.lang.String, java.lang.String, java.lang.String) <em>Instance Of</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Instance Of</em>' operation.
	 * @see it.unibo.cmdb.archimate.model.transformationUtil.TransformationUtil#instanceOf(java.lang.String, java.lang.String, java.lang.String, java.lang.String)
	 * @generated
	 */
	EOperation getTransformationUtil__InstanceOf__String_String_String_String();

	/**
	 * Returns the meta object for the '{@link it.unibo.cmdb.archimate.model.transformationUtil.TransformationUtil#setFolder(com.archimatetool.model.IArchimateModel, org.eclipse.emf.ecore.EObject, java.lang.String) <em>Set Folder</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Set Folder</em>' operation.
	 * @see it.unibo.cmdb.archimate.model.transformationUtil.TransformationUtil#setFolder(com.archimatetool.model.IArchimateModel, org.eclipse.emf.ecore.EObject, java.lang.String)
	 * @generated
	 */
	EOperation getTransformationUtil__SetFolder__IArchimateModel_EObject_String();

	/**
	 * Returns the meta object for the '{@link it.unibo.cmdb.archimate.model.transformationUtil.TransformationUtil#getFolder(org.eclipse.emf.ecore.EObject) <em>Get Folder</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Get Folder</em>' operation.
	 * @see it.unibo.cmdb.archimate.model.transformationUtil.TransformationUtil#getFolder(org.eclipse.emf.ecore.EObject)
	 * @generated
	 */
	EOperation getTransformationUtil__GetFolder__EObject();

	/**
	 * Returns the meta object for the '{@link it.unibo.cmdb.archimate.model.transformationUtil.TransformationUtil#getFolderFromType(it.unibo.cmdb.cmdbf.client.model.cmdbf.ModelRecordType, int) <em>Get Folder From Type</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Get Folder From Type</em>' operation.
	 * @see it.unibo.cmdb.archimate.model.transformationUtil.TransformationUtil#getFolderFromType(it.unibo.cmdb.cmdbf.client.model.cmdbf.ModelRecordType, int)
	 * @generated
	 */
	EOperation getTransformationUtil__GetFolderFromType__ModelRecordType_int();

	/**
	 * Returns the meta object for the '{@link it.unibo.cmdb.archimate.model.transformationUtil.TransformationUtil#getProperty(com.archimatetool.model.IProperties, java.lang.String) <em>Get Property</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Get Property</em>' operation.
	 * @see it.unibo.cmdb.archimate.model.transformationUtil.TransformationUtil#getProperty(com.archimatetool.model.IProperties, java.lang.String)
	 * @generated
	 */
	EOperation getTransformationUtil__GetProperty__IProperties_String();

	/**
	 * Returns the meta object for the '{@link it.unibo.cmdb.archimate.model.transformationUtil.TransformationUtil#setProperty(com.archimatetool.model.IProperties, java.lang.String, java.lang.String) <em>Set Property</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Set Property</em>' operation.
	 * @see it.unibo.cmdb.archimate.model.transformationUtil.TransformationUtil#setProperty(com.archimatetool.model.IProperties, java.lang.String, java.lang.String)
	 * @generated
	 */
	EOperation getTransformationUtil__SetProperty__IProperties_String_String();

	/**
	 * Returns the factory that creates the instances of the model.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the factory that creates the instances of the model.
	 * @generated
	 */
	TransformationUtilFactory getTransformationUtilFactory();

	/**
	 * <!-- begin-user-doc -->
	 * Defines literals for the meta objects that represent
	 * <ul>
	 *   <li>each class,</li>
	 *   <li>each feature of each class,</li>
	 *   <li>each operation of each class,</li>
	 *   <li>each enum,</li>
	 *   <li>and each data type</li>
	 * </ul>
	 * <!-- end-user-doc -->
	 * @generated
	 */
	interface Literals {
		/**
		 * The meta object literal for the '{@link it.unibo.cmdb.archimate.model.transformationUtil.impl.TransformationUtilImpl <em>Transformation Util</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see it.unibo.cmdb.archimate.model.transformationUtil.impl.TransformationUtilImpl
		 * @see it.unibo.cmdb.archimate.model.transformationUtil.impl.TransformationUtilPackageImpl#getTransformationUtil()
		 * @generated
		 */
		EClass TRANSFORMATION_UTIL = eINSTANCE.getTransformationUtil();

		/**
		 * The meta object literal for the '<em><b>Cmdbf Client</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute TRANSFORMATION_UTIL__CMDBF_CLIENT = eINSTANCE.getTransformationUtil_CmdbfClient();

		/**
		 * The meta object literal for the '<em><b>Diagram Serializer</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute TRANSFORMATION_UTIL__DIAGRAM_SERIALIZER = eINSTANCE.getTransformationUtil_DiagramSerializer();

		/**
		 * The meta object literal for the '<em><b>Serialize</b></em>' operation.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EOperation TRANSFORMATION_UTIL___SERIALIZE__IDIAGRAMMODEL_RECORDTYPE_STRING = eINSTANCE.getTransformationUtil__Serialize__IDiagramModel_RecordType_String();

		/**
		 * The meta object literal for the '<em><b>Deserialize</b></em>' operation.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EOperation TRANSFORMATION_UTIL___DESERIALIZE__IDIAGRAMMODEL_RECORDTYPE_STRING = eINSTANCE.getTransformationUtil__Deserialize__IDiagramModel_RecordType_String();

		/**
		 * The meta object literal for the '<em><b>Create Image</b></em>' operation.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EOperation TRANSFORMATION_UTIL___CREATE_IMAGE__IDIAGRAMMODEL = eINSTANCE.getTransformationUtil__CreateImage__IDiagramModel();

		/**
		 * The meta object literal for the '<em><b>Normalize Filename</b></em>' operation.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EOperation TRANSFORMATION_UTIL___NORMALIZE_FILENAME__STRING = eINSTANCE.getTransformationUtil__NormalizeFilename__String();

		/**
		 * The meta object literal for the '<em><b>Is Deleted</b></em>' operation.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EOperation TRANSFORMATION_UTIL___IS_DELETED__IARCHIMATEMODELELEMENT = eINSTANCE.getTransformationUtil__IsDeleted__IArchimateModelElement();

		/**
		 * The meta object literal for the '<em><b>Is Derived</b></em>' operation.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EOperation TRANSFORMATION_UTIL___IS_DERIVED__IRELATIONSHIP = eINSTANCE.getTransformationUtil__IsDerived__IRelationship();

		/**
		 * The meta object literal for the '<em><b>Instance Of</b></em>' operation.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EOperation TRANSFORMATION_UTIL___INSTANCE_OF__STRING_STRING_STRING_STRING = eINSTANCE.getTransformationUtil__InstanceOf__String_String_String_String();

		/**
		 * The meta object literal for the '<em><b>Set Folder</b></em>' operation.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EOperation TRANSFORMATION_UTIL___SET_FOLDER__IARCHIMATEMODEL_EOBJECT_STRING = eINSTANCE.getTransformationUtil__SetFolder__IArchimateModel_EObject_String();

		/**
		 * The meta object literal for the '<em><b>Get Folder</b></em>' operation.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EOperation TRANSFORMATION_UTIL___GET_FOLDER__EOBJECT = eINSTANCE.getTransformationUtil__GetFolder__EObject();

		/**
		 * The meta object literal for the '<em><b>Get Folder From Type</b></em>' operation.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EOperation TRANSFORMATION_UTIL___GET_FOLDER_FROM_TYPE__MODELRECORDTYPE_INT = eINSTANCE.getTransformationUtil__GetFolderFromType__ModelRecordType_int();

		/**
		 * The meta object literal for the '<em><b>Get Property</b></em>' operation.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EOperation TRANSFORMATION_UTIL___GET_PROPERTY__IPROPERTIES_STRING = eINSTANCE.getTransformationUtil__GetProperty__IProperties_String();

		/**
		 * The meta object literal for the '<em><b>Set Property</b></em>' operation.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EOperation TRANSFORMATION_UTIL___SET_PROPERTY__IPROPERTIES_STRING_STRING = eINSTANCE.getTransformationUtil__SetProperty__IProperties_String_String();

	}

} //TransformationUtilPackage
