/**
 */
package it.unibo.cmdb.cmdbf.client.model.cmdbf.impl;

import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.common.util.EMap;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.emf.ecore.EcorePackage;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.impl.EStringToStringMapEntryImpl;
import org.eclipse.emf.ecore.impl.MinimalEObjectImpl;
import org.eclipse.emf.ecore.util.BasicFeatureMap;
import org.eclipse.emf.ecore.util.EcoreEMap;
import org.eclipse.emf.ecore.util.FeatureMap;
import org.eclipse.emf.ecore.util.InternalEList;

import it.unibo.cmdb.cmdbf.client.model.cmdbf.CmdbfPackage;
import it.unibo.cmdb.cmdbf.client.model.cmdbf.DeregisterRequestType;
import it.unibo.cmdb.cmdbf.client.model.cmdbf.DeregisterResponseType;
import it.unibo.cmdb.cmdbf.client.model.cmdbf.DeregistrationErrorFaultType;
import it.unibo.cmdb.cmdbf.client.model.cmdbf.DocumentRoot;
import it.unibo.cmdb.cmdbf.client.model.cmdbf.ExpensiveQueryErrorFaultType;
import it.unibo.cmdb.cmdbf.client.model.cmdbf.InvalidMDRFaultType;
import it.unibo.cmdb.cmdbf.client.model.cmdbf.InvalidPropertyTypeFaultType;
import it.unibo.cmdb.cmdbf.client.model.cmdbf.InvalidRecordFaultType;
import it.unibo.cmdb.cmdbf.client.model.cmdbf.ItemType;
import it.unibo.cmdb.cmdbf.client.model.cmdbf.MdrScopedIdType;
import it.unibo.cmdb.cmdbf.client.model.cmdbf.Model;
import it.unibo.cmdb.cmdbf.client.model.cmdbf.PropertySetType;
import it.unibo.cmdb.cmdbf.client.model.cmdbf.QueryErrorFaultType;
import it.unibo.cmdb.cmdbf.client.model.cmdbf.QueryResultType;
import it.unibo.cmdb.cmdbf.client.model.cmdbf.QueryType;
import it.unibo.cmdb.cmdbf.client.model.cmdbf.RecordType;
import it.unibo.cmdb.cmdbf.client.model.cmdbf.RegisterRequestType;
import it.unibo.cmdb.cmdbf.client.model.cmdbf.RegisterResponseType;
import it.unibo.cmdb.cmdbf.client.model.cmdbf.RegistrationErrorFaultType;
import it.unibo.cmdb.cmdbf.client.model.cmdbf.RelationshipType;
import it.unibo.cmdb.cmdbf.client.model.cmdbf.UnknownTemplateIDFaultType;
import it.unibo.cmdb.cmdbf.client.model.cmdbf.UnsupportedConstraintFaultType;
import it.unibo.cmdb.cmdbf.client.model.cmdbf.UnsupportedRecordTypeFaultType;
import it.unibo.cmdb.cmdbf.client.model.cmdbf.UnsupportedSelectorFaultType;
import it.unibo.cmdb.cmdbf.client.model.cmdbf.XPathErrorFaultType;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Document Root</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 *   <li>{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.DocumentRootImpl#getMixed <em>Mixed</em>}</li>
 *   <li>{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.DocumentRootImpl#getXMLNSPrefixMap <em>XMLNS Prefix Map</em>}</li>
 *   <li>{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.DocumentRootImpl#getXSISchemaLocation <em>XSI Schema Location</em>}</li>
 *   <li>{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.DocumentRootImpl#getDeregisterRequest <em>Deregister Request</em>}</li>
 *   <li>{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.DocumentRootImpl#getDeregisterResponse <em>Deregister Response</em>}</li>
 *   <li>{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.DocumentRootImpl#getDeregistrationErrorFault <em>Deregistration Error Fault</em>}</li>
 *   <li>{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.DocumentRootImpl#getExpensiveQueryErrorFault <em>Expensive Query Error Fault</em>}</li>
 *   <li>{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.DocumentRootImpl#getInstanceId <em>Instance Id</em>}</li>
 *   <li>{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.DocumentRootImpl#getInvalidMDRFault <em>Invalid MDR Fault</em>}</li>
 *   <li>{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.DocumentRootImpl#getInvalidPropertyTypeFault <em>Invalid Property Type Fault</em>}</li>
 *   <li>{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.DocumentRootImpl#getInvalidRecordFault <em>Invalid Record Fault</em>}</li>
 *   <li>{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.DocumentRootImpl#getItem <em>Item</em>}</li>
 *   <li>{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.DocumentRootImpl#getPropertySet <em>Property Set</em>}</li>
 *   <li>{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.DocumentRootImpl#getQuery <em>Query</em>}</li>
 *   <li>{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.DocumentRootImpl#getQueryErrorFault <em>Query Error Fault</em>}</li>
 *   <li>{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.DocumentRootImpl#getQueryResult <em>Query Result</em>}</li>
 *   <li>{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.DocumentRootImpl#getRecord <em>Record</em>}</li>
 *   <li>{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.DocumentRootImpl#getRegisterRequest <em>Register Request</em>}</li>
 *   <li>{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.DocumentRootImpl#getRegisterResponse <em>Register Response</em>}</li>
 *   <li>{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.DocumentRootImpl#getRegistrationErrorFault <em>Registration Error Fault</em>}</li>
 *   <li>{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.DocumentRootImpl#getRelationship <em>Relationship</em>}</li>
 *   <li>{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.DocumentRootImpl#getUnknownTemplateIDFault <em>Unknown Template ID Fault</em>}</li>
 *   <li>{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.DocumentRootImpl#getUnsupportedConstraintFault <em>Unsupported Constraint Fault</em>}</li>
 *   <li>{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.DocumentRootImpl#getUnsupportedRecordTypeFault <em>Unsupported Record Type Fault</em>}</li>
 *   <li>{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.DocumentRootImpl#getUnsupportedSelectorFault <em>Unsupported Selector Fault</em>}</li>
 *   <li>{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.DocumentRootImpl#getXPathErrorFault <em>XPath Error Fault</em>}</li>
 *   <li>{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.DocumentRootImpl#getModel <em>Model</em>}</li>
 * </ul>
 *
 * @generated
 */
public class DocumentRootImpl extends MinimalEObjectImpl.Container implements DocumentRoot {
	/**
	 * The cached value of the '{@link #getMixed() <em>Mixed</em>}' attribute list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getMixed()
	 * @generated
	 * @ordered
	 */
	protected FeatureMap mixed;

	/**
	 * The cached value of the '{@link #getXMLNSPrefixMap() <em>XMLNS Prefix Map</em>}' map.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getXMLNSPrefixMap()
	 * @generated
	 * @ordered
	 */
	protected EMap<String, String> xMLNSPrefixMap;

	/**
	 * The cached value of the '{@link #getXSISchemaLocation() <em>XSI Schema Location</em>}' map.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getXSISchemaLocation()
	 * @generated
	 * @ordered
	 */
	protected EMap<String, String> xSISchemaLocation;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected DocumentRootImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return CmdbfPackage.Literals.DOCUMENT_ROOT;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public FeatureMap getMixed() {
		if (mixed == null) {
			mixed = new BasicFeatureMap(this, CmdbfPackage.DOCUMENT_ROOT__MIXED);
		}
		return mixed;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EMap<String, String> getXMLNSPrefixMap() {
		if (xMLNSPrefixMap == null) {
			xMLNSPrefixMap = new EcoreEMap<String,String>(EcorePackage.Literals.ESTRING_TO_STRING_MAP_ENTRY, EStringToStringMapEntryImpl.class, this, CmdbfPackage.DOCUMENT_ROOT__XMLNS_PREFIX_MAP);
		}
		return xMLNSPrefixMap;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EMap<String, String> getXSISchemaLocation() {
		if (xSISchemaLocation == null) {
			xSISchemaLocation = new EcoreEMap<String,String>(EcorePackage.Literals.ESTRING_TO_STRING_MAP_ENTRY, EStringToStringMapEntryImpl.class, this, CmdbfPackage.DOCUMENT_ROOT__XSI_SCHEMA_LOCATION);
		}
		return xSISchemaLocation;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public DeregisterRequestType getDeregisterRequest() {
		return (DeregisterRequestType)getMixed().get(CmdbfPackage.Literals.DOCUMENT_ROOT__DEREGISTER_REQUEST, true);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetDeregisterRequest(DeregisterRequestType newDeregisterRequest, NotificationChain msgs) {
		return ((FeatureMap.Internal)getMixed()).basicAdd(CmdbfPackage.Literals.DOCUMENT_ROOT__DEREGISTER_REQUEST, newDeregisterRequest, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setDeregisterRequest(DeregisterRequestType newDeregisterRequest) {
		((FeatureMap.Internal)getMixed()).set(CmdbfPackage.Literals.DOCUMENT_ROOT__DEREGISTER_REQUEST, newDeregisterRequest);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public DeregisterResponseType getDeregisterResponse() {
		return (DeregisterResponseType)getMixed().get(CmdbfPackage.Literals.DOCUMENT_ROOT__DEREGISTER_RESPONSE, true);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetDeregisterResponse(DeregisterResponseType newDeregisterResponse, NotificationChain msgs) {
		return ((FeatureMap.Internal)getMixed()).basicAdd(CmdbfPackage.Literals.DOCUMENT_ROOT__DEREGISTER_RESPONSE, newDeregisterResponse, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setDeregisterResponse(DeregisterResponseType newDeregisterResponse) {
		((FeatureMap.Internal)getMixed()).set(CmdbfPackage.Literals.DOCUMENT_ROOT__DEREGISTER_RESPONSE, newDeregisterResponse);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public DeregistrationErrorFaultType getDeregistrationErrorFault() {
		return (DeregistrationErrorFaultType)getMixed().get(CmdbfPackage.Literals.DOCUMENT_ROOT__DEREGISTRATION_ERROR_FAULT, true);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetDeregistrationErrorFault(DeregistrationErrorFaultType newDeregistrationErrorFault, NotificationChain msgs) {
		return ((FeatureMap.Internal)getMixed()).basicAdd(CmdbfPackage.Literals.DOCUMENT_ROOT__DEREGISTRATION_ERROR_FAULT, newDeregistrationErrorFault, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setDeregistrationErrorFault(DeregistrationErrorFaultType newDeregistrationErrorFault) {
		((FeatureMap.Internal)getMixed()).set(CmdbfPackage.Literals.DOCUMENT_ROOT__DEREGISTRATION_ERROR_FAULT, newDeregistrationErrorFault);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ExpensiveQueryErrorFaultType getExpensiveQueryErrorFault() {
		return (ExpensiveQueryErrorFaultType)getMixed().get(CmdbfPackage.Literals.DOCUMENT_ROOT__EXPENSIVE_QUERY_ERROR_FAULT, true);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetExpensiveQueryErrorFault(ExpensiveQueryErrorFaultType newExpensiveQueryErrorFault, NotificationChain msgs) {
		return ((FeatureMap.Internal)getMixed()).basicAdd(CmdbfPackage.Literals.DOCUMENT_ROOT__EXPENSIVE_QUERY_ERROR_FAULT, newExpensiveQueryErrorFault, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setExpensiveQueryErrorFault(ExpensiveQueryErrorFaultType newExpensiveQueryErrorFault) {
		((FeatureMap.Internal)getMixed()).set(CmdbfPackage.Literals.DOCUMENT_ROOT__EXPENSIVE_QUERY_ERROR_FAULT, newExpensiveQueryErrorFault);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public MdrScopedIdType getInstanceId() {
		return (MdrScopedIdType)getMixed().get(CmdbfPackage.Literals.DOCUMENT_ROOT__INSTANCE_ID, true);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetInstanceId(MdrScopedIdType newInstanceId, NotificationChain msgs) {
		return ((FeatureMap.Internal)getMixed()).basicAdd(CmdbfPackage.Literals.DOCUMENT_ROOT__INSTANCE_ID, newInstanceId, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setInstanceId(MdrScopedIdType newInstanceId) {
		((FeatureMap.Internal)getMixed()).set(CmdbfPackage.Literals.DOCUMENT_ROOT__INSTANCE_ID, newInstanceId);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public InvalidMDRFaultType getInvalidMDRFault() {
		return (InvalidMDRFaultType)getMixed().get(CmdbfPackage.Literals.DOCUMENT_ROOT__INVALID_MDR_FAULT, true);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetInvalidMDRFault(InvalidMDRFaultType newInvalidMDRFault, NotificationChain msgs) {
		return ((FeatureMap.Internal)getMixed()).basicAdd(CmdbfPackage.Literals.DOCUMENT_ROOT__INVALID_MDR_FAULT, newInvalidMDRFault, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setInvalidMDRFault(InvalidMDRFaultType newInvalidMDRFault) {
		((FeatureMap.Internal)getMixed()).set(CmdbfPackage.Literals.DOCUMENT_ROOT__INVALID_MDR_FAULT, newInvalidMDRFault);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public InvalidPropertyTypeFaultType getInvalidPropertyTypeFault() {
		return (InvalidPropertyTypeFaultType)getMixed().get(CmdbfPackage.Literals.DOCUMENT_ROOT__INVALID_PROPERTY_TYPE_FAULT, true);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetInvalidPropertyTypeFault(InvalidPropertyTypeFaultType newInvalidPropertyTypeFault, NotificationChain msgs) {
		return ((FeatureMap.Internal)getMixed()).basicAdd(CmdbfPackage.Literals.DOCUMENT_ROOT__INVALID_PROPERTY_TYPE_FAULT, newInvalidPropertyTypeFault, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setInvalidPropertyTypeFault(InvalidPropertyTypeFaultType newInvalidPropertyTypeFault) {
		((FeatureMap.Internal)getMixed()).set(CmdbfPackage.Literals.DOCUMENT_ROOT__INVALID_PROPERTY_TYPE_FAULT, newInvalidPropertyTypeFault);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public InvalidRecordFaultType getInvalidRecordFault() {
		return (InvalidRecordFaultType)getMixed().get(CmdbfPackage.Literals.DOCUMENT_ROOT__INVALID_RECORD_FAULT, true);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetInvalidRecordFault(InvalidRecordFaultType newInvalidRecordFault, NotificationChain msgs) {
		return ((FeatureMap.Internal)getMixed()).basicAdd(CmdbfPackage.Literals.DOCUMENT_ROOT__INVALID_RECORD_FAULT, newInvalidRecordFault, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setInvalidRecordFault(InvalidRecordFaultType newInvalidRecordFault) {
		((FeatureMap.Internal)getMixed()).set(CmdbfPackage.Literals.DOCUMENT_ROOT__INVALID_RECORD_FAULT, newInvalidRecordFault);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ItemType getItem() {
		return (ItemType)getMixed().get(CmdbfPackage.Literals.DOCUMENT_ROOT__ITEM, true);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setItem(ItemType newItem) {
		((FeatureMap.Internal)getMixed()).set(CmdbfPackage.Literals.DOCUMENT_ROOT__ITEM, newItem);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public PropertySetType getPropertySet() {
		return (PropertySetType)getMixed().get(CmdbfPackage.Literals.DOCUMENT_ROOT__PROPERTY_SET, true);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetPropertySet(PropertySetType newPropertySet, NotificationChain msgs) {
		return ((FeatureMap.Internal)getMixed()).basicAdd(CmdbfPackage.Literals.DOCUMENT_ROOT__PROPERTY_SET, newPropertySet, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setPropertySet(PropertySetType newPropertySet) {
		((FeatureMap.Internal)getMixed()).set(CmdbfPackage.Literals.DOCUMENT_ROOT__PROPERTY_SET, newPropertySet);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public QueryType getQuery() {
		return (QueryType)getMixed().get(CmdbfPackage.Literals.DOCUMENT_ROOT__QUERY, true);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetQuery(QueryType newQuery, NotificationChain msgs) {
		return ((FeatureMap.Internal)getMixed()).basicAdd(CmdbfPackage.Literals.DOCUMENT_ROOT__QUERY, newQuery, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setQuery(QueryType newQuery) {
		((FeatureMap.Internal)getMixed()).set(CmdbfPackage.Literals.DOCUMENT_ROOT__QUERY, newQuery);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public QueryErrorFaultType getQueryErrorFault() {
		return (QueryErrorFaultType)getMixed().get(CmdbfPackage.Literals.DOCUMENT_ROOT__QUERY_ERROR_FAULT, true);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetQueryErrorFault(QueryErrorFaultType newQueryErrorFault, NotificationChain msgs) {
		return ((FeatureMap.Internal)getMixed()).basicAdd(CmdbfPackage.Literals.DOCUMENT_ROOT__QUERY_ERROR_FAULT, newQueryErrorFault, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setQueryErrorFault(QueryErrorFaultType newQueryErrorFault) {
		((FeatureMap.Internal)getMixed()).set(CmdbfPackage.Literals.DOCUMENT_ROOT__QUERY_ERROR_FAULT, newQueryErrorFault);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public QueryResultType getQueryResult() {
		return (QueryResultType)getMixed().get(CmdbfPackage.Literals.DOCUMENT_ROOT__QUERY_RESULT, true);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetQueryResult(QueryResultType newQueryResult, NotificationChain msgs) {
		return ((FeatureMap.Internal)getMixed()).basicAdd(CmdbfPackage.Literals.DOCUMENT_ROOT__QUERY_RESULT, newQueryResult, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setQueryResult(QueryResultType newQueryResult) {
		((FeatureMap.Internal)getMixed()).set(CmdbfPackage.Literals.DOCUMENT_ROOT__QUERY_RESULT, newQueryResult);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public RecordType getRecord() {
		return (RecordType)getMixed().get(CmdbfPackage.Literals.DOCUMENT_ROOT__RECORD, true);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetRecord(RecordType newRecord, NotificationChain msgs) {
		return ((FeatureMap.Internal)getMixed()).basicAdd(CmdbfPackage.Literals.DOCUMENT_ROOT__RECORD, newRecord, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setRecord(RecordType newRecord) {
		((FeatureMap.Internal)getMixed()).set(CmdbfPackage.Literals.DOCUMENT_ROOT__RECORD, newRecord);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public RegisterRequestType getRegisterRequest() {
		return (RegisterRequestType)getMixed().get(CmdbfPackage.Literals.DOCUMENT_ROOT__REGISTER_REQUEST, true);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetRegisterRequest(RegisterRequestType newRegisterRequest, NotificationChain msgs) {
		return ((FeatureMap.Internal)getMixed()).basicAdd(CmdbfPackage.Literals.DOCUMENT_ROOT__REGISTER_REQUEST, newRegisterRequest, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setRegisterRequest(RegisterRequestType newRegisterRequest) {
		((FeatureMap.Internal)getMixed()).set(CmdbfPackage.Literals.DOCUMENT_ROOT__REGISTER_REQUEST, newRegisterRequest);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public RegisterResponseType getRegisterResponse() {
		return (RegisterResponseType)getMixed().get(CmdbfPackage.Literals.DOCUMENT_ROOT__REGISTER_RESPONSE, true);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetRegisterResponse(RegisterResponseType newRegisterResponse, NotificationChain msgs) {
		return ((FeatureMap.Internal)getMixed()).basicAdd(CmdbfPackage.Literals.DOCUMENT_ROOT__REGISTER_RESPONSE, newRegisterResponse, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setRegisterResponse(RegisterResponseType newRegisterResponse) {
		((FeatureMap.Internal)getMixed()).set(CmdbfPackage.Literals.DOCUMENT_ROOT__REGISTER_RESPONSE, newRegisterResponse);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public RegistrationErrorFaultType getRegistrationErrorFault() {
		return (RegistrationErrorFaultType)getMixed().get(CmdbfPackage.Literals.DOCUMENT_ROOT__REGISTRATION_ERROR_FAULT, true);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetRegistrationErrorFault(RegistrationErrorFaultType newRegistrationErrorFault, NotificationChain msgs) {
		return ((FeatureMap.Internal)getMixed()).basicAdd(CmdbfPackage.Literals.DOCUMENT_ROOT__REGISTRATION_ERROR_FAULT, newRegistrationErrorFault, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setRegistrationErrorFault(RegistrationErrorFaultType newRegistrationErrorFault) {
		((FeatureMap.Internal)getMixed()).set(CmdbfPackage.Literals.DOCUMENT_ROOT__REGISTRATION_ERROR_FAULT, newRegistrationErrorFault);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public RelationshipType getRelationship() {
		return (RelationshipType)getMixed().get(CmdbfPackage.Literals.DOCUMENT_ROOT__RELATIONSHIP, true);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setRelationship(RelationshipType newRelationship) {
		((FeatureMap.Internal)getMixed()).set(CmdbfPackage.Literals.DOCUMENT_ROOT__RELATIONSHIP, newRelationship);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public UnknownTemplateIDFaultType getUnknownTemplateIDFault() {
		return (UnknownTemplateIDFaultType)getMixed().get(CmdbfPackage.Literals.DOCUMENT_ROOT__UNKNOWN_TEMPLATE_ID_FAULT, true);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetUnknownTemplateIDFault(UnknownTemplateIDFaultType newUnknownTemplateIDFault, NotificationChain msgs) {
		return ((FeatureMap.Internal)getMixed()).basicAdd(CmdbfPackage.Literals.DOCUMENT_ROOT__UNKNOWN_TEMPLATE_ID_FAULT, newUnknownTemplateIDFault, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setUnknownTemplateIDFault(UnknownTemplateIDFaultType newUnknownTemplateIDFault) {
		((FeatureMap.Internal)getMixed()).set(CmdbfPackage.Literals.DOCUMENT_ROOT__UNKNOWN_TEMPLATE_ID_FAULT, newUnknownTemplateIDFault);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public UnsupportedConstraintFaultType getUnsupportedConstraintFault() {
		return (UnsupportedConstraintFaultType)getMixed().get(CmdbfPackage.Literals.DOCUMENT_ROOT__UNSUPPORTED_CONSTRAINT_FAULT, true);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetUnsupportedConstraintFault(UnsupportedConstraintFaultType newUnsupportedConstraintFault, NotificationChain msgs) {
		return ((FeatureMap.Internal)getMixed()).basicAdd(CmdbfPackage.Literals.DOCUMENT_ROOT__UNSUPPORTED_CONSTRAINT_FAULT, newUnsupportedConstraintFault, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setUnsupportedConstraintFault(UnsupportedConstraintFaultType newUnsupportedConstraintFault) {
		((FeatureMap.Internal)getMixed()).set(CmdbfPackage.Literals.DOCUMENT_ROOT__UNSUPPORTED_CONSTRAINT_FAULT, newUnsupportedConstraintFault);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public UnsupportedRecordTypeFaultType getUnsupportedRecordTypeFault() {
		return (UnsupportedRecordTypeFaultType)getMixed().get(CmdbfPackage.Literals.DOCUMENT_ROOT__UNSUPPORTED_RECORD_TYPE_FAULT, true);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetUnsupportedRecordTypeFault(UnsupportedRecordTypeFaultType newUnsupportedRecordTypeFault, NotificationChain msgs) {
		return ((FeatureMap.Internal)getMixed()).basicAdd(CmdbfPackage.Literals.DOCUMENT_ROOT__UNSUPPORTED_RECORD_TYPE_FAULT, newUnsupportedRecordTypeFault, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setUnsupportedRecordTypeFault(UnsupportedRecordTypeFaultType newUnsupportedRecordTypeFault) {
		((FeatureMap.Internal)getMixed()).set(CmdbfPackage.Literals.DOCUMENT_ROOT__UNSUPPORTED_RECORD_TYPE_FAULT, newUnsupportedRecordTypeFault);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public UnsupportedSelectorFaultType getUnsupportedSelectorFault() {
		return (UnsupportedSelectorFaultType)getMixed().get(CmdbfPackage.Literals.DOCUMENT_ROOT__UNSUPPORTED_SELECTOR_FAULT, true);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetUnsupportedSelectorFault(UnsupportedSelectorFaultType newUnsupportedSelectorFault, NotificationChain msgs) {
		return ((FeatureMap.Internal)getMixed()).basicAdd(CmdbfPackage.Literals.DOCUMENT_ROOT__UNSUPPORTED_SELECTOR_FAULT, newUnsupportedSelectorFault, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setUnsupportedSelectorFault(UnsupportedSelectorFaultType newUnsupportedSelectorFault) {
		((FeatureMap.Internal)getMixed()).set(CmdbfPackage.Literals.DOCUMENT_ROOT__UNSUPPORTED_SELECTOR_FAULT, newUnsupportedSelectorFault);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public XPathErrorFaultType getXPathErrorFault() {
		return (XPathErrorFaultType)getMixed().get(CmdbfPackage.Literals.DOCUMENT_ROOT__XPATH_ERROR_FAULT, true);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetXPathErrorFault(XPathErrorFaultType newXPathErrorFault, NotificationChain msgs) {
		return ((FeatureMap.Internal)getMixed()).basicAdd(CmdbfPackage.Literals.DOCUMENT_ROOT__XPATH_ERROR_FAULT, newXPathErrorFault, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setXPathErrorFault(XPathErrorFaultType newXPathErrorFault) {
		((FeatureMap.Internal)getMixed()).set(CmdbfPackage.Literals.DOCUMENT_ROOT__XPATH_ERROR_FAULT, newXPathErrorFault);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Model getModel() {
		return (Model)getMixed().get(CmdbfPackage.Literals.DOCUMENT_ROOT__MODEL, true);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain basicSetModel(Model newModel, NotificationChain msgs) {
		return ((FeatureMap.Internal)getMixed()).basicAdd(CmdbfPackage.Literals.DOCUMENT_ROOT__MODEL, newModel, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setModel(Model newModel) {
		((FeatureMap.Internal)getMixed()).set(CmdbfPackage.Literals.DOCUMENT_ROOT__MODEL, newModel);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case CmdbfPackage.DOCUMENT_ROOT__MIXED:
				return ((InternalEList<?>)getMixed()).basicRemove(otherEnd, msgs);
			case CmdbfPackage.DOCUMENT_ROOT__XMLNS_PREFIX_MAP:
				return ((InternalEList<?>)getXMLNSPrefixMap()).basicRemove(otherEnd, msgs);
			case CmdbfPackage.DOCUMENT_ROOT__XSI_SCHEMA_LOCATION:
				return ((InternalEList<?>)getXSISchemaLocation()).basicRemove(otherEnd, msgs);
			case CmdbfPackage.DOCUMENT_ROOT__DEREGISTER_REQUEST:
				return basicSetDeregisterRequest(null, msgs);
			case CmdbfPackage.DOCUMENT_ROOT__DEREGISTER_RESPONSE:
				return basicSetDeregisterResponse(null, msgs);
			case CmdbfPackage.DOCUMENT_ROOT__DEREGISTRATION_ERROR_FAULT:
				return basicSetDeregistrationErrorFault(null, msgs);
			case CmdbfPackage.DOCUMENT_ROOT__EXPENSIVE_QUERY_ERROR_FAULT:
				return basicSetExpensiveQueryErrorFault(null, msgs);
			case CmdbfPackage.DOCUMENT_ROOT__INSTANCE_ID:
				return basicSetInstanceId(null, msgs);
			case CmdbfPackage.DOCUMENT_ROOT__INVALID_MDR_FAULT:
				return basicSetInvalidMDRFault(null, msgs);
			case CmdbfPackage.DOCUMENT_ROOT__INVALID_PROPERTY_TYPE_FAULT:
				return basicSetInvalidPropertyTypeFault(null, msgs);
			case CmdbfPackage.DOCUMENT_ROOT__INVALID_RECORD_FAULT:
				return basicSetInvalidRecordFault(null, msgs);
			case CmdbfPackage.DOCUMENT_ROOT__PROPERTY_SET:
				return basicSetPropertySet(null, msgs);
			case CmdbfPackage.DOCUMENT_ROOT__QUERY:
				return basicSetQuery(null, msgs);
			case CmdbfPackage.DOCUMENT_ROOT__QUERY_ERROR_FAULT:
				return basicSetQueryErrorFault(null, msgs);
			case CmdbfPackage.DOCUMENT_ROOT__QUERY_RESULT:
				return basicSetQueryResult(null, msgs);
			case CmdbfPackage.DOCUMENT_ROOT__RECORD:
				return basicSetRecord(null, msgs);
			case CmdbfPackage.DOCUMENT_ROOT__REGISTER_REQUEST:
				return basicSetRegisterRequest(null, msgs);
			case CmdbfPackage.DOCUMENT_ROOT__REGISTER_RESPONSE:
				return basicSetRegisterResponse(null, msgs);
			case CmdbfPackage.DOCUMENT_ROOT__REGISTRATION_ERROR_FAULT:
				return basicSetRegistrationErrorFault(null, msgs);
			case CmdbfPackage.DOCUMENT_ROOT__UNKNOWN_TEMPLATE_ID_FAULT:
				return basicSetUnknownTemplateIDFault(null, msgs);
			case CmdbfPackage.DOCUMENT_ROOT__UNSUPPORTED_CONSTRAINT_FAULT:
				return basicSetUnsupportedConstraintFault(null, msgs);
			case CmdbfPackage.DOCUMENT_ROOT__UNSUPPORTED_RECORD_TYPE_FAULT:
				return basicSetUnsupportedRecordTypeFault(null, msgs);
			case CmdbfPackage.DOCUMENT_ROOT__UNSUPPORTED_SELECTOR_FAULT:
				return basicSetUnsupportedSelectorFault(null, msgs);
			case CmdbfPackage.DOCUMENT_ROOT__XPATH_ERROR_FAULT:
				return basicSetXPathErrorFault(null, msgs);
			case CmdbfPackage.DOCUMENT_ROOT__MODEL:
				return basicSetModel(null, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case CmdbfPackage.DOCUMENT_ROOT__MIXED:
				if (coreType) return getMixed();
				return ((FeatureMap.Internal)getMixed()).getWrapper();
			case CmdbfPackage.DOCUMENT_ROOT__XMLNS_PREFIX_MAP:
				if (coreType) return getXMLNSPrefixMap();
				else return getXMLNSPrefixMap().map();
			case CmdbfPackage.DOCUMENT_ROOT__XSI_SCHEMA_LOCATION:
				if (coreType) return getXSISchemaLocation();
				else return getXSISchemaLocation().map();
			case CmdbfPackage.DOCUMENT_ROOT__DEREGISTER_REQUEST:
				return getDeregisterRequest();
			case CmdbfPackage.DOCUMENT_ROOT__DEREGISTER_RESPONSE:
				return getDeregisterResponse();
			case CmdbfPackage.DOCUMENT_ROOT__DEREGISTRATION_ERROR_FAULT:
				return getDeregistrationErrorFault();
			case CmdbfPackage.DOCUMENT_ROOT__EXPENSIVE_QUERY_ERROR_FAULT:
				return getExpensiveQueryErrorFault();
			case CmdbfPackage.DOCUMENT_ROOT__INSTANCE_ID:
				return getInstanceId();
			case CmdbfPackage.DOCUMENT_ROOT__INVALID_MDR_FAULT:
				return getInvalidMDRFault();
			case CmdbfPackage.DOCUMENT_ROOT__INVALID_PROPERTY_TYPE_FAULT:
				return getInvalidPropertyTypeFault();
			case CmdbfPackage.DOCUMENT_ROOT__INVALID_RECORD_FAULT:
				return getInvalidRecordFault();
			case CmdbfPackage.DOCUMENT_ROOT__ITEM:
				return getItem();
			case CmdbfPackage.DOCUMENT_ROOT__PROPERTY_SET:
				return getPropertySet();
			case CmdbfPackage.DOCUMENT_ROOT__QUERY:
				return getQuery();
			case CmdbfPackage.DOCUMENT_ROOT__QUERY_ERROR_FAULT:
				return getQueryErrorFault();
			case CmdbfPackage.DOCUMENT_ROOT__QUERY_RESULT:
				return getQueryResult();
			case CmdbfPackage.DOCUMENT_ROOT__RECORD:
				return getRecord();
			case CmdbfPackage.DOCUMENT_ROOT__REGISTER_REQUEST:
				return getRegisterRequest();
			case CmdbfPackage.DOCUMENT_ROOT__REGISTER_RESPONSE:
				return getRegisterResponse();
			case CmdbfPackage.DOCUMENT_ROOT__REGISTRATION_ERROR_FAULT:
				return getRegistrationErrorFault();
			case CmdbfPackage.DOCUMENT_ROOT__RELATIONSHIP:
				return getRelationship();
			case CmdbfPackage.DOCUMENT_ROOT__UNKNOWN_TEMPLATE_ID_FAULT:
				return getUnknownTemplateIDFault();
			case CmdbfPackage.DOCUMENT_ROOT__UNSUPPORTED_CONSTRAINT_FAULT:
				return getUnsupportedConstraintFault();
			case CmdbfPackage.DOCUMENT_ROOT__UNSUPPORTED_RECORD_TYPE_FAULT:
				return getUnsupportedRecordTypeFault();
			case CmdbfPackage.DOCUMENT_ROOT__UNSUPPORTED_SELECTOR_FAULT:
				return getUnsupportedSelectorFault();
			case CmdbfPackage.DOCUMENT_ROOT__XPATH_ERROR_FAULT:
				return getXPathErrorFault();
			case CmdbfPackage.DOCUMENT_ROOT__MODEL:
				return getModel();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case CmdbfPackage.DOCUMENT_ROOT__MIXED:
				((FeatureMap.Internal)getMixed()).set(newValue);
				return;
			case CmdbfPackage.DOCUMENT_ROOT__XMLNS_PREFIX_MAP:
				((EStructuralFeature.Setting)getXMLNSPrefixMap()).set(newValue);
				return;
			case CmdbfPackage.DOCUMENT_ROOT__XSI_SCHEMA_LOCATION:
				((EStructuralFeature.Setting)getXSISchemaLocation()).set(newValue);
				return;
			case CmdbfPackage.DOCUMENT_ROOT__DEREGISTER_REQUEST:
				setDeregisterRequest((DeregisterRequestType)newValue);
				return;
			case CmdbfPackage.DOCUMENT_ROOT__DEREGISTER_RESPONSE:
				setDeregisterResponse((DeregisterResponseType)newValue);
				return;
			case CmdbfPackage.DOCUMENT_ROOT__DEREGISTRATION_ERROR_FAULT:
				setDeregistrationErrorFault((DeregistrationErrorFaultType)newValue);
				return;
			case CmdbfPackage.DOCUMENT_ROOT__EXPENSIVE_QUERY_ERROR_FAULT:
				setExpensiveQueryErrorFault((ExpensiveQueryErrorFaultType)newValue);
				return;
			case CmdbfPackage.DOCUMENT_ROOT__INSTANCE_ID:
				setInstanceId((MdrScopedIdType)newValue);
				return;
			case CmdbfPackage.DOCUMENT_ROOT__INVALID_MDR_FAULT:
				setInvalidMDRFault((InvalidMDRFaultType)newValue);
				return;
			case CmdbfPackage.DOCUMENT_ROOT__INVALID_PROPERTY_TYPE_FAULT:
				setInvalidPropertyTypeFault((InvalidPropertyTypeFaultType)newValue);
				return;
			case CmdbfPackage.DOCUMENT_ROOT__INVALID_RECORD_FAULT:
				setInvalidRecordFault((InvalidRecordFaultType)newValue);
				return;
			case CmdbfPackage.DOCUMENT_ROOT__ITEM:
				setItem((ItemType)newValue);
				return;
			case CmdbfPackage.DOCUMENT_ROOT__PROPERTY_SET:
				setPropertySet((PropertySetType)newValue);
				return;
			case CmdbfPackage.DOCUMENT_ROOT__QUERY:
				setQuery((QueryType)newValue);
				return;
			case CmdbfPackage.DOCUMENT_ROOT__QUERY_ERROR_FAULT:
				setQueryErrorFault((QueryErrorFaultType)newValue);
				return;
			case CmdbfPackage.DOCUMENT_ROOT__QUERY_RESULT:
				setQueryResult((QueryResultType)newValue);
				return;
			case CmdbfPackage.DOCUMENT_ROOT__RECORD:
				setRecord((RecordType)newValue);
				return;
			case CmdbfPackage.DOCUMENT_ROOT__REGISTER_REQUEST:
				setRegisterRequest((RegisterRequestType)newValue);
				return;
			case CmdbfPackage.DOCUMENT_ROOT__REGISTER_RESPONSE:
				setRegisterResponse((RegisterResponseType)newValue);
				return;
			case CmdbfPackage.DOCUMENT_ROOT__REGISTRATION_ERROR_FAULT:
				setRegistrationErrorFault((RegistrationErrorFaultType)newValue);
				return;
			case CmdbfPackage.DOCUMENT_ROOT__RELATIONSHIP:
				setRelationship((RelationshipType)newValue);
				return;
			case CmdbfPackage.DOCUMENT_ROOT__UNKNOWN_TEMPLATE_ID_FAULT:
				setUnknownTemplateIDFault((UnknownTemplateIDFaultType)newValue);
				return;
			case CmdbfPackage.DOCUMENT_ROOT__UNSUPPORTED_CONSTRAINT_FAULT:
				setUnsupportedConstraintFault((UnsupportedConstraintFaultType)newValue);
				return;
			case CmdbfPackage.DOCUMENT_ROOT__UNSUPPORTED_RECORD_TYPE_FAULT:
				setUnsupportedRecordTypeFault((UnsupportedRecordTypeFaultType)newValue);
				return;
			case CmdbfPackage.DOCUMENT_ROOT__UNSUPPORTED_SELECTOR_FAULT:
				setUnsupportedSelectorFault((UnsupportedSelectorFaultType)newValue);
				return;
			case CmdbfPackage.DOCUMENT_ROOT__XPATH_ERROR_FAULT:
				setXPathErrorFault((XPathErrorFaultType)newValue);
				return;
			case CmdbfPackage.DOCUMENT_ROOT__MODEL:
				setModel((Model)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case CmdbfPackage.DOCUMENT_ROOT__MIXED:
				getMixed().clear();
				return;
			case CmdbfPackage.DOCUMENT_ROOT__XMLNS_PREFIX_MAP:
				getXMLNSPrefixMap().clear();
				return;
			case CmdbfPackage.DOCUMENT_ROOT__XSI_SCHEMA_LOCATION:
				getXSISchemaLocation().clear();
				return;
			case CmdbfPackage.DOCUMENT_ROOT__DEREGISTER_REQUEST:
				setDeregisterRequest((DeregisterRequestType)null);
				return;
			case CmdbfPackage.DOCUMENT_ROOT__DEREGISTER_RESPONSE:
				setDeregisterResponse((DeregisterResponseType)null);
				return;
			case CmdbfPackage.DOCUMENT_ROOT__DEREGISTRATION_ERROR_FAULT:
				setDeregistrationErrorFault((DeregistrationErrorFaultType)null);
				return;
			case CmdbfPackage.DOCUMENT_ROOT__EXPENSIVE_QUERY_ERROR_FAULT:
				setExpensiveQueryErrorFault((ExpensiveQueryErrorFaultType)null);
				return;
			case CmdbfPackage.DOCUMENT_ROOT__INSTANCE_ID:
				setInstanceId((MdrScopedIdType)null);
				return;
			case CmdbfPackage.DOCUMENT_ROOT__INVALID_MDR_FAULT:
				setInvalidMDRFault((InvalidMDRFaultType)null);
				return;
			case CmdbfPackage.DOCUMENT_ROOT__INVALID_PROPERTY_TYPE_FAULT:
				setInvalidPropertyTypeFault((InvalidPropertyTypeFaultType)null);
				return;
			case CmdbfPackage.DOCUMENT_ROOT__INVALID_RECORD_FAULT:
				setInvalidRecordFault((InvalidRecordFaultType)null);
				return;
			case CmdbfPackage.DOCUMENT_ROOT__ITEM:
				setItem((ItemType)null);
				return;
			case CmdbfPackage.DOCUMENT_ROOT__PROPERTY_SET:
				setPropertySet((PropertySetType)null);
				return;
			case CmdbfPackage.DOCUMENT_ROOT__QUERY:
				setQuery((QueryType)null);
				return;
			case CmdbfPackage.DOCUMENT_ROOT__QUERY_ERROR_FAULT:
				setQueryErrorFault((QueryErrorFaultType)null);
				return;
			case CmdbfPackage.DOCUMENT_ROOT__QUERY_RESULT:
				setQueryResult((QueryResultType)null);
				return;
			case CmdbfPackage.DOCUMENT_ROOT__RECORD:
				setRecord((RecordType)null);
				return;
			case CmdbfPackage.DOCUMENT_ROOT__REGISTER_REQUEST:
				setRegisterRequest((RegisterRequestType)null);
				return;
			case CmdbfPackage.DOCUMENT_ROOT__REGISTER_RESPONSE:
				setRegisterResponse((RegisterResponseType)null);
				return;
			case CmdbfPackage.DOCUMENT_ROOT__REGISTRATION_ERROR_FAULT:
				setRegistrationErrorFault((RegistrationErrorFaultType)null);
				return;
			case CmdbfPackage.DOCUMENT_ROOT__RELATIONSHIP:
				setRelationship((RelationshipType)null);
				return;
			case CmdbfPackage.DOCUMENT_ROOT__UNKNOWN_TEMPLATE_ID_FAULT:
				setUnknownTemplateIDFault((UnknownTemplateIDFaultType)null);
				return;
			case CmdbfPackage.DOCUMENT_ROOT__UNSUPPORTED_CONSTRAINT_FAULT:
				setUnsupportedConstraintFault((UnsupportedConstraintFaultType)null);
				return;
			case CmdbfPackage.DOCUMENT_ROOT__UNSUPPORTED_RECORD_TYPE_FAULT:
				setUnsupportedRecordTypeFault((UnsupportedRecordTypeFaultType)null);
				return;
			case CmdbfPackage.DOCUMENT_ROOT__UNSUPPORTED_SELECTOR_FAULT:
				setUnsupportedSelectorFault((UnsupportedSelectorFaultType)null);
				return;
			case CmdbfPackage.DOCUMENT_ROOT__XPATH_ERROR_FAULT:
				setXPathErrorFault((XPathErrorFaultType)null);
				return;
			case CmdbfPackage.DOCUMENT_ROOT__MODEL:
				setModel((Model)null);
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case CmdbfPackage.DOCUMENT_ROOT__MIXED:
				return mixed != null && !mixed.isEmpty();
			case CmdbfPackage.DOCUMENT_ROOT__XMLNS_PREFIX_MAP:
				return xMLNSPrefixMap != null && !xMLNSPrefixMap.isEmpty();
			case CmdbfPackage.DOCUMENT_ROOT__XSI_SCHEMA_LOCATION:
				return xSISchemaLocation != null && !xSISchemaLocation.isEmpty();
			case CmdbfPackage.DOCUMENT_ROOT__DEREGISTER_REQUEST:
				return getDeregisterRequest() != null;
			case CmdbfPackage.DOCUMENT_ROOT__DEREGISTER_RESPONSE:
				return getDeregisterResponse() != null;
			case CmdbfPackage.DOCUMENT_ROOT__DEREGISTRATION_ERROR_FAULT:
				return getDeregistrationErrorFault() != null;
			case CmdbfPackage.DOCUMENT_ROOT__EXPENSIVE_QUERY_ERROR_FAULT:
				return getExpensiveQueryErrorFault() != null;
			case CmdbfPackage.DOCUMENT_ROOT__INSTANCE_ID:
				return getInstanceId() != null;
			case CmdbfPackage.DOCUMENT_ROOT__INVALID_MDR_FAULT:
				return getInvalidMDRFault() != null;
			case CmdbfPackage.DOCUMENT_ROOT__INVALID_PROPERTY_TYPE_FAULT:
				return getInvalidPropertyTypeFault() != null;
			case CmdbfPackage.DOCUMENT_ROOT__INVALID_RECORD_FAULT:
				return getInvalidRecordFault() != null;
			case CmdbfPackage.DOCUMENT_ROOT__ITEM:
				return getItem() != null;
			case CmdbfPackage.DOCUMENT_ROOT__PROPERTY_SET:
				return getPropertySet() != null;
			case CmdbfPackage.DOCUMENT_ROOT__QUERY:
				return getQuery() != null;
			case CmdbfPackage.DOCUMENT_ROOT__QUERY_ERROR_FAULT:
				return getQueryErrorFault() != null;
			case CmdbfPackage.DOCUMENT_ROOT__QUERY_RESULT:
				return getQueryResult() != null;
			case CmdbfPackage.DOCUMENT_ROOT__RECORD:
				return getRecord() != null;
			case CmdbfPackage.DOCUMENT_ROOT__REGISTER_REQUEST:
				return getRegisterRequest() != null;
			case CmdbfPackage.DOCUMENT_ROOT__REGISTER_RESPONSE:
				return getRegisterResponse() != null;
			case CmdbfPackage.DOCUMENT_ROOT__REGISTRATION_ERROR_FAULT:
				return getRegistrationErrorFault() != null;
			case CmdbfPackage.DOCUMENT_ROOT__RELATIONSHIP:
				return getRelationship() != null;
			case CmdbfPackage.DOCUMENT_ROOT__UNKNOWN_TEMPLATE_ID_FAULT:
				return getUnknownTemplateIDFault() != null;
			case CmdbfPackage.DOCUMENT_ROOT__UNSUPPORTED_CONSTRAINT_FAULT:
				return getUnsupportedConstraintFault() != null;
			case CmdbfPackage.DOCUMENT_ROOT__UNSUPPORTED_RECORD_TYPE_FAULT:
				return getUnsupportedRecordTypeFault() != null;
			case CmdbfPackage.DOCUMENT_ROOT__UNSUPPORTED_SELECTOR_FAULT:
				return getUnsupportedSelectorFault() != null;
			case CmdbfPackage.DOCUMENT_ROOT__XPATH_ERROR_FAULT:
				return getXPathErrorFault() != null;
			case CmdbfPackage.DOCUMENT_ROOT__MODEL:
				return getModel() != null;
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		if (eIsProxy()) return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (mixed: ");
		result.append(mixed);
		result.append(')');
		return result.toString();
	}

} //DocumentRootImpl
