/**
 */
package it.unibo.cmdb.monitoring.model.icinga;

import org.eclipse.emf.common.util.EList;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Dependency</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link it.unibo.cmdb.monitoring.model.icinga.Dependency#getParent <em>Parent</em>}</li>
 *   <li>{@link it.unibo.cmdb.monitoring.model.icinga.Dependency#getChild <em>Child</em>}</li>
 *   <li>{@link it.unibo.cmdb.monitoring.model.icinga.Dependency#isDisable_checks <em>Disable checks</em>}</li>
 *   <li>{@link it.unibo.cmdb.monitoring.model.icinga.Dependency#isDisable_notifications <em>Disable notifications</em>}</li>
 *   <li>{@link it.unibo.cmdb.monitoring.model.icinga.Dependency#isIgnore_soft_states <em>Ignore soft states</em>}</li>
 *   <li>{@link it.unibo.cmdb.monitoring.model.icinga.Dependency#getPeriod <em>Period</em>}</li>
 *   <li>{@link it.unibo.cmdb.monitoring.model.icinga.Dependency#getStates <em>States</em>}</li>
 * </ul>
 * </p>
 *
 * @see it.unibo.cmdb.monitoring.model.icinga.IcingaPackage#getDependency()
 * @model
 * @generated
 */
public interface Dependency extends ConfigurationObject, ZoneElement {
	/**
	 * Returns the value of the '<em><b>Parent</b></em>' container reference.
	 * It is bidirectional and its opposite is '{@link it.unibo.cmdb.monitoring.model.icinga.Checkable#getDependencies <em>Dependencies</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Parent</em>' container reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Parent</em>' container reference.
	 * @see #setParent(Checkable)
	 * @see it.unibo.cmdb.monitoring.model.icinga.IcingaPackage#getDependency_Parent()
	 * @see it.unibo.cmdb.monitoring.model.icinga.Checkable#getDependencies
	 * @model opposite="dependencies" required="true" transient="false"
	 * @generated
	 */
	Checkable getParent();

	/**
	 * Sets the value of the '{@link it.unibo.cmdb.monitoring.model.icinga.Dependency#getParent <em>Parent</em>}' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Parent</em>' container reference.
	 * @see #getParent()
	 * @generated
	 */
	void setParent(Checkable value);

	/**
	 * Returns the value of the '<em><b>Child</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Child</em>' reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Child</em>' reference.
	 * @see #setChild(Checkable)
	 * @see it.unibo.cmdb.monitoring.model.icinga.IcingaPackage#getDependency_Child()
	 * @model required="true"
	 * @generated
	 */
	Checkable getChild();

	/**
	 * Sets the value of the '{@link it.unibo.cmdb.monitoring.model.icinga.Dependency#getChild <em>Child</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Child</em>' reference.
	 * @see #getChild()
	 * @generated
	 */
	void setChild(Checkable value);

	/**
	 * Returns the value of the '<em><b>Disable checks</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Disable checks</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Disable checks</em>' attribute.
	 * @see #setDisable_checks(boolean)
	 * @see it.unibo.cmdb.monitoring.model.icinga.IcingaPackage#getDependency_Disable_checks()
	 * @model
	 * @generated
	 */
	boolean isDisable_checks();

	/**
	 * Sets the value of the '{@link it.unibo.cmdb.monitoring.model.icinga.Dependency#isDisable_checks <em>Disable checks</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Disable checks</em>' attribute.
	 * @see #isDisable_checks()
	 * @generated
	 */
	void setDisable_checks(boolean value);

	/**
	 * Returns the value of the '<em><b>Disable notifications</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Disable notifications</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Disable notifications</em>' attribute.
	 * @see #setDisable_notifications(boolean)
	 * @see it.unibo.cmdb.monitoring.model.icinga.IcingaPackage#getDependency_Disable_notifications()
	 * @model
	 * @generated
	 */
	boolean isDisable_notifications();

	/**
	 * Sets the value of the '{@link it.unibo.cmdb.monitoring.model.icinga.Dependency#isDisable_notifications <em>Disable notifications</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Disable notifications</em>' attribute.
	 * @see #isDisable_notifications()
	 * @generated
	 */
	void setDisable_notifications(boolean value);

	/**
	 * Returns the value of the '<em><b>Ignore soft states</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Ignore soft states</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Ignore soft states</em>' attribute.
	 * @see #setIgnore_soft_states(boolean)
	 * @see it.unibo.cmdb.monitoring.model.icinga.IcingaPackage#getDependency_Ignore_soft_states()
	 * @model
	 * @generated
	 */
	boolean isIgnore_soft_states();

	/**
	 * Sets the value of the '{@link it.unibo.cmdb.monitoring.model.icinga.Dependency#isIgnore_soft_states <em>Ignore soft states</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Ignore soft states</em>' attribute.
	 * @see #isIgnore_soft_states()
	 * @generated
	 */
	void setIgnore_soft_states(boolean value);

	/**
	 * Returns the value of the '<em><b>Period</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Period</em>' reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Period</em>' reference.
	 * @see #setPeriod(TimePeriod)
	 * @see it.unibo.cmdb.monitoring.model.icinga.IcingaPackage#getDependency_Period()
	 * @model
	 * @generated
	 */
	TimePeriod getPeriod();

	/**
	 * Sets the value of the '{@link it.unibo.cmdb.monitoring.model.icinga.Dependency#getPeriod <em>Period</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Period</em>' reference.
	 * @see #getPeriod()
	 * @generated
	 */
	void setPeriod(TimePeriod value);

	/**
	 * Returns the value of the '<em><b>States</b></em>' attribute list.
	 * The list contents are of type {@link it.unibo.cmdb.monitoring.model.icinga.State}.
	 * The literals are from the enumeration {@link it.unibo.cmdb.monitoring.model.icinga.State}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>States</em>' attribute list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>States</em>' attribute list.
	 * @see it.unibo.cmdb.monitoring.model.icinga.State
	 * @see it.unibo.cmdb.monitoring.model.icinga.IcingaPackage#getDependency_States()
	 * @model
	 * @generated
	 */
	EList<State> getStates();

} // Dependency
