/**
 */
package it.unibo.cmdb.monitoring.model.icinga;

import org.eclipse.emf.common.util.EList;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Notification</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link it.unibo.cmdb.monitoring.model.icinga.Notification#getCheckable <em>Checkable</em>}</li>
 *   <li>{@link it.unibo.cmdb.monitoring.model.icinga.Notification#getVars <em>Vars</em>}</li>
 *   <li>{@link it.unibo.cmdb.monitoring.model.icinga.Notification#getUsers <em>Users</em>}</li>
 *   <li>{@link it.unibo.cmdb.monitoring.model.icinga.Notification#getUser_groups <em>User groups</em>}</li>
 *   <li>{@link it.unibo.cmdb.monitoring.model.icinga.Notification#getTimes <em>Times</em>}</li>
 *   <li>{@link it.unibo.cmdb.monitoring.model.icinga.Notification#getCommand <em>Command</em>}</li>
 *   <li>{@link it.unibo.cmdb.monitoring.model.icinga.Notification#getInterval <em>Interval</em>}</li>
 *   <li>{@link it.unibo.cmdb.monitoring.model.icinga.Notification#getPeriod <em>Period</em>}</li>
 *   <li>{@link it.unibo.cmdb.monitoring.model.icinga.Notification#getTypes <em>Types</em>}</li>
 *   <li>{@link it.unibo.cmdb.monitoring.model.icinga.Notification#getStates <em>States</em>}</li>
 * </ul>
 * </p>
 *
 * @see it.unibo.cmdb.monitoring.model.icinga.IcingaPackage#getNotification()
 * @model
 * @generated
 */
public interface Notification extends ConfigurationObject, ZoneElement {
	/**
	 * Returns the value of the '<em><b>Checkable</b></em>' container reference.
	 * It is bidirectional and its opposite is '{@link it.unibo.cmdb.monitoring.model.icinga.Checkable#getNotifications <em>Notifications</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Checkable</em>' container reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Checkable</em>' container reference.
	 * @see #setCheckable(Checkable)
	 * @see it.unibo.cmdb.monitoring.model.icinga.IcingaPackage#getNotification_Checkable()
	 * @see it.unibo.cmdb.monitoring.model.icinga.Checkable#getNotifications
	 * @model opposite="notifications" required="true" transient="false"
	 * @generated
	 */
	Checkable getCheckable();

	/**
	 * Sets the value of the '{@link it.unibo.cmdb.monitoring.model.icinga.Notification#getCheckable <em>Checkable</em>}' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Checkable</em>' container reference.
	 * @see #getCheckable()
	 * @generated
	 */
	void setCheckable(Checkable value);

	/**
	 * Returns the value of the '<em><b>Vars</b></em>' containment reference list.
	 * The list contents are of type {@link it.unibo.cmdb.monitoring.model.icinga.UserVar}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Vars</em>' containment reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Vars</em>' containment reference list.
	 * @see it.unibo.cmdb.monitoring.model.icinga.IcingaPackage#getNotification_Vars()
	 * @model containment="true" keys="key"
	 * @generated
	 */
	EList<UserVar> getVars();

	/**
	 * Returns the value of the '<em><b>Users</b></em>' reference list.
	 * The list contents are of type {@link it.unibo.cmdb.monitoring.model.icinga.User}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Users</em>' reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Users</em>' reference list.
	 * @see it.unibo.cmdb.monitoring.model.icinga.IcingaPackage#getNotification_Users()
	 * @model
	 * @generated
	 */
	EList<User> getUsers();

	/**
	 * Returns the value of the '<em><b>User groups</b></em>' reference list.
	 * The list contents are of type {@link it.unibo.cmdb.monitoring.model.icinga.UserGroup}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>User groups</em>' reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>User groups</em>' reference list.
	 * @see it.unibo.cmdb.monitoring.model.icinga.IcingaPackage#getNotification_User_groups()
	 * @model
	 * @generated
	 */
	EList<UserGroup> getUser_groups();

	/**
	 * Returns the value of the '<em><b>Times</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Times</em>' containment reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Times</em>' containment reference.
	 * @see #setTimes(NotificationTimes)
	 * @see it.unibo.cmdb.monitoring.model.icinga.IcingaPackage#getNotification_Times()
	 * @model containment="true"
	 * @generated
	 */
	NotificationTimes getTimes();

	/**
	 * Sets the value of the '{@link it.unibo.cmdb.monitoring.model.icinga.Notification#getTimes <em>Times</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Times</em>' containment reference.
	 * @see #getTimes()
	 * @generated
	 */
	void setTimes(NotificationTimes value);

	/**
	 * Returns the value of the '<em><b>Command</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Command</em>' reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Command</em>' reference.
	 * @see #setCommand(NotificationCommand)
	 * @see it.unibo.cmdb.monitoring.model.icinga.IcingaPackage#getNotification_Command()
	 * @model required="true"
	 * @generated
	 */
	NotificationCommand getCommand();

	/**
	 * Sets the value of the '{@link it.unibo.cmdb.monitoring.model.icinga.Notification#getCommand <em>Command</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Command</em>' reference.
	 * @see #getCommand()
	 * @generated
	 */
	void setCommand(NotificationCommand value);

	/**
	 * Returns the value of the '<em><b>Interval</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Interval</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Interval</em>' attribute.
	 * @see #setInterval(int)
	 * @see it.unibo.cmdb.monitoring.model.icinga.IcingaPackage#getNotification_Interval()
	 * @model
	 * @generated
	 */
	int getInterval();

	/**
	 * Sets the value of the '{@link it.unibo.cmdb.monitoring.model.icinga.Notification#getInterval <em>Interval</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Interval</em>' attribute.
	 * @see #getInterval()
	 * @generated
	 */
	void setInterval(int value);

	/**
	 * Returns the value of the '<em><b>Period</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Period</em>' reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Period</em>' reference.
	 * @see #setPeriod(TimePeriod)
	 * @see it.unibo.cmdb.monitoring.model.icinga.IcingaPackage#getNotification_Period()
	 * @model
	 * @generated
	 */
	TimePeriod getPeriod();

	/**
	 * Sets the value of the '{@link it.unibo.cmdb.monitoring.model.icinga.Notification#getPeriod <em>Period</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Period</em>' reference.
	 * @see #getPeriod()
	 * @generated
	 */
	void setPeriod(TimePeriod value);

	/**
	 * Returns the value of the '<em><b>Types</b></em>' attribute list.
	 * The list contents are of type {@link it.unibo.cmdb.monitoring.model.icinga.NotificationType}.
	 * The literals are from the enumeration {@link it.unibo.cmdb.monitoring.model.icinga.NotificationType}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Types</em>' attribute list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Types</em>' attribute list.
	 * @see it.unibo.cmdb.monitoring.model.icinga.NotificationType
	 * @see it.unibo.cmdb.monitoring.model.icinga.IcingaPackage#getNotification_Types()
	 * @model
	 * @generated
	 */
	EList<NotificationType> getTypes();

	/**
	 * Returns the value of the '<em><b>States</b></em>' attribute list.
	 * The list contents are of type {@link it.unibo.cmdb.monitoring.model.icinga.State}.
	 * The literals are from the enumeration {@link it.unibo.cmdb.monitoring.model.icinga.State}.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>States</em>' attribute list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>States</em>' attribute list.
	 * @see it.unibo.cmdb.monitoring.model.icinga.State
	 * @see it.unibo.cmdb.monitoring.model.icinga.IcingaPackage#getNotification_States()
	 * @model
	 * @generated
	 */
	EList<State> getStates();

} // Notification
