/**
 */
package it.unibo.cmdb.monitoring.model.icinga.impl;

import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EEnum;
import org.eclipse.emf.ecore.EGenericType;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.EReference;
import org.eclipse.emf.ecore.ETypeParameter;

import org.eclipse.emf.ecore.impl.EPackageImpl;

import it.unibo.cmdb.monitoring.model.icinga.ApiListener;
import it.unibo.cmdb.monitoring.model.icinga.CheckCommand;
import it.unibo.cmdb.monitoring.model.icinga.CheckResultReader;
import it.unibo.cmdb.monitoring.model.icinga.Checkable;
import it.unibo.cmdb.monitoring.model.icinga.CheckerComponent;
import it.unibo.cmdb.monitoring.model.icinga.Command;
import it.unibo.cmdb.monitoring.model.icinga.CommandArgument;
import it.unibo.cmdb.monitoring.model.icinga.CommandEnv;
import it.unibo.cmdb.monitoring.model.icinga.CompatLogger;
import it.unibo.cmdb.monitoring.model.icinga.ComplexUserValue;
import it.unibo.cmdb.monitoring.model.icinga.ConfigurationObject;
import it.unibo.cmdb.monitoring.model.icinga.DatabaseCategory;
import it.unibo.cmdb.monitoring.model.icinga.DatabaseCleanup;
import it.unibo.cmdb.monitoring.model.icinga.Dependency;
import it.unibo.cmdb.monitoring.model.icinga.Endpoint;
import it.unibo.cmdb.monitoring.model.icinga.EventCommand;
import it.unibo.cmdb.monitoring.model.icinga.ExternalCommandListener;
import it.unibo.cmdb.monitoring.model.icinga.FileLogger;
import it.unibo.cmdb.monitoring.model.icinga.GelfWriter;
import it.unibo.cmdb.monitoring.model.icinga.GraphiteWriter;
import it.unibo.cmdb.monitoring.model.icinga.Host;
import it.unibo.cmdb.monitoring.model.icinga.HostGroup;
import it.unibo.cmdb.monitoring.model.icinga.IcingaFactory;
import it.unibo.cmdb.monitoring.model.icinga.IcingaPackage;
import it.unibo.cmdb.monitoring.model.icinga.IcingaStatusWriter;
import it.unibo.cmdb.monitoring.model.icinga.IdoConnection;
import it.unibo.cmdb.monitoring.model.icinga.IdoMySqlConnection;
import it.unibo.cmdb.monitoring.model.icinga.IdoPgSqlConnection;
import it.unibo.cmdb.monitoring.model.icinga.LiveStatusListener;
import it.unibo.cmdb.monitoring.model.icinga.LogRotationMethod;
import it.unibo.cmdb.monitoring.model.icinga.LogSeverity;
import it.unibo.cmdb.monitoring.model.icinga.Notification;
import it.unibo.cmdb.monitoring.model.icinga.NotificationCommand;
import it.unibo.cmdb.monitoring.model.icinga.NotificationComponent;
import it.unibo.cmdb.monitoring.model.icinga.NotificationTimes;
import it.unibo.cmdb.monitoring.model.icinga.NotificationType;
import it.unibo.cmdb.monitoring.model.icinga.NumericUserValue;
import it.unibo.cmdb.monitoring.model.icinga.OpenTsdbWriter;
import it.unibo.cmdb.monitoring.model.icinga.PerfdataWriter;
import it.unibo.cmdb.monitoring.model.icinga.ScheduledDowntime;
import it.unibo.cmdb.monitoring.model.icinga.Service;
import it.unibo.cmdb.monitoring.model.icinga.ServiceGroup;
import it.unibo.cmdb.monitoring.model.icinga.SimpleUserValue;
import it.unibo.cmdb.monitoring.model.icinga.SocketType;
import it.unibo.cmdb.monitoring.model.icinga.State;
import it.unibo.cmdb.monitoring.model.icinga.StatusDataWriter;
import it.unibo.cmdb.monitoring.model.icinga.StringUserValue;
import it.unibo.cmdb.monitoring.model.icinga.SyslogLogger;
import it.unibo.cmdb.monitoring.model.icinga.TimePeriod;
import it.unibo.cmdb.monitoring.model.icinga.TimeRange;
import it.unibo.cmdb.monitoring.model.icinga.User;
import it.unibo.cmdb.monitoring.model.icinga.UserGroup;
import it.unibo.cmdb.monitoring.model.icinga.UserValue;
import it.unibo.cmdb.monitoring.model.icinga.UserVar;
import it.unibo.cmdb.monitoring.model.icinga.Zone;
import it.unibo.cmdb.monitoring.model.icinga.ZoneElement;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model <b>Package</b>.
 * <!-- end-user-doc -->
 * @generated
 */
public class IcingaPackageImpl extends EPackageImpl implements IcingaPackage {
	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass userVarEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass userValueEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass simpleUserValueEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass stringUserValueEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass numericUserValueEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass complexUserValueEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass commandArgumentEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass commandEnvEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass databaseCleanupEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass timeRangeEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass notificationTimesEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass checkableEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass zoneElementEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass configurationObjectEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass commandEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass checkCommandEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass notificationCommandEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass eventCommandEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass scheduledDowntimeEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass dependencyEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass notificationEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass timePeriodEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass hostEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass hostGroupEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass serviceEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass serviceGroupEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass userEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass userGroupEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass zoneEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass endpointEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass checkerComponentEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass notificationComponentEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass checkResultReaderEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass apiListenerEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass liveStatusListenerEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass externalCommandListenerEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass compatLoggerEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass fileLoggerEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass syslogLoggerEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass gelfWriterEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass graphiteWriterEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass icingaStatusWriterEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass openTsdbWriterEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass perfdataWriterEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass statusDataWriterEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass idoConnectionEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass idoMySqlConnectionEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass idoPgSqlConnectionEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EEnum databaseCategoryEEnum = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EEnum notificationTypeEEnum = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EEnum logRotationMethodEEnum = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EEnum logSeverityEEnum = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EEnum socketTypeEEnum = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EEnum stateEEnum = null;

	/**
	 * Creates an instance of the model <b>Package</b>, registered with
	 * {@link org.eclipse.emf.ecore.EPackage.Registry EPackage.Registry} by the package
	 * package URI value.
	 * <p>Note: the correct way to create the package is via the static
	 * factory method {@link #init init()}, which also performs
	 * initialization of the package, or returns the registered package,
	 * if one already exists.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.emf.ecore.EPackage.Registry
	 * @see it.unibo.cmdb.monitoring.model.icinga.IcingaPackage#eNS_URI
	 * @see #init()
	 * @generated
	 */
	private IcingaPackageImpl() {
		super(eNS_URI, IcingaFactory.eINSTANCE);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private static boolean isInited = false;

	/**
	 * Creates, registers, and initializes the <b>Package</b> for this model, and for any others upon which it depends.
	 * 
	 * <p>This method is used to initialize {@link IcingaPackage#eINSTANCE} when that field is accessed.
	 * Clients should not invoke it directly. Instead, they should simply access that field to obtain the package.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #eNS_URI
	 * @see #createPackageContents()
	 * @see #initializePackageContents()
	 * @generated
	 */
	public static IcingaPackage init() {
		if (isInited) return (IcingaPackage)EPackage.Registry.INSTANCE.getEPackage(IcingaPackage.eNS_URI);

		// Obtain or create and register package
		IcingaPackageImpl theIcingaPackage = (IcingaPackageImpl)(EPackage.Registry.INSTANCE.get(eNS_URI) instanceof IcingaPackageImpl ? EPackage.Registry.INSTANCE.get(eNS_URI) : new IcingaPackageImpl());

		isInited = true;

		// Create package meta-data objects
		theIcingaPackage.createPackageContents();

		// Initialize created meta-data
		theIcingaPackage.initializePackageContents();

		// Mark meta-data to indicate it can't be changed
		theIcingaPackage.freeze();

  
		// Update the registry and return the package
		EPackage.Registry.INSTANCE.put(IcingaPackage.eNS_URI, theIcingaPackage);
		return theIcingaPackage;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getUserVar() {
		return userVarEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getUserVar_Key() {
		return (EAttribute)userVarEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getUserVar_Value() {
		return (EReference)userVarEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getUserValue() {
		return userValueEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getSimpleUserValue() {
		return simpleUserValueEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getSimpleUserValue_Value() {
		return (EAttribute)simpleUserValueEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getStringUserValue() {
		return stringUserValueEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getNumericUserValue() {
		return numericUserValueEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getComplexUserValue() {
		return complexUserValueEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getComplexUserValue_Value() {
		return (EReference)complexUserValueEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getCommandArgument() {
		return commandArgumentEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getCommandArgument_Value() {
		return (EAttribute)commandArgumentEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getCommandArgument_Key() {
		return (EAttribute)commandArgumentEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getCommandArgument_Description() {
		return (EAttribute)commandArgumentEClass.getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getCommandArgument_Required() {
		return (EAttribute)commandArgumentEClass.getEStructuralFeatures().get(3);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getCommandArgument_Skip_key() {
		return (EAttribute)commandArgumentEClass.getEStructuralFeatures().get(4);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getCommandArgument_Set_if() {
		return (EAttribute)commandArgumentEClass.getEStructuralFeatures().get(5);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getCommandArgument_Order() {
		return (EAttribute)commandArgumentEClass.getEStructuralFeatures().get(6);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getCommandArgument_Repeat_key() {
		return (EAttribute)commandArgumentEClass.getEStructuralFeatures().get(7);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getCommandEnv() {
		return commandEnvEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getCommandEnv_Value() {
		return (EAttribute)commandEnvEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getCommandEnv_Key() {
		return (EAttribute)commandEnvEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getDatabaseCleanup() {
		return databaseCleanupEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getDatabaseCleanup_Acknowledgements_age() {
		return (EAttribute)databaseCleanupEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getDatabaseCleanup_Commenthistory_age() {
		return (EAttribute)databaseCleanupEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getDatabaseCleanup_Contactnotifications_age() {
		return (EAttribute)databaseCleanupEClass.getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getDatabaseCleanup_Contactnotificationmethods_age() {
		return (EAttribute)databaseCleanupEClass.getEStructuralFeatures().get(3);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getDatabaseCleanup_Downtimehistory_age() {
		return (EAttribute)databaseCleanupEClass.getEStructuralFeatures().get(4);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getDatabaseCleanup_Eventhandlers_age() {
		return (EAttribute)databaseCleanupEClass.getEStructuralFeatures().get(5);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getDatabaseCleanup_Externalcommands_age() {
		return (EAttribute)databaseCleanupEClass.getEStructuralFeatures().get(6);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getDatabaseCleanup_Flappinghistory_age() {
		return (EAttribute)databaseCleanupEClass.getEStructuralFeatures().get(7);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getDatabaseCleanup_Hostchecks_age() {
		return (EAttribute)databaseCleanupEClass.getEStructuralFeatures().get(8);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getDatabaseCleanup_Logentries_age() {
		return (EAttribute)databaseCleanupEClass.getEStructuralFeatures().get(9);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getDatabaseCleanup_Notifications_age() {
		return (EAttribute)databaseCleanupEClass.getEStructuralFeatures().get(10);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getDatabaseCleanup_Processevents_age() {
		return (EAttribute)databaseCleanupEClass.getEStructuralFeatures().get(11);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getDatabaseCleanup_Statehistory_age() {
		return (EAttribute)databaseCleanupEClass.getEStructuralFeatures().get(12);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getDatabaseCleanup_Servicechecks_age() {
		return (EAttribute)databaseCleanupEClass.getEStructuralFeatures().get(13);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getDatabaseCleanup_Systemcommands_age() {
		return (EAttribute)databaseCleanupEClass.getEStructuralFeatures().get(14);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getTimeRange() {
		return timeRangeEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getTimeRange_Directive() {
		return (EAttribute)timeRangeEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getTimeRange_Value() {
		return (EAttribute)timeRangeEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getNotificationTimes() {
		return notificationTimesEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getNotificationTimes_Begin() {
		return (EAttribute)notificationTimesEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getNotificationTimes_End() {
		return (EAttribute)notificationTimesEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getCheckable() {
		return checkableEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getCheckable_Dependencies() {
		return (EReference)checkableEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getCheckable_Notifications() {
		return (EReference)checkableEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getCheckable_ScheduledDowntimes() {
		return (EReference)checkableEClass.getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getZoneElement() {
		return zoneElementEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getZoneElement_Zone() {
		return (EReference)zoneElementEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getConfigurationObject() {
		return configurationObjectEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getConfigurationObject_Name() {
		return (EAttribute)configurationObjectEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getConfigurationObject_Import() {
		return (EAttribute)configurationObjectEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getCommand() {
		return commandEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getCommand_Execute() {
		return (EAttribute)commandEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getCommand_Command() {
		return (EAttribute)commandEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getCommand_Env() {
		return (EReference)commandEClass.getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getCommand_Vars() {
		return (EReference)commandEClass.getEStructuralFeatures().get(3);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getCommand_Timeout() {
		return (EAttribute)commandEClass.getEStructuralFeatures().get(4);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getCommand_Arguments() {
		return (EReference)commandEClass.getEStructuralFeatures().get(5);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getCheckCommand() {
		return checkCommandEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getNotificationCommand() {
		return notificationCommandEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getEventCommand() {
		return eventCommandEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getScheduledDowntime() {
		return scheduledDowntimeEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getScheduledDowntime_Checkable() {
		return (EReference)scheduledDowntimeEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getScheduledDowntime_Author() {
		return (EAttribute)scheduledDowntimeEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getScheduledDowntime_Comment() {
		return (EAttribute)scheduledDowntimeEClass.getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getScheduledDowntime_Fixed() {
		return (EAttribute)scheduledDowntimeEClass.getEStructuralFeatures().get(3);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getScheduledDowntime_Duration() {
		return (EAttribute)scheduledDowntimeEClass.getEStructuralFeatures().get(4);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getScheduledDowntime_Ranges() {
		return (EReference)scheduledDowntimeEClass.getEStructuralFeatures().get(5);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getDependency() {
		return dependencyEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getDependency_Parent() {
		return (EReference)dependencyEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getDependency_Child() {
		return (EReference)dependencyEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getDependency_Disable_checks() {
		return (EAttribute)dependencyEClass.getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getDependency_Disable_notifications() {
		return (EAttribute)dependencyEClass.getEStructuralFeatures().get(3);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getDependency_Ignore_soft_states() {
		return (EAttribute)dependencyEClass.getEStructuralFeatures().get(4);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getDependency_Period() {
		return (EReference)dependencyEClass.getEStructuralFeatures().get(5);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getDependency_States() {
		return (EAttribute)dependencyEClass.getEStructuralFeatures().get(6);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getNotification() {
		return notificationEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getNotification_Checkable() {
		return (EReference)notificationEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getNotification_Vars() {
		return (EReference)notificationEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getNotification_Users() {
		return (EReference)notificationEClass.getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getNotification_User_groups() {
		return (EReference)notificationEClass.getEStructuralFeatures().get(3);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getNotification_Times() {
		return (EReference)notificationEClass.getEStructuralFeatures().get(4);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getNotification_Command() {
		return (EReference)notificationEClass.getEStructuralFeatures().get(5);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getNotification_Interval() {
		return (EAttribute)notificationEClass.getEStructuralFeatures().get(6);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getNotification_Period() {
		return (EReference)notificationEClass.getEStructuralFeatures().get(7);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getNotification_Types() {
		return (EAttribute)notificationEClass.getEStructuralFeatures().get(8);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getNotification_States() {
		return (EAttribute)notificationEClass.getEStructuralFeatures().get(9);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getTimePeriod() {
		return timePeriodEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getTimePeriod_Display_name() {
		return (EAttribute)timePeriodEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getTimePeriod_Update() {
		return (EAttribute)timePeriodEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getTimePeriod_Ranges() {
		return (EReference)timePeriodEClass.getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getHost() {
		return hostEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getHost_Display_name() {
		return (EAttribute)hostEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getHost_Address() {
		return (EAttribute)hostEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getHost_Address6() {
		return (EAttribute)hostEClass.getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getHost_Groups() {
		return (EReference)hostEClass.getEStructuralFeatures().get(3);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getHost_Vars() {
		return (EReference)hostEClass.getEStructuralFeatures().get(4);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getHost_Check_command() {
		return (EReference)hostEClass.getEStructuralFeatures().get(5);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getHost_Max_check_attempts() {
		return (EAttribute)hostEClass.getEStructuralFeatures().get(6);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getHost_Check_period() {
		return (EReference)hostEClass.getEStructuralFeatures().get(7);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getHost_Check_interval() {
		return (EAttribute)hostEClass.getEStructuralFeatures().get(8);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getHost_Retry_interval() {
		return (EAttribute)hostEClass.getEStructuralFeatures().get(9);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getHost_Enable_notifications() {
		return (EAttribute)hostEClass.getEStructuralFeatures().get(10);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getHost_Enable_active_checks() {
		return (EAttribute)hostEClass.getEStructuralFeatures().get(11);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getHost_Enable_passive_checks() {
		return (EAttribute)hostEClass.getEStructuralFeatures().get(12);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getHost_Enable_event_handler() {
		return (EAttribute)hostEClass.getEStructuralFeatures().get(13);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getHost_Enable_flapping() {
		return (EAttribute)hostEClass.getEStructuralFeatures().get(14);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getHost_Enable_perfdata() {
		return (EAttribute)hostEClass.getEStructuralFeatures().get(15);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getHost_Event_command() {
		return (EReference)hostEClass.getEStructuralFeatures().get(16);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getHost_Flapping_threshold() {
		return (EAttribute)hostEClass.getEStructuralFeatures().get(17);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getHost_Volatile() {
		return (EAttribute)hostEClass.getEStructuralFeatures().get(18);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getHost_Command_endpoint() {
		return (EReference)hostEClass.getEStructuralFeatures().get(19);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getHost_Notes() {
		return (EAttribute)hostEClass.getEStructuralFeatures().get(20);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getHost_Notes_url() {
		return (EAttribute)hostEClass.getEStructuralFeatures().get(21);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getHost_Action_url() {
		return (EAttribute)hostEClass.getEStructuralFeatures().get(22);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getHost_Icon_image() {
		return (EAttribute)hostEClass.getEStructuralFeatures().get(23);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getHost_Icon_image_alt() {
		return (EAttribute)hostEClass.getEStructuralFeatures().get(24);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getHost_Services() {
		return (EReference)hostEClass.getEStructuralFeatures().get(25);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getHostGroup() {
		return hostGroupEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getHostGroup_Display_name() {
		return (EAttribute)hostGroupEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getHostGroup_Groups() {
		return (EReference)hostGroupEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getService() {
		return serviceEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getService_Display_name() {
		return (EAttribute)serviceEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getService_Host() {
		return (EReference)serviceEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getService_Groups() {
		return (EReference)serviceEClass.getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getService_Vars() {
		return (EReference)serviceEClass.getEStructuralFeatures().get(3);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getService_Check_command() {
		return (EReference)serviceEClass.getEStructuralFeatures().get(4);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getService_Max_check_attempts() {
		return (EAttribute)serviceEClass.getEStructuralFeatures().get(5);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getService_Check_period() {
		return (EReference)serviceEClass.getEStructuralFeatures().get(6);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getService_Check_interval() {
		return (EAttribute)serviceEClass.getEStructuralFeatures().get(7);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getService_Retry_interval() {
		return (EAttribute)serviceEClass.getEStructuralFeatures().get(8);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getService_Enable_notifications() {
		return (EAttribute)serviceEClass.getEStructuralFeatures().get(9);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getService_Enable_active_checks() {
		return (EAttribute)serviceEClass.getEStructuralFeatures().get(10);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getService_Enable_passive_checks() {
		return (EAttribute)serviceEClass.getEStructuralFeatures().get(11);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getService_Enable_event_handler() {
		return (EAttribute)serviceEClass.getEStructuralFeatures().get(12);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getService_Enable_flapping() {
		return (EAttribute)serviceEClass.getEStructuralFeatures().get(13);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getService_Enable_perfdata() {
		return (EAttribute)serviceEClass.getEStructuralFeatures().get(14);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getService_Event_command() {
		return (EReference)serviceEClass.getEStructuralFeatures().get(15);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getService_Flapping_threshold() {
		return (EAttribute)serviceEClass.getEStructuralFeatures().get(16);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getService_Volatile() {
		return (EAttribute)serviceEClass.getEStructuralFeatures().get(17);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getService_Command_endpoint() {
		return (EReference)serviceEClass.getEStructuralFeatures().get(18);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getService_Notes() {
		return (EAttribute)serviceEClass.getEStructuralFeatures().get(19);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getService_Notes_url() {
		return (EAttribute)serviceEClass.getEStructuralFeatures().get(20);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getService_Action_url() {
		return (EAttribute)serviceEClass.getEStructuralFeatures().get(21);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getService_Icon_image() {
		return (EAttribute)serviceEClass.getEStructuralFeatures().get(22);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getService_Icon_image_alt() {
		return (EAttribute)serviceEClass.getEStructuralFeatures().get(23);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getServiceGroup() {
		return serviceGroupEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getServiceGroup_Display_name() {
		return (EAttribute)serviceGroupEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getServiceGroup_Groups() {
		return (EReference)serviceGroupEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getUser() {
		return userEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getUser_Display_name() {
		return (EAttribute)userEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getUser_Email() {
		return (EAttribute)userEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getUser_Pager() {
		return (EAttribute)userEClass.getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getUser_Vars() {
		return (EReference)userEClass.getEStructuralFeatures().get(3);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getUser_Groups() {
		return (EReference)userEClass.getEStructuralFeatures().get(4);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getUser_Enable_notifications() {
		return (EAttribute)userEClass.getEStructuralFeatures().get(5);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getUser_Period() {
		return (EReference)userEClass.getEStructuralFeatures().get(6);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getUser_Types() {
		return (EAttribute)userEClass.getEStructuralFeatures().get(7);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getUser_States() {
		return (EAttribute)userEClass.getEStructuralFeatures().get(8);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getUserGroup() {
		return userGroupEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getUserGroup_Display_name() {
		return (EAttribute)userGroupEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getUserGroup_Groups() {
		return (EReference)userGroupEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getZone() {
		return zoneEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getZone_Endpoints() {
		return (EReference)zoneEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getZone_Parent() {
		return (EReference)zoneEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getZone_Global() {
		return (EAttribute)zoneEClass.getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getZone_Elements() {
		return (EReference)zoneEClass.getEStructuralFeatures().get(3);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getZone_Subzones() {
		return (EReference)zoneEClass.getEStructuralFeatures().get(4);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getEndpoint() {
		return endpointEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getEndpoint_Host() {
		return (EAttribute)endpointEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getEndpoint_Port() {
		return (EAttribute)endpointEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getEndpoint_Log_duration() {
		return (EAttribute)endpointEClass.getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getCheckerComponent() {
		return checkerComponentEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getNotificationComponent() {
		return notificationComponentEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getNotificationComponent_Enable_ha() {
		return (EAttribute)notificationComponentEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getCheckResultReader() {
		return checkResultReaderEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getCheckResultReader_Spool_dir() {
		return (EAttribute)checkResultReaderEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getApiListener() {
		return apiListenerEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getApiListener_Cert_path() {
		return (EAttribute)apiListenerEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getApiListener_Key_path() {
		return (EAttribute)apiListenerEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getApiListener_Ca_path() {
		return (EAttribute)apiListenerEClass.getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getApiListener_Crl_path() {
		return (EAttribute)apiListenerEClass.getEStructuralFeatures().get(3);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getApiListener_Bind_host() {
		return (EAttribute)apiListenerEClass.getEStructuralFeatures().get(4);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getApiListener_Bind_port() {
		return (EAttribute)apiListenerEClass.getEStructuralFeatures().get(5);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getApiListener_Accept_config() {
		return (EAttribute)apiListenerEClass.getEStructuralFeatures().get(6);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getApiListener_Accept_commands() {
		return (EAttribute)apiListenerEClass.getEStructuralFeatures().get(7);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getLiveStatusListener() {
		return liveStatusListenerEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getLiveStatusListener_Socket_type() {
		return (EAttribute)liveStatusListenerEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getLiveStatusListener_Bind_host() {
		return (EAttribute)liveStatusListenerEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getLiveStatusListener_Bind_port() {
		return (EAttribute)liveStatusListenerEClass.getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getLiveStatusListener_Socket_path() {
		return (EAttribute)liveStatusListenerEClass.getEStructuralFeatures().get(3);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getLiveStatusListener_Compat_log_path() {
		return (EAttribute)liveStatusListenerEClass.getEStructuralFeatures().get(4);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getExternalCommandListener() {
		return externalCommandListenerEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getExternalCommandListener_Command_path() {
		return (EAttribute)externalCommandListenerEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getCompatLogger() {
		return compatLoggerEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getCompatLogger_Log_dir() {
		return (EAttribute)compatLoggerEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getCompatLogger_Rotation_method() {
		return (EAttribute)compatLoggerEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getFileLogger() {
		return fileLoggerEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getFileLogger_Path() {
		return (EAttribute)fileLoggerEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getFileLogger_Severity() {
		return (EAttribute)fileLoggerEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getSyslogLogger() {
		return syslogLoggerEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getSyslogLogger_Severity() {
		return (EAttribute)syslogLoggerEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getGelfWriter() {
		return gelfWriterEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getGelfWriter_Host() {
		return (EAttribute)gelfWriterEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getGelfWriter_Port() {
		return (EAttribute)gelfWriterEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getGelfWriter_Source() {
		return (EAttribute)gelfWriterEClass.getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getGraphiteWriter() {
		return graphiteWriterEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getGraphiteWriter_Host() {
		return (EAttribute)graphiteWriterEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getGraphiteWriter_Port() {
		return (EAttribute)graphiteWriterEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getGraphiteWriter_Host_name_template() {
		return (EAttribute)graphiteWriterEClass.getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getGraphiteWriter_Service_name_template() {
		return (EAttribute)graphiteWriterEClass.getEStructuralFeatures().get(3);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getIcingaStatusWriter() {
		return icingaStatusWriterEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getIcingaStatusWriter_Status_path() {
		return (EAttribute)icingaStatusWriterEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getIcingaStatusWriter_Update_interval() {
		return (EAttribute)icingaStatusWriterEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getOpenTsdbWriter() {
		return openTsdbWriterEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getOpenTsdbWriter_Host() {
		return (EAttribute)openTsdbWriterEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getOpenTsdbWriter_Port() {
		return (EAttribute)openTsdbWriterEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getPerfdataWriter() {
		return perfdataWriterEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getPerfdataWriter_Host_perfdata_path() {
		return (EAttribute)perfdataWriterEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getPerfdataWriter_Service_perfdata_path() {
		return (EAttribute)perfdataWriterEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getPerfdataWriter_Host_temp_path() {
		return (EAttribute)perfdataWriterEClass.getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getPerfdataWriter_Service_temp_path() {
		return (EAttribute)perfdataWriterEClass.getEStructuralFeatures().get(3);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getPerfdataWriter_Host_format_template() {
		return (EAttribute)perfdataWriterEClass.getEStructuralFeatures().get(4);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getPerfdataWriter_Service_format_template() {
		return (EAttribute)perfdataWriterEClass.getEStructuralFeatures().get(5);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getPerfdataWriter_Rotation_interval() {
		return (EAttribute)perfdataWriterEClass.getEStructuralFeatures().get(6);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getStatusDataWriter() {
		return statusDataWriterEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getStatusDataWriter_Status_path() {
		return (EAttribute)statusDataWriterEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getStatusDataWriter_Objects_path() {
		return (EAttribute)statusDataWriterEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getStatusDataWriter_Update_interval() {
		return (EAttribute)statusDataWriterEClass.getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getIdoConnection() {
		return idoConnectionEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getIdoConnection_Host() {
		return (EAttribute)idoConnectionEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getIdoConnection_Port() {
		return (EAttribute)idoConnectionEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getIdoConnection_User() {
		return (EAttribute)idoConnectionEClass.getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getIdoConnection_Password() {
		return (EAttribute)idoConnectionEClass.getEStructuralFeatures().get(3);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getIdoConnection_Database() {
		return (EAttribute)idoConnectionEClass.getEStructuralFeatures().get(4);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getIdoConnection_Table_prefix() {
		return (EAttribute)idoConnectionEClass.getEStructuralFeatures().get(5);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getIdoConnection_Instance_name() {
		return (EAttribute)idoConnectionEClass.getEStructuralFeatures().get(6);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getIdoConnection_Instance_description() {
		return (EAttribute)idoConnectionEClass.getEStructuralFeatures().get(7);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getIdoConnection_Enable_ha() {
		return (EAttribute)idoConnectionEClass.getEStructuralFeatures().get(8);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getIdoConnection_Failover_timeout() {
		return (EAttribute)idoConnectionEClass.getEStructuralFeatures().get(9);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getIdoConnection_Cleanup() {
		return (EReference)idoConnectionEClass.getEStructuralFeatures().get(10);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getIdoConnection_Categories() {
		return (EAttribute)idoConnectionEClass.getEStructuralFeatures().get(11);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getIdoMySqlConnection() {
		return idoMySqlConnectionEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getIdoMySqlConnection_Socket_path() {
		return (EAttribute)idoMySqlConnectionEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getIdoPgSqlConnection() {
		return idoPgSqlConnectionEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EEnum getDatabaseCategory() {
		return databaseCategoryEEnum;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EEnum getNotificationType() {
		return notificationTypeEEnum;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EEnum getLogRotationMethod() {
		return logRotationMethodEEnum;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EEnum getLogSeverity() {
		return logSeverityEEnum;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EEnum getSocketType() {
		return socketTypeEEnum;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EEnum getState() {
		return stateEEnum;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public IcingaFactory getIcingaFactory() {
		return (IcingaFactory)getEFactoryInstance();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private boolean isCreated = false;

	/**
	 * Creates the meta-model objects for the package.  This method is
	 * guarded to have no affect on any invocation but its first.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void createPackageContents() {
		if (isCreated) return;
		isCreated = true;

		// Create classes and their features
		userVarEClass = createEClass(USER_VAR);
		createEAttribute(userVarEClass, USER_VAR__KEY);
		createEReference(userVarEClass, USER_VAR__VALUE);

		userValueEClass = createEClass(USER_VALUE);

		simpleUserValueEClass = createEClass(SIMPLE_USER_VALUE);
		createEAttribute(simpleUserValueEClass, SIMPLE_USER_VALUE__VALUE);

		stringUserValueEClass = createEClass(STRING_USER_VALUE);

		numericUserValueEClass = createEClass(NUMERIC_USER_VALUE);

		complexUserValueEClass = createEClass(COMPLEX_USER_VALUE);
		createEReference(complexUserValueEClass, COMPLEX_USER_VALUE__VALUE);

		commandArgumentEClass = createEClass(COMMAND_ARGUMENT);
		createEAttribute(commandArgumentEClass, COMMAND_ARGUMENT__VALUE);
		createEAttribute(commandArgumentEClass, COMMAND_ARGUMENT__KEY);
		createEAttribute(commandArgumentEClass, COMMAND_ARGUMENT__DESCRIPTION);
		createEAttribute(commandArgumentEClass, COMMAND_ARGUMENT__REQUIRED);
		createEAttribute(commandArgumentEClass, COMMAND_ARGUMENT__SKIP_KEY);
		createEAttribute(commandArgumentEClass, COMMAND_ARGUMENT__SET_IF);
		createEAttribute(commandArgumentEClass, COMMAND_ARGUMENT__ORDER);
		createEAttribute(commandArgumentEClass, COMMAND_ARGUMENT__REPEAT_KEY);

		commandEnvEClass = createEClass(COMMAND_ENV);
		createEAttribute(commandEnvEClass, COMMAND_ENV__VALUE);
		createEAttribute(commandEnvEClass, COMMAND_ENV__KEY);

		databaseCleanupEClass = createEClass(DATABASE_CLEANUP);
		createEAttribute(databaseCleanupEClass, DATABASE_CLEANUP__ACKNOWLEDGEMENTS_AGE);
		createEAttribute(databaseCleanupEClass, DATABASE_CLEANUP__COMMENTHISTORY_AGE);
		createEAttribute(databaseCleanupEClass, DATABASE_CLEANUP__CONTACTNOTIFICATIONS_AGE);
		createEAttribute(databaseCleanupEClass, DATABASE_CLEANUP__CONTACTNOTIFICATIONMETHODS_AGE);
		createEAttribute(databaseCleanupEClass, DATABASE_CLEANUP__DOWNTIMEHISTORY_AGE);
		createEAttribute(databaseCleanupEClass, DATABASE_CLEANUP__EVENTHANDLERS_AGE);
		createEAttribute(databaseCleanupEClass, DATABASE_CLEANUP__EXTERNALCOMMANDS_AGE);
		createEAttribute(databaseCleanupEClass, DATABASE_CLEANUP__FLAPPINGHISTORY_AGE);
		createEAttribute(databaseCleanupEClass, DATABASE_CLEANUP__HOSTCHECKS_AGE);
		createEAttribute(databaseCleanupEClass, DATABASE_CLEANUP__LOGENTRIES_AGE);
		createEAttribute(databaseCleanupEClass, DATABASE_CLEANUP__NOTIFICATIONS_AGE);
		createEAttribute(databaseCleanupEClass, DATABASE_CLEANUP__PROCESSEVENTS_AGE);
		createEAttribute(databaseCleanupEClass, DATABASE_CLEANUP__STATEHISTORY_AGE);
		createEAttribute(databaseCleanupEClass, DATABASE_CLEANUP__SERVICECHECKS_AGE);
		createEAttribute(databaseCleanupEClass, DATABASE_CLEANUP__SYSTEMCOMMANDS_AGE);

		timeRangeEClass = createEClass(TIME_RANGE);
		createEAttribute(timeRangeEClass, TIME_RANGE__DIRECTIVE);
		createEAttribute(timeRangeEClass, TIME_RANGE__VALUE);

		notificationTimesEClass = createEClass(NOTIFICATION_TIMES);
		createEAttribute(notificationTimesEClass, NOTIFICATION_TIMES__BEGIN);
		createEAttribute(notificationTimesEClass, NOTIFICATION_TIMES__END);

		checkableEClass = createEClass(CHECKABLE);
		createEReference(checkableEClass, CHECKABLE__DEPENDENCIES);
		createEReference(checkableEClass, CHECKABLE__NOTIFICATIONS);
		createEReference(checkableEClass, CHECKABLE__SCHEDULED_DOWNTIMES);

		zoneElementEClass = createEClass(ZONE_ELEMENT);
		createEReference(zoneElementEClass, ZONE_ELEMENT__ZONE);

		configurationObjectEClass = createEClass(CONFIGURATION_OBJECT);
		createEAttribute(configurationObjectEClass, CONFIGURATION_OBJECT__NAME);
		createEAttribute(configurationObjectEClass, CONFIGURATION_OBJECT__IMPORT);

		commandEClass = createEClass(COMMAND);
		createEAttribute(commandEClass, COMMAND__EXECUTE);
		createEAttribute(commandEClass, COMMAND__COMMAND);
		createEReference(commandEClass, COMMAND__ENV);
		createEReference(commandEClass, COMMAND__VARS);
		createEAttribute(commandEClass, COMMAND__TIMEOUT);
		createEReference(commandEClass, COMMAND__ARGUMENTS);

		checkCommandEClass = createEClass(CHECK_COMMAND);

		notificationCommandEClass = createEClass(NOTIFICATION_COMMAND);

		eventCommandEClass = createEClass(EVENT_COMMAND);

		scheduledDowntimeEClass = createEClass(SCHEDULED_DOWNTIME);
		createEReference(scheduledDowntimeEClass, SCHEDULED_DOWNTIME__CHECKABLE);
		createEAttribute(scheduledDowntimeEClass, SCHEDULED_DOWNTIME__AUTHOR);
		createEAttribute(scheduledDowntimeEClass, SCHEDULED_DOWNTIME__COMMENT);
		createEAttribute(scheduledDowntimeEClass, SCHEDULED_DOWNTIME__FIXED);
		createEAttribute(scheduledDowntimeEClass, SCHEDULED_DOWNTIME__DURATION);
		createEReference(scheduledDowntimeEClass, SCHEDULED_DOWNTIME__RANGES);

		dependencyEClass = createEClass(DEPENDENCY);
		createEReference(dependencyEClass, DEPENDENCY__PARENT);
		createEReference(dependencyEClass, DEPENDENCY__CHILD);
		createEAttribute(dependencyEClass, DEPENDENCY__DISABLE_CHECKS);
		createEAttribute(dependencyEClass, DEPENDENCY__DISABLE_NOTIFICATIONS);
		createEAttribute(dependencyEClass, DEPENDENCY__IGNORE_SOFT_STATES);
		createEReference(dependencyEClass, DEPENDENCY__PERIOD);
		createEAttribute(dependencyEClass, DEPENDENCY__STATES);

		notificationEClass = createEClass(NOTIFICATION);
		createEReference(notificationEClass, NOTIFICATION__CHECKABLE);
		createEReference(notificationEClass, NOTIFICATION__VARS);
		createEReference(notificationEClass, NOTIFICATION__USERS);
		createEReference(notificationEClass, NOTIFICATION__USER_GROUPS);
		createEReference(notificationEClass, NOTIFICATION__TIMES);
		createEReference(notificationEClass, NOTIFICATION__COMMAND);
		createEAttribute(notificationEClass, NOTIFICATION__INTERVAL);
		createEReference(notificationEClass, NOTIFICATION__PERIOD);
		createEAttribute(notificationEClass, NOTIFICATION__TYPES);
		createEAttribute(notificationEClass, NOTIFICATION__STATES);

		timePeriodEClass = createEClass(TIME_PERIOD);
		createEAttribute(timePeriodEClass, TIME_PERIOD__DISPLAY_NAME);
		createEAttribute(timePeriodEClass, TIME_PERIOD__UPDATE);
		createEReference(timePeriodEClass, TIME_PERIOD__RANGES);

		hostEClass = createEClass(HOST);
		createEAttribute(hostEClass, HOST__DISPLAY_NAME);
		createEAttribute(hostEClass, HOST__ADDRESS);
		createEAttribute(hostEClass, HOST__ADDRESS6);
		createEReference(hostEClass, HOST__GROUPS);
		createEReference(hostEClass, HOST__VARS);
		createEReference(hostEClass, HOST__CHECK_COMMAND);
		createEAttribute(hostEClass, HOST__MAX_CHECK_ATTEMPTS);
		createEReference(hostEClass, HOST__CHECK_PERIOD);
		createEAttribute(hostEClass, HOST__CHECK_INTERVAL);
		createEAttribute(hostEClass, HOST__RETRY_INTERVAL);
		createEAttribute(hostEClass, HOST__ENABLE_NOTIFICATIONS);
		createEAttribute(hostEClass, HOST__ENABLE_ACTIVE_CHECKS);
		createEAttribute(hostEClass, HOST__ENABLE_PASSIVE_CHECKS);
		createEAttribute(hostEClass, HOST__ENABLE_EVENT_HANDLER);
		createEAttribute(hostEClass, HOST__ENABLE_FLAPPING);
		createEAttribute(hostEClass, HOST__ENABLE_PERFDATA);
		createEReference(hostEClass, HOST__EVENT_COMMAND);
		createEAttribute(hostEClass, HOST__FLAPPING_THRESHOLD);
		createEAttribute(hostEClass, HOST__VOLATILE);
		createEReference(hostEClass, HOST__COMMAND_ENDPOINT);
		createEAttribute(hostEClass, HOST__NOTES);
		createEAttribute(hostEClass, HOST__NOTES_URL);
		createEAttribute(hostEClass, HOST__ACTION_URL);
		createEAttribute(hostEClass, HOST__ICON_IMAGE);
		createEAttribute(hostEClass, HOST__ICON_IMAGE_ALT);
		createEReference(hostEClass, HOST__SERVICES);

		hostGroupEClass = createEClass(HOST_GROUP);
		createEAttribute(hostGroupEClass, HOST_GROUP__DISPLAY_NAME);
		createEReference(hostGroupEClass, HOST_GROUP__GROUPS);

		serviceEClass = createEClass(SERVICE);
		createEAttribute(serviceEClass, SERVICE__DISPLAY_NAME);
		createEReference(serviceEClass, SERVICE__HOST);
		createEReference(serviceEClass, SERVICE__GROUPS);
		createEReference(serviceEClass, SERVICE__VARS);
		createEReference(serviceEClass, SERVICE__CHECK_COMMAND);
		createEAttribute(serviceEClass, SERVICE__MAX_CHECK_ATTEMPTS);
		createEReference(serviceEClass, SERVICE__CHECK_PERIOD);
		createEAttribute(serviceEClass, SERVICE__CHECK_INTERVAL);
		createEAttribute(serviceEClass, SERVICE__RETRY_INTERVAL);
		createEAttribute(serviceEClass, SERVICE__ENABLE_NOTIFICATIONS);
		createEAttribute(serviceEClass, SERVICE__ENABLE_ACTIVE_CHECKS);
		createEAttribute(serviceEClass, SERVICE__ENABLE_PASSIVE_CHECKS);
		createEAttribute(serviceEClass, SERVICE__ENABLE_EVENT_HANDLER);
		createEAttribute(serviceEClass, SERVICE__ENABLE_FLAPPING);
		createEAttribute(serviceEClass, SERVICE__ENABLE_PERFDATA);
		createEReference(serviceEClass, SERVICE__EVENT_COMMAND);
		createEAttribute(serviceEClass, SERVICE__FLAPPING_THRESHOLD);
		createEAttribute(serviceEClass, SERVICE__VOLATILE);
		createEReference(serviceEClass, SERVICE__COMMAND_ENDPOINT);
		createEAttribute(serviceEClass, SERVICE__NOTES);
		createEAttribute(serviceEClass, SERVICE__NOTES_URL);
		createEAttribute(serviceEClass, SERVICE__ACTION_URL);
		createEAttribute(serviceEClass, SERVICE__ICON_IMAGE);
		createEAttribute(serviceEClass, SERVICE__ICON_IMAGE_ALT);

		serviceGroupEClass = createEClass(SERVICE_GROUP);
		createEAttribute(serviceGroupEClass, SERVICE_GROUP__DISPLAY_NAME);
		createEReference(serviceGroupEClass, SERVICE_GROUP__GROUPS);

		userEClass = createEClass(USER);
		createEAttribute(userEClass, USER__DISPLAY_NAME);
		createEAttribute(userEClass, USER__EMAIL);
		createEAttribute(userEClass, USER__PAGER);
		createEReference(userEClass, USER__VARS);
		createEReference(userEClass, USER__GROUPS);
		createEAttribute(userEClass, USER__ENABLE_NOTIFICATIONS);
		createEReference(userEClass, USER__PERIOD);
		createEAttribute(userEClass, USER__TYPES);
		createEAttribute(userEClass, USER__STATES);

		userGroupEClass = createEClass(USER_GROUP);
		createEAttribute(userGroupEClass, USER_GROUP__DISPLAY_NAME);
		createEReference(userGroupEClass, USER_GROUP__GROUPS);

		zoneEClass = createEClass(ZONE);
		createEReference(zoneEClass, ZONE__ENDPOINTS);
		createEReference(zoneEClass, ZONE__PARENT);
		createEAttribute(zoneEClass, ZONE__GLOBAL);
		createEReference(zoneEClass, ZONE__ELEMENTS);
		createEReference(zoneEClass, ZONE__SUBZONES);

		endpointEClass = createEClass(ENDPOINT);
		createEAttribute(endpointEClass, ENDPOINT__HOST);
		createEAttribute(endpointEClass, ENDPOINT__PORT);
		createEAttribute(endpointEClass, ENDPOINT__LOG_DURATION);

		checkerComponentEClass = createEClass(CHECKER_COMPONENT);

		notificationComponentEClass = createEClass(NOTIFICATION_COMPONENT);
		createEAttribute(notificationComponentEClass, NOTIFICATION_COMPONENT__ENABLE_HA);

		checkResultReaderEClass = createEClass(CHECK_RESULT_READER);
		createEAttribute(checkResultReaderEClass, CHECK_RESULT_READER__SPOOL_DIR);

		apiListenerEClass = createEClass(API_LISTENER);
		createEAttribute(apiListenerEClass, API_LISTENER__CERT_PATH);
		createEAttribute(apiListenerEClass, API_LISTENER__KEY_PATH);
		createEAttribute(apiListenerEClass, API_LISTENER__CA_PATH);
		createEAttribute(apiListenerEClass, API_LISTENER__CRL_PATH);
		createEAttribute(apiListenerEClass, API_LISTENER__BIND_HOST);
		createEAttribute(apiListenerEClass, API_LISTENER__BIND_PORT);
		createEAttribute(apiListenerEClass, API_LISTENER__ACCEPT_CONFIG);
		createEAttribute(apiListenerEClass, API_LISTENER__ACCEPT_COMMANDS);

		liveStatusListenerEClass = createEClass(LIVE_STATUS_LISTENER);
		createEAttribute(liveStatusListenerEClass, LIVE_STATUS_LISTENER__SOCKET_TYPE);
		createEAttribute(liveStatusListenerEClass, LIVE_STATUS_LISTENER__BIND_HOST);
		createEAttribute(liveStatusListenerEClass, LIVE_STATUS_LISTENER__BIND_PORT);
		createEAttribute(liveStatusListenerEClass, LIVE_STATUS_LISTENER__SOCKET_PATH);
		createEAttribute(liveStatusListenerEClass, LIVE_STATUS_LISTENER__COMPAT_LOG_PATH);

		externalCommandListenerEClass = createEClass(EXTERNAL_COMMAND_LISTENER);
		createEAttribute(externalCommandListenerEClass, EXTERNAL_COMMAND_LISTENER__COMMAND_PATH);

		compatLoggerEClass = createEClass(COMPAT_LOGGER);
		createEAttribute(compatLoggerEClass, COMPAT_LOGGER__LOG_DIR);
		createEAttribute(compatLoggerEClass, COMPAT_LOGGER__ROTATION_METHOD);

		fileLoggerEClass = createEClass(FILE_LOGGER);
		createEAttribute(fileLoggerEClass, FILE_LOGGER__PATH);
		createEAttribute(fileLoggerEClass, FILE_LOGGER__SEVERITY);

		syslogLoggerEClass = createEClass(SYSLOG_LOGGER);
		createEAttribute(syslogLoggerEClass, SYSLOG_LOGGER__SEVERITY);

		gelfWriterEClass = createEClass(GELF_WRITER);
		createEAttribute(gelfWriterEClass, GELF_WRITER__HOST);
		createEAttribute(gelfWriterEClass, GELF_WRITER__PORT);
		createEAttribute(gelfWriterEClass, GELF_WRITER__SOURCE);

		graphiteWriterEClass = createEClass(GRAPHITE_WRITER);
		createEAttribute(graphiteWriterEClass, GRAPHITE_WRITER__HOST);
		createEAttribute(graphiteWriterEClass, GRAPHITE_WRITER__PORT);
		createEAttribute(graphiteWriterEClass, GRAPHITE_WRITER__HOST_NAME_TEMPLATE);
		createEAttribute(graphiteWriterEClass, GRAPHITE_WRITER__SERVICE_NAME_TEMPLATE);

		icingaStatusWriterEClass = createEClass(ICINGA_STATUS_WRITER);
		createEAttribute(icingaStatusWriterEClass, ICINGA_STATUS_WRITER__STATUS_PATH);
		createEAttribute(icingaStatusWriterEClass, ICINGA_STATUS_WRITER__UPDATE_INTERVAL);

		openTsdbWriterEClass = createEClass(OPEN_TSDB_WRITER);
		createEAttribute(openTsdbWriterEClass, OPEN_TSDB_WRITER__HOST);
		createEAttribute(openTsdbWriterEClass, OPEN_TSDB_WRITER__PORT);

		perfdataWriterEClass = createEClass(PERFDATA_WRITER);
		createEAttribute(perfdataWriterEClass, PERFDATA_WRITER__HOST_PERFDATA_PATH);
		createEAttribute(perfdataWriterEClass, PERFDATA_WRITER__SERVICE_PERFDATA_PATH);
		createEAttribute(perfdataWriterEClass, PERFDATA_WRITER__HOST_TEMP_PATH);
		createEAttribute(perfdataWriterEClass, PERFDATA_WRITER__SERVICE_TEMP_PATH);
		createEAttribute(perfdataWriterEClass, PERFDATA_WRITER__HOST_FORMAT_TEMPLATE);
		createEAttribute(perfdataWriterEClass, PERFDATA_WRITER__SERVICE_FORMAT_TEMPLATE);
		createEAttribute(perfdataWriterEClass, PERFDATA_WRITER__ROTATION_INTERVAL);

		statusDataWriterEClass = createEClass(STATUS_DATA_WRITER);
		createEAttribute(statusDataWriterEClass, STATUS_DATA_WRITER__STATUS_PATH);
		createEAttribute(statusDataWriterEClass, STATUS_DATA_WRITER__OBJECTS_PATH);
		createEAttribute(statusDataWriterEClass, STATUS_DATA_WRITER__UPDATE_INTERVAL);

		idoConnectionEClass = createEClass(IDO_CONNECTION);
		createEAttribute(idoConnectionEClass, IDO_CONNECTION__HOST);
		createEAttribute(idoConnectionEClass, IDO_CONNECTION__PORT);
		createEAttribute(idoConnectionEClass, IDO_CONNECTION__USER);
		createEAttribute(idoConnectionEClass, IDO_CONNECTION__PASSWORD);
		createEAttribute(idoConnectionEClass, IDO_CONNECTION__DATABASE);
		createEAttribute(idoConnectionEClass, IDO_CONNECTION__TABLE_PREFIX);
		createEAttribute(idoConnectionEClass, IDO_CONNECTION__INSTANCE_NAME);
		createEAttribute(idoConnectionEClass, IDO_CONNECTION__INSTANCE_DESCRIPTION);
		createEAttribute(idoConnectionEClass, IDO_CONNECTION__ENABLE_HA);
		createEAttribute(idoConnectionEClass, IDO_CONNECTION__FAILOVER_TIMEOUT);
		createEReference(idoConnectionEClass, IDO_CONNECTION__CLEANUP);
		createEAttribute(idoConnectionEClass, IDO_CONNECTION__CATEGORIES);

		idoMySqlConnectionEClass = createEClass(IDO_MY_SQL_CONNECTION);
		createEAttribute(idoMySqlConnectionEClass, IDO_MY_SQL_CONNECTION__SOCKET_PATH);

		idoPgSqlConnectionEClass = createEClass(IDO_PG_SQL_CONNECTION);

		// Create enums
		databaseCategoryEEnum = createEEnum(DATABASE_CATEGORY);
		notificationTypeEEnum = createEEnum(NOTIFICATION_TYPE);
		logRotationMethodEEnum = createEEnum(LOG_ROTATION_METHOD);
		logSeverityEEnum = createEEnum(LOG_SEVERITY);
		socketTypeEEnum = createEEnum(SOCKET_TYPE);
		stateEEnum = createEEnum(STATE);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private boolean isInitialized = false;

	/**
	 * Complete the initialization of the package and its meta-model.  This
	 * method is guarded to have no affect on any invocation but its first.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void initializePackageContents() {
		if (isInitialized) return;
		isInitialized = true;

		// Initialize package
		setName(eNAME);
		setNsPrefix(eNS_PREFIX);
		setNsURI(eNS_URI);

		// Create type parameters
		ETypeParameter simpleUserValueEClass_T = addETypeParameter(simpleUserValueEClass, "T");

		// Set bounds for type parameters

		// Add supertypes to classes
		simpleUserValueEClass.getESuperTypes().add(this.getUserValue());
		EGenericType g1 = createEGenericType(this.getSimpleUserValue());
		EGenericType g2 = createEGenericType(ecorePackage.getEString());
		g1.getETypeArguments().add(g2);
		stringUserValueEClass.getEGenericSuperTypes().add(g1);
		g1 = createEGenericType(this.getSimpleUserValue());
		g2 = createEGenericType(ecorePackage.getEString());
		g1.getETypeArguments().add(g2);
		numericUserValueEClass.getEGenericSuperTypes().add(g1);
		complexUserValueEClass.getESuperTypes().add(this.getUserValue());
		commandEClass.getESuperTypes().add(this.getConfigurationObject());
		checkCommandEClass.getESuperTypes().add(this.getCommand());
		checkCommandEClass.getESuperTypes().add(this.getZoneElement());
		notificationCommandEClass.getESuperTypes().add(this.getCommand());
		notificationCommandEClass.getESuperTypes().add(this.getZoneElement());
		eventCommandEClass.getESuperTypes().add(this.getCommand());
		scheduledDowntimeEClass.getESuperTypes().add(this.getConfigurationObject());
		scheduledDowntimeEClass.getESuperTypes().add(this.getZoneElement());
		dependencyEClass.getESuperTypes().add(this.getConfigurationObject());
		dependencyEClass.getESuperTypes().add(this.getZoneElement());
		notificationEClass.getESuperTypes().add(this.getConfigurationObject());
		notificationEClass.getESuperTypes().add(this.getZoneElement());
		timePeriodEClass.getESuperTypes().add(this.getConfigurationObject());
		timePeriodEClass.getESuperTypes().add(this.getZoneElement());
		hostEClass.getESuperTypes().add(this.getConfigurationObject());
		hostEClass.getESuperTypes().add(this.getCheckable());
		hostEClass.getESuperTypes().add(this.getZoneElement());
		hostGroupEClass.getESuperTypes().add(this.getConfigurationObject());
		serviceEClass.getESuperTypes().add(this.getConfigurationObject());
		serviceEClass.getESuperTypes().add(this.getCheckable());
		serviceEClass.getESuperTypes().add(this.getZoneElement());
		serviceGroupEClass.getESuperTypes().add(this.getConfigurationObject());
		userEClass.getESuperTypes().add(this.getConfigurationObject());
		userEClass.getESuperTypes().add(this.getZoneElement());
		userGroupEClass.getESuperTypes().add(this.getConfigurationObject());
		userGroupEClass.getESuperTypes().add(this.getZoneElement());
		zoneEClass.getESuperTypes().add(this.getConfigurationObject());
		endpointEClass.getESuperTypes().add(this.getConfigurationObject());
		checkerComponentEClass.getESuperTypes().add(this.getConfigurationObject());
		notificationComponentEClass.getESuperTypes().add(this.getConfigurationObject());
		checkResultReaderEClass.getESuperTypes().add(this.getConfigurationObject());
		apiListenerEClass.getESuperTypes().add(this.getConfigurationObject());
		liveStatusListenerEClass.getESuperTypes().add(this.getConfigurationObject());
		externalCommandListenerEClass.getESuperTypes().add(this.getConfigurationObject());
		compatLoggerEClass.getESuperTypes().add(this.getConfigurationObject());
		fileLoggerEClass.getESuperTypes().add(this.getConfigurationObject());
		syslogLoggerEClass.getESuperTypes().add(this.getConfigurationObject());
		gelfWriterEClass.getESuperTypes().add(this.getConfigurationObject());
		graphiteWriterEClass.getESuperTypes().add(this.getConfigurationObject());
		icingaStatusWriterEClass.getESuperTypes().add(this.getConfigurationObject());
		openTsdbWriterEClass.getESuperTypes().add(this.getConfigurationObject());
		perfdataWriterEClass.getESuperTypes().add(this.getConfigurationObject());
		statusDataWriterEClass.getESuperTypes().add(this.getConfigurationObject());
		idoConnectionEClass.getESuperTypes().add(this.getConfigurationObject());
		idoMySqlConnectionEClass.getESuperTypes().add(this.getIdoConnection());
		idoPgSqlConnectionEClass.getESuperTypes().add(this.getIdoConnection());

		// Initialize classes, features, and operations; add parameters
		initEClass(userVarEClass, UserVar.class, "UserVar", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getUserVar_Key(), ecorePackage.getEString(), "key", null, 0, 1, UserVar.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getUserVar_Value(), this.getUserValue(), null, "value", null, 0, -1, UserVar.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(userValueEClass, UserValue.class, "UserValue", IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(simpleUserValueEClass, SimpleUserValue.class, "SimpleUserValue", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		g1 = createEGenericType(simpleUserValueEClass_T);
		initEAttribute(getSimpleUserValue_Value(), g1, "value", null, 1, 1, SimpleUserValue.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(stringUserValueEClass, StringUserValue.class, "StringUserValue", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(numericUserValueEClass, NumericUserValue.class, "NumericUserValue", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(complexUserValueEClass, ComplexUserValue.class, "ComplexUserValue", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getComplexUserValue_Value(), this.getUserVar(), null, "value", null, 0, -1, ComplexUserValue.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		getComplexUserValue_Value().getEKeys().add(this.getUserVar_Key());

		initEClass(commandArgumentEClass, CommandArgument.class, "CommandArgument", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getCommandArgument_Value(), ecorePackage.getEString(), "value", null, 0, -1, CommandArgument.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getCommandArgument_Key(), ecorePackage.getEString(), "key", null, 0, 1, CommandArgument.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getCommandArgument_Description(), ecorePackage.getEString(), "description", null, 0, 1, CommandArgument.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getCommandArgument_Required(), ecorePackage.getEBoolean(), "required", null, 0, 1, CommandArgument.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getCommandArgument_Skip_key(), ecorePackage.getEBoolean(), "skip_key", null, 0, 1, CommandArgument.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getCommandArgument_Set_if(), ecorePackage.getEString(), "set_if", null, 0, 1, CommandArgument.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getCommandArgument_Order(), ecorePackage.getEBoolean(), "order", null, 0, 1, CommandArgument.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getCommandArgument_Repeat_key(), ecorePackage.getEBoolean(), "repeat_key", null, 0, 1, CommandArgument.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(commandEnvEClass, CommandEnv.class, "CommandEnv", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getCommandEnv_Value(), ecorePackage.getEString(), "value", null, 0, -1, CommandEnv.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getCommandEnv_Key(), ecorePackage.getEString(), "key", null, 0, 1, CommandEnv.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(databaseCleanupEClass, DatabaseCleanup.class, "DatabaseCleanup", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getDatabaseCleanup_Acknowledgements_age(), ecorePackage.getEInt(), "acknowledgements_age", null, 0, 1, DatabaseCleanup.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getDatabaseCleanup_Commenthistory_age(), ecorePackage.getEInt(), "commenthistory_age", null, 0, 1, DatabaseCleanup.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getDatabaseCleanup_Contactnotifications_age(), ecorePackage.getEInt(), "contactnotifications_age", null, 0, 1, DatabaseCleanup.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getDatabaseCleanup_Contactnotificationmethods_age(), ecorePackage.getEInt(), "contactnotificationmethods_age", null, 0, 1, DatabaseCleanup.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getDatabaseCleanup_Downtimehistory_age(), ecorePackage.getEInt(), "downtimehistory_age", null, 0, 1, DatabaseCleanup.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getDatabaseCleanup_Eventhandlers_age(), ecorePackage.getEInt(), "eventhandlers_age", null, 0, 1, DatabaseCleanup.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getDatabaseCleanup_Externalcommands_age(), ecorePackage.getEInt(), "externalcommands_age", null, 0, 1, DatabaseCleanup.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getDatabaseCleanup_Flappinghistory_age(), ecorePackage.getEInt(), "flappinghistory_age", null, 0, 1, DatabaseCleanup.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getDatabaseCleanup_Hostchecks_age(), ecorePackage.getEInt(), "hostchecks_age", null, 0, 1, DatabaseCleanup.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getDatabaseCleanup_Logentries_age(), ecorePackage.getEInt(), "logentries_age", null, 0, 1, DatabaseCleanup.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getDatabaseCleanup_Notifications_age(), ecorePackage.getEInt(), "notifications_age", null, 0, 1, DatabaseCleanup.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getDatabaseCleanup_Processevents_age(), ecorePackage.getEInt(), "processevents_age", null, 0, 1, DatabaseCleanup.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getDatabaseCleanup_Statehistory_age(), ecorePackage.getEInt(), "statehistory_age", null, 0, 1, DatabaseCleanup.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getDatabaseCleanup_Servicechecks_age(), ecorePackage.getEInt(), "servicechecks_age", null, 0, 1, DatabaseCleanup.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getDatabaseCleanup_Systemcommands_age(), ecorePackage.getEInt(), "systemcommands_age", null, 0, 1, DatabaseCleanup.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(timeRangeEClass, TimeRange.class, "TimeRange", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getTimeRange_Directive(), ecorePackage.getEString(), "directive", null, 0, 1, TimeRange.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getTimeRange_Value(), ecorePackage.getEString(), "value", null, 0, 1, TimeRange.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(notificationTimesEClass, NotificationTimes.class, "NotificationTimes", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getNotificationTimes_Begin(), ecorePackage.getEString(), "begin", null, 1, 1, NotificationTimes.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getNotificationTimes_End(), ecorePackage.getEString(), "end", null, 1, 1, NotificationTimes.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(checkableEClass, Checkable.class, "Checkable", IS_ABSTRACT, IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getCheckable_Dependencies(), this.getDependency(), this.getDependency_Parent(), "dependencies", null, 0, -1, Checkable.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getCheckable_Notifications(), this.getNotification(), this.getNotification_Checkable(), "notifications", null, 0, -1, Checkable.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getCheckable_ScheduledDowntimes(), this.getScheduledDowntime(), this.getScheduledDowntime_Checkable(), "scheduledDowntimes", null, 0, -1, Checkable.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(zoneElementEClass, ZoneElement.class, "ZoneElement", IS_ABSTRACT, IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getZoneElement_Zone(), this.getZone(), this.getZone_Elements(), "zone", null, 0, 1, ZoneElement.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(configurationObjectEClass, ConfigurationObject.class, "ConfigurationObject", IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getConfigurationObject_Name(), ecorePackage.getEString(), "name", null, 0, 1, ConfigurationObject.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getConfigurationObject_Import(), ecorePackage.getEString(), "import", null, 0, -1, ConfigurationObject.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(commandEClass, Command.class, "Command", IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getCommand_Execute(), ecorePackage.getEString(), "execute", null, 1, 1, Command.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getCommand_Command(), ecorePackage.getEString(), "command", null, 1, -1, Command.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getCommand_Env(), this.getCommandEnv(), null, "env", null, 0, -1, Command.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		getCommand_Env().getEKeys().add(this.getCommandEnv_Key());
		initEReference(getCommand_Vars(), this.getUserVar(), null, "vars", null, 0, -1, Command.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		getCommand_Vars().getEKeys().add(this.getUserVar_Key());
		initEAttribute(getCommand_Timeout(), ecorePackage.getEInt(), "timeout", null, 0, 1, Command.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getCommand_Arguments(), this.getCommandArgument(), null, "arguments", null, 0, -1, Command.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		getCommand_Arguments().getEKeys().add(this.getCommandArgument_Key());

		initEClass(checkCommandEClass, CheckCommand.class, "CheckCommand", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(notificationCommandEClass, NotificationCommand.class, "NotificationCommand", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(eventCommandEClass, EventCommand.class, "EventCommand", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(scheduledDowntimeEClass, ScheduledDowntime.class, "ScheduledDowntime", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getScheduledDowntime_Checkable(), this.getCheckable(), this.getCheckable_ScheduledDowntimes(), "checkable", null, 1, 1, ScheduledDowntime.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getScheduledDowntime_Author(), ecorePackage.getEString(), "author", null, 1, 1, ScheduledDowntime.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getScheduledDowntime_Comment(), ecorePackage.getEString(), "comment", null, 1, 1, ScheduledDowntime.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getScheduledDowntime_Fixed(), ecorePackage.getEBoolean(), "fixed", null, 0, 1, ScheduledDowntime.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getScheduledDowntime_Duration(), ecorePackage.getEString(), "duration", null, 0, 1, ScheduledDowntime.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getScheduledDowntime_Ranges(), this.getTimeRange(), null, "ranges", null, 0, -1, ScheduledDowntime.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(dependencyEClass, Dependency.class, "Dependency", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getDependency_Parent(), this.getCheckable(), this.getCheckable_Dependencies(), "parent", null, 1, 1, Dependency.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getDependency_Child(), this.getCheckable(), null, "child", null, 1, 1, Dependency.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getDependency_Disable_checks(), ecorePackage.getEBoolean(), "disable_checks", null, 0, 1, Dependency.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getDependency_Disable_notifications(), ecorePackage.getEBoolean(), "disable_notifications", null, 0, 1, Dependency.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getDependency_Ignore_soft_states(), ecorePackage.getEBoolean(), "ignore_soft_states", null, 0, 1, Dependency.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getDependency_Period(), this.getTimePeriod(), null, "period", null, 0, 1, Dependency.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getDependency_States(), this.getState(), "states", null, 0, -1, Dependency.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(notificationEClass, Notification.class, "Notification", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getNotification_Checkable(), this.getCheckable(), this.getCheckable_Notifications(), "checkable", null, 1, 1, Notification.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getNotification_Vars(), this.getUserVar(), null, "vars", null, 0, -1, Notification.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		getNotification_Vars().getEKeys().add(this.getUserVar_Key());
		initEReference(getNotification_Users(), this.getUser(), null, "users", null, 0, -1, Notification.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getNotification_User_groups(), this.getUserGroup(), null, "user_groups", null, 0, -1, Notification.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getNotification_Times(), this.getNotificationTimes(), null, "times", null, 0, 1, Notification.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getNotification_Command(), this.getNotificationCommand(), null, "command", null, 1, 1, Notification.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getNotification_Interval(), ecorePackage.getEInt(), "interval", null, 0, 1, Notification.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getNotification_Period(), this.getTimePeriod(), null, "period", null, 0, 1, Notification.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getNotification_Types(), this.getNotificationType(), "types", null, 0, -1, Notification.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getNotification_States(), this.getState(), "states", null, 0, -1, Notification.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(timePeriodEClass, TimePeriod.class, "TimePeriod", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getTimePeriod_Display_name(), ecorePackage.getEString(), "display_name", null, 0, 1, TimePeriod.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getTimePeriod_Update(), ecorePackage.getEString(), "update", null, 1, 1, TimePeriod.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getTimePeriod_Ranges(), this.getTimeRange(), null, "ranges", null, 1, -1, TimePeriod.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(hostEClass, Host.class, "Host", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getHost_Display_name(), ecorePackage.getEString(), "display_name", null, 0, 1, Host.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getHost_Address(), ecorePackage.getEString(), "address", null, 0, 1, Host.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getHost_Address6(), ecorePackage.getEString(), "address6", null, 0, 1, Host.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getHost_Groups(), this.getHostGroup(), null, "groups", null, 0, -1, Host.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getHost_Vars(), this.getUserVar(), null, "vars", null, 0, -1, Host.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		getHost_Vars().getEKeys().add(this.getUserVar_Key());
		initEReference(getHost_Check_command(), this.getCheckCommand(), null, "check_command", null, 1, 1, Host.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getHost_Max_check_attempts(), ecorePackage.getEInt(), "max_check_attempts", null, 0, 1, Host.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getHost_Check_period(), this.getTimePeriod(), null, "check_period", null, 0, 1, Host.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getHost_Check_interval(), ecorePackage.getEInt(), "check_interval", null, 0, 1, Host.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getHost_Retry_interval(), ecorePackage.getEInt(), "retry_interval", null, 0, 1, Host.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getHost_Enable_notifications(), ecorePackage.getEBoolean(), "enable_notifications", null, 0, 1, Host.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getHost_Enable_active_checks(), ecorePackage.getEBoolean(), "enable_active_checks", null, 0, 1, Host.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getHost_Enable_passive_checks(), ecorePackage.getEBoolean(), "enable_passive_checks", null, 0, 1, Host.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getHost_Enable_event_handler(), ecorePackage.getEBoolean(), "enable_event_handler", null, 0, 1, Host.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getHost_Enable_flapping(), ecorePackage.getEBoolean(), "enable_flapping", null, 0, 1, Host.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getHost_Enable_perfdata(), ecorePackage.getEBoolean(), "enable_perfdata", null, 0, 1, Host.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getHost_Event_command(), this.getEventCommand(), null, "event_command", null, 0, 1, Host.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getHost_Flapping_threshold(), ecorePackage.getEDouble(), "flapping_threshold", null, 0, 1, Host.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getHost_Volatile(), ecorePackage.getEBoolean(), "volatile", null, 0, 1, Host.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getHost_Command_endpoint(), this.getEndpoint(), null, "command_endpoint", null, 0, 1, Host.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getHost_Notes(), ecorePackage.getEString(), "notes", null, 0, 1, Host.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getHost_Notes_url(), ecorePackage.getEString(), "notes_url", null, 0, 1, Host.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getHost_Action_url(), ecorePackage.getEString(), "action_url", null, 0, 1, Host.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getHost_Icon_image(), ecorePackage.getEString(), "icon_image", null, 0, 1, Host.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getHost_Icon_image_alt(), ecorePackage.getEString(), "icon_image_alt", null, 0, 1, Host.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getHost_Services(), this.getService(), this.getService_Host(), "services", null, 0, -1, Host.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(hostGroupEClass, HostGroup.class, "HostGroup", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getHostGroup_Display_name(), ecorePackage.getEString(), "display_name", null, 0, 1, HostGroup.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getHostGroup_Groups(), this.getHostGroup(), null, "groups", null, 0, -1, HostGroup.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(serviceEClass, Service.class, "Service", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getService_Display_name(), ecorePackage.getEString(), "display_name", null, 0, 1, Service.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getService_Host(), this.getHost(), this.getHost_Services(), "host", null, 1, 1, Service.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getService_Groups(), this.getServiceGroup(), null, "groups", null, 0, -1, Service.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getService_Vars(), this.getUserVar(), null, "vars", null, 0, -1, Service.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		getService_Vars().getEKeys().add(this.getUserVar_Key());
		initEReference(getService_Check_command(), this.getCheckCommand(), null, "check_command", null, 1, 1, Service.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getService_Max_check_attempts(), ecorePackage.getEInt(), "max_check_attempts", null, 0, 1, Service.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getService_Check_period(), this.getTimePeriod(), null, "check_period", null, 0, 1, Service.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getService_Check_interval(), ecorePackage.getEInt(), "check_interval", null, 0, 1, Service.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getService_Retry_interval(), ecorePackage.getEInt(), "retry_interval", null, 0, 1, Service.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getService_Enable_notifications(), ecorePackage.getEBoolean(), "enable_notifications", null, 0, 1, Service.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getService_Enable_active_checks(), ecorePackage.getEBoolean(), "enable_active_checks", null, 0, 1, Service.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getService_Enable_passive_checks(), ecorePackage.getEBoolean(), "enable_passive_checks", null, 0, 1, Service.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getService_Enable_event_handler(), ecorePackage.getEBoolean(), "enable_event_handler", null, 0, 1, Service.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getService_Enable_flapping(), ecorePackage.getEBoolean(), "enable_flapping", null, 0, 1, Service.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getService_Enable_perfdata(), ecorePackage.getEBoolean(), "enable_perfdata", null, 0, 1, Service.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getService_Event_command(), this.getEventCommand(), null, "event_command", null, 0, 1, Service.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getService_Flapping_threshold(), ecorePackage.getEDouble(), "flapping_threshold", null, 0, 1, Service.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getService_Volatile(), ecorePackage.getEBoolean(), "volatile", null, 0, 1, Service.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getService_Command_endpoint(), this.getEndpoint(), null, "command_endpoint", null, 0, 1, Service.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getService_Notes(), ecorePackage.getEString(), "notes", null, 0, 1, Service.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getService_Notes_url(), ecorePackage.getEString(), "notes_url", null, 0, 1, Service.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getService_Action_url(), ecorePackage.getEString(), "action_url", null, 0, 1, Service.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getService_Icon_image(), ecorePackage.getEString(), "icon_image", null, 0, 1, Service.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getService_Icon_image_alt(), ecorePackage.getEString(), "icon_image_alt", null, 0, 1, Service.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(serviceGroupEClass, ServiceGroup.class, "ServiceGroup", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getServiceGroup_Display_name(), ecorePackage.getEString(), "display_name", null, 0, 1, ServiceGroup.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getServiceGroup_Groups(), this.getServiceGroup(), null, "groups", null, 0, -1, ServiceGroup.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(userEClass, User.class, "User", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getUser_Display_name(), ecorePackage.getEString(), "display_name", null, 0, 1, User.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getUser_Email(), ecorePackage.getEString(), "email", null, 0, 1, User.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getUser_Pager(), ecorePackage.getEString(), "pager", null, 0, 1, User.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getUser_Vars(), this.getUserVar(), null, "vars", null, 0, -1, User.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		getUser_Vars().getEKeys().add(this.getUserVar_Key());
		initEReference(getUser_Groups(), this.getUserGroup(), null, "groups", null, 0, -1, User.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getUser_Enable_notifications(), ecorePackage.getEBoolean(), "enable_notifications", null, 0, 1, User.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getUser_Period(), this.getTimePeriod(), null, "period", null, 0, 1, User.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getUser_Types(), this.getNotificationType(), "types", null, 0, -1, User.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getUser_States(), this.getState(), "states", null, 0, -1, User.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(userGroupEClass, UserGroup.class, "UserGroup", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getUserGroup_Display_name(), ecorePackage.getEString(), "display_name", null, 0, 1, UserGroup.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getUserGroup_Groups(), this.getUserGroup(), null, "groups", null, 0, -1, UserGroup.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(zoneEClass, Zone.class, "Zone", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getZone_Endpoints(), this.getEndpoint(), null, "endpoints", null, 0, -1, Zone.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getZone_Parent(), this.getZone(), this.getZone_Subzones(), "parent", null, 0, 1, Zone.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getZone_Global(), ecorePackage.getEBoolean(), "global", null, 0, 1, Zone.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getZone_Elements(), this.getZoneElement(), this.getZoneElement_Zone(), "elements", null, 0, 1, Zone.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getZone_Subzones(), this.getZone(), this.getZone_Parent(), "subzones", null, 0, -1, Zone.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(endpointEClass, Endpoint.class, "Endpoint", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getEndpoint_Host(), ecorePackage.getEString(), "host", null, 0, 1, Endpoint.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getEndpoint_Port(), ecorePackage.getEShort(), "port", null, 0, 1, Endpoint.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getEndpoint_Log_duration(), ecorePackage.getEString(), "log_duration", null, 0, 1, Endpoint.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(checkerComponentEClass, CheckerComponent.class, "CheckerComponent", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(notificationComponentEClass, NotificationComponent.class, "NotificationComponent", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getNotificationComponent_Enable_ha(), ecorePackage.getEBoolean(), "enable_ha", null, 0, 1, NotificationComponent.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(checkResultReaderEClass, CheckResultReader.class, "CheckResultReader", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getCheckResultReader_Spool_dir(), ecorePackage.getEString(), "spool_dir", null, 0, 1, CheckResultReader.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(apiListenerEClass, ApiListener.class, "ApiListener", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getApiListener_Cert_path(), ecorePackage.getEString(), "cert_path", null, 1, 1, ApiListener.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getApiListener_Key_path(), ecorePackage.getEString(), "key_path", null, 1, 1, ApiListener.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getApiListener_Ca_path(), ecorePackage.getEString(), "ca_path", null, 1, 1, ApiListener.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getApiListener_Crl_path(), ecorePackage.getEString(), "crl_path", null, 0, 1, ApiListener.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getApiListener_Bind_host(), ecorePackage.getEString(), "bind_host", null, 0, 1, ApiListener.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getApiListener_Bind_port(), ecorePackage.getEShort(), "bind_port", null, 0, 1, ApiListener.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getApiListener_Accept_config(), ecorePackage.getEBoolean(), "accept_config", null, 0, 1, ApiListener.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getApiListener_Accept_commands(), ecorePackage.getEBoolean(), "accept_commands", null, 0, 1, ApiListener.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(liveStatusListenerEClass, LiveStatusListener.class, "LiveStatusListener", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getLiveStatusListener_Socket_type(), this.getSocketType(), "socket_type", null, 0, 1, LiveStatusListener.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getLiveStatusListener_Bind_host(), ecorePackage.getEString(), "bind_host", null, 0, 1, LiveStatusListener.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getLiveStatusListener_Bind_port(), ecorePackage.getEShort(), "bind_port", null, 0, 1, LiveStatusListener.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getLiveStatusListener_Socket_path(), ecorePackage.getEString(), "socket_path", null, 0, 1, LiveStatusListener.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getLiveStatusListener_Compat_log_path(), ecorePackage.getEString(), "compat_log_path", null, 0, 1, LiveStatusListener.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(externalCommandListenerEClass, ExternalCommandListener.class, "ExternalCommandListener", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getExternalCommandListener_Command_path(), ecorePackage.getEString(), "command_path", null, 0, 1, ExternalCommandListener.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(compatLoggerEClass, CompatLogger.class, "CompatLogger", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getCompatLogger_Log_dir(), ecorePackage.getEString(), "log_dir", null, 0, 1, CompatLogger.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getCompatLogger_Rotation_method(), this.getLogRotationMethod(), "rotation_method", null, 0, 1, CompatLogger.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(fileLoggerEClass, FileLogger.class, "FileLogger", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getFileLogger_Path(), ecorePackage.getEString(), "path", null, 1, 1, FileLogger.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getFileLogger_Severity(), this.getLogSeverity(), "severity", null, 0, 1, FileLogger.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(syslogLoggerEClass, SyslogLogger.class, "SyslogLogger", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getSyslogLogger_Severity(), this.getLogSeverity(), "severity", null, 0, 1, SyslogLogger.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(gelfWriterEClass, GelfWriter.class, "GelfWriter", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getGelfWriter_Host(), ecorePackage.getEString(), "host", null, 0, 1, GelfWriter.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getGelfWriter_Port(), ecorePackage.getEShort(), "port", null, 0, 1, GelfWriter.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getGelfWriter_Source(), ecorePackage.getEString(), "source", null, 0, 1, GelfWriter.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(graphiteWriterEClass, GraphiteWriter.class, "GraphiteWriter", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getGraphiteWriter_Host(), ecorePackage.getEString(), "host", null, 0, 1, GraphiteWriter.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getGraphiteWriter_Port(), ecorePackage.getEShort(), "port", null, 0, 1, GraphiteWriter.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getGraphiteWriter_Host_name_template(), ecorePackage.getEString(), "host_name_template", null, 0, 1, GraphiteWriter.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getGraphiteWriter_Service_name_template(), ecorePackage.getEString(), "service_name_template", null, 0, 1, GraphiteWriter.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(icingaStatusWriterEClass, IcingaStatusWriter.class, "IcingaStatusWriter", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getIcingaStatusWriter_Status_path(), ecorePackage.getEString(), "status_path", null, 0, 1, IcingaStatusWriter.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getIcingaStatusWriter_Update_interval(), ecorePackage.getEString(), "update_interval", null, 0, 1, IcingaStatusWriter.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(openTsdbWriterEClass, OpenTsdbWriter.class, "OpenTsdbWriter", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getOpenTsdbWriter_Host(), ecorePackage.getEString(), "host", null, 0, 1, OpenTsdbWriter.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getOpenTsdbWriter_Port(), ecorePackage.getEShort(), "port", null, 0, 1, OpenTsdbWriter.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(perfdataWriterEClass, PerfdataWriter.class, "PerfdataWriter", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getPerfdataWriter_Host_perfdata_path(), ecorePackage.getEString(), "host_perfdata_path", null, 0, 1, PerfdataWriter.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getPerfdataWriter_Service_perfdata_path(), ecorePackage.getEString(), "service_perfdata_path", null, 0, 1, PerfdataWriter.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getPerfdataWriter_Host_temp_path(), ecorePackage.getEString(), "host_temp_path", null, 0, 1, PerfdataWriter.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getPerfdataWriter_Service_temp_path(), ecorePackage.getEString(), "service_temp_path", null, 0, 1, PerfdataWriter.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getPerfdataWriter_Host_format_template(), ecorePackage.getEString(), "host_format_template", null, 0, 1, PerfdataWriter.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getPerfdataWriter_Service_format_template(), ecorePackage.getEString(), "service_format_template", null, 0, 1, PerfdataWriter.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getPerfdataWriter_Rotation_interval(), ecorePackage.getEInt(), "rotation_interval", null, 0, 1, PerfdataWriter.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(statusDataWriterEClass, StatusDataWriter.class, "StatusDataWriter", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getStatusDataWriter_Status_path(), ecorePackage.getEString(), "status_path", null, 0, 1, StatusDataWriter.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getStatusDataWriter_Objects_path(), ecorePackage.getEString(), "objects_path", null, 0, 1, StatusDataWriter.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getStatusDataWriter_Update_interval(), ecorePackage.getEString(), "update_interval", null, 0, 1, StatusDataWriter.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(idoConnectionEClass, IdoConnection.class, "IdoConnection", IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getIdoConnection_Host(), ecorePackage.getEString(), "host", null, 0, 1, IdoConnection.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getIdoConnection_Port(), ecorePackage.getEShort(), "port", null, 0, 1, IdoConnection.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getIdoConnection_User(), ecorePackage.getEString(), "user", null, 0, 1, IdoConnection.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getIdoConnection_Password(), ecorePackage.getEString(), "password", null, 0, 1, IdoConnection.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getIdoConnection_Database(), ecorePackage.getEString(), "database", null, 0, 1, IdoConnection.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getIdoConnection_Table_prefix(), ecorePackage.getEString(), "table_prefix", null, 0, 1, IdoConnection.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getIdoConnection_Instance_name(), ecorePackage.getEString(), "instance_name", null, 0, 1, IdoConnection.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getIdoConnection_Instance_description(), ecorePackage.getEString(), "instance_description", null, 0, 1, IdoConnection.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getIdoConnection_Enable_ha(), ecorePackage.getEBoolean(), "enable_ha", null, 0, 1, IdoConnection.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getIdoConnection_Failover_timeout(), ecorePackage.getEString(), "failover_timeout", null, 0, 1, IdoConnection.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getIdoConnection_Cleanup(), this.getDatabaseCleanup(), null, "cleanup", null, 0, 1, IdoConnection.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getIdoConnection_Categories(), this.getDatabaseCategory(), "categories", null, 0, -1, IdoConnection.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(idoMySqlConnectionEClass, IdoMySqlConnection.class, "IdoMySqlConnection", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getIdoMySqlConnection_Socket_path(), ecorePackage.getEString(), "socket_path", null, 0, 1, IdoMySqlConnection.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(idoPgSqlConnectionEClass, IdoPgSqlConnection.class, "IdoPgSqlConnection", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		// Initialize enums and add enum literals
		initEEnum(databaseCategoryEEnum, DatabaseCategory.class, "DatabaseCategory");
		addEEnumLiteral(databaseCategoryEEnum, DatabaseCategory.DB_CAT_CONFIG);
		addEEnumLiteral(databaseCategoryEEnum, DatabaseCategory.DB_CAT_STATE);
		addEEnumLiteral(databaseCategoryEEnum, DatabaseCategory.DB_CAT_ACKNOWLEDGEMENT);
		addEEnumLiteral(databaseCategoryEEnum, DatabaseCategory.DB_CAT_COMMENT);
		addEEnumLiteral(databaseCategoryEEnum, DatabaseCategory.DB_CAT_DOWNTIME);
		addEEnumLiteral(databaseCategoryEEnum, DatabaseCategory.DB_CAT_EVENT_HANDLER);
		addEEnumLiteral(databaseCategoryEEnum, DatabaseCategory.DB_CAT_EXTERNAL_COMMAND);
		addEEnumLiteral(databaseCategoryEEnum, DatabaseCategory.DB_CAT_FLAPPING);
		addEEnumLiteral(databaseCategoryEEnum, DatabaseCategory.DB_CAT_CHECK);
		addEEnumLiteral(databaseCategoryEEnum, DatabaseCategory.DB_CAT_LOG);
		addEEnumLiteral(databaseCategoryEEnum, DatabaseCategory.DB_CAT_NOTIFICATION);
		addEEnumLiteral(databaseCategoryEEnum, DatabaseCategory.DB_CAT_PROGRAM_STATUS);
		addEEnumLiteral(databaseCategoryEEnum, DatabaseCategory.DB_CAT_RETENTION);
		addEEnumLiteral(databaseCategoryEEnum, DatabaseCategory.DB_CAT_STATE_HISTORY);
		addEEnumLiteral(databaseCategoryEEnum, DatabaseCategory.DB_CAT_EVERYTHING);

		initEEnum(notificationTypeEEnum, NotificationType.class, "NotificationType");
		addEEnumLiteral(notificationTypeEEnum, NotificationType.DOWNTIME_START);
		addEEnumLiteral(notificationTypeEEnum, NotificationType.DOWNTIME_END);
		addEEnumLiteral(notificationTypeEEnum, NotificationType.DOWNTIME_REMOVED);
		addEEnumLiteral(notificationTypeEEnum, NotificationType.CUSTOM);
		addEEnumLiteral(notificationTypeEEnum, NotificationType.ACKNOWLEDGEMENT);
		addEEnumLiteral(notificationTypeEEnum, NotificationType.PROBLEM);
		addEEnumLiteral(notificationTypeEEnum, NotificationType.RECOVERY);
		addEEnumLiteral(notificationTypeEEnum, NotificationType.FLAPPING_START);
		addEEnumLiteral(notificationTypeEEnum, NotificationType.FLAPPING_END);

		initEEnum(logRotationMethodEEnum, LogRotationMethod.class, "LogRotationMethod");
		addEEnumLiteral(logRotationMethodEEnum, LogRotationMethod.HOURLY);
		addEEnumLiteral(logRotationMethodEEnum, LogRotationMethod.DAILY);
		addEEnumLiteral(logRotationMethodEEnum, LogRotationMethod.WEEKLY);
		addEEnumLiteral(logRotationMethodEEnum, LogRotationMethod.MONTHLY);

		initEEnum(logSeverityEEnum, LogSeverity.class, "LogSeverity");
		addEEnumLiteral(logSeverityEEnum, LogSeverity.DEBUG);
		addEEnumLiteral(logSeverityEEnum, LogSeverity.NOTICE);
		addEEnumLiteral(logSeverityEEnum, LogSeverity.INFORMATION);
		addEEnumLiteral(logSeverityEEnum, LogSeverity.WARNING);
		addEEnumLiteral(logSeverityEEnum, LogSeverity.CRITICAL);

		initEEnum(socketTypeEEnum, SocketType.class, "SocketType");
		addEEnumLiteral(socketTypeEEnum, SocketType.TCP);
		addEEnumLiteral(socketTypeEEnum, SocketType.UNIX);

		initEEnum(stateEEnum, State.class, "State");
		addEEnumLiteral(stateEEnum, State.OK);
		addEEnumLiteral(stateEEnum, State.WARNING);
		addEEnumLiteral(stateEEnum, State.CRITICAL);
		addEEnumLiteral(stateEEnum, State.UNKNOWN);
		addEEnumLiteral(stateEEnum, State.UP);
		addEEnumLiteral(stateEEnum, State.DOWN);

		// Create resource
		createResource(eNS_URI);
	}

} //IcingaPackageImpl
