/**
 */
package it.unibo.cmdb.monitoring.model.icinga.util;

import org.eclipse.emf.common.notify.Adapter;
import org.eclipse.emf.common.notify.Notifier;

import org.eclipse.emf.common.notify.impl.AdapterFactoryImpl;

import org.eclipse.emf.ecore.EObject;

import it.unibo.cmdb.monitoring.model.icinga.*;

/**
 * <!-- begin-user-doc -->
 * The <b>Adapter Factory</b> for the model.
 * It provides an adapter <code>createXXX</code> method for each class of the model.
 * <!-- end-user-doc -->
 * @see it.unibo.cmdb.monitoring.model.icinga.IcingaPackage
 * @generated
 */
public class IcingaAdapterFactory extends AdapterFactoryImpl {
	/**
	 * The cached model package.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected static IcingaPackage modelPackage;

	/**
	 * Creates an instance of the adapter factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public IcingaAdapterFactory() {
		if (modelPackage == null) {
			modelPackage = IcingaPackage.eINSTANCE;
		}
	}

	/**
	 * Returns whether this factory is applicable for the type of the object.
	 * <!-- begin-user-doc -->
	 * This implementation returns <code>true</code> if the object is either the model's package or is an instance object of the model.
	 * <!-- end-user-doc -->
	 * @return whether this factory is applicable for the type of the object.
	 * @generated
	 */
	@Override
	public boolean isFactoryForType(Object object) {
		if (object == modelPackage) {
			return true;
		}
		if (object instanceof EObject) {
			return ((EObject)object).eClass().getEPackage() == modelPackage;
		}
		return false;
	}

	/**
	 * The switch that delegates to the <code>createXXX</code> methods.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected IcingaSwitch<Adapter> modelSwitch =
		new IcingaSwitch<Adapter>() {
			@Override
			public Adapter caseUserVar(UserVar object) {
				return createUserVarAdapter();
			}
			@Override
			public Adapter caseUserValue(UserValue object) {
				return createUserValueAdapter();
			}
			@Override
			public <T> Adapter caseSimpleUserValue(SimpleUserValue<T> object) {
				return createSimpleUserValueAdapter();
			}
			@Override
			public Adapter caseStringUserValue(StringUserValue object) {
				return createStringUserValueAdapter();
			}
			@Override
			public Adapter caseNumericUserValue(NumericUserValue object) {
				return createNumericUserValueAdapter();
			}
			@Override
			public Adapter caseComplexUserValue(ComplexUserValue object) {
				return createComplexUserValueAdapter();
			}
			@Override
			public Adapter caseCommandArgument(CommandArgument object) {
				return createCommandArgumentAdapter();
			}
			@Override
			public Adapter caseCommandEnv(CommandEnv object) {
				return createCommandEnvAdapter();
			}
			@Override
			public Adapter caseDatabaseCleanup(DatabaseCleanup object) {
				return createDatabaseCleanupAdapter();
			}
			@Override
			public Adapter caseTimeRange(TimeRange object) {
				return createTimeRangeAdapter();
			}
			@Override
			public Adapter caseNotificationTimes(NotificationTimes object) {
				return createNotificationTimesAdapter();
			}
			@Override
			public Adapter caseCheckable(Checkable object) {
				return createCheckableAdapter();
			}
			@Override
			public Adapter caseZoneElement(ZoneElement object) {
				return createZoneElementAdapter();
			}
			@Override
			public Adapter caseConfigurationObject(ConfigurationObject object) {
				return createConfigurationObjectAdapter();
			}
			@Override
			public Adapter caseCommand(Command object) {
				return createCommandAdapter();
			}
			@Override
			public Adapter caseCheckCommand(CheckCommand object) {
				return createCheckCommandAdapter();
			}
			@Override
			public Adapter caseNotificationCommand(NotificationCommand object) {
				return createNotificationCommandAdapter();
			}
			@Override
			public Adapter caseEventCommand(EventCommand object) {
				return createEventCommandAdapter();
			}
			@Override
			public Adapter caseScheduledDowntime(ScheduledDowntime object) {
				return createScheduledDowntimeAdapter();
			}
			@Override
			public Adapter caseDependency(Dependency object) {
				return createDependencyAdapter();
			}
			@Override
			public Adapter caseNotification(Notification object) {
				return createNotificationAdapter();
			}
			@Override
			public Adapter caseTimePeriod(TimePeriod object) {
				return createTimePeriodAdapter();
			}
			@Override
			public Adapter caseHost(Host object) {
				return createHostAdapter();
			}
			@Override
			public Adapter caseHostGroup(HostGroup object) {
				return createHostGroupAdapter();
			}
			@Override
			public Adapter caseService(Service object) {
				return createServiceAdapter();
			}
			@Override
			public Adapter caseServiceGroup(ServiceGroup object) {
				return createServiceGroupAdapter();
			}
			@Override
			public Adapter caseUser(User object) {
				return createUserAdapter();
			}
			@Override
			public Adapter caseUserGroup(UserGroup object) {
				return createUserGroupAdapter();
			}
			@Override
			public Adapter caseZone(Zone object) {
				return createZoneAdapter();
			}
			@Override
			public Adapter caseEndpoint(Endpoint object) {
				return createEndpointAdapter();
			}
			@Override
			public Adapter caseCheckerComponent(CheckerComponent object) {
				return createCheckerComponentAdapter();
			}
			@Override
			public Adapter caseNotificationComponent(NotificationComponent object) {
				return createNotificationComponentAdapter();
			}
			@Override
			public Adapter caseCheckResultReader(CheckResultReader object) {
				return createCheckResultReaderAdapter();
			}
			@Override
			public Adapter caseApiListener(ApiListener object) {
				return createApiListenerAdapter();
			}
			@Override
			public Adapter caseLiveStatusListener(LiveStatusListener object) {
				return createLiveStatusListenerAdapter();
			}
			@Override
			public Adapter caseExternalCommandListener(ExternalCommandListener object) {
				return createExternalCommandListenerAdapter();
			}
			@Override
			public Adapter caseCompatLogger(CompatLogger object) {
				return createCompatLoggerAdapter();
			}
			@Override
			public Adapter caseFileLogger(FileLogger object) {
				return createFileLoggerAdapter();
			}
			@Override
			public Adapter caseSyslogLogger(SyslogLogger object) {
				return createSyslogLoggerAdapter();
			}
			@Override
			public Adapter caseGelfWriter(GelfWriter object) {
				return createGelfWriterAdapter();
			}
			@Override
			public Adapter caseGraphiteWriter(GraphiteWriter object) {
				return createGraphiteWriterAdapter();
			}
			@Override
			public Adapter caseIcingaStatusWriter(IcingaStatusWriter object) {
				return createIcingaStatusWriterAdapter();
			}
			@Override
			public Adapter caseOpenTsdbWriter(OpenTsdbWriter object) {
				return createOpenTsdbWriterAdapter();
			}
			@Override
			public Adapter casePerfdataWriter(PerfdataWriter object) {
				return createPerfdataWriterAdapter();
			}
			@Override
			public Adapter caseStatusDataWriter(StatusDataWriter object) {
				return createStatusDataWriterAdapter();
			}
			@Override
			public Adapter caseIdoConnection(IdoConnection object) {
				return createIdoConnectionAdapter();
			}
			@Override
			public Adapter caseIdoMySqlConnection(IdoMySqlConnection object) {
				return createIdoMySqlConnectionAdapter();
			}
			@Override
			public Adapter caseIdoPgSqlConnection(IdoPgSqlConnection object) {
				return createIdoPgSqlConnectionAdapter();
			}
			@Override
			public Adapter defaultCase(EObject object) {
				return createEObjectAdapter();
			}
		};

	/**
	 * Creates an adapter for the <code>target</code>.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param target the object to adapt.
	 * @return the adapter for the <code>target</code>.
	 * @generated
	 */
	@Override
	public Adapter createAdapter(Notifier target) {
		return modelSwitch.doSwitch((EObject)target);
	}


	/**
	 * Creates a new adapter for an object of class '{@link it.unibo.cmdb.monitoring.model.icinga.UserVar <em>User Var</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see it.unibo.cmdb.monitoring.model.icinga.UserVar
	 * @generated
	 */
	public Adapter createUserVarAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link it.unibo.cmdb.monitoring.model.icinga.UserValue <em>User Value</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see it.unibo.cmdb.monitoring.model.icinga.UserValue
	 * @generated
	 */
	public Adapter createUserValueAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link it.unibo.cmdb.monitoring.model.icinga.SimpleUserValue <em>Simple User Value</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see it.unibo.cmdb.monitoring.model.icinga.SimpleUserValue
	 * @generated
	 */
	public Adapter createSimpleUserValueAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link it.unibo.cmdb.monitoring.model.icinga.StringUserValue <em>String User Value</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see it.unibo.cmdb.monitoring.model.icinga.StringUserValue
	 * @generated
	 */
	public Adapter createStringUserValueAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link it.unibo.cmdb.monitoring.model.icinga.NumericUserValue <em>Numeric User Value</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see it.unibo.cmdb.monitoring.model.icinga.NumericUserValue
	 * @generated
	 */
	public Adapter createNumericUserValueAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link it.unibo.cmdb.monitoring.model.icinga.ComplexUserValue <em>Complex User Value</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see it.unibo.cmdb.monitoring.model.icinga.ComplexUserValue
	 * @generated
	 */
	public Adapter createComplexUserValueAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link it.unibo.cmdb.monitoring.model.icinga.CommandArgument <em>Command Argument</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see it.unibo.cmdb.monitoring.model.icinga.CommandArgument
	 * @generated
	 */
	public Adapter createCommandArgumentAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link it.unibo.cmdb.monitoring.model.icinga.CommandEnv <em>Command Env</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see it.unibo.cmdb.monitoring.model.icinga.CommandEnv
	 * @generated
	 */
	public Adapter createCommandEnvAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link it.unibo.cmdb.monitoring.model.icinga.DatabaseCleanup <em>Database Cleanup</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see it.unibo.cmdb.monitoring.model.icinga.DatabaseCleanup
	 * @generated
	 */
	public Adapter createDatabaseCleanupAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link it.unibo.cmdb.monitoring.model.icinga.TimeRange <em>Time Range</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see it.unibo.cmdb.monitoring.model.icinga.TimeRange
	 * @generated
	 */
	public Adapter createTimeRangeAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link it.unibo.cmdb.monitoring.model.icinga.NotificationTimes <em>Notification Times</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see it.unibo.cmdb.monitoring.model.icinga.NotificationTimes
	 * @generated
	 */
	public Adapter createNotificationTimesAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link it.unibo.cmdb.monitoring.model.icinga.Checkable <em>Checkable</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see it.unibo.cmdb.monitoring.model.icinga.Checkable
	 * @generated
	 */
	public Adapter createCheckableAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link it.unibo.cmdb.monitoring.model.icinga.ZoneElement <em>Zone Element</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see it.unibo.cmdb.monitoring.model.icinga.ZoneElement
	 * @generated
	 */
	public Adapter createZoneElementAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link it.unibo.cmdb.monitoring.model.icinga.ConfigurationObject <em>Configuration Object</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see it.unibo.cmdb.monitoring.model.icinga.ConfigurationObject
	 * @generated
	 */
	public Adapter createConfigurationObjectAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link it.unibo.cmdb.monitoring.model.icinga.Command <em>Command</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see it.unibo.cmdb.monitoring.model.icinga.Command
	 * @generated
	 */
	public Adapter createCommandAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link it.unibo.cmdb.monitoring.model.icinga.CheckCommand <em>Check Command</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see it.unibo.cmdb.monitoring.model.icinga.CheckCommand
	 * @generated
	 */
	public Adapter createCheckCommandAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link it.unibo.cmdb.monitoring.model.icinga.NotificationCommand <em>Notification Command</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see it.unibo.cmdb.monitoring.model.icinga.NotificationCommand
	 * @generated
	 */
	public Adapter createNotificationCommandAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link it.unibo.cmdb.monitoring.model.icinga.EventCommand <em>Event Command</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see it.unibo.cmdb.monitoring.model.icinga.EventCommand
	 * @generated
	 */
	public Adapter createEventCommandAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link it.unibo.cmdb.monitoring.model.icinga.ScheduledDowntime <em>Scheduled Downtime</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see it.unibo.cmdb.monitoring.model.icinga.ScheduledDowntime
	 * @generated
	 */
	public Adapter createScheduledDowntimeAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link it.unibo.cmdb.monitoring.model.icinga.Dependency <em>Dependency</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see it.unibo.cmdb.monitoring.model.icinga.Dependency
	 * @generated
	 */
	public Adapter createDependencyAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link it.unibo.cmdb.monitoring.model.icinga.Notification <em>Notification</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see it.unibo.cmdb.monitoring.model.icinga.Notification
	 * @generated
	 */
	public Adapter createNotificationAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link it.unibo.cmdb.monitoring.model.icinga.TimePeriod <em>Time Period</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see it.unibo.cmdb.monitoring.model.icinga.TimePeriod
	 * @generated
	 */
	public Adapter createTimePeriodAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link it.unibo.cmdb.monitoring.model.icinga.Host <em>Host</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see it.unibo.cmdb.monitoring.model.icinga.Host
	 * @generated
	 */
	public Adapter createHostAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link it.unibo.cmdb.monitoring.model.icinga.HostGroup <em>Host Group</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see it.unibo.cmdb.monitoring.model.icinga.HostGroup
	 * @generated
	 */
	public Adapter createHostGroupAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link it.unibo.cmdb.monitoring.model.icinga.Service <em>Service</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see it.unibo.cmdb.monitoring.model.icinga.Service
	 * @generated
	 */
	public Adapter createServiceAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link it.unibo.cmdb.monitoring.model.icinga.ServiceGroup <em>Service Group</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see it.unibo.cmdb.monitoring.model.icinga.ServiceGroup
	 * @generated
	 */
	public Adapter createServiceGroupAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link it.unibo.cmdb.monitoring.model.icinga.User <em>User</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see it.unibo.cmdb.monitoring.model.icinga.User
	 * @generated
	 */
	public Adapter createUserAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link it.unibo.cmdb.monitoring.model.icinga.UserGroup <em>User Group</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see it.unibo.cmdb.monitoring.model.icinga.UserGroup
	 * @generated
	 */
	public Adapter createUserGroupAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link it.unibo.cmdb.monitoring.model.icinga.Zone <em>Zone</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see it.unibo.cmdb.monitoring.model.icinga.Zone
	 * @generated
	 */
	public Adapter createZoneAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link it.unibo.cmdb.monitoring.model.icinga.Endpoint <em>Endpoint</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see it.unibo.cmdb.monitoring.model.icinga.Endpoint
	 * @generated
	 */
	public Adapter createEndpointAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link it.unibo.cmdb.monitoring.model.icinga.CheckerComponent <em>Checker Component</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see it.unibo.cmdb.monitoring.model.icinga.CheckerComponent
	 * @generated
	 */
	public Adapter createCheckerComponentAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link it.unibo.cmdb.monitoring.model.icinga.NotificationComponent <em>Notification Component</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see it.unibo.cmdb.monitoring.model.icinga.NotificationComponent
	 * @generated
	 */
	public Adapter createNotificationComponentAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link it.unibo.cmdb.monitoring.model.icinga.CheckResultReader <em>Check Result Reader</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see it.unibo.cmdb.monitoring.model.icinga.CheckResultReader
	 * @generated
	 */
	public Adapter createCheckResultReaderAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link it.unibo.cmdb.monitoring.model.icinga.ApiListener <em>Api Listener</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see it.unibo.cmdb.monitoring.model.icinga.ApiListener
	 * @generated
	 */
	public Adapter createApiListenerAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link it.unibo.cmdb.monitoring.model.icinga.LiveStatusListener <em>Live Status Listener</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see it.unibo.cmdb.monitoring.model.icinga.LiveStatusListener
	 * @generated
	 */
	public Adapter createLiveStatusListenerAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link it.unibo.cmdb.monitoring.model.icinga.ExternalCommandListener <em>External Command Listener</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see it.unibo.cmdb.monitoring.model.icinga.ExternalCommandListener
	 * @generated
	 */
	public Adapter createExternalCommandListenerAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link it.unibo.cmdb.monitoring.model.icinga.CompatLogger <em>Compat Logger</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see it.unibo.cmdb.monitoring.model.icinga.CompatLogger
	 * @generated
	 */
	public Adapter createCompatLoggerAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link it.unibo.cmdb.monitoring.model.icinga.FileLogger <em>File Logger</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see it.unibo.cmdb.monitoring.model.icinga.FileLogger
	 * @generated
	 */
	public Adapter createFileLoggerAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link it.unibo.cmdb.monitoring.model.icinga.SyslogLogger <em>Syslog Logger</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see it.unibo.cmdb.monitoring.model.icinga.SyslogLogger
	 * @generated
	 */
	public Adapter createSyslogLoggerAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link it.unibo.cmdb.monitoring.model.icinga.GelfWriter <em>Gelf Writer</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see it.unibo.cmdb.monitoring.model.icinga.GelfWriter
	 * @generated
	 */
	public Adapter createGelfWriterAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link it.unibo.cmdb.monitoring.model.icinga.GraphiteWriter <em>Graphite Writer</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see it.unibo.cmdb.monitoring.model.icinga.GraphiteWriter
	 * @generated
	 */
	public Adapter createGraphiteWriterAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link it.unibo.cmdb.monitoring.model.icinga.IcingaStatusWriter <em>Status Writer</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see it.unibo.cmdb.monitoring.model.icinga.IcingaStatusWriter
	 * @generated
	 */
	public Adapter createIcingaStatusWriterAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link it.unibo.cmdb.monitoring.model.icinga.OpenTsdbWriter <em>Open Tsdb Writer</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see it.unibo.cmdb.monitoring.model.icinga.OpenTsdbWriter
	 * @generated
	 */
	public Adapter createOpenTsdbWriterAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link it.unibo.cmdb.monitoring.model.icinga.PerfdataWriter <em>Perfdata Writer</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see it.unibo.cmdb.monitoring.model.icinga.PerfdataWriter
	 * @generated
	 */
	public Adapter createPerfdataWriterAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link it.unibo.cmdb.monitoring.model.icinga.StatusDataWriter <em>Status Data Writer</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see it.unibo.cmdb.monitoring.model.icinga.StatusDataWriter
	 * @generated
	 */
	public Adapter createStatusDataWriterAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link it.unibo.cmdb.monitoring.model.icinga.IdoConnection <em>Ido Connection</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see it.unibo.cmdb.monitoring.model.icinga.IdoConnection
	 * @generated
	 */
	public Adapter createIdoConnectionAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link it.unibo.cmdb.monitoring.model.icinga.IdoMySqlConnection <em>Ido My Sql Connection</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see it.unibo.cmdb.monitoring.model.icinga.IdoMySqlConnection
	 * @generated
	 */
	public Adapter createIdoMySqlConnectionAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link it.unibo.cmdb.monitoring.model.icinga.IdoPgSqlConnection <em>Ido Pg Sql Connection</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see it.unibo.cmdb.monitoring.model.icinga.IdoPgSqlConnection
	 * @generated
	 */
	public Adapter createIdoPgSqlConnectionAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for the default case.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @generated
	 */
	public Adapter createEObjectAdapter() {
		return null;
	}

} //IcingaAdapterFactory
