/**
 */
package it.unibo.cmdb.cmdbf.client.model.cmdbf;

import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EOperation;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.EReference;

/**
 * <!-- begin-user-doc -->
 * The <b>Package</b> for the model.
 * It contains accessors for the meta objects to represent
 * <ul>
 *   <li>each class,</li>
 *   <li>each feature of each class,</li>
 *   <li>each operation of each class,</li>
 *   <li>each enum,</li>
 *   <li>and each data type</li>
 * </ul>
 * <!-- end-user-doc -->
 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.CmdbfFactory
 * @model kind="package"
 * @generated
 */
public interface CmdbfPackage extends EPackage {
	/**
	 * The package name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNAME = "cmdbf";

	/**
	 * The package namespace URI.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_URI = "http://schemas.dmtf.org/cmdbf/1/tns/serviceData";

	/**
	 * The package namespace name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_PREFIX = "cmdbf";

	/**
	 * The singleton instance of the package.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	CmdbfPackage eINSTANCE = it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.CmdbfPackageImpl.init();

	/**
	 * The meta object id for the '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.AcceptedTypeImpl <em>Accepted Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.AcceptedTypeImpl
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.CmdbfPackageImpl#getAcceptedType()
	 * @generated
	 */
	int ACCEPTED_TYPE = 0;

	/**
	 * The feature id for the '<em><b>Alternate Instance Id</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACCEPTED_TYPE__ALTERNATE_INSTANCE_ID = 0;

	/**
	 * The number of structural features of the '<em>Accepted Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACCEPTED_TYPE_FEATURE_COUNT = 1;

	/**
	 * The number of operations of the '<em>Accepted Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ACCEPTED_TYPE_OPERATION_COUNT = 0;

	/**
	 * The meta object id for the '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.ComparisonOperatorTypeImpl <em>Comparison Operator Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.ComparisonOperatorTypeImpl
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.CmdbfPackageImpl#getComparisonOperatorType()
	 * @generated
	 */
	int COMPARISON_OPERATOR_TYPE = 1;

	/**
	 * The feature id for the '<em><b>Value</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPARISON_OPERATOR_TYPE__VALUE = 0;

	/**
	 * The feature id for the '<em><b>Negate</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPARISON_OPERATOR_TYPE__NEGATE = 1;

	/**
	 * The number of structural features of the '<em>Comparison Operator Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPARISON_OPERATOR_TYPE_FEATURE_COUNT = 2;

	/**
	 * The number of operations of the '<em>Comparison Operator Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COMPARISON_OPERATOR_TYPE_OPERATION_COUNT = 0;

	/**
	 * The meta object id for the '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.ConstraintTypeImpl <em>Constraint Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.ConstraintTypeImpl
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.CmdbfPackageImpl#getConstraintType()
	 * @generated
	 */
	int CONSTRAINT_TYPE = 2;

	/**
	 * The feature id for the '<em><b>Local Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONSTRAINT_TYPE__LOCAL_NAME = 0;

	/**
	 * The feature id for the '<em><b>Namespace</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONSTRAINT_TYPE__NAMESPACE = 1;

	/**
	 * The number of structural features of the '<em>Constraint Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONSTRAINT_TYPE_FEATURE_COUNT = 2;

	/**
	 * The number of operations of the '<em>Constraint Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONSTRAINT_TYPE_OPERATION_COUNT = 0;

	/**
	 * The meta object id for the '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.ContentSelectorTypeImpl <em>Content Selector Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.ContentSelectorTypeImpl
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.CmdbfPackageImpl#getContentSelectorType()
	 * @generated
	 */
	int CONTENT_SELECTOR_TYPE = 3;

	/**
	 * The feature id for the '<em><b>Selected Record Type</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTENT_SELECTOR_TYPE__SELECTED_RECORD_TYPE = 0;

	/**
	 * The feature id for the '<em><b>Xpath Selector</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTENT_SELECTOR_TYPE__XPATH_SELECTOR = 1;

	/**
	 * The feature id for the '<em><b>Any</b></em>' attribute list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTENT_SELECTOR_TYPE__ANY = 2;

	/**
	 * The feature id for the '<em><b>Parent</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTENT_SELECTOR_TYPE__PARENT = 3;

	/**
	 * The number of structural features of the '<em>Content Selector Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTENT_SELECTOR_TYPE_FEATURE_COUNT = 4;

	/**
	 * The number of operations of the '<em>Content Selector Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int CONTENT_SELECTOR_TYPE_OPERATION_COUNT = 0;

	/**
	 * The meta object id for the '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.DeclinedTypeImpl <em>Declined Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.DeclinedTypeImpl
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.CmdbfPackageImpl#getDeclinedType()
	 * @generated
	 */
	int DECLINED_TYPE = 4;

	/**
	 * The feature id for the '<em><b>Reason</b></em>' attribute list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DECLINED_TYPE__REASON = 0;

	/**
	 * The number of structural features of the '<em>Declined Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DECLINED_TYPE_FEATURE_COUNT = 1;

	/**
	 * The number of operations of the '<em>Declined Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DECLINED_TYPE_OPERATION_COUNT = 0;

	/**
	 * The meta object id for the '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.DepthLimitTypeImpl <em>Depth Limit Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.DepthLimitTypeImpl
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.CmdbfPackageImpl#getDepthLimitType()
	 * @generated
	 */
	int DEPTH_LIMIT_TYPE = 5;

	/**
	 * The feature id for the '<em><b>Max Intermediate Items</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEPTH_LIMIT_TYPE__MAX_INTERMEDIATE_ITEMS = 0;

	/**
	 * The feature id for the '<em><b>Intermediate Item Template</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEPTH_LIMIT_TYPE__INTERMEDIATE_ITEM_TEMPLATE = 1;

	/**
	 * The number of structural features of the '<em>Depth Limit Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEPTH_LIMIT_TYPE_FEATURE_COUNT = 2;

	/**
	 * The number of operations of the '<em>Depth Limit Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEPTH_LIMIT_TYPE_OPERATION_COUNT = 0;

	/**
	 * The meta object id for the '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.ModelUpdateInstanceResponseImpl <em>Model Update Instance Response</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.ModelUpdateInstanceResponseImpl
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.CmdbfPackageImpl#getModelUpdateInstanceResponse()
	 * @generated
	 */
	int MODEL_UPDATE_INSTANCE_RESPONSE = 56;

	/**
	 * The feature id for the '<em><b>Instance Id</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODEL_UPDATE_INSTANCE_RESPONSE__INSTANCE_ID = 0;

	/**
	 * The feature id for the '<em><b>Declined</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODEL_UPDATE_INSTANCE_RESPONSE__DECLINED = 1;

	/**
	 * The number of structural features of the '<em>Model Update Instance Response</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODEL_UPDATE_INSTANCE_RESPONSE_FEATURE_COUNT = 2;

	/**
	 * The number of operations of the '<em>Model Update Instance Response</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODEL_UPDATE_INSTANCE_RESPONSE_OPERATION_COUNT = 0;

	/**
	 * The meta object id for the '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.DeregisterInstanceResponseTypeImpl <em>Deregister Instance Response Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.DeregisterInstanceResponseTypeImpl
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.CmdbfPackageImpl#getDeregisterInstanceResponseType()
	 * @generated
	 */
	int DEREGISTER_INSTANCE_RESPONSE_TYPE = 6;

	/**
	 * The feature id for the '<em><b>Instance Id</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEREGISTER_INSTANCE_RESPONSE_TYPE__INSTANCE_ID = MODEL_UPDATE_INSTANCE_RESPONSE__INSTANCE_ID;

	/**
	 * The feature id for the '<em><b>Declined</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEREGISTER_INSTANCE_RESPONSE_TYPE__DECLINED = MODEL_UPDATE_INSTANCE_RESPONSE__DECLINED;

	/**
	 * The feature id for the '<em><b>Accepted</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEREGISTER_INSTANCE_RESPONSE_TYPE__ACCEPTED = MODEL_UPDATE_INSTANCE_RESPONSE_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Deregister Instance Response Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEREGISTER_INSTANCE_RESPONSE_TYPE_FEATURE_COUNT = MODEL_UPDATE_INSTANCE_RESPONSE_FEATURE_COUNT + 1;

	/**
	 * The number of operations of the '<em>Deregister Instance Response Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEREGISTER_INSTANCE_RESPONSE_TYPE_OPERATION_COUNT = MODEL_UPDATE_INSTANCE_RESPONSE_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.DeregisterRequestTypeImpl <em>Deregister Request Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.DeregisterRequestTypeImpl
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.CmdbfPackageImpl#getDeregisterRequestType()
	 * @generated
	 */
	int DEREGISTER_REQUEST_TYPE = 7;

	/**
	 * The feature id for the '<em><b>Mdr Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEREGISTER_REQUEST_TYPE__MDR_ID = 0;

	/**
	 * The feature id for the '<em><b>Item Id List</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEREGISTER_REQUEST_TYPE__ITEM_ID_LIST = 1;

	/**
	 * The feature id for the '<em><b>Relationship Id List</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEREGISTER_REQUEST_TYPE__RELATIONSHIP_ID_LIST = 2;

	/**
	 * The number of structural features of the '<em>Deregister Request Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEREGISTER_REQUEST_TYPE_FEATURE_COUNT = 3;

	/**
	 * The number of operations of the '<em>Deregister Request Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEREGISTER_REQUEST_TYPE_OPERATION_COUNT = 0;

	/**
	 * The meta object id for the '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.DeregisterResponseTypeImpl <em>Deregister Response Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.DeregisterResponseTypeImpl
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.CmdbfPackageImpl#getDeregisterResponseType()
	 * @generated
	 */
	int DEREGISTER_RESPONSE_TYPE = 8;

	/**
	 * The feature id for the '<em><b>Deregister Instance Response</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEREGISTER_RESPONSE_TYPE__DEREGISTER_INSTANCE_RESPONSE = 0;

	/**
	 * The number of structural features of the '<em>Deregister Response Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEREGISTER_RESPONSE_TYPE_FEATURE_COUNT = 1;

	/**
	 * The number of operations of the '<em>Deregister Response Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEREGISTER_RESPONSE_TYPE_OPERATION_COUNT = 0;

	/**
	 * The meta object id for the '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.DeregistrationErrorFaultTypeImpl <em>Deregistration Error Fault Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.DeregistrationErrorFaultTypeImpl
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.CmdbfPackageImpl#getDeregistrationErrorFaultType()
	 * @generated
	 */
	int DEREGISTRATION_ERROR_FAULT_TYPE = 9;

	/**
	 * The feature id for the '<em><b>Record Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEREGISTRATION_ERROR_FAULT_TYPE__RECORD_ID = 0;

	/**
	 * The number of structural features of the '<em>Deregistration Error Fault Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEREGISTRATION_ERROR_FAULT_TYPE_FEATURE_COUNT = 1;

	/**
	 * The number of operations of the '<em>Deregistration Error Fault Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DEREGISTRATION_ERROR_FAULT_TYPE_OPERATION_COUNT = 0;

	/**
	 * The meta object id for the '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.DocumentRootImpl <em>Document Root</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.DocumentRootImpl
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.CmdbfPackageImpl#getDocumentRoot()
	 * @generated
	 */
	int DOCUMENT_ROOT = 10;

	/**
	 * The feature id for the '<em><b>Mixed</b></em>' attribute list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOCUMENT_ROOT__MIXED = 0;

	/**
	 * The feature id for the '<em><b>XMLNS Prefix Map</b></em>' map.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOCUMENT_ROOT__XMLNS_PREFIX_MAP = 1;

	/**
	 * The feature id for the '<em><b>XSI Schema Location</b></em>' map.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOCUMENT_ROOT__XSI_SCHEMA_LOCATION = 2;

	/**
	 * The feature id for the '<em><b>Deregister Request</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOCUMENT_ROOT__DEREGISTER_REQUEST = 3;

	/**
	 * The feature id for the '<em><b>Deregister Response</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOCUMENT_ROOT__DEREGISTER_RESPONSE = 4;

	/**
	 * The feature id for the '<em><b>Deregistration Error Fault</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOCUMENT_ROOT__DEREGISTRATION_ERROR_FAULT = 5;

	/**
	 * The feature id for the '<em><b>Expensive Query Error Fault</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOCUMENT_ROOT__EXPENSIVE_QUERY_ERROR_FAULT = 6;

	/**
	 * The feature id for the '<em><b>Instance Id</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOCUMENT_ROOT__INSTANCE_ID = 7;

	/**
	 * The feature id for the '<em><b>Invalid MDR Fault</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOCUMENT_ROOT__INVALID_MDR_FAULT = 8;

	/**
	 * The feature id for the '<em><b>Invalid Property Type Fault</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOCUMENT_ROOT__INVALID_PROPERTY_TYPE_FAULT = 9;

	/**
	 * The feature id for the '<em><b>Invalid Record Fault</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOCUMENT_ROOT__INVALID_RECORD_FAULT = 10;

	/**
	 * The feature id for the '<em><b>Item</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOCUMENT_ROOT__ITEM = 11;

	/**
	 * The feature id for the '<em><b>Property Set</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOCUMENT_ROOT__PROPERTY_SET = 12;

	/**
	 * The feature id for the '<em><b>Query</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOCUMENT_ROOT__QUERY = 13;

	/**
	 * The feature id for the '<em><b>Query Error Fault</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOCUMENT_ROOT__QUERY_ERROR_FAULT = 14;

	/**
	 * The feature id for the '<em><b>Query Result</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOCUMENT_ROOT__QUERY_RESULT = 15;

	/**
	 * The feature id for the '<em><b>Record</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOCUMENT_ROOT__RECORD = 16;

	/**
	 * The feature id for the '<em><b>Register Request</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOCUMENT_ROOT__REGISTER_REQUEST = 17;

	/**
	 * The feature id for the '<em><b>Register Response</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOCUMENT_ROOT__REGISTER_RESPONSE = 18;

	/**
	 * The feature id for the '<em><b>Registration Error Fault</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOCUMENT_ROOT__REGISTRATION_ERROR_FAULT = 19;

	/**
	 * The feature id for the '<em><b>Relationship</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOCUMENT_ROOT__RELATIONSHIP = 20;

	/**
	 * The feature id for the '<em><b>Unknown Template ID Fault</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOCUMENT_ROOT__UNKNOWN_TEMPLATE_ID_FAULT = 21;

	/**
	 * The feature id for the '<em><b>Unsupported Constraint Fault</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOCUMENT_ROOT__UNSUPPORTED_CONSTRAINT_FAULT = 22;

	/**
	 * The feature id for the '<em><b>Unsupported Record Type Fault</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOCUMENT_ROOT__UNSUPPORTED_RECORD_TYPE_FAULT = 23;

	/**
	 * The feature id for the '<em><b>Unsupported Selector Fault</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOCUMENT_ROOT__UNSUPPORTED_SELECTOR_FAULT = 24;

	/**
	 * The feature id for the '<em><b>XPath Error Fault</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOCUMENT_ROOT__XPATH_ERROR_FAULT = 25;

	/**
	 * The feature id for the '<em><b>Model</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOCUMENT_ROOT__MODEL = 26;

	/**
	 * The number of structural features of the '<em>Document Root</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOCUMENT_ROOT_FEATURE_COUNT = 27;

	/**
	 * The number of operations of the '<em>Document Root</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOCUMENT_ROOT_OPERATION_COUNT = 0;

	/**
	 * The meta object id for the '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.EdgesTypeImpl <em>Edges Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.EdgesTypeImpl
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.CmdbfPackageImpl#getEdgesType()
	 * @generated
	 */
	int EDGES_TYPE = 11;

	/**
	 * The feature id for the '<em><b>Relationship</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EDGES_TYPE__RELATIONSHIP = 0;

	/**
	 * The feature id for the '<em><b>Template Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EDGES_TYPE__TEMPLATE_ID = 1;

	/**
	 * The number of structural features of the '<em>Edges Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EDGES_TYPE_FEATURE_COUNT = 2;

	/**
	 * The number of operations of the '<em>Edges Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EDGES_TYPE_OPERATION_COUNT = 0;

	/**
	 * The meta object id for the '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.EqualOperatorTypeImpl <em>Equal Operator Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.EqualOperatorTypeImpl
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.CmdbfPackageImpl#getEqualOperatorType()
	 * @generated
	 */
	int EQUAL_OPERATOR_TYPE = 12;

	/**
	 * The feature id for the '<em><b>Value</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQUAL_OPERATOR_TYPE__VALUE = 0;

	/**
	 * The feature id for the '<em><b>Case Sensitive</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQUAL_OPERATOR_TYPE__CASE_SENSITIVE = 1;

	/**
	 * The feature id for the '<em><b>Negate</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQUAL_OPERATOR_TYPE__NEGATE = 2;

	/**
	 * The number of structural features of the '<em>Equal Operator Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQUAL_OPERATOR_TYPE_FEATURE_COUNT = 3;

	/**
	 * The number of operations of the '<em>Equal Operator Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EQUAL_OPERATOR_TYPE_OPERATION_COUNT = 0;

	/**
	 * The meta object id for the '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.ExpensiveQueryErrorFaultTypeImpl <em>Expensive Query Error Fault Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.ExpensiveQueryErrorFaultTypeImpl
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.CmdbfPackageImpl#getExpensiveQueryErrorFaultType()
	 * @generated
	 */
	int EXPENSIVE_QUERY_ERROR_FAULT_TYPE = 13;

	/**
	 * The feature id for the '<em><b>Any</b></em>' attribute list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXPENSIVE_QUERY_ERROR_FAULT_TYPE__ANY = 0;

	/**
	 * The number of structural features of the '<em>Expensive Query Error Fault Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXPENSIVE_QUERY_ERROR_FAULT_TYPE_FEATURE_COUNT = 1;

	/**
	 * The number of operations of the '<em>Expensive Query Error Fault Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int EXPENSIVE_QUERY_ERROR_FAULT_TYPE_OPERATION_COUNT = 0;

	/**
	 * The meta object id for the '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.InstanceIdConstraintTypeImpl <em>Instance Id Constraint Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.InstanceIdConstraintTypeImpl
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.CmdbfPackageImpl#getInstanceIdConstraintType()
	 * @generated
	 */
	int INSTANCE_ID_CONSTRAINT_TYPE = 14;

	/**
	 * The feature id for the '<em><b>Instance Id</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INSTANCE_ID_CONSTRAINT_TYPE__INSTANCE_ID = 0;

	/**
	 * The number of structural features of the '<em>Instance Id Constraint Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INSTANCE_ID_CONSTRAINT_TYPE_FEATURE_COUNT = 1;

	/**
	 * The number of operations of the '<em>Instance Id Constraint Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INSTANCE_ID_CONSTRAINT_TYPE_OPERATION_COUNT = 0;

	/**
	 * The meta object id for the '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.InvalidMDRFaultTypeImpl <em>Invalid MDR Fault Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.InvalidMDRFaultTypeImpl
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.CmdbfPackageImpl#getInvalidMDRFaultType()
	 * @generated
	 */
	int INVALID_MDR_FAULT_TYPE = 15;

	/**
	 * The feature id for the '<em><b>Mdr Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INVALID_MDR_FAULT_TYPE__MDR_ID = 0;

	/**
	 * The number of structural features of the '<em>Invalid MDR Fault Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INVALID_MDR_FAULT_TYPE_FEATURE_COUNT = 1;

	/**
	 * The number of operations of the '<em>Invalid MDR Fault Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INVALID_MDR_FAULT_TYPE_OPERATION_COUNT = 0;

	/**
	 * The meta object id for the '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.InvalidPropertyTypeFaultTypeImpl <em>Invalid Property Type Fault Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.InvalidPropertyTypeFaultTypeImpl
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.CmdbfPackageImpl#getInvalidPropertyTypeFaultType()
	 * @generated
	 */
	int INVALID_PROPERTY_TYPE_FAULT_TYPE = 16;

	/**
	 * The feature id for the '<em><b>Property Name</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INVALID_PROPERTY_TYPE_FAULT_TYPE__PROPERTY_NAME = 0;

	/**
	 * The number of structural features of the '<em>Invalid Property Type Fault Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INVALID_PROPERTY_TYPE_FAULT_TYPE_FEATURE_COUNT = 1;

	/**
	 * The number of operations of the '<em>Invalid Property Type Fault Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INVALID_PROPERTY_TYPE_FAULT_TYPE_OPERATION_COUNT = 0;

	/**
	 * The meta object id for the '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.InvalidRecordFaultTypeImpl <em>Invalid Record Fault Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.InvalidRecordFaultTypeImpl
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.CmdbfPackageImpl#getInvalidRecordFaultType()
	 * @generated
	 */
	int INVALID_RECORD_FAULT_TYPE = 17;

	/**
	 * The feature id for the '<em><b>Record Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INVALID_RECORD_FAULT_TYPE__RECORD_ID = 0;

	/**
	 * The number of structural features of the '<em>Invalid Record Fault Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INVALID_RECORD_FAULT_TYPE_FEATURE_COUNT = 1;

	/**
	 * The number of operations of the '<em>Invalid Record Fault Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INVALID_RECORD_FAULT_TYPE_OPERATION_COUNT = 0;

	/**
	 * The meta object id for the '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.ItemListTypeImpl <em>Item List Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.ItemListTypeImpl
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.CmdbfPackageImpl#getItemListType()
	 * @generated
	 */
	int ITEM_LIST_TYPE = 18;

	/**
	 * The feature id for the '<em><b>Item</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ITEM_LIST_TYPE__ITEM = 0;

	/**
	 * The number of structural features of the '<em>Item List Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ITEM_LIST_TYPE_FEATURE_COUNT = 1;

	/**
	 * The operation id for the '<em>Find</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ITEM_LIST_TYPE___FIND__MDRSCOPEDIDTYPE = 0;

	/**
	 * The operation id for the '<em>Find</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ITEM_LIST_TYPE___FIND__ITEMTYPE = 1;

	/**
	 * The number of operations of the '<em>Item List Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ITEM_LIST_TYPE_OPERATION_COUNT = 2;

	/**
	 * The meta object id for the '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.ModelTemplateImpl <em>Model Template</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.ModelTemplateImpl
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.CmdbfPackageImpl#getModelTemplate()
	 * @generated
	 */
	int MODEL_TEMPLATE = 55;

	/**
	 * The feature id for the '<em><b>Content Selector</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODEL_TEMPLATE__CONTENT_SELECTOR = 0;

	/**
	 * The feature id for the '<em><b>Instance Id Constraint</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODEL_TEMPLATE__INSTANCE_ID_CONSTRAINT = 1;

	/**
	 * The feature id for the '<em><b>Record Constraint</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODEL_TEMPLATE__RECORD_CONSTRAINT = 2;

	/**
	 * The feature id for the '<em><b>Any</b></em>' attribute list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODEL_TEMPLATE__ANY = 3;

	/**
	 * The feature id for the '<em><b>Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODEL_TEMPLATE__ID = 4;

	/**
	 * The feature id for the '<em><b>Suppress From Result</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODEL_TEMPLATE__SUPPRESS_FROM_RESULT = 5;

	/**
	 * The feature id for the '<em><b>Query</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODEL_TEMPLATE__QUERY = 6;

	/**
	 * The number of structural features of the '<em>Model Template</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODEL_TEMPLATE_FEATURE_COUNT = 7;

	/**
	 * The operation id for the '<em>Add Instance Id Constraint</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODEL_TEMPLATE___ADD_INSTANCE_ID_CONSTRAINT__STRING = 0;

	/**
	 * The operation id for the '<em>Add Instance Id Constraint</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODEL_TEMPLATE___ADD_INSTANCE_ID_CONSTRAINT__STRING_STRING = 1;

	/**
	 * The operation id for the '<em>Add Record Constraint</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODEL_TEMPLATE___ADD_RECORD_CONSTRAINT = 2;

	/**
	 * The operation id for the '<em>Add Content Selector</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODEL_TEMPLATE___ADD_CONTENT_SELECTOR__STRING = 3;

	/**
	 * The operation id for the '<em>Add Content Selector</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODEL_TEMPLATE___ADD_CONTENT_SELECTOR__STRING_STRING = 4;

	/**
	 * The number of operations of the '<em>Model Template</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODEL_TEMPLATE_OPERATION_COUNT = 5;

	/**
	 * The meta object id for the '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.ItemTemplateTypeImpl <em>Item Template Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.ItemTemplateTypeImpl
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.CmdbfPackageImpl#getItemTemplateType()
	 * @generated
	 */
	int ITEM_TEMPLATE_TYPE = 19;

	/**
	 * The feature id for the '<em><b>Content Selector</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ITEM_TEMPLATE_TYPE__CONTENT_SELECTOR = MODEL_TEMPLATE__CONTENT_SELECTOR;

	/**
	 * The feature id for the '<em><b>Instance Id Constraint</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ITEM_TEMPLATE_TYPE__INSTANCE_ID_CONSTRAINT = MODEL_TEMPLATE__INSTANCE_ID_CONSTRAINT;

	/**
	 * The feature id for the '<em><b>Record Constraint</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ITEM_TEMPLATE_TYPE__RECORD_CONSTRAINT = MODEL_TEMPLATE__RECORD_CONSTRAINT;

	/**
	 * The feature id for the '<em><b>Any</b></em>' attribute list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ITEM_TEMPLATE_TYPE__ANY = MODEL_TEMPLATE__ANY;

	/**
	 * The feature id for the '<em><b>Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ITEM_TEMPLATE_TYPE__ID = MODEL_TEMPLATE__ID;

	/**
	 * The feature id for the '<em><b>Suppress From Result</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ITEM_TEMPLATE_TYPE__SUPPRESS_FROM_RESULT = MODEL_TEMPLATE__SUPPRESS_FROM_RESULT;

	/**
	 * The feature id for the '<em><b>Query</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ITEM_TEMPLATE_TYPE__QUERY = MODEL_TEMPLATE__QUERY;

	/**
	 * The number of structural features of the '<em>Item Template Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ITEM_TEMPLATE_TYPE_FEATURE_COUNT = MODEL_TEMPLATE_FEATURE_COUNT + 0;

	/**
	 * The operation id for the '<em>Add Instance Id Constraint</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ITEM_TEMPLATE_TYPE___ADD_INSTANCE_ID_CONSTRAINT__STRING = MODEL_TEMPLATE___ADD_INSTANCE_ID_CONSTRAINT__STRING;

	/**
	 * The operation id for the '<em>Add Instance Id Constraint</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ITEM_TEMPLATE_TYPE___ADD_INSTANCE_ID_CONSTRAINT__STRING_STRING = MODEL_TEMPLATE___ADD_INSTANCE_ID_CONSTRAINT__STRING_STRING;

	/**
	 * The operation id for the '<em>Add Record Constraint</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ITEM_TEMPLATE_TYPE___ADD_RECORD_CONSTRAINT = MODEL_TEMPLATE___ADD_RECORD_CONSTRAINT;

	/**
	 * The operation id for the '<em>Add Content Selector</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ITEM_TEMPLATE_TYPE___ADD_CONTENT_SELECTOR__STRING = MODEL_TEMPLATE___ADD_CONTENT_SELECTOR__STRING;

	/**
	 * The operation id for the '<em>Add Content Selector</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ITEM_TEMPLATE_TYPE___ADD_CONTENT_SELECTOR__STRING_STRING = MODEL_TEMPLATE___ADD_CONTENT_SELECTOR__STRING_STRING;

	/**
	 * The number of operations of the '<em>Item Template Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ITEM_TEMPLATE_TYPE_OPERATION_COUNT = MODEL_TEMPLATE_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.ModelElementImpl <em>Model Element</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.ModelElementImpl
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.CmdbfPackageImpl#getModelElement()
	 * @generated
	 */
	int MODEL_ELEMENT = 54;

	/**
	 * The feature id for the '<em><b>Record</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODEL_ELEMENT__RECORD = 0;

	/**
	 * The feature id for the '<em><b>Instance Id</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODEL_ELEMENT__INSTANCE_ID = 1;

	/**
	 * The feature id for the '<em><b>Additional Record Type</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODEL_ELEMENT__ADDITIONAL_RECORD_TYPE = 2;

	/**
	 * The feature id for the '<em><b>Template Id</b></em>' attribute list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODEL_ELEMENT__TEMPLATE_ID = 3;

	/**
	 * The feature id for the '<em><b>Parent</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODEL_ELEMENT__PARENT = 4;

	/**
	 * The feature id for the '<em><b>Deregister</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODEL_ELEMENT__DEREGISTER = 5;

	/**
	 * The number of structural features of the '<em>Model Element</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODEL_ELEMENT_FEATURE_COUNT = 6;

	/**
	 * The operation id for the '<em>Find Instance Id</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODEL_ELEMENT___FIND_INSTANCE_ID = 0;

	/**
	 * The operation id for the '<em>Find Instance Id</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODEL_ELEMENT___FIND_INSTANCE_ID__STRING = 1;

	/**
	 * The operation id for the '<em>Add Instance Id</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODEL_ELEMENT___ADD_INSTANCE_ID__STRING = 2;

	/**
	 * The operation id for the '<em>Add Instance Id</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODEL_ELEMENT___ADD_INSTANCE_ID__STRING_STRING = 3;

	/**
	 * The operation id for the '<em>Add Additional Record Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODEL_ELEMENT___ADD_ADDITIONAL_RECORD_TYPE__STRING = 4;

	/**
	 * The operation id for the '<em>Add Additional Record Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODEL_ELEMENT___ADD_ADDITIONAL_RECORD_TYPE__STRING_STRING = 5;

	/**
	 * The operation id for the '<em>Add Record</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODEL_ELEMENT___ADD_RECORD__STRING = 6;

	/**
	 * The operation id for the '<em>Add Record</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODEL_ELEMENT___ADD_RECORD__STRING_STRING = 7;

	/**
	 * The operation id for the '<em>Add Record</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODEL_ELEMENT___ADD_RECORD__STRING_BOOLEAN = 8;

	/**
	 * The operation id for the '<em>Add Record</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODEL_ELEMENT___ADD_RECORD__STRING_STRING_BOOLEAN = 9;

	/**
	 * The operation id for the '<em>Find Record</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODEL_ELEMENT___FIND_RECORD__STRING = 10;

	/**
	 * The operation id for the '<em>Find Record</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODEL_ELEMENT___FIND_RECORD__STRING_STRING = 11;

	/**
	 * The operation id for the '<em>Find Record By Template</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODEL_ELEMENT___FIND_RECORD_BY_TEMPLATE__STRING_STRING = 12;

	/**
	 * The operation id for the '<em>Find Record By Template</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODEL_ELEMENT___FIND_RECORD_BY_TEMPLATE__STRING_STRING_STRING = 13;

	/**
	 * The operation id for the '<em>Find Record By Id</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODEL_ELEMENT___FIND_RECORD_BY_ID__STRING = 14;

	/**
	 * The operation id for the '<em>Merge</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODEL_ELEMENT___MERGE__MODELELEMENT = 15;

	/**
	 * The number of operations of the '<em>Model Element</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODEL_ELEMENT_OPERATION_COUNT = 16;

	/**
	 * The meta object id for the '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.ItemTypeImpl <em>Item Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.ItemTypeImpl
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.CmdbfPackageImpl#getItemType()
	 * @generated
	 */
	int ITEM_TYPE = 20;

	/**
	 * The feature id for the '<em><b>Record</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ITEM_TYPE__RECORD = MODEL_ELEMENT__RECORD;

	/**
	 * The feature id for the '<em><b>Instance Id</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ITEM_TYPE__INSTANCE_ID = MODEL_ELEMENT__INSTANCE_ID;

	/**
	 * The feature id for the '<em><b>Additional Record Type</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ITEM_TYPE__ADDITIONAL_RECORD_TYPE = MODEL_ELEMENT__ADDITIONAL_RECORD_TYPE;

	/**
	 * The feature id for the '<em><b>Template Id</b></em>' attribute list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ITEM_TYPE__TEMPLATE_ID = MODEL_ELEMENT__TEMPLATE_ID;

	/**
	 * The feature id for the '<em><b>Parent</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ITEM_TYPE__PARENT = MODEL_ELEMENT__PARENT;

	/**
	 * The feature id for the '<em><b>Deregister</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ITEM_TYPE__DEREGISTER = MODEL_ELEMENT__DEREGISTER;

	/**
	 * The feature id for the '<em><b>Relationship By Source</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ITEM_TYPE__RELATIONSHIP_BY_SOURCE = MODEL_ELEMENT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Relationship By Target</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ITEM_TYPE__RELATIONSHIP_BY_TARGET = MODEL_ELEMENT_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>Item Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ITEM_TYPE_FEATURE_COUNT = MODEL_ELEMENT_FEATURE_COUNT + 2;

	/**
	 * The operation id for the '<em>Find Instance Id</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ITEM_TYPE___FIND_INSTANCE_ID = MODEL_ELEMENT___FIND_INSTANCE_ID;

	/**
	 * The operation id for the '<em>Find Instance Id</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ITEM_TYPE___FIND_INSTANCE_ID__STRING = MODEL_ELEMENT___FIND_INSTANCE_ID__STRING;

	/**
	 * The operation id for the '<em>Add Instance Id</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ITEM_TYPE___ADD_INSTANCE_ID__STRING = MODEL_ELEMENT___ADD_INSTANCE_ID__STRING;

	/**
	 * The operation id for the '<em>Add Instance Id</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ITEM_TYPE___ADD_INSTANCE_ID__STRING_STRING = MODEL_ELEMENT___ADD_INSTANCE_ID__STRING_STRING;

	/**
	 * The operation id for the '<em>Add Additional Record Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ITEM_TYPE___ADD_ADDITIONAL_RECORD_TYPE__STRING = MODEL_ELEMENT___ADD_ADDITIONAL_RECORD_TYPE__STRING;

	/**
	 * The operation id for the '<em>Add Additional Record Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ITEM_TYPE___ADD_ADDITIONAL_RECORD_TYPE__STRING_STRING = MODEL_ELEMENT___ADD_ADDITIONAL_RECORD_TYPE__STRING_STRING;

	/**
	 * The operation id for the '<em>Add Record</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ITEM_TYPE___ADD_RECORD__STRING = MODEL_ELEMENT___ADD_RECORD__STRING;

	/**
	 * The operation id for the '<em>Add Record</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ITEM_TYPE___ADD_RECORD__STRING_STRING = MODEL_ELEMENT___ADD_RECORD__STRING_STRING;

	/**
	 * The operation id for the '<em>Add Record</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ITEM_TYPE___ADD_RECORD__STRING_BOOLEAN = MODEL_ELEMENT___ADD_RECORD__STRING_BOOLEAN;

	/**
	 * The operation id for the '<em>Add Record</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ITEM_TYPE___ADD_RECORD__STRING_STRING_BOOLEAN = MODEL_ELEMENT___ADD_RECORD__STRING_STRING_BOOLEAN;

	/**
	 * The operation id for the '<em>Find Record</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ITEM_TYPE___FIND_RECORD__STRING = MODEL_ELEMENT___FIND_RECORD__STRING;

	/**
	 * The operation id for the '<em>Find Record</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ITEM_TYPE___FIND_RECORD__STRING_STRING = MODEL_ELEMENT___FIND_RECORD__STRING_STRING;

	/**
	 * The operation id for the '<em>Find Record By Template</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ITEM_TYPE___FIND_RECORD_BY_TEMPLATE__STRING_STRING = MODEL_ELEMENT___FIND_RECORD_BY_TEMPLATE__STRING_STRING;

	/**
	 * The operation id for the '<em>Find Record By Template</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ITEM_TYPE___FIND_RECORD_BY_TEMPLATE__STRING_STRING_STRING = MODEL_ELEMENT___FIND_RECORD_BY_TEMPLATE__STRING_STRING_STRING;

	/**
	 * The operation id for the '<em>Find Record By Id</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ITEM_TYPE___FIND_RECORD_BY_ID__STRING = MODEL_ELEMENT___FIND_RECORD_BY_ID__STRING;

	/**
	 * The operation id for the '<em>Merge</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ITEM_TYPE___MERGE__MODELELEMENT = MODEL_ELEMENT___MERGE__MODELELEMENT;

	/**
	 * The number of operations of the '<em>Item Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ITEM_TYPE_OPERATION_COUNT = MODEL_ELEMENT_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.MdrScopedIdListTypeImpl <em>Mdr Scoped Id List Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.MdrScopedIdListTypeImpl
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.CmdbfPackageImpl#getMdrScopedIdListType()
	 * @generated
	 */
	int MDR_SCOPED_ID_LIST_TYPE = 21;

	/**
	 * The feature id for the '<em><b>Instance Id</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MDR_SCOPED_ID_LIST_TYPE__INSTANCE_ID = 0;

	/**
	 * The number of structural features of the '<em>Mdr Scoped Id List Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MDR_SCOPED_ID_LIST_TYPE_FEATURE_COUNT = 1;

	/**
	 * The number of operations of the '<em>Mdr Scoped Id List Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MDR_SCOPED_ID_LIST_TYPE_OPERATION_COUNT = 0;

	/**
	 * The meta object id for the '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.MdrScopedIdTypeImpl <em>Mdr Scoped Id Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.MdrScopedIdTypeImpl
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.CmdbfPackageImpl#getMdrScopedIdType()
	 * @generated
	 */
	int MDR_SCOPED_ID_TYPE = 22;

	/**
	 * The feature id for the '<em><b>Mdr Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MDR_SCOPED_ID_TYPE__MDR_ID = 0;

	/**
	 * The feature id for the '<em><b>Local Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MDR_SCOPED_ID_TYPE__LOCAL_ID = 1;

	/**
	 * The number of structural features of the '<em>Mdr Scoped Id Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MDR_SCOPED_ID_TYPE_FEATURE_COUNT = 2;

	/**
	 * The operation id for the '<em>Init</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MDR_SCOPED_ID_TYPE___INIT__STRING = 0;

	/**
	 * The number of operations of the '<em>Mdr Scoped Id Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MDR_SCOPED_ID_TYPE_OPERATION_COUNT = 1;

	/**
	 * The meta object id for the '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.NodesTypeImpl <em>Nodes Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.NodesTypeImpl
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.CmdbfPackageImpl#getNodesType()
	 * @generated
	 */
	int NODES_TYPE = 23;

	/**
	 * The feature id for the '<em><b>Item</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NODES_TYPE__ITEM = 0;

	/**
	 * The feature id for the '<em><b>Template Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NODES_TYPE__TEMPLATE_ID = 1;

	/**
	 * The number of structural features of the '<em>Nodes Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NODES_TYPE_FEATURE_COUNT = 2;

	/**
	 * The number of operations of the '<em>Nodes Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NODES_TYPE_OPERATION_COUNT = 0;

	/**
	 * The meta object id for the '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.NullOperatorTypeImpl <em>Null Operator Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.NullOperatorTypeImpl
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.CmdbfPackageImpl#getNullOperatorType()
	 * @generated
	 */
	int NULL_OPERATOR_TYPE = 24;

	/**
	 * The feature id for the '<em><b>Negate</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NULL_OPERATOR_TYPE__NEGATE = 0;

	/**
	 * The number of structural features of the '<em>Null Operator Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NULL_OPERATOR_TYPE_FEATURE_COUNT = 1;

	/**
	 * The number of operations of the '<em>Null Operator Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NULL_OPERATOR_TYPE_OPERATION_COUNT = 0;

	/**
	 * The meta object id for the '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.PrefixMappingTypeImpl <em>Prefix Mapping Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.PrefixMappingTypeImpl
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.CmdbfPackageImpl#getPrefixMappingType()
	 * @generated
	 */
	int PREFIX_MAPPING_TYPE = 25;

	/**
	 * The feature id for the '<em><b>Prefix</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PREFIX_MAPPING_TYPE__PREFIX = 0;

	/**
	 * The feature id for the '<em><b>Namespace</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PREFIX_MAPPING_TYPE__NAMESPACE = 1;

	/**
	 * The number of structural features of the '<em>Prefix Mapping Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PREFIX_MAPPING_TYPE_FEATURE_COUNT = 2;

	/**
	 * The number of operations of the '<em>Prefix Mapping Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PREFIX_MAPPING_TYPE_OPERATION_COUNT = 0;

	/**
	 * The meta object id for the '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.PropertyNameTypeImpl <em>Property Name Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.PropertyNameTypeImpl
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.CmdbfPackageImpl#getPropertyNameType()
	 * @generated
	 */
	int PROPERTY_NAME_TYPE = 26;

	/**
	 * The feature id for the '<em><b>Local Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_NAME_TYPE__LOCAL_NAME = 0;

	/**
	 * The feature id for the '<em><b>Namespace</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_NAME_TYPE__NAMESPACE = 1;

	/**
	 * The number of structural features of the '<em>Property Name Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_NAME_TYPE_FEATURE_COUNT = 2;

	/**
	 * The number of operations of the '<em>Property Name Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_NAME_TYPE_OPERATION_COUNT = 0;

	/**
	 * The meta object id for the '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.PropertySetTypeImpl <em>Property Set Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.PropertySetTypeImpl
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.CmdbfPackageImpl#getPropertySetType()
	 * @generated
	 */
	int PROPERTY_SET_TYPE = 27;

	/**
	 * The feature id for the '<em><b>Any</b></em>' attribute list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_SET_TYPE__ANY = 0;

	/**
	 * The feature id for the '<em><b>Namespace</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_SET_TYPE__NAMESPACE = 1;

	/**
	 * The feature id for the '<em><b>Local Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_SET_TYPE__LOCAL_NAME = 2;

	/**
	 * The number of structural features of the '<em>Property Set Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_SET_TYPE_FEATURE_COUNT = 3;

	/**
	 * The number of operations of the '<em>Property Set Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_SET_TYPE_OPERATION_COUNT = 0;

	/**
	 * The meta object id for the '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.PropertyValueTypeImpl <em>Property Value Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.PropertyValueTypeImpl
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.CmdbfPackageImpl#getPropertyValueType()
	 * @generated
	 */
	int PROPERTY_VALUE_TYPE = 28;

	/**
	 * The feature id for the '<em><b>Equal</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_VALUE_TYPE__EQUAL = 0;

	/**
	 * The feature id for the '<em><b>Less</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_VALUE_TYPE__LESS = 1;

	/**
	 * The feature id for the '<em><b>Less Or Equal</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_VALUE_TYPE__LESS_OR_EQUAL = 2;

	/**
	 * The feature id for the '<em><b>Greater</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_VALUE_TYPE__GREATER = 3;

	/**
	 * The feature id for the '<em><b>Greater Or Equal</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_VALUE_TYPE__GREATER_OR_EQUAL = 4;

	/**
	 * The feature id for the '<em><b>Contains</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_VALUE_TYPE__CONTAINS = 5;

	/**
	 * The feature id for the '<em><b>Like</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_VALUE_TYPE__LIKE = 6;

	/**
	 * The feature id for the '<em><b>Is Null</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_VALUE_TYPE__IS_NULL = 7;

	/**
	 * The feature id for the '<em><b>Any</b></em>' attribute list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_VALUE_TYPE__ANY = 8;

	/**
	 * The feature id for the '<em><b>Namespace</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_VALUE_TYPE__NAMESPACE = 9;

	/**
	 * The feature id for the '<em><b>Local Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_VALUE_TYPE__LOCAL_NAME = 10;

	/**
	 * The feature id for the '<em><b>Record Metadata</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_VALUE_TYPE__RECORD_METADATA = 11;

	/**
	 * The feature id for the '<em><b>Match Any</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_VALUE_TYPE__MATCH_ANY = 12;

	/**
	 * The feature id for the '<em><b>Parent</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_VALUE_TYPE__PARENT = 13;

	/**
	 * The number of structural features of the '<em>Property Value Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_VALUE_TYPE_FEATURE_COUNT = 14;

	/**
	 * The operation id for the '<em>Add Equal</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_VALUE_TYPE___ADD_EQUAL__OBJECT = 0;

	/**
	 * The operation id for the '<em>Add Less</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_VALUE_TYPE___ADD_LESS__OBJECT = 1;

	/**
	 * The operation id for the '<em>Add Less Or Equal</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_VALUE_TYPE___ADD_LESS_OR_EQUAL__OBJECT = 2;

	/**
	 * The operation id for the '<em>Add Greater</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_VALUE_TYPE___ADD_GREATER__OBJECT = 3;

	/**
	 * The operation id for the '<em>Add Greater Or Equal</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_VALUE_TYPE___ADD_GREATER_OR_EQUAL__OBJECT = 4;

	/**
	 * The operation id for the '<em>Add Contains</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_VALUE_TYPE___ADD_CONTAINS__STRING = 5;

	/**
	 * The operation id for the '<em>Add Like</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_VALUE_TYPE___ADD_LIKE__STRING = 6;

	/**
	 * The operation id for the '<em>Add Is Null</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_VALUE_TYPE___ADD_IS_NULL = 7;

	/**
	 * The number of operations of the '<em>Property Value Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PROPERTY_VALUE_TYPE_OPERATION_COUNT = 8;

	/**
	 * The meta object id for the '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.QNameTypeImpl <em>QName Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.QNameTypeImpl
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.CmdbfPackageImpl#getQNameType()
	 * @generated
	 */
	int QNAME_TYPE = 29;

	/**
	 * The feature id for the '<em><b>Namespace</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int QNAME_TYPE__NAMESPACE = 0;

	/**
	 * The feature id for the '<em><b>Local Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int QNAME_TYPE__LOCAL_NAME = 1;

	/**
	 * The number of structural features of the '<em>QName Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int QNAME_TYPE_FEATURE_COUNT = 2;

	/**
	 * The number of operations of the '<em>QName Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int QNAME_TYPE_OPERATION_COUNT = 0;

	/**
	 * The meta object id for the '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.QueryErrorFaultTypeImpl <em>Query Error Fault Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.QueryErrorFaultTypeImpl
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.CmdbfPackageImpl#getQueryErrorFaultType()
	 * @generated
	 */
	int QUERY_ERROR_FAULT_TYPE = 30;

	/**
	 * The feature id for the '<em><b>Any</b></em>' attribute list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int QUERY_ERROR_FAULT_TYPE__ANY = 0;

	/**
	 * The number of structural features of the '<em>Query Error Fault Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int QUERY_ERROR_FAULT_TYPE_FEATURE_COUNT = 1;

	/**
	 * The number of operations of the '<em>Query Error Fault Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int QUERY_ERROR_FAULT_TYPE_OPERATION_COUNT = 0;

	/**
	 * The meta object id for the '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.QueryResultTypeImpl <em>Query Result Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.QueryResultTypeImpl
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.CmdbfPackageImpl#getQueryResultType()
	 * @generated
	 */
	int QUERY_RESULT_TYPE = 31;

	/**
	 * The meta object id for the '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.QueryTypeImpl <em>Query Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.QueryTypeImpl
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.CmdbfPackageImpl#getQueryType()
	 * @generated
	 */
	int QUERY_TYPE = 32;

	/**
	 * The meta object id for the '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.RecordConstraintTypeImpl <em>Record Constraint Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.RecordConstraintTypeImpl
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.CmdbfPackageImpl#getRecordConstraintType()
	 * @generated
	 */
	int RECORD_CONSTRAINT_TYPE = 33;

	/**
	 * The meta object id for the '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.RecordMetadataTypeImpl <em>Record Metadata Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.RecordMetadataTypeImpl
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.CmdbfPackageImpl#getRecordMetadataType()
	 * @generated
	 */
	int RECORD_METADATA_TYPE = 34;

	/**
	 * The meta object id for the '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.RecordTypeImpl <em>Record Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.RecordTypeImpl
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.CmdbfPackageImpl#getRecordType()
	 * @generated
	 */
	int RECORD_TYPE = 35;

	/**
	 * The meta object id for the '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.RecordTypeTypeImpl <em>Record Type Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.RecordTypeTypeImpl
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.CmdbfPackageImpl#getRecordTypeType()
	 * @generated
	 */
	int RECORD_TYPE_TYPE = 36;

	/**
	 * The meta object id for the '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.RegisterInstanceResponseTypeImpl <em>Register Instance Response Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.RegisterInstanceResponseTypeImpl
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.CmdbfPackageImpl#getRegisterInstanceResponseType()
	 * @generated
	 */
	int REGISTER_INSTANCE_RESPONSE_TYPE = 37;

	/**
	 * The meta object id for the '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.RegisterRequestTypeImpl <em>Register Request Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.RegisterRequestTypeImpl
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.CmdbfPackageImpl#getRegisterRequestType()
	 * @generated
	 */
	int REGISTER_REQUEST_TYPE = 38;

	/**
	 * The feature id for the '<em><b>Nodes</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int QUERY_RESULT_TYPE__NODES = 0;

	/**
	 * The feature id for the '<em><b>Edges</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int QUERY_RESULT_TYPE__EDGES = 1;

	/**
	 * The number of structural features of the '<em>Query Result Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int QUERY_RESULT_TYPE_FEATURE_COUNT = 2;

	/**
	 * The number of operations of the '<em>Query Result Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int QUERY_RESULT_TYPE_OPERATION_COUNT = 0;

	/**
	 * The feature id for the '<em><b>Item Template</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int QUERY_TYPE__ITEM_TEMPLATE = 0;

	/**
	 * The feature id for the '<em><b>Relationship Template</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int QUERY_TYPE__RELATIONSHIP_TEMPLATE = 1;

	/**
	 * The feature id for the '<em><b>Mdr Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int QUERY_TYPE__MDR_ID = 2;

	/**
	 * The feature id for the '<em><b>Model Metadata</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int QUERY_TYPE__MODEL_METADATA = 3;

	/**
	 * The number of structural features of the '<em>Query Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int QUERY_TYPE_FEATURE_COUNT = 4;

	/**
	 * The operation id for the '<em>Add Item Template</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int QUERY_TYPE___ADD_ITEM_TEMPLATE__STRING = 0;

	/**
	 * The operation id for the '<em>Add Relationship Template</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int QUERY_TYPE___ADD_RELATIONSHIP_TEMPLATE__STRING = 1;

	/**
	 * The operation id for the '<em>Get Namespace</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int QUERY_TYPE___GET_NAMESPACE__STRING = 2;

	/**
	 * The operation id for the '<em>Get Local Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int QUERY_TYPE___GET_LOCAL_NAME__STRING = 3;

	/**
	 * The number of operations of the '<em>Query Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int QUERY_TYPE_OPERATION_COUNT = 4;

	/**
	 * The feature id for the '<em><b>Record Type</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RECORD_CONSTRAINT_TYPE__RECORD_TYPE = 0;

	/**
	 * The feature id for the '<em><b>Property Value</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RECORD_CONSTRAINT_TYPE__PROPERTY_VALUE = 1;

	/**
	 * The feature id for the '<em><b>Xpath Constraint</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RECORD_CONSTRAINT_TYPE__XPATH_CONSTRAINT = 2;

	/**
	 * The feature id for the '<em><b>Any</b></em>' attribute list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RECORD_CONSTRAINT_TYPE__ANY = 3;

	/**
	 * The feature id for the '<em><b>Parent</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RECORD_CONSTRAINT_TYPE__PARENT = 4;

	/**
	 * The number of structural features of the '<em>Record Constraint Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RECORD_CONSTRAINT_TYPE_FEATURE_COUNT = 5;

	/**
	 * The operation id for the '<em>Add Record Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RECORD_CONSTRAINT_TYPE___ADD_RECORD_TYPE__STRING = 0;

	/**
	 * The operation id for the '<em>Add Record Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RECORD_CONSTRAINT_TYPE___ADD_RECORD_TYPE__STRING_STRING = 1;

	/**
	 * The operation id for the '<em>Add Property Value</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RECORD_CONSTRAINT_TYPE___ADD_PROPERTY_VALUE__STRING = 2;

	/**
	 * The operation id for the '<em>Add Property Value</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RECORD_CONSTRAINT_TYPE___ADD_PROPERTY_VALUE__STRING_STRING = 3;

	/**
	 * The number of operations of the '<em>Record Constraint Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RECORD_CONSTRAINT_TYPE_OPERATION_COUNT = 4;

	/**
	 * The feature id for the '<em><b>Record Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RECORD_METADATA_TYPE__RECORD_ID = 0;

	/**
	 * The feature id for the '<em><b>Last Modified</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RECORD_METADATA_TYPE__LAST_MODIFIED = 1;

	/**
	 * The feature id for the '<em><b>Baseline Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RECORD_METADATA_TYPE__BASELINE_ID = 2;

	/**
	 * The feature id for the '<em><b>Snapshot Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RECORD_METADATA_TYPE__SNAPSHOT_ID = 3;

	/**
	 * The feature id for the '<em><b>Any</b></em>' attribute list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RECORD_METADATA_TYPE__ANY = 4;

	/**
	 * The number of structural features of the '<em>Record Metadata Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RECORD_METADATA_TYPE_FEATURE_COUNT = 5;

	/**
	 * The number of operations of the '<em>Record Metadata Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RECORD_METADATA_TYPE_OPERATION_COUNT = 0;

	/**
	 * The feature id for the '<em><b>Any</b></em>' attribute list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RECORD_TYPE__ANY = 0;

	/**
	 * The feature id for the '<em><b>Property Set</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RECORD_TYPE__PROPERTY_SET = 1;

	/**
	 * The feature id for the '<em><b>Record Metadata</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RECORD_TYPE__RECORD_METADATA = 2;

	/**
	 * The feature id for the '<em><b>Parent</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RECORD_TYPE__PARENT = 3;

	/**
	 * The feature id for the '<em><b>Template Id</b></em>' attribute list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RECORD_TYPE__TEMPLATE_ID = 4;

	/**
	 * The feature id for the '<em><b>Record Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RECORD_TYPE__RECORD_ID = 5;

	/**
	 * The feature id for the '<em><b>Last Modified</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RECORD_TYPE__LAST_MODIFIED = 6;

	/**
	 * The feature id for the '<em><b>Type</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RECORD_TYPE__TYPE = 7;

	/**
	 * The feature id for the '<em><b>Content</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RECORD_TYPE__CONTENT = 8;

	/**
	 * The feature id for the '<em><b>Property Name</b></em>' attribute list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RECORD_TYPE__PROPERTY_NAME = 9;

	/**
	 * The number of structural features of the '<em>Record Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RECORD_TYPE_FEATURE_COUNT = 10;

	/**
	 * The operation id for the '<em>Get</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RECORD_TYPE___GET__STRING = 0;

	/**
	 * The operation id for the '<em>Set</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RECORD_TYPE___SET__STRING_OBJECT = 1;

	/**
	 * The operation id for the '<em>Unset</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RECORD_TYPE___UNSET__STRING = 2;

	/**
	 * The operation id for the '<em>Is Set</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RECORD_TYPE___IS_SET__STRING = 3;

	/**
	 * The operation id for the '<em>Has</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RECORD_TYPE___HAS__STRING = 4;

	/**
	 * The operation id for the '<em>Get As String</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RECORD_TYPE___GET_AS_STRING__STRING = 5;

	/**
	 * The operation id for the '<em>Set As String</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RECORD_TYPE___SET_AS_STRING__STRING_STRING = 6;

	/**
	 * The operation id for the '<em>Instance Of</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RECORD_TYPE___INSTANCE_OF__STRING = 7;

	/**
	 * The operation id for the '<em>Instance Of</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RECORD_TYPE___INSTANCE_OF__STRING_STRING = 8;

	/**
	 * The operation id for the '<em>Instance Of</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RECORD_TYPE___INSTANCE_OF__MODELRECORDTYPE = 9;

	/**
	 * The operation id for the '<em>Merge</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RECORD_TYPE___MERGE__RECORDTYPE = 10;

	/**
	 * The number of operations of the '<em>Record Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RECORD_TYPE_OPERATION_COUNT = 11;

	/**
	 * The feature id for the '<em><b>Local Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RECORD_TYPE_TYPE__LOCAL_NAME = 0;

	/**
	 * The feature id for the '<em><b>Namespace</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RECORD_TYPE_TYPE__NAMESPACE = 1;

	/**
	 * The number of structural features of the '<em>Record Type Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RECORD_TYPE_TYPE_FEATURE_COUNT = 2;

	/**
	 * The number of operations of the '<em>Record Type Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RECORD_TYPE_TYPE_OPERATION_COUNT = 0;

	/**
	 * The feature id for the '<em><b>Instance Id</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REGISTER_INSTANCE_RESPONSE_TYPE__INSTANCE_ID = MODEL_UPDATE_INSTANCE_RESPONSE__INSTANCE_ID;

	/**
	 * The feature id for the '<em><b>Declined</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REGISTER_INSTANCE_RESPONSE_TYPE__DECLINED = MODEL_UPDATE_INSTANCE_RESPONSE__DECLINED;

	/**
	 * The feature id for the '<em><b>Accepted</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REGISTER_INSTANCE_RESPONSE_TYPE__ACCEPTED = MODEL_UPDATE_INSTANCE_RESPONSE_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Register Instance Response Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REGISTER_INSTANCE_RESPONSE_TYPE_FEATURE_COUNT = MODEL_UPDATE_INSTANCE_RESPONSE_FEATURE_COUNT + 1;

	/**
	 * The number of operations of the '<em>Register Instance Response Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REGISTER_INSTANCE_RESPONSE_TYPE_OPERATION_COUNT = MODEL_UPDATE_INSTANCE_RESPONSE_OPERATION_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Mdr Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REGISTER_REQUEST_TYPE__MDR_ID = 0;

	/**
	 * The feature id for the '<em><b>Item List</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REGISTER_REQUEST_TYPE__ITEM_LIST = 1;

	/**
	 * The feature id for the '<em><b>Relationship List</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REGISTER_REQUEST_TYPE__RELATIONSHIP_LIST = 2;

	/**
	 * The feature id for the '<em><b>Parent</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REGISTER_REQUEST_TYPE__PARENT = 3;

	/**
	 * The number of structural features of the '<em>Register Request Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REGISTER_REQUEST_TYPE_FEATURE_COUNT = 4;

	/**
	 * The number of operations of the '<em>Register Request Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REGISTER_REQUEST_TYPE_OPERATION_COUNT = 0;

	/**
	 * The meta object id for the '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.RegisterResponseTypeImpl <em>Register Response Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.RegisterResponseTypeImpl
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.CmdbfPackageImpl#getRegisterResponseType()
	 * @generated
	 */
	int REGISTER_RESPONSE_TYPE = 39;

	/**
	 * The feature id for the '<em><b>Register Instance Response</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REGISTER_RESPONSE_TYPE__REGISTER_INSTANCE_RESPONSE = 0;

	/**
	 * The number of structural features of the '<em>Register Response Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REGISTER_RESPONSE_TYPE_FEATURE_COUNT = 1;

	/**
	 * The number of operations of the '<em>Register Response Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REGISTER_RESPONSE_TYPE_OPERATION_COUNT = 0;

	/**
	 * The meta object id for the '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.RegistrationErrorFaultTypeImpl <em>Registration Error Fault Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.RegistrationErrorFaultTypeImpl
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.CmdbfPackageImpl#getRegistrationErrorFaultType()
	 * @generated
	 */
	int REGISTRATION_ERROR_FAULT_TYPE = 40;

	/**
	 * The feature id for the '<em><b>Record Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REGISTRATION_ERROR_FAULT_TYPE__RECORD_ID = 0;

	/**
	 * The number of structural features of the '<em>Registration Error Fault Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REGISTRATION_ERROR_FAULT_TYPE_FEATURE_COUNT = 1;

	/**
	 * The number of operations of the '<em>Registration Error Fault Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int REGISTRATION_ERROR_FAULT_TYPE_OPERATION_COUNT = 0;

	/**
	 * The meta object id for the '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.RelationshipListTypeImpl <em>Relationship List Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.RelationshipListTypeImpl
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.CmdbfPackageImpl#getRelationshipListType()
	 * @generated
	 */
	int RELATIONSHIP_LIST_TYPE = 41;

	/**
	 * The feature id for the '<em><b>Relationship</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RELATIONSHIP_LIST_TYPE__RELATIONSHIP = 0;

	/**
	 * The number of structural features of the '<em>Relationship List Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RELATIONSHIP_LIST_TYPE_FEATURE_COUNT = 1;

	/**
	 * The operation id for the '<em>Find</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RELATIONSHIP_LIST_TYPE___FIND__MDRSCOPEDIDTYPE = 0;

	/**
	 * The operation id for the '<em>Find</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RELATIONSHIP_LIST_TYPE___FIND__RELATIONSHIPTYPE = 1;

	/**
	 * The number of operations of the '<em>Relationship List Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RELATIONSHIP_LIST_TYPE_OPERATION_COUNT = 2;

	/**
	 * The meta object id for the '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.RelationshipRefTypeImpl <em>Relationship Ref Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.RelationshipRefTypeImpl
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.CmdbfPackageImpl#getRelationshipRefType()
	 * @generated
	 */
	int RELATIONSHIP_REF_TYPE = 42;

	/**
	 * The feature id for the '<em><b>Ref</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RELATIONSHIP_REF_TYPE__REF = 0;

	/**
	 * The feature id for the '<em><b>Minimum</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RELATIONSHIP_REF_TYPE__MINIMUM = 1;

	/**
	 * The feature id for the '<em><b>Maximum</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RELATIONSHIP_REF_TYPE__MAXIMUM = 2;

	/**
	 * The number of structural features of the '<em>Relationship Ref Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RELATIONSHIP_REF_TYPE_FEATURE_COUNT = 3;

	/**
	 * The number of operations of the '<em>Relationship Ref Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RELATIONSHIP_REF_TYPE_OPERATION_COUNT = 0;

	/**
	 * The meta object id for the '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.RelationshipTemplateTypeImpl <em>Relationship Template Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.RelationshipTemplateTypeImpl
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.CmdbfPackageImpl#getRelationshipTemplateType()
	 * @generated
	 */
	int RELATIONSHIP_TEMPLATE_TYPE = 43;

	/**
	 * The feature id for the '<em><b>Content Selector</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RELATIONSHIP_TEMPLATE_TYPE__CONTENT_SELECTOR = MODEL_TEMPLATE__CONTENT_SELECTOR;

	/**
	 * The feature id for the '<em><b>Instance Id Constraint</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RELATIONSHIP_TEMPLATE_TYPE__INSTANCE_ID_CONSTRAINT = MODEL_TEMPLATE__INSTANCE_ID_CONSTRAINT;

	/**
	 * The feature id for the '<em><b>Record Constraint</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RELATIONSHIP_TEMPLATE_TYPE__RECORD_CONSTRAINT = MODEL_TEMPLATE__RECORD_CONSTRAINT;

	/**
	 * The feature id for the '<em><b>Any</b></em>' attribute list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RELATIONSHIP_TEMPLATE_TYPE__ANY = MODEL_TEMPLATE__ANY;

	/**
	 * The feature id for the '<em><b>Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RELATIONSHIP_TEMPLATE_TYPE__ID = MODEL_TEMPLATE__ID;

	/**
	 * The feature id for the '<em><b>Suppress From Result</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RELATIONSHIP_TEMPLATE_TYPE__SUPPRESS_FROM_RESULT = MODEL_TEMPLATE__SUPPRESS_FROM_RESULT;

	/**
	 * The feature id for the '<em><b>Query</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RELATIONSHIP_TEMPLATE_TYPE__QUERY = MODEL_TEMPLATE__QUERY;

	/**
	 * The feature id for the '<em><b>Source Template</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RELATIONSHIP_TEMPLATE_TYPE__SOURCE_TEMPLATE = MODEL_TEMPLATE_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Target Template</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RELATIONSHIP_TEMPLATE_TYPE__TARGET_TEMPLATE = MODEL_TEMPLATE_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Depth Limit</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RELATIONSHIP_TEMPLATE_TYPE__DEPTH_LIMIT = MODEL_TEMPLATE_FEATURE_COUNT + 2;

	/**
	 * The number of structural features of the '<em>Relationship Template Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RELATIONSHIP_TEMPLATE_TYPE_FEATURE_COUNT = MODEL_TEMPLATE_FEATURE_COUNT + 3;

	/**
	 * The operation id for the '<em>Add Instance Id Constraint</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RELATIONSHIP_TEMPLATE_TYPE___ADD_INSTANCE_ID_CONSTRAINT__STRING = MODEL_TEMPLATE___ADD_INSTANCE_ID_CONSTRAINT__STRING;

	/**
	 * The operation id for the '<em>Add Instance Id Constraint</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RELATIONSHIP_TEMPLATE_TYPE___ADD_INSTANCE_ID_CONSTRAINT__STRING_STRING = MODEL_TEMPLATE___ADD_INSTANCE_ID_CONSTRAINT__STRING_STRING;

	/**
	 * The operation id for the '<em>Add Record Constraint</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RELATIONSHIP_TEMPLATE_TYPE___ADD_RECORD_CONSTRAINT = MODEL_TEMPLATE___ADD_RECORD_CONSTRAINT;

	/**
	 * The operation id for the '<em>Add Content Selector</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RELATIONSHIP_TEMPLATE_TYPE___ADD_CONTENT_SELECTOR__STRING = MODEL_TEMPLATE___ADD_CONTENT_SELECTOR__STRING;

	/**
	 * The operation id for the '<em>Add Content Selector</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RELATIONSHIP_TEMPLATE_TYPE___ADD_CONTENT_SELECTOR__STRING_STRING = MODEL_TEMPLATE___ADD_CONTENT_SELECTOR__STRING_STRING;

	/**
	 * The operation id for the '<em>Add Source Template</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RELATIONSHIP_TEMPLATE_TYPE___ADD_SOURCE_TEMPLATE__ITEMTEMPLATETYPE = MODEL_TEMPLATE_OPERATION_COUNT + 0;

	/**
	 * The operation id for the '<em>Add Target Template</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RELATIONSHIP_TEMPLATE_TYPE___ADD_TARGET_TEMPLATE__ITEMTEMPLATETYPE = MODEL_TEMPLATE_OPERATION_COUNT + 1;

	/**
	 * The operation id for the '<em>Add Depth Limit</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RELATIONSHIP_TEMPLATE_TYPE___ADD_DEPTH_LIMIT__ITEMTEMPLATETYPE = MODEL_TEMPLATE_OPERATION_COUNT + 2;

	/**
	 * The number of operations of the '<em>Relationship Template Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RELATIONSHIP_TEMPLATE_TYPE_OPERATION_COUNT = MODEL_TEMPLATE_OPERATION_COUNT + 3;

	/**
	 * The meta object id for the '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.RelationshipTypeImpl <em>Relationship Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.RelationshipTypeImpl
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.CmdbfPackageImpl#getRelationshipType()
	 * @generated
	 */
	int RELATIONSHIP_TYPE = 44;

	/**
	 * The feature id for the '<em><b>Record</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RELATIONSHIP_TYPE__RECORD = MODEL_ELEMENT__RECORD;

	/**
	 * The feature id for the '<em><b>Instance Id</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RELATIONSHIP_TYPE__INSTANCE_ID = MODEL_ELEMENT__INSTANCE_ID;

	/**
	 * The feature id for the '<em><b>Additional Record Type</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RELATIONSHIP_TYPE__ADDITIONAL_RECORD_TYPE = MODEL_ELEMENT__ADDITIONAL_RECORD_TYPE;

	/**
	 * The feature id for the '<em><b>Template Id</b></em>' attribute list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RELATIONSHIP_TYPE__TEMPLATE_ID = MODEL_ELEMENT__TEMPLATE_ID;

	/**
	 * The feature id for the '<em><b>Parent</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RELATIONSHIP_TYPE__PARENT = MODEL_ELEMENT__PARENT;

	/**
	 * The feature id for the '<em><b>Deregister</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RELATIONSHIP_TYPE__DEREGISTER = MODEL_ELEMENT__DEREGISTER;

	/**
	 * The feature id for the '<em><b>Source Item</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RELATIONSHIP_TYPE__SOURCE_ITEM = MODEL_ELEMENT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Target Item</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RELATIONSHIP_TYPE__TARGET_ITEM = MODEL_ELEMENT_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>Relationship Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RELATIONSHIP_TYPE_FEATURE_COUNT = MODEL_ELEMENT_FEATURE_COUNT + 2;

	/**
	 * The operation id for the '<em>Find Instance Id</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RELATIONSHIP_TYPE___FIND_INSTANCE_ID = MODEL_ELEMENT___FIND_INSTANCE_ID;

	/**
	 * The operation id for the '<em>Find Instance Id</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RELATIONSHIP_TYPE___FIND_INSTANCE_ID__STRING = MODEL_ELEMENT___FIND_INSTANCE_ID__STRING;

	/**
	 * The operation id for the '<em>Add Instance Id</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RELATIONSHIP_TYPE___ADD_INSTANCE_ID__STRING = MODEL_ELEMENT___ADD_INSTANCE_ID__STRING;

	/**
	 * The operation id for the '<em>Add Instance Id</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RELATIONSHIP_TYPE___ADD_INSTANCE_ID__STRING_STRING = MODEL_ELEMENT___ADD_INSTANCE_ID__STRING_STRING;

	/**
	 * The operation id for the '<em>Add Additional Record Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RELATIONSHIP_TYPE___ADD_ADDITIONAL_RECORD_TYPE__STRING = MODEL_ELEMENT___ADD_ADDITIONAL_RECORD_TYPE__STRING;

	/**
	 * The operation id for the '<em>Add Additional Record Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RELATIONSHIP_TYPE___ADD_ADDITIONAL_RECORD_TYPE__STRING_STRING = MODEL_ELEMENT___ADD_ADDITIONAL_RECORD_TYPE__STRING_STRING;

	/**
	 * The operation id for the '<em>Add Record</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RELATIONSHIP_TYPE___ADD_RECORD__STRING = MODEL_ELEMENT___ADD_RECORD__STRING;

	/**
	 * The operation id for the '<em>Add Record</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RELATIONSHIP_TYPE___ADD_RECORD__STRING_STRING = MODEL_ELEMENT___ADD_RECORD__STRING_STRING;

	/**
	 * The operation id for the '<em>Add Record</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RELATIONSHIP_TYPE___ADD_RECORD__STRING_BOOLEAN = MODEL_ELEMENT___ADD_RECORD__STRING_BOOLEAN;

	/**
	 * The operation id for the '<em>Add Record</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RELATIONSHIP_TYPE___ADD_RECORD__STRING_STRING_BOOLEAN = MODEL_ELEMENT___ADD_RECORD__STRING_STRING_BOOLEAN;

	/**
	 * The operation id for the '<em>Find Record</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RELATIONSHIP_TYPE___FIND_RECORD__STRING = MODEL_ELEMENT___FIND_RECORD__STRING;

	/**
	 * The operation id for the '<em>Find Record</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RELATIONSHIP_TYPE___FIND_RECORD__STRING_STRING = MODEL_ELEMENT___FIND_RECORD__STRING_STRING;

	/**
	 * The operation id for the '<em>Find Record By Template</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RELATIONSHIP_TYPE___FIND_RECORD_BY_TEMPLATE__STRING_STRING = MODEL_ELEMENT___FIND_RECORD_BY_TEMPLATE__STRING_STRING;

	/**
	 * The operation id for the '<em>Find Record By Template</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RELATIONSHIP_TYPE___FIND_RECORD_BY_TEMPLATE__STRING_STRING_STRING = MODEL_ELEMENT___FIND_RECORD_BY_TEMPLATE__STRING_STRING_STRING;

	/**
	 * The operation id for the '<em>Find Record By Id</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RELATIONSHIP_TYPE___FIND_RECORD_BY_ID__STRING = MODEL_ELEMENT___FIND_RECORD_BY_ID__STRING;

	/**
	 * The operation id for the '<em>Merge</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RELATIONSHIP_TYPE___MERGE__MODELELEMENT = MODEL_ELEMENT___MERGE__MODELELEMENT;

	/**
	 * The number of operations of the '<em>Relationship Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RELATIONSHIP_TYPE_OPERATION_COUNT = MODEL_ELEMENT_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.SelectedRecordTypeTypeImpl <em>Selected Record Type Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.SelectedRecordTypeTypeImpl
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.CmdbfPackageImpl#getSelectedRecordTypeType()
	 * @generated
	 */
	int SELECTED_RECORD_TYPE_TYPE = 45;

	/**
	 * The feature id for the '<em><b>Selected Property</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SELECTED_RECORD_TYPE_TYPE__SELECTED_PROPERTY = 0;

	/**
	 * The feature id for the '<em><b>Namespace</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SELECTED_RECORD_TYPE_TYPE__NAMESPACE = 1;

	/**
	 * The feature id for the '<em><b>Local Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SELECTED_RECORD_TYPE_TYPE__LOCAL_NAME = 2;

	/**
	 * The feature id for the '<em><b>Parent</b></em>' container reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SELECTED_RECORD_TYPE_TYPE__PARENT = 3;

	/**
	 * The number of structural features of the '<em>Selected Record Type Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SELECTED_RECORD_TYPE_TYPE_FEATURE_COUNT = 4;

	/**
	 * The operation id for the '<em>Add Selected Property</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SELECTED_RECORD_TYPE_TYPE___ADD_SELECTED_PROPERTY__STRING = 0;

	/**
	 * The operation id for the '<em>Add Selected Property</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SELECTED_RECORD_TYPE_TYPE___ADD_SELECTED_PROPERTY__STRING_STRING = 1;

	/**
	 * The number of operations of the '<em>Selected Record Type Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SELECTED_RECORD_TYPE_TYPE_OPERATION_COUNT = 2;

	/**
	 * The meta object id for the '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.SelectorTypeImpl <em>Selector Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.SelectorTypeImpl
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.CmdbfPackageImpl#getSelectorType()
	 * @generated
	 */
	int SELECTOR_TYPE = 46;

	/**
	 * The feature id for the '<em><b>Local Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SELECTOR_TYPE__LOCAL_NAME = 0;

	/**
	 * The feature id for the '<em><b>Namespace</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SELECTOR_TYPE__NAMESPACE = 1;

	/**
	 * The number of structural features of the '<em>Selector Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SELECTOR_TYPE_FEATURE_COUNT = 2;

	/**
	 * The number of operations of the '<em>Selector Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SELECTOR_TYPE_OPERATION_COUNT = 0;

	/**
	 * The meta object id for the '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.StringOperatorTypeImpl <em>String Operator Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.StringOperatorTypeImpl
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.CmdbfPackageImpl#getStringOperatorType()
	 * @generated
	 */
	int STRING_OPERATOR_TYPE = 47;

	/**
	 * The feature id for the '<em><b>Value</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int STRING_OPERATOR_TYPE__VALUE = 0;

	/**
	 * The feature id for the '<em><b>Case Sensitive</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int STRING_OPERATOR_TYPE__CASE_SENSITIVE = 1;

	/**
	 * The feature id for the '<em><b>Negate</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int STRING_OPERATOR_TYPE__NEGATE = 2;

	/**
	 * The number of structural features of the '<em>String Operator Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int STRING_OPERATOR_TYPE_FEATURE_COUNT = 3;

	/**
	 * The number of operations of the '<em>String Operator Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int STRING_OPERATOR_TYPE_OPERATION_COUNT = 0;

	/**
	 * The meta object id for the '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.UnknownTemplateIDFaultTypeImpl <em>Unknown Template ID Fault Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.UnknownTemplateIDFaultTypeImpl
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.CmdbfPackageImpl#getUnknownTemplateIDFaultType()
	 * @generated
	 */
	int UNKNOWN_TEMPLATE_ID_FAULT_TYPE = 48;

	/**
	 * The feature id for the '<em><b>Graph Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int UNKNOWN_TEMPLATE_ID_FAULT_TYPE__GRAPH_ID = 0;

	/**
	 * The number of structural features of the '<em>Unknown Template ID Fault Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int UNKNOWN_TEMPLATE_ID_FAULT_TYPE_FEATURE_COUNT = 1;

	/**
	 * The number of operations of the '<em>Unknown Template ID Fault Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int UNKNOWN_TEMPLATE_ID_FAULT_TYPE_OPERATION_COUNT = 0;

	/**
	 * The meta object id for the '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.UnsupportedConstraintFaultTypeImpl <em>Unsupported Constraint Fault Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.UnsupportedConstraintFaultTypeImpl
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.CmdbfPackageImpl#getUnsupportedConstraintFaultType()
	 * @generated
	 */
	int UNSUPPORTED_CONSTRAINT_FAULT_TYPE = 49;

	/**
	 * The feature id for the '<em><b>Constraint</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int UNSUPPORTED_CONSTRAINT_FAULT_TYPE__CONSTRAINT = 0;

	/**
	 * The number of structural features of the '<em>Unsupported Constraint Fault Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int UNSUPPORTED_CONSTRAINT_FAULT_TYPE_FEATURE_COUNT = 1;

	/**
	 * The number of operations of the '<em>Unsupported Constraint Fault Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int UNSUPPORTED_CONSTRAINT_FAULT_TYPE_OPERATION_COUNT = 0;

	/**
	 * The meta object id for the '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.UnsupportedRecordTypeFaultTypeImpl <em>Unsupported Record Type Fault Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.UnsupportedRecordTypeFaultTypeImpl
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.CmdbfPackageImpl#getUnsupportedRecordTypeFaultType()
	 * @generated
	 */
	int UNSUPPORTED_RECORD_TYPE_FAULT_TYPE = 50;

	/**
	 * The feature id for the '<em><b>Record Type</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int UNSUPPORTED_RECORD_TYPE_FAULT_TYPE__RECORD_TYPE = 0;

	/**
	 * The number of structural features of the '<em>Unsupported Record Type Fault Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int UNSUPPORTED_RECORD_TYPE_FAULT_TYPE_FEATURE_COUNT = 1;

	/**
	 * The number of operations of the '<em>Unsupported Record Type Fault Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int UNSUPPORTED_RECORD_TYPE_FAULT_TYPE_OPERATION_COUNT = 0;

	/**
	 * The meta object id for the '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.UnsupportedSelectorFaultTypeImpl <em>Unsupported Selector Fault Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.UnsupportedSelectorFaultTypeImpl
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.CmdbfPackageImpl#getUnsupportedSelectorFaultType()
	 * @generated
	 */
	int UNSUPPORTED_SELECTOR_FAULT_TYPE = 51;

	/**
	 * The feature id for the '<em><b>Selector</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int UNSUPPORTED_SELECTOR_FAULT_TYPE__SELECTOR = 0;

	/**
	 * The number of structural features of the '<em>Unsupported Selector Fault Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int UNSUPPORTED_SELECTOR_FAULT_TYPE_FEATURE_COUNT = 1;

	/**
	 * The number of operations of the '<em>Unsupported Selector Fault Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int UNSUPPORTED_SELECTOR_FAULT_TYPE_OPERATION_COUNT = 0;

	/**
	 * The meta object id for the '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.XPathErrorFaultTypeImpl <em>XPath Error Fault Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.XPathErrorFaultTypeImpl
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.CmdbfPackageImpl#getXPathErrorFaultType()
	 * @generated
	 */
	int XPATH_ERROR_FAULT_TYPE = 52;

	/**
	 * The feature id for the '<em><b>Expression</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int XPATH_ERROR_FAULT_TYPE__EXPRESSION = 0;

	/**
	 * The feature id for the '<em><b>Xpath Error Code</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int XPATH_ERROR_FAULT_TYPE__XPATH_ERROR_CODE = 1;

	/**
	 * The number of structural features of the '<em>XPath Error Fault Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int XPATH_ERROR_FAULT_TYPE_FEATURE_COUNT = 2;

	/**
	 * The number of operations of the '<em>XPath Error Fault Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int XPATH_ERROR_FAULT_TYPE_OPERATION_COUNT = 0;

	/**
	 * The meta object id for the '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.XPathExpressionTypeImpl <em>XPath Expression Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.XPathExpressionTypeImpl
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.CmdbfPackageImpl#getXPathExpressionType()
	 * @generated
	 */
	int XPATH_EXPRESSION_TYPE = 53;

	/**
	 * The feature id for the '<em><b>Prefix Mapping</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int XPATH_EXPRESSION_TYPE__PREFIX_MAPPING = 0;

	/**
	 * The feature id for the '<em><b>Expression</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int XPATH_EXPRESSION_TYPE__EXPRESSION = 1;

	/**
	 * The feature id for the '<em><b>Dialect</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int XPATH_EXPRESSION_TYPE__DIALECT = 2;

	/**
	 * The number of structural features of the '<em>XPath Expression Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int XPATH_EXPRESSION_TYPE_FEATURE_COUNT = 3;

	/**
	 * The number of operations of the '<em>XPath Expression Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int XPATH_EXPRESSION_TYPE_OPERATION_COUNT = 0;

	/**
	 * The meta object id for the '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.ModelUpdateResponseImpl <em>Model Update Response</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.ModelUpdateResponseImpl
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.CmdbfPackageImpl#getModelUpdateResponse()
	 * @generated
	 */
	int MODEL_UPDATE_RESPONSE = 57;

	/**
	 * The feature id for the '<em><b>Instance Response</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODEL_UPDATE_RESPONSE__INSTANCE_RESPONSE = 0;

	/**
	 * The number of structural features of the '<em>Model Update Response</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODEL_UPDATE_RESPONSE_FEATURE_COUNT = 1;

	/**
	 * The number of operations of the '<em>Model Update Response</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODEL_UPDATE_RESPONSE_OPERATION_COUNT = 0;


	/**
	 * The meta object id for the '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.ModelRecordTypeImpl <em>Model Record Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.ModelRecordTypeImpl
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.CmdbfPackageImpl#getModelRecordType()
	 * @generated
	 */
	int MODEL_RECORD_TYPE = 58;

	/**
	 * The feature id for the '<em><b>Local Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODEL_RECORD_TYPE__LOCAL_NAME = 0;

	/**
	 * The feature id for the '<em><b>Namespace</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODEL_RECORD_TYPE__NAMESPACE = 1;

	/**
	 * The feature id for the '<em><b>Applies To Item</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODEL_RECORD_TYPE__APPLIES_TO_ITEM = 2;

	/**
	 * The feature id for the '<em><b>Applies To Relationship</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODEL_RECORD_TYPE__APPLIES_TO_RELATIONSHIP = 3;

	/**
	 * The feature id for the '<em><b>Super Type</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODEL_RECORD_TYPE__SUPER_TYPE = 4;

	/**
	 * The number of structural features of the '<em>Model Record Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODEL_RECORD_TYPE_FEATURE_COUNT = 5;

	/**
	 * The operation id for the '<em>Is Assignable From</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODEL_RECORD_TYPE___IS_ASSIGNABLE_FROM__MODELRECORDTYPE = 0;

	/**
	 * The number of operations of the '<em>Model Record Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODEL_RECORD_TYPE_OPERATION_COUNT = 1;


	/**
	 * The meta object id for the '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.ModelImpl <em>Model</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.ModelImpl
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.CmdbfPackageImpl#getModel()
	 * @generated
	 */
	int MODEL = 59;

	/**
	 * The feature id for the '<em><b>Register</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODEL__REGISTER = 0;

	/**
	 * The feature id for the '<em><b>Deregister</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODEL__DEREGISTER = 1;

	/**
	 * The feature id for the '<em><b>Item</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODEL__ITEM = 2;

	/**
	 * The feature id for the '<em><b>Relationship</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODEL__RELATIONSHIP = 3;

	/**
	 * The feature id for the '<em><b>Model Metadata</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODEL__MODEL_METADATA = 4;

	/**
	 * The feature id for the '<em><b>Mdr Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODEL__MDR_ID = 5;

	/**
	 * The feature id for the '<em><b>Removed Item Id</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODEL__REMOVED_ITEM_ID = 6;

	/**
	 * The feature id for the '<em><b>Removed Relationship Id</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODEL__REMOVED_RELATIONSHIP_ID = 7;

	/**
	 * The number of structural features of the '<em>Model</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODEL_FEATURE_COUNT = 8;

	/**
	 * The operation id for the '<em>Add Item</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODEL___ADD_ITEM = 0;

	/**
	 * The operation id for the '<em>Add Relationship</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODEL___ADD_RELATIONSHIP = 1;

	/**
	 * The operation id for the '<em>Get Item By Template</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODEL___GET_ITEM_BY_TEMPLATE__STRING = 2;

	/**
	 * The operation id for the '<em>Get Relationship By Template</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODEL___GET_RELATIONSHIP_BY_TEMPLATE__STRING = 3;

	/**
	 * The operation id for the '<em>Find Item</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODEL___FIND_ITEM__MDRSCOPEDIDTYPE = 4;

	/**
	 * The operation id for the '<em>Find Item</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODEL___FIND_ITEM__ITEMTYPE = 5;

	/**
	 * The operation id for the '<em>Find Item</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODEL___FIND_ITEM__STRING_STRING = 6;

	/**
	 * The operation id for the '<em>Find Relationship</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODEL___FIND_RELATIONSHIP__MDRSCOPEDIDTYPE = 7;

	/**
	 * The operation id for the '<em>Find Relationship</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODEL___FIND_RELATIONSHIP__RELATIONSHIPTYPE = 8;

	/**
	 * The operation id for the '<em>Find Relationship</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODEL___FIND_RELATIONSHIP__STRING_STRING = 9;

	/**
	 * The operation id for the '<em>Remove</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODEL___REMOVE__ITEMTYPE = 10;

	/**
	 * The operation id for the '<em>Remove</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODEL___REMOVE__RELATIONSHIPTYPE = 11;

	/**
	 * The number of operations of the '<em>Model</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODEL_OPERATION_COUNT = 12;


	/**
	 * The meta object id for the '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.ModelMetadataImpl <em>Model Metadata</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.ModelMetadataImpl
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.CmdbfPackageImpl#getModelMetadata()
	 * @generated
	 */
	int MODEL_METADATA = 60;

	/**
	 * The number of structural features of the '<em>Model Metadata</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODEL_METADATA_FEATURE_COUNT = 0;

	/**
	 * The operation id for the '<em>Get Element</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODEL_METADATA___GET_ELEMENT__STRING_STRING = 0;

	/**
	 * The operation id for the '<em>Get Namespace</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODEL_METADATA___GET_NAMESPACE__ECLASSIFIER = 1;

	/**
	 * The operation id for the '<em>Get Local Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODEL_METADATA___GET_LOCAL_NAME__ECLASSIFIER = 2;

	/**
	 * The operation id for the '<em>Get Record Type</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODEL_METADATA___GET_RECORD_TYPE__STRING_STRING = 3;

	/**
	 * The operation id for the '<em>Get Namespace</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODEL_METADATA___GET_NAMESPACE__STRING = 4;

	/**
	 * The operation id for the '<em>Get Local Name</em>' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODEL_METADATA___GET_LOCAL_NAME__STRING = 5;

	/**
	 * The number of operations of the '<em>Model Metadata</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int MODEL_METADATA_OPERATION_COUNT = 6;


	/**
	 * Returns the meta object for class '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.AcceptedType <em>Accepted Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Accepted Type</em>'.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.AcceptedType
	 * @generated
	 */
	EClass getAcceptedType();

	/**
	 * Returns the meta object for the containment reference list '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.AcceptedType#getAlternateInstanceId <em>Alternate Instance Id</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Alternate Instance Id</em>'.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.AcceptedType#getAlternateInstanceId()
	 * @see #getAcceptedType()
	 * @generated
	 */
	EReference getAcceptedType_AlternateInstanceId();

	/**
	 * Returns the meta object for class '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.ComparisonOperatorType <em>Comparison Operator Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Comparison Operator Type</em>'.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.ComparisonOperatorType
	 * @generated
	 */
	EClass getComparisonOperatorType();

	/**
	 * Returns the meta object for the attribute '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.ComparisonOperatorType#getValue <em>Value</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Value</em>'.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.ComparisonOperatorType#getValue()
	 * @see #getComparisonOperatorType()
	 * @generated
	 */
	EAttribute getComparisonOperatorType_Value();

	/**
	 * Returns the meta object for the attribute '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.ComparisonOperatorType#isNegate <em>Negate</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Negate</em>'.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.ComparisonOperatorType#isNegate()
	 * @see #getComparisonOperatorType()
	 * @generated
	 */
	EAttribute getComparisonOperatorType_Negate();

	/**
	 * Returns the meta object for class '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.ConstraintType <em>Constraint Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Constraint Type</em>'.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.ConstraintType
	 * @generated
	 */
	EClass getConstraintType();

	/**
	 * Returns the meta object for the attribute '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.ConstraintType#getLocalName <em>Local Name</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Local Name</em>'.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.ConstraintType#getLocalName()
	 * @see #getConstraintType()
	 * @generated
	 */
	EAttribute getConstraintType_LocalName();

	/**
	 * Returns the meta object for the attribute '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.ConstraintType#getNamespace <em>Namespace</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Namespace</em>'.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.ConstraintType#getNamespace()
	 * @see #getConstraintType()
	 * @generated
	 */
	EAttribute getConstraintType_Namespace();

	/**
	 * Returns the meta object for class '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.ContentSelectorType <em>Content Selector Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Content Selector Type</em>'.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.ContentSelectorType
	 * @generated
	 */
	EClass getContentSelectorType();

	/**
	 * Returns the meta object for the containment reference list '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.ContentSelectorType#getSelectedRecordType <em>Selected Record Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Selected Record Type</em>'.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.ContentSelectorType#getSelectedRecordType()
	 * @see #getContentSelectorType()
	 * @generated
	 */
	EReference getContentSelectorType_SelectedRecordType();

	/**
	 * Returns the meta object for the containment reference '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.ContentSelectorType#getXpathSelector <em>Xpath Selector</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Xpath Selector</em>'.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.ContentSelectorType#getXpathSelector()
	 * @see #getContentSelectorType()
	 * @generated
	 */
	EReference getContentSelectorType_XpathSelector();

	/**
	 * Returns the meta object for the attribute list '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.ContentSelectorType#getAny <em>Any</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute list '<em>Any</em>'.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.ContentSelectorType#getAny()
	 * @see #getContentSelectorType()
	 * @generated
	 */
	EAttribute getContentSelectorType_Any();

	/**
	 * Returns the meta object for the container reference '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.ContentSelectorType#getParent <em>Parent</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>Parent</em>'.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.ContentSelectorType#getParent()
	 * @see #getContentSelectorType()
	 * @generated
	 */
	EReference getContentSelectorType_Parent();

	/**
	 * Returns the meta object for class '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.DeclinedType <em>Declined Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Declined Type</em>'.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.DeclinedType
	 * @generated
	 */
	EClass getDeclinedType();

	/**
	 * Returns the meta object for the attribute list '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.DeclinedType#getReason <em>Reason</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute list '<em>Reason</em>'.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.DeclinedType#getReason()
	 * @see #getDeclinedType()
	 * @generated
	 */
	EAttribute getDeclinedType_Reason();

	/**
	 * Returns the meta object for class '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.DepthLimitType <em>Depth Limit Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Depth Limit Type</em>'.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.DepthLimitType
	 * @generated
	 */
	EClass getDepthLimitType();

	/**
	 * Returns the meta object for the attribute '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.DepthLimitType#getMaxIntermediateItems <em>Max Intermediate Items</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Max Intermediate Items</em>'.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.DepthLimitType#getMaxIntermediateItems()
	 * @see #getDepthLimitType()
	 * @generated
	 */
	EAttribute getDepthLimitType_MaxIntermediateItems();

	/**
	 * Returns the meta object for the attribute '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.DepthLimitType#getIntermediateItemTemplate <em>Intermediate Item Template</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Intermediate Item Template</em>'.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.DepthLimitType#getIntermediateItemTemplate()
	 * @see #getDepthLimitType()
	 * @generated
	 */
	EAttribute getDepthLimitType_IntermediateItemTemplate();

	/**
	 * Returns the meta object for class '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.DeregisterInstanceResponseType <em>Deregister Instance Response Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Deregister Instance Response Type</em>'.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.DeregisterInstanceResponseType
	 * @generated
	 */
	EClass getDeregisterInstanceResponseType();

	/**
	 * Returns the meta object for the attribute '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.DeregisterInstanceResponseType#getAccepted <em>Accepted</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Accepted</em>'.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.DeregisterInstanceResponseType#getAccepted()
	 * @see #getDeregisterInstanceResponseType()
	 * @generated
	 */
	EAttribute getDeregisterInstanceResponseType_Accepted();

	/**
	 * Returns the meta object for class '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.DeregisterRequestType <em>Deregister Request Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Deregister Request Type</em>'.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.DeregisterRequestType
	 * @generated
	 */
	EClass getDeregisterRequestType();

	/**
	 * Returns the meta object for the attribute '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.DeregisterRequestType#getMdrId <em>Mdr Id</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Mdr Id</em>'.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.DeregisterRequestType#getMdrId()
	 * @see #getDeregisterRequestType()
	 * @generated
	 */
	EAttribute getDeregisterRequestType_MdrId();

	/**
	 * Returns the meta object for the containment reference '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.DeregisterRequestType#getItemIdList <em>Item Id List</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Item Id List</em>'.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.DeregisterRequestType#getItemIdList()
	 * @see #getDeregisterRequestType()
	 * @generated
	 */
	EReference getDeregisterRequestType_ItemIdList();

	/**
	 * Returns the meta object for the containment reference '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.DeregisterRequestType#getRelationshipIdList <em>Relationship Id List</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Relationship Id List</em>'.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.DeregisterRequestType#getRelationshipIdList()
	 * @see #getDeregisterRequestType()
	 * @generated
	 */
	EReference getDeregisterRequestType_RelationshipIdList();

	/**
	 * Returns the meta object for class '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.DeregisterResponseType <em>Deregister Response Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Deregister Response Type</em>'.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.DeregisterResponseType
	 * @generated
	 */
	EClass getDeregisterResponseType();

	/**
	 * Returns the meta object for the containment reference list '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.DeregisterResponseType#getDeregisterInstanceResponse <em>Deregister Instance Response</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Deregister Instance Response</em>'.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.DeregisterResponseType#getDeregisterInstanceResponse()
	 * @see #getDeregisterResponseType()
	 * @generated
	 */
	EReference getDeregisterResponseType_DeregisterInstanceResponse();

	/**
	 * Returns the meta object for class '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.DeregistrationErrorFaultType <em>Deregistration Error Fault Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Deregistration Error Fault Type</em>'.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.DeregistrationErrorFaultType
	 * @generated
	 */
	EClass getDeregistrationErrorFaultType();

	/**
	 * Returns the meta object for the attribute '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.DeregistrationErrorFaultType#getRecordId <em>Record Id</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Record Id</em>'.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.DeregistrationErrorFaultType#getRecordId()
	 * @see #getDeregistrationErrorFaultType()
	 * @generated
	 */
	EAttribute getDeregistrationErrorFaultType_RecordId();

	/**
	 * Returns the meta object for class '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.DocumentRoot <em>Document Root</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Document Root</em>'.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.DocumentRoot
	 * @generated
	 */
	EClass getDocumentRoot();

	/**
	 * Returns the meta object for the attribute list '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.DocumentRoot#getMixed <em>Mixed</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute list '<em>Mixed</em>'.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.DocumentRoot#getMixed()
	 * @see #getDocumentRoot()
	 * @generated
	 */
	EAttribute getDocumentRoot_Mixed();

	/**
	 * Returns the meta object for the map '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.DocumentRoot#getXMLNSPrefixMap <em>XMLNS Prefix Map</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the map '<em>XMLNS Prefix Map</em>'.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.DocumentRoot#getXMLNSPrefixMap()
	 * @see #getDocumentRoot()
	 * @generated
	 */
	EReference getDocumentRoot_XMLNSPrefixMap();

	/**
	 * Returns the meta object for the map '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.DocumentRoot#getXSISchemaLocation <em>XSI Schema Location</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the map '<em>XSI Schema Location</em>'.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.DocumentRoot#getXSISchemaLocation()
	 * @see #getDocumentRoot()
	 * @generated
	 */
	EReference getDocumentRoot_XSISchemaLocation();

	/**
	 * Returns the meta object for the containment reference '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.DocumentRoot#getDeregisterRequest <em>Deregister Request</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Deregister Request</em>'.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.DocumentRoot#getDeregisterRequest()
	 * @see #getDocumentRoot()
	 * @generated
	 */
	EReference getDocumentRoot_DeregisterRequest();

	/**
	 * Returns the meta object for the containment reference '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.DocumentRoot#getDeregisterResponse <em>Deregister Response</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Deregister Response</em>'.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.DocumentRoot#getDeregisterResponse()
	 * @see #getDocumentRoot()
	 * @generated
	 */
	EReference getDocumentRoot_DeregisterResponse();

	/**
	 * Returns the meta object for the containment reference '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.DocumentRoot#getDeregistrationErrorFault <em>Deregistration Error Fault</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Deregistration Error Fault</em>'.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.DocumentRoot#getDeregistrationErrorFault()
	 * @see #getDocumentRoot()
	 * @generated
	 */
	EReference getDocumentRoot_DeregistrationErrorFault();

	/**
	 * Returns the meta object for the containment reference '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.DocumentRoot#getExpensiveQueryErrorFault <em>Expensive Query Error Fault</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Expensive Query Error Fault</em>'.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.DocumentRoot#getExpensiveQueryErrorFault()
	 * @see #getDocumentRoot()
	 * @generated
	 */
	EReference getDocumentRoot_ExpensiveQueryErrorFault();

	/**
	 * Returns the meta object for the containment reference '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.DocumentRoot#getInstanceId <em>Instance Id</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Instance Id</em>'.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.DocumentRoot#getInstanceId()
	 * @see #getDocumentRoot()
	 * @generated
	 */
	EReference getDocumentRoot_InstanceId();

	/**
	 * Returns the meta object for the containment reference '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.DocumentRoot#getInvalidMDRFault <em>Invalid MDR Fault</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Invalid MDR Fault</em>'.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.DocumentRoot#getInvalidMDRFault()
	 * @see #getDocumentRoot()
	 * @generated
	 */
	EReference getDocumentRoot_InvalidMDRFault();

	/**
	 * Returns the meta object for the containment reference '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.DocumentRoot#getInvalidPropertyTypeFault <em>Invalid Property Type Fault</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Invalid Property Type Fault</em>'.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.DocumentRoot#getInvalidPropertyTypeFault()
	 * @see #getDocumentRoot()
	 * @generated
	 */
	EReference getDocumentRoot_InvalidPropertyTypeFault();

	/**
	 * Returns the meta object for the containment reference '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.DocumentRoot#getInvalidRecordFault <em>Invalid Record Fault</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Invalid Record Fault</em>'.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.DocumentRoot#getInvalidRecordFault()
	 * @see #getDocumentRoot()
	 * @generated
	 */
	EReference getDocumentRoot_InvalidRecordFault();

	/**
	 * Returns the meta object for the reference '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.DocumentRoot#getItem <em>Item</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Item</em>'.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.DocumentRoot#getItem()
	 * @see #getDocumentRoot()
	 * @generated
	 */
	EReference getDocumentRoot_Item();

	/**
	 * Returns the meta object for the containment reference '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.DocumentRoot#getPropertySet <em>Property Set</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Property Set</em>'.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.DocumentRoot#getPropertySet()
	 * @see #getDocumentRoot()
	 * @generated
	 */
	EReference getDocumentRoot_PropertySet();

	/**
	 * Returns the meta object for the containment reference '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.DocumentRoot#getQuery <em>Query</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Query</em>'.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.DocumentRoot#getQuery()
	 * @see #getDocumentRoot()
	 * @generated
	 */
	EReference getDocumentRoot_Query();

	/**
	 * Returns the meta object for the containment reference '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.DocumentRoot#getQueryErrorFault <em>Query Error Fault</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Query Error Fault</em>'.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.DocumentRoot#getQueryErrorFault()
	 * @see #getDocumentRoot()
	 * @generated
	 */
	EReference getDocumentRoot_QueryErrorFault();

	/**
	 * Returns the meta object for the containment reference '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.DocumentRoot#getQueryResult <em>Query Result</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Query Result</em>'.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.DocumentRoot#getQueryResult()
	 * @see #getDocumentRoot()
	 * @generated
	 */
	EReference getDocumentRoot_QueryResult();

	/**
	 * Returns the meta object for the containment reference '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.DocumentRoot#getRecord <em>Record</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Record</em>'.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.DocumentRoot#getRecord()
	 * @see #getDocumentRoot()
	 * @generated
	 */
	EReference getDocumentRoot_Record();

	/**
	 * Returns the meta object for the containment reference '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.DocumentRoot#getRegisterRequest <em>Register Request</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Register Request</em>'.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.DocumentRoot#getRegisterRequest()
	 * @see #getDocumentRoot()
	 * @generated
	 */
	EReference getDocumentRoot_RegisterRequest();

	/**
	 * Returns the meta object for the containment reference '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.DocumentRoot#getRegisterResponse <em>Register Response</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Register Response</em>'.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.DocumentRoot#getRegisterResponse()
	 * @see #getDocumentRoot()
	 * @generated
	 */
	EReference getDocumentRoot_RegisterResponse();

	/**
	 * Returns the meta object for the containment reference '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.DocumentRoot#getRegistrationErrorFault <em>Registration Error Fault</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Registration Error Fault</em>'.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.DocumentRoot#getRegistrationErrorFault()
	 * @see #getDocumentRoot()
	 * @generated
	 */
	EReference getDocumentRoot_RegistrationErrorFault();

	/**
	 * Returns the meta object for the reference '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.DocumentRoot#getRelationship <em>Relationship</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Relationship</em>'.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.DocumentRoot#getRelationship()
	 * @see #getDocumentRoot()
	 * @generated
	 */
	EReference getDocumentRoot_Relationship();

	/**
	 * Returns the meta object for the containment reference '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.DocumentRoot#getUnknownTemplateIDFault <em>Unknown Template ID Fault</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Unknown Template ID Fault</em>'.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.DocumentRoot#getUnknownTemplateIDFault()
	 * @see #getDocumentRoot()
	 * @generated
	 */
	EReference getDocumentRoot_UnknownTemplateIDFault();

	/**
	 * Returns the meta object for the containment reference '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.DocumentRoot#getUnsupportedConstraintFault <em>Unsupported Constraint Fault</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Unsupported Constraint Fault</em>'.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.DocumentRoot#getUnsupportedConstraintFault()
	 * @see #getDocumentRoot()
	 * @generated
	 */
	EReference getDocumentRoot_UnsupportedConstraintFault();

	/**
	 * Returns the meta object for the containment reference '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.DocumentRoot#getUnsupportedRecordTypeFault <em>Unsupported Record Type Fault</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Unsupported Record Type Fault</em>'.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.DocumentRoot#getUnsupportedRecordTypeFault()
	 * @see #getDocumentRoot()
	 * @generated
	 */
	EReference getDocumentRoot_UnsupportedRecordTypeFault();

	/**
	 * Returns the meta object for the containment reference '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.DocumentRoot#getUnsupportedSelectorFault <em>Unsupported Selector Fault</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Unsupported Selector Fault</em>'.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.DocumentRoot#getUnsupportedSelectorFault()
	 * @see #getDocumentRoot()
	 * @generated
	 */
	EReference getDocumentRoot_UnsupportedSelectorFault();

	/**
	 * Returns the meta object for the containment reference '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.DocumentRoot#getXPathErrorFault <em>XPath Error Fault</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>XPath Error Fault</em>'.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.DocumentRoot#getXPathErrorFault()
	 * @see #getDocumentRoot()
	 * @generated
	 */
	EReference getDocumentRoot_XPathErrorFault();

	/**
	 * Returns the meta object for the containment reference '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.DocumentRoot#getModel <em>Model</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Model</em>'.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.DocumentRoot#getModel()
	 * @see #getDocumentRoot()
	 * @generated
	 */
	EReference getDocumentRoot_Model();

	/**
	 * Returns the meta object for class '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.EdgesType <em>Edges Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Edges Type</em>'.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.EdgesType
	 * @generated
	 */
	EClass getEdgesType();

	/**
	 * Returns the meta object for the containment reference list '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.EdgesType#getRelationship <em>Relationship</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Relationship</em>'.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.EdgesType#getRelationship()
	 * @see #getEdgesType()
	 * @generated
	 */
	EReference getEdgesType_Relationship();

	/**
	 * Returns the meta object for the attribute '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.EdgesType#getTemplateId <em>Template Id</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Template Id</em>'.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.EdgesType#getTemplateId()
	 * @see #getEdgesType()
	 * @generated
	 */
	EAttribute getEdgesType_TemplateId();

	/**
	 * Returns the meta object for class '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.EqualOperatorType <em>Equal Operator Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Equal Operator Type</em>'.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.EqualOperatorType
	 * @generated
	 */
	EClass getEqualOperatorType();

	/**
	 * Returns the meta object for the attribute '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.EqualOperatorType#getValue <em>Value</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Value</em>'.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.EqualOperatorType#getValue()
	 * @see #getEqualOperatorType()
	 * @generated
	 */
	EAttribute getEqualOperatorType_Value();

	/**
	 * Returns the meta object for the attribute '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.EqualOperatorType#isCaseSensitive <em>Case Sensitive</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Case Sensitive</em>'.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.EqualOperatorType#isCaseSensitive()
	 * @see #getEqualOperatorType()
	 * @generated
	 */
	EAttribute getEqualOperatorType_CaseSensitive();

	/**
	 * Returns the meta object for the attribute '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.EqualOperatorType#isNegate <em>Negate</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Negate</em>'.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.EqualOperatorType#isNegate()
	 * @see #getEqualOperatorType()
	 * @generated
	 */
	EAttribute getEqualOperatorType_Negate();

	/**
	 * Returns the meta object for class '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.ExpensiveQueryErrorFaultType <em>Expensive Query Error Fault Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Expensive Query Error Fault Type</em>'.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.ExpensiveQueryErrorFaultType
	 * @generated
	 */
	EClass getExpensiveQueryErrorFaultType();

	/**
	 * Returns the meta object for the attribute list '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.ExpensiveQueryErrorFaultType#getAny <em>Any</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute list '<em>Any</em>'.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.ExpensiveQueryErrorFaultType#getAny()
	 * @see #getExpensiveQueryErrorFaultType()
	 * @generated
	 */
	EAttribute getExpensiveQueryErrorFaultType_Any();

	/**
	 * Returns the meta object for class '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.InstanceIdConstraintType <em>Instance Id Constraint Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Instance Id Constraint Type</em>'.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.InstanceIdConstraintType
	 * @generated
	 */
	EClass getInstanceIdConstraintType();

	/**
	 * Returns the meta object for the containment reference list '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.InstanceIdConstraintType#getInstanceId <em>Instance Id</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Instance Id</em>'.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.InstanceIdConstraintType#getInstanceId()
	 * @see #getInstanceIdConstraintType()
	 * @generated
	 */
	EReference getInstanceIdConstraintType_InstanceId();

	/**
	 * Returns the meta object for class '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.InvalidMDRFaultType <em>Invalid MDR Fault Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Invalid MDR Fault Type</em>'.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.InvalidMDRFaultType
	 * @generated
	 */
	EClass getInvalidMDRFaultType();

	/**
	 * Returns the meta object for the attribute '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.InvalidMDRFaultType#getMdrId <em>Mdr Id</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Mdr Id</em>'.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.InvalidMDRFaultType#getMdrId()
	 * @see #getInvalidMDRFaultType()
	 * @generated
	 */
	EAttribute getInvalidMDRFaultType_MdrId();

	/**
	 * Returns the meta object for class '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.InvalidPropertyTypeFaultType <em>Invalid Property Type Fault Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Invalid Property Type Fault Type</em>'.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.InvalidPropertyTypeFaultType
	 * @generated
	 */
	EClass getInvalidPropertyTypeFaultType();

	/**
	 * Returns the meta object for the containment reference '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.InvalidPropertyTypeFaultType#getPropertyName <em>Property Name</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Property Name</em>'.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.InvalidPropertyTypeFaultType#getPropertyName()
	 * @see #getInvalidPropertyTypeFaultType()
	 * @generated
	 */
	EReference getInvalidPropertyTypeFaultType_PropertyName();

	/**
	 * Returns the meta object for class '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.InvalidRecordFaultType <em>Invalid Record Fault Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Invalid Record Fault Type</em>'.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.InvalidRecordFaultType
	 * @generated
	 */
	EClass getInvalidRecordFaultType();

	/**
	 * Returns the meta object for the attribute '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.InvalidRecordFaultType#getRecordId <em>Record Id</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Record Id</em>'.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.InvalidRecordFaultType#getRecordId()
	 * @see #getInvalidRecordFaultType()
	 * @generated
	 */
	EAttribute getInvalidRecordFaultType_RecordId();

	/**
	 * Returns the meta object for class '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.ItemListType <em>Item List Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Item List Type</em>'.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.ItemListType
	 * @generated
	 */
	EClass getItemListType();

	/**
	 * Returns the meta object for the containment reference list '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.ItemListType#getItem <em>Item</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Item</em>'.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.ItemListType#getItem()
	 * @see #getItemListType()
	 * @generated
	 */
	EReference getItemListType_Item();

	/**
	 * Returns the meta object for the '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.ItemListType#find(it.unibo.cmdb.cmdbf.client.model.cmdbf.MdrScopedIdType) <em>Find</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Find</em>' operation.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.ItemListType#find(it.unibo.cmdb.cmdbf.client.model.cmdbf.MdrScopedIdType)
	 * @generated
	 */
	EOperation getItemListType__Find__MdrScopedIdType();

	/**
	 * Returns the meta object for the '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.ItemListType#find(it.unibo.cmdb.cmdbf.client.model.cmdbf.ItemType) <em>Find</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Find</em>' operation.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.ItemListType#find(it.unibo.cmdb.cmdbf.client.model.cmdbf.ItemType)
	 * @generated
	 */
	EOperation getItemListType__Find__ItemType();

	/**
	 * Returns the meta object for class '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.ItemTemplateType <em>Item Template Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Item Template Type</em>'.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.ItemTemplateType
	 * @generated
	 */
	EClass getItemTemplateType();

	/**
	 * Returns the meta object for class '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.ItemType <em>Item Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Item Type</em>'.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.ItemType
	 * @generated
	 */
	EClass getItemType();

	/**
	 * Returns the meta object for the reference list '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.ItemType#getRelationshipBySource <em>Relationship By Source</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Relationship By Source</em>'.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.ItemType#getRelationshipBySource()
	 * @see #getItemType()
	 * @generated
	 */
	EReference getItemType_RelationshipBySource();

	/**
	 * Returns the meta object for the reference list '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.ItemType#getRelationshipByTarget <em>Relationship By Target</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Relationship By Target</em>'.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.ItemType#getRelationshipByTarget()
	 * @see #getItemType()
	 * @generated
	 */
	EReference getItemType_RelationshipByTarget();

	/**
	 * Returns the meta object for class '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.MdrScopedIdListType <em>Mdr Scoped Id List Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Mdr Scoped Id List Type</em>'.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.MdrScopedIdListType
	 * @generated
	 */
	EClass getMdrScopedIdListType();

	/**
	 * Returns the meta object for the containment reference list '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.MdrScopedIdListType#getInstanceId <em>Instance Id</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Instance Id</em>'.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.MdrScopedIdListType#getInstanceId()
	 * @see #getMdrScopedIdListType()
	 * @generated
	 */
	EReference getMdrScopedIdListType_InstanceId();

	/**
	 * Returns the meta object for class '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.MdrScopedIdType <em>Mdr Scoped Id Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Mdr Scoped Id Type</em>'.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.MdrScopedIdType
	 * @generated
	 */
	EClass getMdrScopedIdType();

	/**
	 * Returns the meta object for the attribute '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.MdrScopedIdType#getMdrId <em>Mdr Id</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Mdr Id</em>'.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.MdrScopedIdType#getMdrId()
	 * @see #getMdrScopedIdType()
	 * @generated
	 */
	EAttribute getMdrScopedIdType_MdrId();

	/**
	 * Returns the meta object for the attribute '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.MdrScopedIdType#getLocalId <em>Local Id</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Local Id</em>'.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.MdrScopedIdType#getLocalId()
	 * @see #getMdrScopedIdType()
	 * @generated
	 */
	EAttribute getMdrScopedIdType_LocalId();

	/**
	 * Returns the meta object for the '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.MdrScopedIdType#init(java.lang.String) <em>Init</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Init</em>' operation.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.MdrScopedIdType#init(java.lang.String)
	 * @generated
	 */
	EOperation getMdrScopedIdType__Init__String();

	/**
	 * Returns the meta object for class '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.NodesType <em>Nodes Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Nodes Type</em>'.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.NodesType
	 * @generated
	 */
	EClass getNodesType();

	/**
	 * Returns the meta object for the containment reference list '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.NodesType#getItem <em>Item</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Item</em>'.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.NodesType#getItem()
	 * @see #getNodesType()
	 * @generated
	 */
	EReference getNodesType_Item();

	/**
	 * Returns the meta object for the attribute '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.NodesType#getTemplateId <em>Template Id</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Template Id</em>'.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.NodesType#getTemplateId()
	 * @see #getNodesType()
	 * @generated
	 */
	EAttribute getNodesType_TemplateId();

	/**
	 * Returns the meta object for class '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.NullOperatorType <em>Null Operator Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Null Operator Type</em>'.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.NullOperatorType
	 * @generated
	 */
	EClass getNullOperatorType();

	/**
	 * Returns the meta object for the attribute '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.NullOperatorType#isNegate <em>Negate</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Negate</em>'.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.NullOperatorType#isNegate()
	 * @see #getNullOperatorType()
	 * @generated
	 */
	EAttribute getNullOperatorType_Negate();

	/**
	 * Returns the meta object for class '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.PrefixMappingType <em>Prefix Mapping Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Prefix Mapping Type</em>'.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.PrefixMappingType
	 * @generated
	 */
	EClass getPrefixMappingType();

	/**
	 * Returns the meta object for the attribute '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.PrefixMappingType#getPrefix <em>Prefix</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Prefix</em>'.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.PrefixMappingType#getPrefix()
	 * @see #getPrefixMappingType()
	 * @generated
	 */
	EAttribute getPrefixMappingType_Prefix();

	/**
	 * Returns the meta object for the attribute '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.PrefixMappingType#getNamespace <em>Namespace</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Namespace</em>'.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.PrefixMappingType#getNamespace()
	 * @see #getPrefixMappingType()
	 * @generated
	 */
	EAttribute getPrefixMappingType_Namespace();

	/**
	 * Returns the meta object for class '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.PropertyNameType <em>Property Name Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Property Name Type</em>'.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.PropertyNameType
	 * @generated
	 */
	EClass getPropertyNameType();

	/**
	 * Returns the meta object for the attribute '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.PropertyNameType#getLocalName <em>Local Name</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Local Name</em>'.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.PropertyNameType#getLocalName()
	 * @see #getPropertyNameType()
	 * @generated
	 */
	EAttribute getPropertyNameType_LocalName();

	/**
	 * Returns the meta object for the attribute '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.PropertyNameType#getNamespace <em>Namespace</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Namespace</em>'.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.PropertyNameType#getNamespace()
	 * @see #getPropertyNameType()
	 * @generated
	 */
	EAttribute getPropertyNameType_Namespace();

	/**
	 * Returns the meta object for class '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.PropertySetType <em>Property Set Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Property Set Type</em>'.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.PropertySetType
	 * @generated
	 */
	EClass getPropertySetType();

	/**
	 * Returns the meta object for the attribute list '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.PropertySetType#getAny <em>Any</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute list '<em>Any</em>'.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.PropertySetType#getAny()
	 * @see #getPropertySetType()
	 * @generated
	 */
	EAttribute getPropertySetType_Any();

	/**
	 * Returns the meta object for the attribute '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.PropertySetType#getNamespace <em>Namespace</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Namespace</em>'.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.PropertySetType#getNamespace()
	 * @see #getPropertySetType()
	 * @generated
	 */
	EAttribute getPropertySetType_Namespace();

	/**
	 * Returns the meta object for the attribute '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.PropertySetType#getLocalName <em>Local Name</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Local Name</em>'.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.PropertySetType#getLocalName()
	 * @see #getPropertySetType()
	 * @generated
	 */
	EAttribute getPropertySetType_LocalName();

	/**
	 * Returns the meta object for class '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.PropertyValueType <em>Property Value Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Property Value Type</em>'.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.PropertyValueType
	 * @generated
	 */
	EClass getPropertyValueType();

	/**
	 * Returns the meta object for the containment reference list '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.PropertyValueType#getEqual <em>Equal</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Equal</em>'.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.PropertyValueType#getEqual()
	 * @see #getPropertyValueType()
	 * @generated
	 */
	EReference getPropertyValueType_Equal();

	/**
	 * Returns the meta object for the containment reference '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.PropertyValueType#getLess <em>Less</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Less</em>'.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.PropertyValueType#getLess()
	 * @see #getPropertyValueType()
	 * @generated
	 */
	EReference getPropertyValueType_Less();

	/**
	 * Returns the meta object for the containment reference '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.PropertyValueType#getLessOrEqual <em>Less Or Equal</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Less Or Equal</em>'.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.PropertyValueType#getLessOrEqual()
	 * @see #getPropertyValueType()
	 * @generated
	 */
	EReference getPropertyValueType_LessOrEqual();

	/**
	 * Returns the meta object for the containment reference '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.PropertyValueType#getGreater <em>Greater</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Greater</em>'.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.PropertyValueType#getGreater()
	 * @see #getPropertyValueType()
	 * @generated
	 */
	EReference getPropertyValueType_Greater();

	/**
	 * Returns the meta object for the containment reference '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.PropertyValueType#getGreaterOrEqual <em>Greater Or Equal</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Greater Or Equal</em>'.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.PropertyValueType#getGreaterOrEqual()
	 * @see #getPropertyValueType()
	 * @generated
	 */
	EReference getPropertyValueType_GreaterOrEqual();

	/**
	 * Returns the meta object for the containment reference list '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.PropertyValueType#getContains <em>Contains</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Contains</em>'.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.PropertyValueType#getContains()
	 * @see #getPropertyValueType()
	 * @generated
	 */
	EReference getPropertyValueType_Contains();

	/**
	 * Returns the meta object for the containment reference list '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.PropertyValueType#getLike <em>Like</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Like</em>'.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.PropertyValueType#getLike()
	 * @see #getPropertyValueType()
	 * @generated
	 */
	EReference getPropertyValueType_Like();

	/**
	 * Returns the meta object for the containment reference '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.PropertyValueType#getIsNull <em>Is Null</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Is Null</em>'.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.PropertyValueType#getIsNull()
	 * @see #getPropertyValueType()
	 * @generated
	 */
	EReference getPropertyValueType_IsNull();

	/**
	 * Returns the meta object for the attribute list '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.PropertyValueType#getAny <em>Any</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute list '<em>Any</em>'.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.PropertyValueType#getAny()
	 * @see #getPropertyValueType()
	 * @generated
	 */
	EAttribute getPropertyValueType_Any();

	/**
	 * Returns the meta object for the attribute '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.PropertyValueType#getNamespace <em>Namespace</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Namespace</em>'.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.PropertyValueType#getNamespace()
	 * @see #getPropertyValueType()
	 * @generated
	 */
	EAttribute getPropertyValueType_Namespace();

	/**
	 * Returns the meta object for the attribute '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.PropertyValueType#getLocalName <em>Local Name</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Local Name</em>'.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.PropertyValueType#getLocalName()
	 * @see #getPropertyValueType()
	 * @generated
	 */
	EAttribute getPropertyValueType_LocalName();

	/**
	 * Returns the meta object for the attribute '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.PropertyValueType#isRecordMetadata <em>Record Metadata</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Record Metadata</em>'.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.PropertyValueType#isRecordMetadata()
	 * @see #getPropertyValueType()
	 * @generated
	 */
	EAttribute getPropertyValueType_RecordMetadata();

	/**
	 * Returns the meta object for the attribute '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.PropertyValueType#isMatchAny <em>Match Any</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Match Any</em>'.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.PropertyValueType#isMatchAny()
	 * @see #getPropertyValueType()
	 * @generated
	 */
	EAttribute getPropertyValueType_MatchAny();

	/**
	 * Returns the meta object for the container reference '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.PropertyValueType#getParent <em>Parent</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>Parent</em>'.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.PropertyValueType#getParent()
	 * @see #getPropertyValueType()
	 * @generated
	 */
	EReference getPropertyValueType_Parent();

	/**
	 * Returns the meta object for the '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.PropertyValueType#addEqual(java.lang.Object) <em>Add Equal</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Add Equal</em>' operation.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.PropertyValueType#addEqual(java.lang.Object)
	 * @generated
	 */
	EOperation getPropertyValueType__AddEqual__Object();

	/**
	 * Returns the meta object for the '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.PropertyValueType#addLess(java.lang.Object) <em>Add Less</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Add Less</em>' operation.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.PropertyValueType#addLess(java.lang.Object)
	 * @generated
	 */
	EOperation getPropertyValueType__AddLess__Object();

	/**
	 * Returns the meta object for the '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.PropertyValueType#addLessOrEqual(java.lang.Object) <em>Add Less Or Equal</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Add Less Or Equal</em>' operation.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.PropertyValueType#addLessOrEqual(java.lang.Object)
	 * @generated
	 */
	EOperation getPropertyValueType__AddLessOrEqual__Object();

	/**
	 * Returns the meta object for the '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.PropertyValueType#addGreater(java.lang.Object) <em>Add Greater</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Add Greater</em>' operation.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.PropertyValueType#addGreater(java.lang.Object)
	 * @generated
	 */
	EOperation getPropertyValueType__AddGreater__Object();

	/**
	 * Returns the meta object for the '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.PropertyValueType#addGreaterOrEqual(java.lang.Object) <em>Add Greater Or Equal</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Add Greater Or Equal</em>' operation.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.PropertyValueType#addGreaterOrEqual(java.lang.Object)
	 * @generated
	 */
	EOperation getPropertyValueType__AddGreaterOrEqual__Object();

	/**
	 * Returns the meta object for the '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.PropertyValueType#addContains(java.lang.String) <em>Add Contains</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Add Contains</em>' operation.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.PropertyValueType#addContains(java.lang.String)
	 * @generated
	 */
	EOperation getPropertyValueType__AddContains__String();

	/**
	 * Returns the meta object for the '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.PropertyValueType#addLike(java.lang.String) <em>Add Like</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Add Like</em>' operation.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.PropertyValueType#addLike(java.lang.String)
	 * @generated
	 */
	EOperation getPropertyValueType__AddLike__String();

	/**
	 * Returns the meta object for the '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.PropertyValueType#addIsNull() <em>Add Is Null</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Add Is Null</em>' operation.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.PropertyValueType#addIsNull()
	 * @generated
	 */
	EOperation getPropertyValueType__AddIsNull();

	/**
	 * Returns the meta object for class '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.QNameType <em>QName Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>QName Type</em>'.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.QNameType
	 * @generated
	 */
	EClass getQNameType();

	/**
	 * Returns the meta object for the attribute '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.QNameType#getNamespace <em>Namespace</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Namespace</em>'.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.QNameType#getNamespace()
	 * @see #getQNameType()
	 * @generated
	 */
	EAttribute getQNameType_Namespace();

	/**
	 * Returns the meta object for the attribute '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.QNameType#getLocalName <em>Local Name</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Local Name</em>'.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.QNameType#getLocalName()
	 * @see #getQNameType()
	 * @generated
	 */
	EAttribute getQNameType_LocalName();

	/**
	 * Returns the meta object for class '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.QueryErrorFaultType <em>Query Error Fault Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Query Error Fault Type</em>'.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.QueryErrorFaultType
	 * @generated
	 */
	EClass getQueryErrorFaultType();

	/**
	 * Returns the meta object for the attribute list '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.QueryErrorFaultType#getAny <em>Any</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute list '<em>Any</em>'.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.QueryErrorFaultType#getAny()
	 * @see #getQueryErrorFaultType()
	 * @generated
	 */
	EAttribute getQueryErrorFaultType_Any();

	/**
	 * Returns the meta object for class '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.QueryResultType <em>Query Result Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Query Result Type</em>'.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.QueryResultType
	 * @generated
	 */
	EClass getQueryResultType();

	/**
	 * Returns the meta object for the containment reference list '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.QueryResultType#getNodes <em>Nodes</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Nodes</em>'.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.QueryResultType#getNodes()
	 * @see #getQueryResultType()
	 * @generated
	 */
	EReference getQueryResultType_Nodes();

	/**
	 * Returns the meta object for the containment reference list '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.QueryResultType#getEdges <em>Edges</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Edges</em>'.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.QueryResultType#getEdges()
	 * @see #getQueryResultType()
	 * @generated
	 */
	EReference getQueryResultType_Edges();

	/**
	 * Returns the meta object for class '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.QueryType <em>Query Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Query Type</em>'.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.QueryType
	 * @generated
	 */
	EClass getQueryType();

	/**
	 * Returns the meta object for the containment reference list '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.QueryType#getItemTemplate <em>Item Template</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Item Template</em>'.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.QueryType#getItemTemplate()
	 * @see #getQueryType()
	 * @generated
	 */
	EReference getQueryType_ItemTemplate();

	/**
	 * Returns the meta object for the containment reference list '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.QueryType#getRelationshipTemplate <em>Relationship Template</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Relationship Template</em>'.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.QueryType#getRelationshipTemplate()
	 * @see #getQueryType()
	 * @generated
	 */
	EReference getQueryType_RelationshipTemplate();

	/**
	 * Returns the meta object for the attribute '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.QueryType#getMdrId <em>Mdr Id</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Mdr Id</em>'.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.QueryType#getMdrId()
	 * @see #getQueryType()
	 * @generated
	 */
	EAttribute getQueryType_MdrId();

	/**
	 * Returns the meta object for the reference '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.QueryType#getModelMetadata <em>Model Metadata</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Model Metadata</em>'.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.QueryType#getModelMetadata()
	 * @see #getQueryType()
	 * @generated
	 */
	EReference getQueryType_ModelMetadata();

	/**
	 * Returns the meta object for the '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.QueryType#addItemTemplate(java.lang.String) <em>Add Item Template</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Add Item Template</em>' operation.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.QueryType#addItemTemplate(java.lang.String)
	 * @generated
	 */
	EOperation getQueryType__AddItemTemplate__String();

	/**
	 * Returns the meta object for the '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.QueryType#addRelationshipTemplate(java.lang.String) <em>Add Relationship Template</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Add Relationship Template</em>' operation.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.QueryType#addRelationshipTemplate(java.lang.String)
	 * @generated
	 */
	EOperation getQueryType__AddRelationshipTemplate__String();

	/**
	 * Returns the meta object for the '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.QueryType#getNamespace(java.lang.String) <em>Get Namespace</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Get Namespace</em>' operation.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.QueryType#getNamespace(java.lang.String)
	 * @generated
	 */
	EOperation getQueryType__GetNamespace__String();

	/**
	 * Returns the meta object for the '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.QueryType#getLocalName(java.lang.String) <em>Get Local Name</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Get Local Name</em>' operation.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.QueryType#getLocalName(java.lang.String)
	 * @generated
	 */
	EOperation getQueryType__GetLocalName__String();

	/**
	 * Returns the meta object for class '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.RecordConstraintType <em>Record Constraint Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Record Constraint Type</em>'.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.RecordConstraintType
	 * @generated
	 */
	EClass getRecordConstraintType();

	/**
	 * Returns the meta object for the containment reference list '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.RecordConstraintType#getRecordType <em>Record Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Record Type</em>'.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.RecordConstraintType#getRecordType()
	 * @see #getRecordConstraintType()
	 * @generated
	 */
	EReference getRecordConstraintType_RecordType();

	/**
	 * Returns the meta object for the containment reference list '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.RecordConstraintType#getPropertyValue <em>Property Value</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Property Value</em>'.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.RecordConstraintType#getPropertyValue()
	 * @see #getRecordConstraintType()
	 * @generated
	 */
	EReference getRecordConstraintType_PropertyValue();

	/**
	 * Returns the meta object for the containment reference '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.RecordConstraintType#getXpathConstraint <em>Xpath Constraint</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Xpath Constraint</em>'.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.RecordConstraintType#getXpathConstraint()
	 * @see #getRecordConstraintType()
	 * @generated
	 */
	EReference getRecordConstraintType_XpathConstraint();

	/**
	 * Returns the meta object for the attribute list '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.RecordConstraintType#getAny <em>Any</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute list '<em>Any</em>'.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.RecordConstraintType#getAny()
	 * @see #getRecordConstraintType()
	 * @generated
	 */
	EAttribute getRecordConstraintType_Any();

	/**
	 * Returns the meta object for the container reference '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.RecordConstraintType#getParent <em>Parent</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>Parent</em>'.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.RecordConstraintType#getParent()
	 * @see #getRecordConstraintType()
	 * @generated
	 */
	EReference getRecordConstraintType_Parent();

	/**
	 * Returns the meta object for the '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.RecordConstraintType#addRecordType(java.lang.String) <em>Add Record Type</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Add Record Type</em>' operation.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.RecordConstraintType#addRecordType(java.lang.String)
	 * @generated
	 */
	EOperation getRecordConstraintType__AddRecordType__String();

	/**
	 * Returns the meta object for the '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.RecordConstraintType#addRecordType(java.lang.String, java.lang.String) <em>Add Record Type</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Add Record Type</em>' operation.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.RecordConstraintType#addRecordType(java.lang.String, java.lang.String)
	 * @generated
	 */
	EOperation getRecordConstraintType__AddRecordType__String_String();

	/**
	 * Returns the meta object for the '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.RecordConstraintType#addPropertyValue(java.lang.String) <em>Add Property Value</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Add Property Value</em>' operation.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.RecordConstraintType#addPropertyValue(java.lang.String)
	 * @generated
	 */
	EOperation getRecordConstraintType__AddPropertyValue__String();

	/**
	 * Returns the meta object for the '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.RecordConstraintType#addPropertyValue(java.lang.String, java.lang.String) <em>Add Property Value</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Add Property Value</em>' operation.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.RecordConstraintType#addPropertyValue(java.lang.String, java.lang.String)
	 * @generated
	 */
	EOperation getRecordConstraintType__AddPropertyValue__String_String();

	/**
	 * Returns the meta object for class '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.RecordMetadataType <em>Record Metadata Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Record Metadata Type</em>'.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.RecordMetadataType
	 * @generated
	 */
	EClass getRecordMetadataType();

	/**
	 * Returns the meta object for the attribute '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.RecordMetadataType#getRecordId <em>Record Id</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Record Id</em>'.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.RecordMetadataType#getRecordId()
	 * @see #getRecordMetadataType()
	 * @generated
	 */
	EAttribute getRecordMetadataType_RecordId();

	/**
	 * Returns the meta object for the attribute '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.RecordMetadataType#getLastModified <em>Last Modified</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Last Modified</em>'.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.RecordMetadataType#getLastModified()
	 * @see #getRecordMetadataType()
	 * @generated
	 */
	EAttribute getRecordMetadataType_LastModified();

	/**
	 * Returns the meta object for the attribute '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.RecordMetadataType#getBaselineId <em>Baseline Id</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Baseline Id</em>'.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.RecordMetadataType#getBaselineId()
	 * @see #getRecordMetadataType()
	 * @generated
	 */
	EAttribute getRecordMetadataType_BaselineId();

	/**
	 * Returns the meta object for the attribute '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.RecordMetadataType#getSnapshotId <em>Snapshot Id</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Snapshot Id</em>'.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.RecordMetadataType#getSnapshotId()
	 * @see #getRecordMetadataType()
	 * @generated
	 */
	EAttribute getRecordMetadataType_SnapshotId();

	/**
	 * Returns the meta object for the attribute list '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.RecordMetadataType#getAny <em>Any</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute list '<em>Any</em>'.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.RecordMetadataType#getAny()
	 * @see #getRecordMetadataType()
	 * @generated
	 */
	EAttribute getRecordMetadataType_Any();

	/**
	 * Returns the meta object for class '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.RecordType <em>Record Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Record Type</em>'.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.RecordType
	 * @generated
	 */
	EClass getRecordType();

	/**
	 * Returns the meta object for the attribute list '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.RecordType#getAny <em>Any</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute list '<em>Any</em>'.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.RecordType#getAny()
	 * @see #getRecordType()
	 * @generated
	 */
	EAttribute getRecordType_Any();

	/**
	 * Returns the meta object for the containment reference '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.RecordType#getPropertySet <em>Property Set</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Property Set</em>'.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.RecordType#getPropertySet()
	 * @see #getRecordType()
	 * @generated
	 */
	EReference getRecordType_PropertySet();

	/**
	 * Returns the meta object for the containment reference '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.RecordType#getRecordMetadata <em>Record Metadata</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Record Metadata</em>'.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.RecordType#getRecordMetadata()
	 * @see #getRecordType()
	 * @generated
	 */
	EReference getRecordType_RecordMetadata();

	/**
	 * Returns the meta object for the container reference '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.RecordType#getParent <em>Parent</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>Parent</em>'.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.RecordType#getParent()
	 * @see #getRecordType()
	 * @generated
	 */
	EReference getRecordType_Parent();

	/**
	 * Returns the meta object for the attribute list '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.RecordType#getTemplateId <em>Template Id</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute list '<em>Template Id</em>'.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.RecordType#getTemplateId()
	 * @see #getRecordType()
	 * @generated
	 */
	EAttribute getRecordType_TemplateId();

	/**
	 * Returns the meta object for the attribute '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.RecordType#getRecordId <em>Record Id</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Record Id</em>'.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.RecordType#getRecordId()
	 * @see #getRecordType()
	 * @generated
	 */
	EAttribute getRecordType_RecordId();

	/**
	 * Returns the meta object for the attribute '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.RecordType#getLastModified <em>Last Modified</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Last Modified</em>'.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.RecordType#getLastModified()
	 * @see #getRecordType()
	 * @generated
	 */
	EAttribute getRecordType_LastModified();

	/**
	 * Returns the meta object for the reference '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.RecordType#getType <em>Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Type</em>'.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.RecordType#getType()
	 * @see #getRecordType()
	 * @generated
	 */
	EReference getRecordType_Type();

	/**
	 * Returns the meta object for the reference '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.RecordType#getContent <em>Content</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Content</em>'.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.RecordType#getContent()
	 * @see #getRecordType()
	 * @generated
	 */
	EReference getRecordType_Content();

	/**
	 * Returns the meta object for the attribute list '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.RecordType#getPropertyName <em>Property Name</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute list '<em>Property Name</em>'.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.RecordType#getPropertyName()
	 * @see #getRecordType()
	 * @generated
	 */
	EAttribute getRecordType_PropertyName();

	/**
	 * Returns the meta object for the '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.RecordType#get(java.lang.String) <em>Get</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Get</em>' operation.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.RecordType#get(java.lang.String)
	 * @generated
	 */
	EOperation getRecordType__Get__String();

	/**
	 * Returns the meta object for the '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.RecordType#set(java.lang.String, java.lang.Object) <em>Set</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Set</em>' operation.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.RecordType#set(java.lang.String, java.lang.Object)
	 * @generated
	 */
	EOperation getRecordType__Set__String_Object();

	/**
	 * Returns the meta object for the '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.RecordType#unset(java.lang.String) <em>Unset</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Unset</em>' operation.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.RecordType#unset(java.lang.String)
	 * @generated
	 */
	EOperation getRecordType__Unset__String();

	/**
	 * Returns the meta object for the '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.RecordType#isSet(java.lang.String) <em>Is Set</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Is Set</em>' operation.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.RecordType#isSet(java.lang.String)
	 * @generated
	 */
	EOperation getRecordType__IsSet__String();

	/**
	 * Returns the meta object for the '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.RecordType#has(java.lang.String) <em>Has</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Has</em>' operation.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.RecordType#has(java.lang.String)
	 * @generated
	 */
	EOperation getRecordType__Has__String();

	/**
	 * Returns the meta object for the '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.RecordType#instanceOf(java.lang.String) <em>Instance Of</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Instance Of</em>' operation.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.RecordType#instanceOf(java.lang.String)
	 * @generated
	 */
	EOperation getRecordType__InstanceOf__String();

	/**
	 * Returns the meta object for the '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.RecordType#instanceOf(java.lang.String, java.lang.String) <em>Instance Of</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Instance Of</em>' operation.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.RecordType#instanceOf(java.lang.String, java.lang.String)
	 * @generated
	 */
	EOperation getRecordType__InstanceOf__String_String();

	/**
	 * Returns the meta object for the '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.RecordType#getAsString(java.lang.String) <em>Get As String</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Get As String</em>' operation.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.RecordType#getAsString(java.lang.String)
	 * @generated
	 */
	EOperation getRecordType__GetAsString__String();

	/**
	 * Returns the meta object for the '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.RecordType#setAsString(java.lang.String, java.lang.String) <em>Set As String</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Set As String</em>' operation.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.RecordType#setAsString(java.lang.String, java.lang.String)
	 * @generated
	 */
	EOperation getRecordType__SetAsString__String_String();

	/**
	 * Returns the meta object for the '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.RecordType#instanceOf(it.unibo.cmdb.cmdbf.client.model.cmdbf.ModelRecordType) <em>Instance Of</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Instance Of</em>' operation.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.RecordType#instanceOf(it.unibo.cmdb.cmdbf.client.model.cmdbf.ModelRecordType)
	 * @generated
	 */
	EOperation getRecordType__InstanceOf__ModelRecordType();

	/**
	 * Returns the meta object for the '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.RecordType#merge(it.unibo.cmdb.cmdbf.client.model.cmdbf.RecordType) <em>Merge</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Merge</em>' operation.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.RecordType#merge(it.unibo.cmdb.cmdbf.client.model.cmdbf.RecordType)
	 * @generated
	 */
	EOperation getRecordType__Merge__RecordType();

	/**
	 * Returns the meta object for class '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.RecordTypeType <em>Record Type Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Record Type Type</em>'.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.RecordTypeType
	 * @generated
	 */
	EClass getRecordTypeType();

	/**
	 * Returns the meta object for the attribute '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.RecordTypeType#getLocalName <em>Local Name</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Local Name</em>'.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.RecordTypeType#getLocalName()
	 * @see #getRecordTypeType()
	 * @generated
	 */
	EAttribute getRecordTypeType_LocalName();

	/**
	 * Returns the meta object for the attribute '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.RecordTypeType#getNamespace <em>Namespace</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Namespace</em>'.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.RecordTypeType#getNamespace()
	 * @see #getRecordTypeType()
	 * @generated
	 */
	EAttribute getRecordTypeType_Namespace();

	/**
	 * Returns the meta object for class '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.RegisterInstanceResponseType <em>Register Instance Response Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Register Instance Response Type</em>'.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.RegisterInstanceResponseType
	 * @generated
	 */
	EClass getRegisterInstanceResponseType();

	/**
	 * Returns the meta object for the containment reference '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.RegisterInstanceResponseType#getAccepted <em>Accepted</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Accepted</em>'.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.RegisterInstanceResponseType#getAccepted()
	 * @see #getRegisterInstanceResponseType()
	 * @generated
	 */
	EReference getRegisterInstanceResponseType_Accepted();

	/**
	 * Returns the meta object for class '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.RegisterRequestType <em>Register Request Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Register Request Type</em>'.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.RegisterRequestType
	 * @generated
	 */
	EClass getRegisterRequestType();

	/**
	 * Returns the meta object for the attribute '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.RegisterRequestType#getMdrId <em>Mdr Id</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Mdr Id</em>'.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.RegisterRequestType#getMdrId()
	 * @see #getRegisterRequestType()
	 * @generated
	 */
	EAttribute getRegisterRequestType_MdrId();

	/**
	 * Returns the meta object for the containment reference '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.RegisterRequestType#getItemList <em>Item List</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Item List</em>'.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.RegisterRequestType#getItemList()
	 * @see #getRegisterRequestType()
	 * @generated
	 */
	EReference getRegisterRequestType_ItemList();

	/**
	 * Returns the meta object for the containment reference '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.RegisterRequestType#getRelationshipList <em>Relationship List</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Relationship List</em>'.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.RegisterRequestType#getRelationshipList()
	 * @see #getRegisterRequestType()
	 * @generated
	 */
	EReference getRegisterRequestType_RelationshipList();

	/**
	 * Returns the meta object for the reference '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.RegisterRequestType#getParent <em>Parent</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Parent</em>'.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.RegisterRequestType#getParent()
	 * @see #getRegisterRequestType()
	 * @generated
	 */
	EReference getRegisterRequestType_Parent();

	/**
	 * Returns the meta object for class '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.RegisterResponseType <em>Register Response Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Register Response Type</em>'.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.RegisterResponseType
	 * @generated
	 */
	EClass getRegisterResponseType();

	/**
	 * Returns the meta object for the containment reference list '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.RegisterResponseType#getRegisterInstanceResponse <em>Register Instance Response</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Register Instance Response</em>'.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.RegisterResponseType#getRegisterInstanceResponse()
	 * @see #getRegisterResponseType()
	 * @generated
	 */
	EReference getRegisterResponseType_RegisterInstanceResponse();

	/**
	 * Returns the meta object for class '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.RegistrationErrorFaultType <em>Registration Error Fault Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Registration Error Fault Type</em>'.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.RegistrationErrorFaultType
	 * @generated
	 */
	EClass getRegistrationErrorFaultType();

	/**
	 * Returns the meta object for the attribute '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.RegistrationErrorFaultType#getRecordId <em>Record Id</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Record Id</em>'.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.RegistrationErrorFaultType#getRecordId()
	 * @see #getRegistrationErrorFaultType()
	 * @generated
	 */
	EAttribute getRegistrationErrorFaultType_RecordId();

	/**
	 * Returns the meta object for class '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.RelationshipListType <em>Relationship List Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Relationship List Type</em>'.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.RelationshipListType
	 * @generated
	 */
	EClass getRelationshipListType();

	/**
	 * Returns the meta object for the containment reference list '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.RelationshipListType#getRelationship <em>Relationship</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Relationship</em>'.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.RelationshipListType#getRelationship()
	 * @see #getRelationshipListType()
	 * @generated
	 */
	EReference getRelationshipListType_Relationship();

	/**
	 * Returns the meta object for the '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.RelationshipListType#find(it.unibo.cmdb.cmdbf.client.model.cmdbf.MdrScopedIdType) <em>Find</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Find</em>' operation.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.RelationshipListType#find(it.unibo.cmdb.cmdbf.client.model.cmdbf.MdrScopedIdType)
	 * @generated
	 */
	EOperation getRelationshipListType__Find__MdrScopedIdType();

	/**
	 * Returns the meta object for the '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.RelationshipListType#find(it.unibo.cmdb.cmdbf.client.model.cmdbf.RelationshipType) <em>Find</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Find</em>' operation.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.RelationshipListType#find(it.unibo.cmdb.cmdbf.client.model.cmdbf.RelationshipType)
	 * @generated
	 */
	EOperation getRelationshipListType__Find__RelationshipType();

	/**
	 * Returns the meta object for class '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.RelationshipRefType <em>Relationship Ref Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Relationship Ref Type</em>'.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.RelationshipRefType
	 * @generated
	 */
	EClass getRelationshipRefType();

	/**
	 * Returns the meta object for the attribute '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.RelationshipRefType#getRef <em>Ref</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Ref</em>'.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.RelationshipRefType#getRef()
	 * @see #getRelationshipRefType()
	 * @generated
	 */
	EAttribute getRelationshipRefType_Ref();

	/**
	 * Returns the meta object for the attribute '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.RelationshipRefType#getMinimum <em>Minimum</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Minimum</em>'.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.RelationshipRefType#getMinimum()
	 * @see #getRelationshipRefType()
	 * @generated
	 */
	EAttribute getRelationshipRefType_Minimum();

	/**
	 * Returns the meta object for the attribute '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.RelationshipRefType#getMaximum <em>Maximum</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Maximum</em>'.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.RelationshipRefType#getMaximum()
	 * @see #getRelationshipRefType()
	 * @generated
	 */
	EAttribute getRelationshipRefType_Maximum();

	/**
	 * Returns the meta object for class '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.RelationshipTemplateType <em>Relationship Template Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Relationship Template Type</em>'.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.RelationshipTemplateType
	 * @generated
	 */
	EClass getRelationshipTemplateType();

	/**
	 * Returns the meta object for the containment reference '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.RelationshipTemplateType#getSourceTemplate <em>Source Template</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Source Template</em>'.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.RelationshipTemplateType#getSourceTemplate()
	 * @see #getRelationshipTemplateType()
	 * @generated
	 */
	EReference getRelationshipTemplateType_SourceTemplate();

	/**
	 * Returns the meta object for the containment reference '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.RelationshipTemplateType#getTargetTemplate <em>Target Template</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Target Template</em>'.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.RelationshipTemplateType#getTargetTemplate()
	 * @see #getRelationshipTemplateType()
	 * @generated
	 */
	EReference getRelationshipTemplateType_TargetTemplate();

	/**
	 * Returns the meta object for the containment reference '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.RelationshipTemplateType#getDepthLimit <em>Depth Limit</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Depth Limit</em>'.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.RelationshipTemplateType#getDepthLimit()
	 * @see #getRelationshipTemplateType()
	 * @generated
	 */
	EReference getRelationshipTemplateType_DepthLimit();

	/**
	 * Returns the meta object for the '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.RelationshipTemplateType#addSourceTemplate(it.unibo.cmdb.cmdbf.client.model.cmdbf.ItemTemplateType) <em>Add Source Template</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Add Source Template</em>' operation.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.RelationshipTemplateType#addSourceTemplate(it.unibo.cmdb.cmdbf.client.model.cmdbf.ItemTemplateType)
	 * @generated
	 */
	EOperation getRelationshipTemplateType__AddSourceTemplate__ItemTemplateType();

	/**
	 * Returns the meta object for the '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.RelationshipTemplateType#addTargetTemplate(it.unibo.cmdb.cmdbf.client.model.cmdbf.ItemTemplateType) <em>Add Target Template</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Add Target Template</em>' operation.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.RelationshipTemplateType#addTargetTemplate(it.unibo.cmdb.cmdbf.client.model.cmdbf.ItemTemplateType)
	 * @generated
	 */
	EOperation getRelationshipTemplateType__AddTargetTemplate__ItemTemplateType();

	/**
	 * Returns the meta object for the '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.RelationshipTemplateType#addDepthLimit(it.unibo.cmdb.cmdbf.client.model.cmdbf.ItemTemplateType) <em>Add Depth Limit</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Add Depth Limit</em>' operation.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.RelationshipTemplateType#addDepthLimit(it.unibo.cmdb.cmdbf.client.model.cmdbf.ItemTemplateType)
	 * @generated
	 */
	EOperation getRelationshipTemplateType__AddDepthLimit__ItemTemplateType();

	/**
	 * Returns the meta object for class '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.RelationshipType <em>Relationship Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Relationship Type</em>'.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.RelationshipType
	 * @generated
	 */
	EClass getRelationshipType();

	/**
	 * Returns the meta object for the reference '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.RelationshipType#getSourceItem <em>Source Item</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Source Item</em>'.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.RelationshipType#getSourceItem()
	 * @see #getRelationshipType()
	 * @generated
	 */
	EReference getRelationshipType_SourceItem();

	/**
	 * Returns the meta object for the reference '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.RelationshipType#getTargetItem <em>Target Item</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Target Item</em>'.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.RelationshipType#getTargetItem()
	 * @see #getRelationshipType()
	 * @generated
	 */
	EReference getRelationshipType_TargetItem();

	/**
	 * Returns the meta object for class '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.SelectedRecordTypeType <em>Selected Record Type Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Selected Record Type Type</em>'.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.SelectedRecordTypeType
	 * @generated
	 */
	EClass getSelectedRecordTypeType();

	/**
	 * Returns the meta object for the containment reference list '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.SelectedRecordTypeType#getSelectedProperty <em>Selected Property</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Selected Property</em>'.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.SelectedRecordTypeType#getSelectedProperty()
	 * @see #getSelectedRecordTypeType()
	 * @generated
	 */
	EReference getSelectedRecordTypeType_SelectedProperty();

	/**
	 * Returns the meta object for the attribute '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.SelectedRecordTypeType#getNamespace <em>Namespace</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Namespace</em>'.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.SelectedRecordTypeType#getNamespace()
	 * @see #getSelectedRecordTypeType()
	 * @generated
	 */
	EAttribute getSelectedRecordTypeType_Namespace();

	/**
	 * Returns the meta object for the attribute '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.SelectedRecordTypeType#getLocalName <em>Local Name</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Local Name</em>'.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.SelectedRecordTypeType#getLocalName()
	 * @see #getSelectedRecordTypeType()
	 * @generated
	 */
	EAttribute getSelectedRecordTypeType_LocalName();

	/**
	 * Returns the meta object for the container reference '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.SelectedRecordTypeType#getParent <em>Parent</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the container reference '<em>Parent</em>'.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.SelectedRecordTypeType#getParent()
	 * @see #getSelectedRecordTypeType()
	 * @generated
	 */
	EReference getSelectedRecordTypeType_Parent();

	/**
	 * Returns the meta object for the '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.SelectedRecordTypeType#addSelectedProperty(java.lang.String) <em>Add Selected Property</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Add Selected Property</em>' operation.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.SelectedRecordTypeType#addSelectedProperty(java.lang.String)
	 * @generated
	 */
	EOperation getSelectedRecordTypeType__AddSelectedProperty__String();

	/**
	 * Returns the meta object for the '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.SelectedRecordTypeType#addSelectedProperty(java.lang.String, java.lang.String) <em>Add Selected Property</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Add Selected Property</em>' operation.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.SelectedRecordTypeType#addSelectedProperty(java.lang.String, java.lang.String)
	 * @generated
	 */
	EOperation getSelectedRecordTypeType__AddSelectedProperty__String_String();

	/**
	 * Returns the meta object for class '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.SelectorType <em>Selector Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Selector Type</em>'.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.SelectorType
	 * @generated
	 */
	EClass getSelectorType();

	/**
	 * Returns the meta object for the attribute '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.SelectorType#getLocalName <em>Local Name</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Local Name</em>'.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.SelectorType#getLocalName()
	 * @see #getSelectorType()
	 * @generated
	 */
	EAttribute getSelectorType_LocalName();

	/**
	 * Returns the meta object for the attribute '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.SelectorType#getNamespace <em>Namespace</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Namespace</em>'.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.SelectorType#getNamespace()
	 * @see #getSelectorType()
	 * @generated
	 */
	EAttribute getSelectorType_Namespace();

	/**
	 * Returns the meta object for class '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.StringOperatorType <em>String Operator Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>String Operator Type</em>'.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.StringOperatorType
	 * @generated
	 */
	EClass getStringOperatorType();

	/**
	 * Returns the meta object for the attribute '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.StringOperatorType#getValue <em>Value</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Value</em>'.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.StringOperatorType#getValue()
	 * @see #getStringOperatorType()
	 * @generated
	 */
	EAttribute getStringOperatorType_Value();

	/**
	 * Returns the meta object for the attribute '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.StringOperatorType#isCaseSensitive <em>Case Sensitive</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Case Sensitive</em>'.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.StringOperatorType#isCaseSensitive()
	 * @see #getStringOperatorType()
	 * @generated
	 */
	EAttribute getStringOperatorType_CaseSensitive();

	/**
	 * Returns the meta object for the attribute '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.StringOperatorType#isNegate <em>Negate</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Negate</em>'.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.StringOperatorType#isNegate()
	 * @see #getStringOperatorType()
	 * @generated
	 */
	EAttribute getStringOperatorType_Negate();

	/**
	 * Returns the meta object for class '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.UnknownTemplateIDFaultType <em>Unknown Template ID Fault Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Unknown Template ID Fault Type</em>'.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.UnknownTemplateIDFaultType
	 * @generated
	 */
	EClass getUnknownTemplateIDFaultType();

	/**
	 * Returns the meta object for the attribute '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.UnknownTemplateIDFaultType#getGraphId <em>Graph Id</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Graph Id</em>'.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.UnknownTemplateIDFaultType#getGraphId()
	 * @see #getUnknownTemplateIDFaultType()
	 * @generated
	 */
	EAttribute getUnknownTemplateIDFaultType_GraphId();

	/**
	 * Returns the meta object for class '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.UnsupportedConstraintFaultType <em>Unsupported Constraint Fault Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Unsupported Constraint Fault Type</em>'.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.UnsupportedConstraintFaultType
	 * @generated
	 */
	EClass getUnsupportedConstraintFaultType();

	/**
	 * Returns the meta object for the containment reference '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.UnsupportedConstraintFaultType#getConstraint <em>Constraint</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Constraint</em>'.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.UnsupportedConstraintFaultType#getConstraint()
	 * @see #getUnsupportedConstraintFaultType()
	 * @generated
	 */
	EReference getUnsupportedConstraintFaultType_Constraint();

	/**
	 * Returns the meta object for class '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.UnsupportedRecordTypeFaultType <em>Unsupported Record Type Fault Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Unsupported Record Type Fault Type</em>'.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.UnsupportedRecordTypeFaultType
	 * @generated
	 */
	EClass getUnsupportedRecordTypeFaultType();

	/**
	 * Returns the meta object for the containment reference '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.UnsupportedRecordTypeFaultType#getRecordType <em>Record Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Record Type</em>'.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.UnsupportedRecordTypeFaultType#getRecordType()
	 * @see #getUnsupportedRecordTypeFaultType()
	 * @generated
	 */
	EReference getUnsupportedRecordTypeFaultType_RecordType();

	/**
	 * Returns the meta object for class '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.UnsupportedSelectorFaultType <em>Unsupported Selector Fault Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Unsupported Selector Fault Type</em>'.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.UnsupportedSelectorFaultType
	 * @generated
	 */
	EClass getUnsupportedSelectorFaultType();

	/**
	 * Returns the meta object for the containment reference '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.UnsupportedSelectorFaultType#getSelector <em>Selector</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Selector</em>'.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.UnsupportedSelectorFaultType#getSelector()
	 * @see #getUnsupportedSelectorFaultType()
	 * @generated
	 */
	EReference getUnsupportedSelectorFaultType_Selector();

	/**
	 * Returns the meta object for class '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.XPathErrorFaultType <em>XPath Error Fault Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>XPath Error Fault Type</em>'.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.XPathErrorFaultType
	 * @generated
	 */
	EClass getXPathErrorFaultType();

	/**
	 * Returns the meta object for the attribute '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.XPathErrorFaultType#getExpression <em>Expression</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Expression</em>'.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.XPathErrorFaultType#getExpression()
	 * @see #getXPathErrorFaultType()
	 * @generated
	 */
	EAttribute getXPathErrorFaultType_Expression();

	/**
	 * Returns the meta object for the attribute '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.XPathErrorFaultType#getXpathErrorCode <em>Xpath Error Code</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Xpath Error Code</em>'.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.XPathErrorFaultType#getXpathErrorCode()
	 * @see #getXPathErrorFaultType()
	 * @generated
	 */
	EAttribute getXPathErrorFaultType_XpathErrorCode();

	/**
	 * Returns the meta object for class '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.XPathExpressionType <em>XPath Expression Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>XPath Expression Type</em>'.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.XPathExpressionType
	 * @generated
	 */
	EClass getXPathExpressionType();

	/**
	 * Returns the meta object for the containment reference list '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.XPathExpressionType#getPrefixMapping <em>Prefix Mapping</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Prefix Mapping</em>'.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.XPathExpressionType#getPrefixMapping()
	 * @see #getXPathExpressionType()
	 * @generated
	 */
	EReference getXPathExpressionType_PrefixMapping();

	/**
	 * Returns the meta object for the attribute '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.XPathExpressionType#getExpression <em>Expression</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Expression</em>'.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.XPathExpressionType#getExpression()
	 * @see #getXPathExpressionType()
	 * @generated
	 */
	EAttribute getXPathExpressionType_Expression();

	/**
	 * Returns the meta object for the attribute '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.XPathExpressionType#getDialect <em>Dialect</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Dialect</em>'.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.XPathExpressionType#getDialect()
	 * @see #getXPathExpressionType()
	 * @generated
	 */
	EAttribute getXPathExpressionType_Dialect();

	/**
	 * Returns the meta object for class '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.ModelElement <em>Model Element</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Model Element</em>'.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.ModelElement
	 * @generated
	 */
	EClass getModelElement();

	/**
	 * Returns the meta object for the containment reference list '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.ModelElement#getRecord <em>Record</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Record</em>'.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.ModelElement#getRecord()
	 * @see #getModelElement()
	 * @generated
	 */
	EReference getModelElement_Record();

	/**
	 * Returns the meta object for the containment reference list '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.ModelElement#getInstanceId <em>Instance Id</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Instance Id</em>'.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.ModelElement#getInstanceId()
	 * @see #getModelElement()
	 * @generated
	 */
	EReference getModelElement_InstanceId();

	/**
	 * Returns the meta object for the containment reference list '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.ModelElement#getAdditionalRecordType <em>Additional Record Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Additional Record Type</em>'.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.ModelElement#getAdditionalRecordType()
	 * @see #getModelElement()
	 * @generated
	 */
	EReference getModelElement_AdditionalRecordType();

	/**
	 * Returns the meta object for the attribute list '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.ModelElement#getTemplateId <em>Template Id</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute list '<em>Template Id</em>'.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.ModelElement#getTemplateId()
	 * @see #getModelElement()
	 * @generated
	 */
	EAttribute getModelElement_TemplateId();

	/**
	 * Returns the meta object for the reference '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.ModelElement#getParent <em>Parent</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Parent</em>'.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.ModelElement#getParent()
	 * @see #getModelElement()
	 * @generated
	 */
	EReference getModelElement_Parent();

	/**
	 * Returns the meta object for the attribute '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.ModelElement#isDeregister <em>Deregister</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Deregister</em>'.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.ModelElement#isDeregister()
	 * @see #getModelElement()
	 * @generated
	 */
	EAttribute getModelElement_Deregister();

	/**
	 * Returns the meta object for the '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.ModelElement#findInstanceId() <em>Find Instance Id</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Find Instance Id</em>' operation.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.ModelElement#findInstanceId()
	 * @generated
	 */
	EOperation getModelElement__FindInstanceId();

	/**
	 * Returns the meta object for the '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.ModelElement#findInstanceId(java.lang.String) <em>Find Instance Id</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Find Instance Id</em>' operation.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.ModelElement#findInstanceId(java.lang.String)
	 * @generated
	 */
	EOperation getModelElement__FindInstanceId__String();

	/**
	 * Returns the meta object for the '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.ModelElement#addInstanceId(java.lang.String) <em>Add Instance Id</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Add Instance Id</em>' operation.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.ModelElement#addInstanceId(java.lang.String)
	 * @generated
	 */
	EOperation getModelElement__AddInstanceId__String();

	/**
	 * Returns the meta object for the '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.ModelElement#addInstanceId(java.lang.String, java.lang.String) <em>Add Instance Id</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Add Instance Id</em>' operation.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.ModelElement#addInstanceId(java.lang.String, java.lang.String)
	 * @generated
	 */
	EOperation getModelElement__AddInstanceId__String_String();

	/**
	 * Returns the meta object for the '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.ModelElement#addAdditionalRecordType(java.lang.String) <em>Add Additional Record Type</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Add Additional Record Type</em>' operation.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.ModelElement#addAdditionalRecordType(java.lang.String)
	 * @generated
	 */
	EOperation getModelElement__AddAdditionalRecordType__String();

	/**
	 * Returns the meta object for the '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.ModelElement#addAdditionalRecordType(java.lang.String, java.lang.String) <em>Add Additional Record Type</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Add Additional Record Type</em>' operation.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.ModelElement#addAdditionalRecordType(java.lang.String, java.lang.String)
	 * @generated
	 */
	EOperation getModelElement__AddAdditionalRecordType__String_String();

	/**
	 * Returns the meta object for the '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.ModelElement#addRecord(java.lang.String) <em>Add Record</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Add Record</em>' operation.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.ModelElement#addRecord(java.lang.String)
	 * @generated
	 */
	EOperation getModelElement__AddRecord__String();

	/**
	 * Returns the meta object for the '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.ModelElement#addRecord(java.lang.String, java.lang.String) <em>Add Record</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Add Record</em>' operation.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.ModelElement#addRecord(java.lang.String, java.lang.String)
	 * @generated
	 */
	EOperation getModelElement__AddRecord__String_String();

	/**
	 * Returns the meta object for the '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.ModelElement#addRecord(java.lang.String, boolean) <em>Add Record</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Add Record</em>' operation.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.ModelElement#addRecord(java.lang.String, boolean)
	 * @generated
	 */
	EOperation getModelElement__AddRecord__String_boolean();

	/**
	 * Returns the meta object for the '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.ModelElement#addRecord(java.lang.String, java.lang.String, boolean) <em>Add Record</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Add Record</em>' operation.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.ModelElement#addRecord(java.lang.String, java.lang.String, boolean)
	 * @generated
	 */
	EOperation getModelElement__AddRecord__String_String_boolean();

	/**
	 * Returns the meta object for the '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.ModelElement#findRecord(java.lang.String) <em>Find Record</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Find Record</em>' operation.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.ModelElement#findRecord(java.lang.String)
	 * @generated
	 */
	EOperation getModelElement__FindRecord__String();

	/**
	 * Returns the meta object for the '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.ModelElement#findRecord(java.lang.String, java.lang.String) <em>Find Record</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Find Record</em>' operation.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.ModelElement#findRecord(java.lang.String, java.lang.String)
	 * @generated
	 */
	EOperation getModelElement__FindRecord__String_String();

	/**
	 * Returns the meta object for the '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.ModelElement#findRecordByTemplate(java.lang.String, java.lang.String) <em>Find Record By Template</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Find Record By Template</em>' operation.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.ModelElement#findRecordByTemplate(java.lang.String, java.lang.String)
	 * @generated
	 */
	EOperation getModelElement__FindRecordByTemplate__String_String();

	/**
	 * Returns the meta object for the '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.ModelElement#findRecordByTemplate(java.lang.String, java.lang.String, java.lang.String) <em>Find Record By Template</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Find Record By Template</em>' operation.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.ModelElement#findRecordByTemplate(java.lang.String, java.lang.String, java.lang.String)
	 * @generated
	 */
	EOperation getModelElement__FindRecordByTemplate__String_String_String();

	/**
	 * Returns the meta object for the '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.ModelElement#findRecordById(java.lang.String) <em>Find Record By Id</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Find Record By Id</em>' operation.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.ModelElement#findRecordById(java.lang.String)
	 * @generated
	 */
	EOperation getModelElement__FindRecordById__String();

	/**
	 * Returns the meta object for the '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.ModelElement#merge(it.unibo.cmdb.cmdbf.client.model.cmdbf.ModelElement) <em>Merge</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Merge</em>' operation.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.ModelElement#merge(it.unibo.cmdb.cmdbf.client.model.cmdbf.ModelElement)
	 * @generated
	 */
	EOperation getModelElement__Merge__ModelElement();

	/**
	 * Returns the meta object for class '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.ModelTemplate <em>Model Template</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Model Template</em>'.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.ModelTemplate
	 * @generated
	 */
	EClass getModelTemplate();

	/**
	 * Returns the meta object for the containment reference '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.ModelTemplate#getContentSelector <em>Content Selector</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Content Selector</em>'.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.ModelTemplate#getContentSelector()
	 * @see #getModelTemplate()
	 * @generated
	 */
	EReference getModelTemplate_ContentSelector();

	/**
	 * Returns the meta object for the containment reference '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.ModelTemplate#getInstanceIdConstraint <em>Instance Id Constraint</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Instance Id Constraint</em>'.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.ModelTemplate#getInstanceIdConstraint()
	 * @see #getModelTemplate()
	 * @generated
	 */
	EReference getModelTemplate_InstanceIdConstraint();

	/**
	 * Returns the meta object for the containment reference list '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.ModelTemplate#getRecordConstraint <em>Record Constraint</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Record Constraint</em>'.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.ModelTemplate#getRecordConstraint()
	 * @see #getModelTemplate()
	 * @generated
	 */
	EReference getModelTemplate_RecordConstraint();

	/**
	 * Returns the meta object for the attribute list '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.ModelTemplate#getAny <em>Any</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute list '<em>Any</em>'.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.ModelTemplate#getAny()
	 * @see #getModelTemplate()
	 * @generated
	 */
	EAttribute getModelTemplate_Any();

	/**
	 * Returns the meta object for the attribute '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.ModelTemplate#getId <em>Id</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Id</em>'.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.ModelTemplate#getId()
	 * @see #getModelTemplate()
	 * @generated
	 */
	EAttribute getModelTemplate_Id();

	/**
	 * Returns the meta object for the attribute '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.ModelTemplate#isSuppressFromResult <em>Suppress From Result</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Suppress From Result</em>'.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.ModelTemplate#isSuppressFromResult()
	 * @see #getModelTemplate()
	 * @generated
	 */
	EAttribute getModelTemplate_SuppressFromResult();

	/**
	 * Returns the meta object for the reference '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.ModelTemplate#getQuery <em>Query</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Query</em>'.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.ModelTemplate#getQuery()
	 * @see #getModelTemplate()
	 * @generated
	 */
	EReference getModelTemplate_Query();

	/**
	 * Returns the meta object for the '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.ModelTemplate#addInstanceIdConstraint(java.lang.String) <em>Add Instance Id Constraint</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Add Instance Id Constraint</em>' operation.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.ModelTemplate#addInstanceIdConstraint(java.lang.String)
	 * @generated
	 */
	EOperation getModelTemplate__AddInstanceIdConstraint__String();

	/**
	 * Returns the meta object for the '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.ModelTemplate#addInstanceIdConstraint(java.lang.String, java.lang.String) <em>Add Instance Id Constraint</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Add Instance Id Constraint</em>' operation.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.ModelTemplate#addInstanceIdConstraint(java.lang.String, java.lang.String)
	 * @generated
	 */
	EOperation getModelTemplate__AddInstanceIdConstraint__String_String();

	/**
	 * Returns the meta object for the '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.ModelTemplate#addRecordConstraint() <em>Add Record Constraint</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Add Record Constraint</em>' operation.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.ModelTemplate#addRecordConstraint()
	 * @generated
	 */
	EOperation getModelTemplate__AddRecordConstraint();

	/**
	 * Returns the meta object for the '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.ModelTemplate#addContentSelector(java.lang.String) <em>Add Content Selector</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Add Content Selector</em>' operation.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.ModelTemplate#addContentSelector(java.lang.String)
	 * @generated
	 */
	EOperation getModelTemplate__AddContentSelector__String();

	/**
	 * Returns the meta object for the '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.ModelTemplate#addContentSelector(java.lang.String, java.lang.String) <em>Add Content Selector</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Add Content Selector</em>' operation.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.ModelTemplate#addContentSelector(java.lang.String, java.lang.String)
	 * @generated
	 */
	EOperation getModelTemplate__AddContentSelector__String_String();

	/**
	 * Returns the meta object for class '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.ModelUpdateInstanceResponse <em>Model Update Instance Response</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Model Update Instance Response</em>'.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.ModelUpdateInstanceResponse
	 * @generated
	 */
	EClass getModelUpdateInstanceResponse();

	/**
	 * Returns the meta object for the containment reference '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.ModelUpdateInstanceResponse#getInstanceId <em>Instance Id</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Instance Id</em>'.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.ModelUpdateInstanceResponse#getInstanceId()
	 * @see #getModelUpdateInstanceResponse()
	 * @generated
	 */
	EReference getModelUpdateInstanceResponse_InstanceId();

	/**
	 * Returns the meta object for the containment reference '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.ModelUpdateInstanceResponse#getDeclined <em>Declined</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Declined</em>'.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.ModelUpdateInstanceResponse#getDeclined()
	 * @see #getModelUpdateInstanceResponse()
	 * @generated
	 */
	EReference getModelUpdateInstanceResponse_Declined();

	/**
	 * Returns the meta object for class '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.ModelUpdateResponse <em>Model Update Response</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Model Update Response</em>'.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.ModelUpdateResponse
	 * @generated
	 */
	EClass getModelUpdateResponse();

	/**
	 * Returns the meta object for the containment reference list '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.ModelUpdateResponse#getInstanceResponse <em>Instance Response</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Instance Response</em>'.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.ModelUpdateResponse#getInstanceResponse()
	 * @see #getModelUpdateResponse()
	 * @generated
	 */
	EReference getModelUpdateResponse_InstanceResponse();

	/**
	 * Returns the meta object for class '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.ModelRecordType <em>Model Record Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Model Record Type</em>'.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.ModelRecordType
	 * @generated
	 */
	EClass getModelRecordType();

	/**
	 * Returns the meta object for the attribute '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.ModelRecordType#getLocalName <em>Local Name</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Local Name</em>'.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.ModelRecordType#getLocalName()
	 * @see #getModelRecordType()
	 * @generated
	 */
	EAttribute getModelRecordType_LocalName();

	/**
	 * Returns the meta object for the attribute '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.ModelRecordType#getNamespace <em>Namespace</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Namespace</em>'.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.ModelRecordType#getNamespace()
	 * @see #getModelRecordType()
	 * @generated
	 */
	EAttribute getModelRecordType_Namespace();

	/**
	 * Returns the meta object for the attribute '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.ModelRecordType#isAppliesToItem <em>Applies To Item</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Applies To Item</em>'.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.ModelRecordType#isAppliesToItem()
	 * @see #getModelRecordType()
	 * @generated
	 */
	EAttribute getModelRecordType_AppliesToItem();

	/**
	 * Returns the meta object for the attribute '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.ModelRecordType#isAppliesToRelationship <em>Applies To Relationship</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Applies To Relationship</em>'.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.ModelRecordType#isAppliesToRelationship()
	 * @see #getModelRecordType()
	 * @generated
	 */
	EAttribute getModelRecordType_AppliesToRelationship();

	/**
	 * Returns the meta object for the reference list '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.ModelRecordType#getSuperType <em>Super Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Super Type</em>'.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.ModelRecordType#getSuperType()
	 * @see #getModelRecordType()
	 * @generated
	 */
	EReference getModelRecordType_SuperType();

	/**
	 * Returns the meta object for the '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.ModelRecordType#isAssignableFrom(it.unibo.cmdb.cmdbf.client.model.cmdbf.ModelRecordType) <em>Is Assignable From</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Is Assignable From</em>' operation.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.ModelRecordType#isAssignableFrom(it.unibo.cmdb.cmdbf.client.model.cmdbf.ModelRecordType)
	 * @generated
	 */
	EOperation getModelRecordType__IsAssignableFrom__ModelRecordType();

	/**
	 * Returns the meta object for class '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.Model <em>Model</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Model</em>'.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.Model
	 * @generated
	 */
	EClass getModel();

	/**
	 * Returns the meta object for the containment reference '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.Model#getRegister <em>Register</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Register</em>'.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.Model#getRegister()
	 * @see #getModel()
	 * @generated
	 */
	EReference getModel_Register();

	/**
	 * Returns the meta object for the containment reference '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.Model#getDeregister <em>Deregister</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Deregister</em>'.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.Model#getDeregister()
	 * @see #getModel()
	 * @generated
	 */
	EReference getModel_Deregister();

	/**
	 * Returns the meta object for the reference list '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.Model#getItem <em>Item</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Item</em>'.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.Model#getItem()
	 * @see #getModel()
	 * @generated
	 */
	EReference getModel_Item();

	/**
	 * Returns the meta object for the reference list '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.Model#getRelationship <em>Relationship</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Relationship</em>'.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.Model#getRelationship()
	 * @see #getModel()
	 * @generated
	 */
	EReference getModel_Relationship();

	/**
	 * Returns the meta object for the reference '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.Model#getModelMetadata <em>Model Metadata</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Model Metadata</em>'.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.Model#getModelMetadata()
	 * @see #getModel()
	 * @generated
	 */
	EReference getModel_ModelMetadata();

	/**
	 * Returns the meta object for the attribute '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.Model#getMdrId <em>Mdr Id</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Mdr Id</em>'.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.Model#getMdrId()
	 * @see #getModel()
	 * @generated
	 */
	EAttribute getModel_MdrId();

	/**
	 * Returns the meta object for the reference list '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.Model#getRemovedItemId <em>Removed Item Id</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Removed Item Id</em>'.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.Model#getRemovedItemId()
	 * @see #getModel()
	 * @generated
	 */
	EReference getModel_RemovedItemId();

	/**
	 * Returns the meta object for the reference list '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.Model#getRemovedRelationshipId <em>Removed Relationship Id</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Removed Relationship Id</em>'.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.Model#getRemovedRelationshipId()
	 * @see #getModel()
	 * @generated
	 */
	EReference getModel_RemovedRelationshipId();

	/**
	 * Returns the meta object for the '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.Model#addItem() <em>Add Item</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Add Item</em>' operation.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.Model#addItem()
	 * @generated
	 */
	EOperation getModel__AddItem();

	/**
	 * Returns the meta object for the '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.Model#addRelationship() <em>Add Relationship</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Add Relationship</em>' operation.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.Model#addRelationship()
	 * @generated
	 */
	EOperation getModel__AddRelationship();

	/**
	 * Returns the meta object for the '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.Model#getItemByTemplate(java.lang.String) <em>Get Item By Template</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Get Item By Template</em>' operation.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.Model#getItemByTemplate(java.lang.String)
	 * @generated
	 */
	EOperation getModel__GetItemByTemplate__String();

	/**
	 * Returns the meta object for the '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.Model#getRelationshipByTemplate(java.lang.String) <em>Get Relationship By Template</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Get Relationship By Template</em>' operation.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.Model#getRelationshipByTemplate(java.lang.String)
	 * @generated
	 */
	EOperation getModel__GetRelationshipByTemplate__String();

	/**
	 * Returns the meta object for the '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.Model#findItem(it.unibo.cmdb.cmdbf.client.model.cmdbf.MdrScopedIdType) <em>Find Item</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Find Item</em>' operation.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.Model#findItem(it.unibo.cmdb.cmdbf.client.model.cmdbf.MdrScopedIdType)
	 * @generated
	 */
	EOperation getModel__FindItem__MdrScopedIdType();

	/**
	 * Returns the meta object for the '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.Model#findItem(it.unibo.cmdb.cmdbf.client.model.cmdbf.ItemType) <em>Find Item</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Find Item</em>' operation.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.Model#findItem(it.unibo.cmdb.cmdbf.client.model.cmdbf.ItemType)
	 * @generated
	 */
	EOperation getModel__FindItem__ItemType();

	/**
	 * Returns the meta object for the '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.Model#findItem(java.lang.String, java.lang.String) <em>Find Item</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Find Item</em>' operation.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.Model#findItem(java.lang.String, java.lang.String)
	 * @generated
	 */
	EOperation getModel__FindItem__String_String();

	/**
	 * Returns the meta object for the '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.Model#findRelationship(it.unibo.cmdb.cmdbf.client.model.cmdbf.MdrScopedIdType) <em>Find Relationship</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Find Relationship</em>' operation.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.Model#findRelationship(it.unibo.cmdb.cmdbf.client.model.cmdbf.MdrScopedIdType)
	 * @generated
	 */
	EOperation getModel__FindRelationship__MdrScopedIdType();

	/**
	 * Returns the meta object for the '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.Model#findRelationship(it.unibo.cmdb.cmdbf.client.model.cmdbf.RelationshipType) <em>Find Relationship</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Find Relationship</em>' operation.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.Model#findRelationship(it.unibo.cmdb.cmdbf.client.model.cmdbf.RelationshipType)
	 * @generated
	 */
	EOperation getModel__FindRelationship__RelationshipType();

	/**
	 * Returns the meta object for the '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.Model#findRelationship(java.lang.String, java.lang.String) <em>Find Relationship</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Find Relationship</em>' operation.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.Model#findRelationship(java.lang.String, java.lang.String)
	 * @generated
	 */
	EOperation getModel__FindRelationship__String_String();

	/**
	 * Returns the meta object for the '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.Model#remove(it.unibo.cmdb.cmdbf.client.model.cmdbf.ItemType) <em>Remove</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Remove</em>' operation.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.Model#remove(it.unibo.cmdb.cmdbf.client.model.cmdbf.ItemType)
	 * @generated
	 */
	EOperation getModel__Remove__ItemType();

	/**
	 * Returns the meta object for the '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.Model#remove(it.unibo.cmdb.cmdbf.client.model.cmdbf.RelationshipType) <em>Remove</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Remove</em>' operation.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.Model#remove(it.unibo.cmdb.cmdbf.client.model.cmdbf.RelationshipType)
	 * @generated
	 */
	EOperation getModel__Remove__RelationshipType();

	/**
	 * Returns the meta object for class '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.ModelMetadata <em>Model Metadata</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Model Metadata</em>'.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.ModelMetadata
	 * @generated
	 */
	EClass getModelMetadata();

	/**
	 * Returns the meta object for the '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.ModelMetadata#getElement(java.lang.String, java.lang.String) <em>Get Element</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Get Element</em>' operation.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.ModelMetadata#getElement(java.lang.String, java.lang.String)
	 * @generated
	 */
	EOperation getModelMetadata__GetElement__String_String();

	/**
	 * Returns the meta object for the '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.ModelMetadata#getNamespace(org.eclipse.emf.ecore.EClassifier) <em>Get Namespace</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Get Namespace</em>' operation.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.ModelMetadata#getNamespace(org.eclipse.emf.ecore.EClassifier)
	 * @generated
	 */
	EOperation getModelMetadata__GetNamespace__EClassifier();

	/**
	 * Returns the meta object for the '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.ModelMetadata#getLocalName(org.eclipse.emf.ecore.EClassifier) <em>Get Local Name</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Get Local Name</em>' operation.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.ModelMetadata#getLocalName(org.eclipse.emf.ecore.EClassifier)
	 * @generated
	 */
	EOperation getModelMetadata__GetLocalName__EClassifier();

	/**
	 * Returns the meta object for the '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.ModelMetadata#getRecordType(java.lang.String, java.lang.String) <em>Get Record Type</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Get Record Type</em>' operation.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.ModelMetadata#getRecordType(java.lang.String, java.lang.String)
	 * @generated
	 */
	EOperation getModelMetadata__GetRecordType__String_String();

	/**
	 * Returns the meta object for the '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.ModelMetadata#getNamespace(java.lang.String) <em>Get Namespace</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Get Namespace</em>' operation.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.ModelMetadata#getNamespace(java.lang.String)
	 * @generated
	 */
	EOperation getModelMetadata__GetNamespace__String();

	/**
	 * Returns the meta object for the '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.ModelMetadata#getLocalName(java.lang.String) <em>Get Local Name</em>}' operation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the '<em>Get Local Name</em>' operation.
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.ModelMetadata#getLocalName(java.lang.String)
	 * @generated
	 */
	EOperation getModelMetadata__GetLocalName__String();

	/**
	 * Returns the factory that creates the instances of the model.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the factory that creates the instances of the model.
	 * @generated
	 */
	CmdbfFactory getCmdbfFactory();

	/**
	 * <!-- begin-user-doc -->
	 * Defines literals for the meta objects that represent
	 * <ul>
	 *   <li>each class,</li>
	 *   <li>each feature of each class,</li>
	 *   <li>each operation of each class,</li>
	 *   <li>each enum,</li>
	 *   <li>and each data type</li>
	 * </ul>
	 * <!-- end-user-doc -->
	 * @generated
	 */
	interface Literals {
		/**
		 * The meta object literal for the '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.AcceptedTypeImpl <em>Accepted Type</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.AcceptedTypeImpl
		 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.CmdbfPackageImpl#getAcceptedType()
		 * @generated
		 */
		EClass ACCEPTED_TYPE = eINSTANCE.getAcceptedType();

		/**
		 * The meta object literal for the '<em><b>Alternate Instance Id</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference ACCEPTED_TYPE__ALTERNATE_INSTANCE_ID = eINSTANCE.getAcceptedType_AlternateInstanceId();

		/**
		 * The meta object literal for the '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.ComparisonOperatorTypeImpl <em>Comparison Operator Type</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.ComparisonOperatorTypeImpl
		 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.CmdbfPackageImpl#getComparisonOperatorType()
		 * @generated
		 */
		EClass COMPARISON_OPERATOR_TYPE = eINSTANCE.getComparisonOperatorType();

		/**
		 * The meta object literal for the '<em><b>Value</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute COMPARISON_OPERATOR_TYPE__VALUE = eINSTANCE.getComparisonOperatorType_Value();

		/**
		 * The meta object literal for the '<em><b>Negate</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute COMPARISON_OPERATOR_TYPE__NEGATE = eINSTANCE.getComparisonOperatorType_Negate();

		/**
		 * The meta object literal for the '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.ConstraintTypeImpl <em>Constraint Type</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.ConstraintTypeImpl
		 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.CmdbfPackageImpl#getConstraintType()
		 * @generated
		 */
		EClass CONSTRAINT_TYPE = eINSTANCE.getConstraintType();

		/**
		 * The meta object literal for the '<em><b>Local Name</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute CONSTRAINT_TYPE__LOCAL_NAME = eINSTANCE.getConstraintType_LocalName();

		/**
		 * The meta object literal for the '<em><b>Namespace</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute CONSTRAINT_TYPE__NAMESPACE = eINSTANCE.getConstraintType_Namespace();

		/**
		 * The meta object literal for the '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.ContentSelectorTypeImpl <em>Content Selector Type</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.ContentSelectorTypeImpl
		 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.CmdbfPackageImpl#getContentSelectorType()
		 * @generated
		 */
		EClass CONTENT_SELECTOR_TYPE = eINSTANCE.getContentSelectorType();

		/**
		 * The meta object literal for the '<em><b>Selected Record Type</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference CONTENT_SELECTOR_TYPE__SELECTED_RECORD_TYPE = eINSTANCE.getContentSelectorType_SelectedRecordType();

		/**
		 * The meta object literal for the '<em><b>Xpath Selector</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference CONTENT_SELECTOR_TYPE__XPATH_SELECTOR = eINSTANCE.getContentSelectorType_XpathSelector();

		/**
		 * The meta object literal for the '<em><b>Any</b></em>' attribute list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute CONTENT_SELECTOR_TYPE__ANY = eINSTANCE.getContentSelectorType_Any();

		/**
		 * The meta object literal for the '<em><b>Parent</b></em>' container reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference CONTENT_SELECTOR_TYPE__PARENT = eINSTANCE.getContentSelectorType_Parent();

		/**
		 * The meta object literal for the '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.DeclinedTypeImpl <em>Declined Type</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.DeclinedTypeImpl
		 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.CmdbfPackageImpl#getDeclinedType()
		 * @generated
		 */
		EClass DECLINED_TYPE = eINSTANCE.getDeclinedType();

		/**
		 * The meta object literal for the '<em><b>Reason</b></em>' attribute list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute DECLINED_TYPE__REASON = eINSTANCE.getDeclinedType_Reason();

		/**
		 * The meta object literal for the '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.DepthLimitTypeImpl <em>Depth Limit Type</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.DepthLimitTypeImpl
		 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.CmdbfPackageImpl#getDepthLimitType()
		 * @generated
		 */
		EClass DEPTH_LIMIT_TYPE = eINSTANCE.getDepthLimitType();

		/**
		 * The meta object literal for the '<em><b>Max Intermediate Items</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute DEPTH_LIMIT_TYPE__MAX_INTERMEDIATE_ITEMS = eINSTANCE.getDepthLimitType_MaxIntermediateItems();

		/**
		 * The meta object literal for the '<em><b>Intermediate Item Template</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute DEPTH_LIMIT_TYPE__INTERMEDIATE_ITEM_TEMPLATE = eINSTANCE.getDepthLimitType_IntermediateItemTemplate();

		/**
		 * The meta object literal for the '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.DeregisterInstanceResponseTypeImpl <em>Deregister Instance Response Type</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.DeregisterInstanceResponseTypeImpl
		 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.CmdbfPackageImpl#getDeregisterInstanceResponseType()
		 * @generated
		 */
		EClass DEREGISTER_INSTANCE_RESPONSE_TYPE = eINSTANCE.getDeregisterInstanceResponseType();

		/**
		 * The meta object literal for the '<em><b>Accepted</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute DEREGISTER_INSTANCE_RESPONSE_TYPE__ACCEPTED = eINSTANCE.getDeregisterInstanceResponseType_Accepted();

		/**
		 * The meta object literal for the '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.DeregisterRequestTypeImpl <em>Deregister Request Type</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.DeregisterRequestTypeImpl
		 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.CmdbfPackageImpl#getDeregisterRequestType()
		 * @generated
		 */
		EClass DEREGISTER_REQUEST_TYPE = eINSTANCE.getDeregisterRequestType();

		/**
		 * The meta object literal for the '<em><b>Mdr Id</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute DEREGISTER_REQUEST_TYPE__MDR_ID = eINSTANCE.getDeregisterRequestType_MdrId();

		/**
		 * The meta object literal for the '<em><b>Item Id List</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference DEREGISTER_REQUEST_TYPE__ITEM_ID_LIST = eINSTANCE.getDeregisterRequestType_ItemIdList();

		/**
		 * The meta object literal for the '<em><b>Relationship Id List</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference DEREGISTER_REQUEST_TYPE__RELATIONSHIP_ID_LIST = eINSTANCE.getDeregisterRequestType_RelationshipIdList();

		/**
		 * The meta object literal for the '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.DeregisterResponseTypeImpl <em>Deregister Response Type</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.DeregisterResponseTypeImpl
		 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.CmdbfPackageImpl#getDeregisterResponseType()
		 * @generated
		 */
		EClass DEREGISTER_RESPONSE_TYPE = eINSTANCE.getDeregisterResponseType();

		/**
		 * The meta object literal for the '<em><b>Deregister Instance Response</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference DEREGISTER_RESPONSE_TYPE__DEREGISTER_INSTANCE_RESPONSE = eINSTANCE.getDeregisterResponseType_DeregisterInstanceResponse();

		/**
		 * The meta object literal for the '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.DeregistrationErrorFaultTypeImpl <em>Deregistration Error Fault Type</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.DeregistrationErrorFaultTypeImpl
		 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.CmdbfPackageImpl#getDeregistrationErrorFaultType()
		 * @generated
		 */
		EClass DEREGISTRATION_ERROR_FAULT_TYPE = eINSTANCE.getDeregistrationErrorFaultType();

		/**
		 * The meta object literal for the '<em><b>Record Id</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute DEREGISTRATION_ERROR_FAULT_TYPE__RECORD_ID = eINSTANCE.getDeregistrationErrorFaultType_RecordId();

		/**
		 * The meta object literal for the '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.DocumentRootImpl <em>Document Root</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.DocumentRootImpl
		 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.CmdbfPackageImpl#getDocumentRoot()
		 * @generated
		 */
		EClass DOCUMENT_ROOT = eINSTANCE.getDocumentRoot();

		/**
		 * The meta object literal for the '<em><b>Mixed</b></em>' attribute list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute DOCUMENT_ROOT__MIXED = eINSTANCE.getDocumentRoot_Mixed();

		/**
		 * The meta object literal for the '<em><b>XMLNS Prefix Map</b></em>' map feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference DOCUMENT_ROOT__XMLNS_PREFIX_MAP = eINSTANCE.getDocumentRoot_XMLNSPrefixMap();

		/**
		 * The meta object literal for the '<em><b>XSI Schema Location</b></em>' map feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference DOCUMENT_ROOT__XSI_SCHEMA_LOCATION = eINSTANCE.getDocumentRoot_XSISchemaLocation();

		/**
		 * The meta object literal for the '<em><b>Deregister Request</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference DOCUMENT_ROOT__DEREGISTER_REQUEST = eINSTANCE.getDocumentRoot_DeregisterRequest();

		/**
		 * The meta object literal for the '<em><b>Deregister Response</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference DOCUMENT_ROOT__DEREGISTER_RESPONSE = eINSTANCE.getDocumentRoot_DeregisterResponse();

		/**
		 * The meta object literal for the '<em><b>Deregistration Error Fault</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference DOCUMENT_ROOT__DEREGISTRATION_ERROR_FAULT = eINSTANCE.getDocumentRoot_DeregistrationErrorFault();

		/**
		 * The meta object literal for the '<em><b>Expensive Query Error Fault</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference DOCUMENT_ROOT__EXPENSIVE_QUERY_ERROR_FAULT = eINSTANCE.getDocumentRoot_ExpensiveQueryErrorFault();

		/**
		 * The meta object literal for the '<em><b>Instance Id</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference DOCUMENT_ROOT__INSTANCE_ID = eINSTANCE.getDocumentRoot_InstanceId();

		/**
		 * The meta object literal for the '<em><b>Invalid MDR Fault</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference DOCUMENT_ROOT__INVALID_MDR_FAULT = eINSTANCE.getDocumentRoot_InvalidMDRFault();

		/**
		 * The meta object literal for the '<em><b>Invalid Property Type Fault</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference DOCUMENT_ROOT__INVALID_PROPERTY_TYPE_FAULT = eINSTANCE.getDocumentRoot_InvalidPropertyTypeFault();

		/**
		 * The meta object literal for the '<em><b>Invalid Record Fault</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference DOCUMENT_ROOT__INVALID_RECORD_FAULT = eINSTANCE.getDocumentRoot_InvalidRecordFault();

		/**
		 * The meta object literal for the '<em><b>Item</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference DOCUMENT_ROOT__ITEM = eINSTANCE.getDocumentRoot_Item();

		/**
		 * The meta object literal for the '<em><b>Property Set</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference DOCUMENT_ROOT__PROPERTY_SET = eINSTANCE.getDocumentRoot_PropertySet();

		/**
		 * The meta object literal for the '<em><b>Query</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference DOCUMENT_ROOT__QUERY = eINSTANCE.getDocumentRoot_Query();

		/**
		 * The meta object literal for the '<em><b>Query Error Fault</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference DOCUMENT_ROOT__QUERY_ERROR_FAULT = eINSTANCE.getDocumentRoot_QueryErrorFault();

		/**
		 * The meta object literal for the '<em><b>Query Result</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference DOCUMENT_ROOT__QUERY_RESULT = eINSTANCE.getDocumentRoot_QueryResult();

		/**
		 * The meta object literal for the '<em><b>Record</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference DOCUMENT_ROOT__RECORD = eINSTANCE.getDocumentRoot_Record();

		/**
		 * The meta object literal for the '<em><b>Register Request</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference DOCUMENT_ROOT__REGISTER_REQUEST = eINSTANCE.getDocumentRoot_RegisterRequest();

		/**
		 * The meta object literal for the '<em><b>Register Response</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference DOCUMENT_ROOT__REGISTER_RESPONSE = eINSTANCE.getDocumentRoot_RegisterResponse();

		/**
		 * The meta object literal for the '<em><b>Registration Error Fault</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference DOCUMENT_ROOT__REGISTRATION_ERROR_FAULT = eINSTANCE.getDocumentRoot_RegistrationErrorFault();

		/**
		 * The meta object literal for the '<em><b>Relationship</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference DOCUMENT_ROOT__RELATIONSHIP = eINSTANCE.getDocumentRoot_Relationship();

		/**
		 * The meta object literal for the '<em><b>Unknown Template ID Fault</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference DOCUMENT_ROOT__UNKNOWN_TEMPLATE_ID_FAULT = eINSTANCE.getDocumentRoot_UnknownTemplateIDFault();

		/**
		 * The meta object literal for the '<em><b>Unsupported Constraint Fault</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference DOCUMENT_ROOT__UNSUPPORTED_CONSTRAINT_FAULT = eINSTANCE.getDocumentRoot_UnsupportedConstraintFault();

		/**
		 * The meta object literal for the '<em><b>Unsupported Record Type Fault</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference DOCUMENT_ROOT__UNSUPPORTED_RECORD_TYPE_FAULT = eINSTANCE.getDocumentRoot_UnsupportedRecordTypeFault();

		/**
		 * The meta object literal for the '<em><b>Unsupported Selector Fault</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference DOCUMENT_ROOT__UNSUPPORTED_SELECTOR_FAULT = eINSTANCE.getDocumentRoot_UnsupportedSelectorFault();

		/**
		 * The meta object literal for the '<em><b>XPath Error Fault</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference DOCUMENT_ROOT__XPATH_ERROR_FAULT = eINSTANCE.getDocumentRoot_XPathErrorFault();

		/**
		 * The meta object literal for the '<em><b>Model</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference DOCUMENT_ROOT__MODEL = eINSTANCE.getDocumentRoot_Model();

		/**
		 * The meta object literal for the '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.EdgesTypeImpl <em>Edges Type</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.EdgesTypeImpl
		 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.CmdbfPackageImpl#getEdgesType()
		 * @generated
		 */
		EClass EDGES_TYPE = eINSTANCE.getEdgesType();

		/**
		 * The meta object literal for the '<em><b>Relationship</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference EDGES_TYPE__RELATIONSHIP = eINSTANCE.getEdgesType_Relationship();

		/**
		 * The meta object literal for the '<em><b>Template Id</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute EDGES_TYPE__TEMPLATE_ID = eINSTANCE.getEdgesType_TemplateId();

		/**
		 * The meta object literal for the '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.EqualOperatorTypeImpl <em>Equal Operator Type</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.EqualOperatorTypeImpl
		 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.CmdbfPackageImpl#getEqualOperatorType()
		 * @generated
		 */
		EClass EQUAL_OPERATOR_TYPE = eINSTANCE.getEqualOperatorType();

		/**
		 * The meta object literal for the '<em><b>Value</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute EQUAL_OPERATOR_TYPE__VALUE = eINSTANCE.getEqualOperatorType_Value();

		/**
		 * The meta object literal for the '<em><b>Case Sensitive</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute EQUAL_OPERATOR_TYPE__CASE_SENSITIVE = eINSTANCE.getEqualOperatorType_CaseSensitive();

		/**
		 * The meta object literal for the '<em><b>Negate</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute EQUAL_OPERATOR_TYPE__NEGATE = eINSTANCE.getEqualOperatorType_Negate();

		/**
		 * The meta object literal for the '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.ExpensiveQueryErrorFaultTypeImpl <em>Expensive Query Error Fault Type</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.ExpensiveQueryErrorFaultTypeImpl
		 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.CmdbfPackageImpl#getExpensiveQueryErrorFaultType()
		 * @generated
		 */
		EClass EXPENSIVE_QUERY_ERROR_FAULT_TYPE = eINSTANCE.getExpensiveQueryErrorFaultType();

		/**
		 * The meta object literal for the '<em><b>Any</b></em>' attribute list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute EXPENSIVE_QUERY_ERROR_FAULT_TYPE__ANY = eINSTANCE.getExpensiveQueryErrorFaultType_Any();

		/**
		 * The meta object literal for the '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.InstanceIdConstraintTypeImpl <em>Instance Id Constraint Type</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.InstanceIdConstraintTypeImpl
		 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.CmdbfPackageImpl#getInstanceIdConstraintType()
		 * @generated
		 */
		EClass INSTANCE_ID_CONSTRAINT_TYPE = eINSTANCE.getInstanceIdConstraintType();

		/**
		 * The meta object literal for the '<em><b>Instance Id</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference INSTANCE_ID_CONSTRAINT_TYPE__INSTANCE_ID = eINSTANCE.getInstanceIdConstraintType_InstanceId();

		/**
		 * The meta object literal for the '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.InvalidMDRFaultTypeImpl <em>Invalid MDR Fault Type</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.InvalidMDRFaultTypeImpl
		 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.CmdbfPackageImpl#getInvalidMDRFaultType()
		 * @generated
		 */
		EClass INVALID_MDR_FAULT_TYPE = eINSTANCE.getInvalidMDRFaultType();

		/**
		 * The meta object literal for the '<em><b>Mdr Id</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute INVALID_MDR_FAULT_TYPE__MDR_ID = eINSTANCE.getInvalidMDRFaultType_MdrId();

		/**
		 * The meta object literal for the '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.InvalidPropertyTypeFaultTypeImpl <em>Invalid Property Type Fault Type</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.InvalidPropertyTypeFaultTypeImpl
		 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.CmdbfPackageImpl#getInvalidPropertyTypeFaultType()
		 * @generated
		 */
		EClass INVALID_PROPERTY_TYPE_FAULT_TYPE = eINSTANCE.getInvalidPropertyTypeFaultType();

		/**
		 * The meta object literal for the '<em><b>Property Name</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference INVALID_PROPERTY_TYPE_FAULT_TYPE__PROPERTY_NAME = eINSTANCE.getInvalidPropertyTypeFaultType_PropertyName();

		/**
		 * The meta object literal for the '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.InvalidRecordFaultTypeImpl <em>Invalid Record Fault Type</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.InvalidRecordFaultTypeImpl
		 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.CmdbfPackageImpl#getInvalidRecordFaultType()
		 * @generated
		 */
		EClass INVALID_RECORD_FAULT_TYPE = eINSTANCE.getInvalidRecordFaultType();

		/**
		 * The meta object literal for the '<em><b>Record Id</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute INVALID_RECORD_FAULT_TYPE__RECORD_ID = eINSTANCE.getInvalidRecordFaultType_RecordId();

		/**
		 * The meta object literal for the '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.ItemListTypeImpl <em>Item List Type</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.ItemListTypeImpl
		 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.CmdbfPackageImpl#getItemListType()
		 * @generated
		 */
		EClass ITEM_LIST_TYPE = eINSTANCE.getItemListType();

		/**
		 * The meta object literal for the '<em><b>Item</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference ITEM_LIST_TYPE__ITEM = eINSTANCE.getItemListType_Item();

		/**
		 * The meta object literal for the '<em><b>Find</b></em>' operation.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EOperation ITEM_LIST_TYPE___FIND__MDRSCOPEDIDTYPE = eINSTANCE.getItemListType__Find__MdrScopedIdType();

		/**
		 * The meta object literal for the '<em><b>Find</b></em>' operation.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EOperation ITEM_LIST_TYPE___FIND__ITEMTYPE = eINSTANCE.getItemListType__Find__ItemType();

		/**
		 * The meta object literal for the '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.ItemTemplateTypeImpl <em>Item Template Type</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.ItemTemplateTypeImpl
		 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.CmdbfPackageImpl#getItemTemplateType()
		 * @generated
		 */
		EClass ITEM_TEMPLATE_TYPE = eINSTANCE.getItemTemplateType();

		/**
		 * The meta object literal for the '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.ItemTypeImpl <em>Item Type</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.ItemTypeImpl
		 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.CmdbfPackageImpl#getItemType()
		 * @generated
		 */
		EClass ITEM_TYPE = eINSTANCE.getItemType();

		/**
		 * The meta object literal for the '<em><b>Relationship By Source</b></em>' reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference ITEM_TYPE__RELATIONSHIP_BY_SOURCE = eINSTANCE.getItemType_RelationshipBySource();

		/**
		 * The meta object literal for the '<em><b>Relationship By Target</b></em>' reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference ITEM_TYPE__RELATIONSHIP_BY_TARGET = eINSTANCE.getItemType_RelationshipByTarget();

		/**
		 * The meta object literal for the '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.MdrScopedIdListTypeImpl <em>Mdr Scoped Id List Type</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.MdrScopedIdListTypeImpl
		 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.CmdbfPackageImpl#getMdrScopedIdListType()
		 * @generated
		 */
		EClass MDR_SCOPED_ID_LIST_TYPE = eINSTANCE.getMdrScopedIdListType();

		/**
		 * The meta object literal for the '<em><b>Instance Id</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference MDR_SCOPED_ID_LIST_TYPE__INSTANCE_ID = eINSTANCE.getMdrScopedIdListType_InstanceId();

		/**
		 * The meta object literal for the '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.MdrScopedIdTypeImpl <em>Mdr Scoped Id Type</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.MdrScopedIdTypeImpl
		 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.CmdbfPackageImpl#getMdrScopedIdType()
		 * @generated
		 */
		EClass MDR_SCOPED_ID_TYPE = eINSTANCE.getMdrScopedIdType();

		/**
		 * The meta object literal for the '<em><b>Mdr Id</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute MDR_SCOPED_ID_TYPE__MDR_ID = eINSTANCE.getMdrScopedIdType_MdrId();

		/**
		 * The meta object literal for the '<em><b>Local Id</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute MDR_SCOPED_ID_TYPE__LOCAL_ID = eINSTANCE.getMdrScopedIdType_LocalId();

		/**
		 * The meta object literal for the '<em><b>Init</b></em>' operation.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EOperation MDR_SCOPED_ID_TYPE___INIT__STRING = eINSTANCE.getMdrScopedIdType__Init__String();

		/**
		 * The meta object literal for the '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.NodesTypeImpl <em>Nodes Type</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.NodesTypeImpl
		 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.CmdbfPackageImpl#getNodesType()
		 * @generated
		 */
		EClass NODES_TYPE = eINSTANCE.getNodesType();

		/**
		 * The meta object literal for the '<em><b>Item</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference NODES_TYPE__ITEM = eINSTANCE.getNodesType_Item();

		/**
		 * The meta object literal for the '<em><b>Template Id</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute NODES_TYPE__TEMPLATE_ID = eINSTANCE.getNodesType_TemplateId();

		/**
		 * The meta object literal for the '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.NullOperatorTypeImpl <em>Null Operator Type</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.NullOperatorTypeImpl
		 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.CmdbfPackageImpl#getNullOperatorType()
		 * @generated
		 */
		EClass NULL_OPERATOR_TYPE = eINSTANCE.getNullOperatorType();

		/**
		 * The meta object literal for the '<em><b>Negate</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute NULL_OPERATOR_TYPE__NEGATE = eINSTANCE.getNullOperatorType_Negate();

		/**
		 * The meta object literal for the '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.PrefixMappingTypeImpl <em>Prefix Mapping Type</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.PrefixMappingTypeImpl
		 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.CmdbfPackageImpl#getPrefixMappingType()
		 * @generated
		 */
		EClass PREFIX_MAPPING_TYPE = eINSTANCE.getPrefixMappingType();

		/**
		 * The meta object literal for the '<em><b>Prefix</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute PREFIX_MAPPING_TYPE__PREFIX = eINSTANCE.getPrefixMappingType_Prefix();

		/**
		 * The meta object literal for the '<em><b>Namespace</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute PREFIX_MAPPING_TYPE__NAMESPACE = eINSTANCE.getPrefixMappingType_Namespace();

		/**
		 * The meta object literal for the '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.PropertyNameTypeImpl <em>Property Name Type</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.PropertyNameTypeImpl
		 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.CmdbfPackageImpl#getPropertyNameType()
		 * @generated
		 */
		EClass PROPERTY_NAME_TYPE = eINSTANCE.getPropertyNameType();

		/**
		 * The meta object literal for the '<em><b>Local Name</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute PROPERTY_NAME_TYPE__LOCAL_NAME = eINSTANCE.getPropertyNameType_LocalName();

		/**
		 * The meta object literal for the '<em><b>Namespace</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute PROPERTY_NAME_TYPE__NAMESPACE = eINSTANCE.getPropertyNameType_Namespace();

		/**
		 * The meta object literal for the '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.PropertySetTypeImpl <em>Property Set Type</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.PropertySetTypeImpl
		 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.CmdbfPackageImpl#getPropertySetType()
		 * @generated
		 */
		EClass PROPERTY_SET_TYPE = eINSTANCE.getPropertySetType();

		/**
		 * The meta object literal for the '<em><b>Any</b></em>' attribute list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute PROPERTY_SET_TYPE__ANY = eINSTANCE.getPropertySetType_Any();

		/**
		 * The meta object literal for the '<em><b>Namespace</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute PROPERTY_SET_TYPE__NAMESPACE = eINSTANCE.getPropertySetType_Namespace();

		/**
		 * The meta object literal for the '<em><b>Local Name</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute PROPERTY_SET_TYPE__LOCAL_NAME = eINSTANCE.getPropertySetType_LocalName();

		/**
		 * The meta object literal for the '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.PropertyValueTypeImpl <em>Property Value Type</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.PropertyValueTypeImpl
		 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.CmdbfPackageImpl#getPropertyValueType()
		 * @generated
		 */
		EClass PROPERTY_VALUE_TYPE = eINSTANCE.getPropertyValueType();

		/**
		 * The meta object literal for the '<em><b>Equal</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference PROPERTY_VALUE_TYPE__EQUAL = eINSTANCE.getPropertyValueType_Equal();

		/**
		 * The meta object literal for the '<em><b>Less</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference PROPERTY_VALUE_TYPE__LESS = eINSTANCE.getPropertyValueType_Less();

		/**
		 * The meta object literal for the '<em><b>Less Or Equal</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference PROPERTY_VALUE_TYPE__LESS_OR_EQUAL = eINSTANCE.getPropertyValueType_LessOrEqual();

		/**
		 * The meta object literal for the '<em><b>Greater</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference PROPERTY_VALUE_TYPE__GREATER = eINSTANCE.getPropertyValueType_Greater();

		/**
		 * The meta object literal for the '<em><b>Greater Or Equal</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference PROPERTY_VALUE_TYPE__GREATER_OR_EQUAL = eINSTANCE.getPropertyValueType_GreaterOrEqual();

		/**
		 * The meta object literal for the '<em><b>Contains</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference PROPERTY_VALUE_TYPE__CONTAINS = eINSTANCE.getPropertyValueType_Contains();

		/**
		 * The meta object literal for the '<em><b>Like</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference PROPERTY_VALUE_TYPE__LIKE = eINSTANCE.getPropertyValueType_Like();

		/**
		 * The meta object literal for the '<em><b>Is Null</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference PROPERTY_VALUE_TYPE__IS_NULL = eINSTANCE.getPropertyValueType_IsNull();

		/**
		 * The meta object literal for the '<em><b>Any</b></em>' attribute list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute PROPERTY_VALUE_TYPE__ANY = eINSTANCE.getPropertyValueType_Any();

		/**
		 * The meta object literal for the '<em><b>Namespace</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute PROPERTY_VALUE_TYPE__NAMESPACE = eINSTANCE.getPropertyValueType_Namespace();

		/**
		 * The meta object literal for the '<em><b>Local Name</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute PROPERTY_VALUE_TYPE__LOCAL_NAME = eINSTANCE.getPropertyValueType_LocalName();

		/**
		 * The meta object literal for the '<em><b>Record Metadata</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute PROPERTY_VALUE_TYPE__RECORD_METADATA = eINSTANCE.getPropertyValueType_RecordMetadata();

		/**
		 * The meta object literal for the '<em><b>Match Any</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute PROPERTY_VALUE_TYPE__MATCH_ANY = eINSTANCE.getPropertyValueType_MatchAny();

		/**
		 * The meta object literal for the '<em><b>Parent</b></em>' container reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference PROPERTY_VALUE_TYPE__PARENT = eINSTANCE.getPropertyValueType_Parent();

		/**
		 * The meta object literal for the '<em><b>Add Equal</b></em>' operation.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EOperation PROPERTY_VALUE_TYPE___ADD_EQUAL__OBJECT = eINSTANCE.getPropertyValueType__AddEqual__Object();

		/**
		 * The meta object literal for the '<em><b>Add Less</b></em>' operation.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EOperation PROPERTY_VALUE_TYPE___ADD_LESS__OBJECT = eINSTANCE.getPropertyValueType__AddLess__Object();

		/**
		 * The meta object literal for the '<em><b>Add Less Or Equal</b></em>' operation.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EOperation PROPERTY_VALUE_TYPE___ADD_LESS_OR_EQUAL__OBJECT = eINSTANCE.getPropertyValueType__AddLessOrEqual__Object();

		/**
		 * The meta object literal for the '<em><b>Add Greater</b></em>' operation.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EOperation PROPERTY_VALUE_TYPE___ADD_GREATER__OBJECT = eINSTANCE.getPropertyValueType__AddGreater__Object();

		/**
		 * The meta object literal for the '<em><b>Add Greater Or Equal</b></em>' operation.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EOperation PROPERTY_VALUE_TYPE___ADD_GREATER_OR_EQUAL__OBJECT = eINSTANCE.getPropertyValueType__AddGreaterOrEqual__Object();

		/**
		 * The meta object literal for the '<em><b>Add Contains</b></em>' operation.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EOperation PROPERTY_VALUE_TYPE___ADD_CONTAINS__STRING = eINSTANCE.getPropertyValueType__AddContains__String();

		/**
		 * The meta object literal for the '<em><b>Add Like</b></em>' operation.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EOperation PROPERTY_VALUE_TYPE___ADD_LIKE__STRING = eINSTANCE.getPropertyValueType__AddLike__String();

		/**
		 * The meta object literal for the '<em><b>Add Is Null</b></em>' operation.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EOperation PROPERTY_VALUE_TYPE___ADD_IS_NULL = eINSTANCE.getPropertyValueType__AddIsNull();

		/**
		 * The meta object literal for the '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.QNameTypeImpl <em>QName Type</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.QNameTypeImpl
		 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.CmdbfPackageImpl#getQNameType()
		 * @generated
		 */
		EClass QNAME_TYPE = eINSTANCE.getQNameType();

		/**
		 * The meta object literal for the '<em><b>Namespace</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute QNAME_TYPE__NAMESPACE = eINSTANCE.getQNameType_Namespace();

		/**
		 * The meta object literal for the '<em><b>Local Name</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute QNAME_TYPE__LOCAL_NAME = eINSTANCE.getQNameType_LocalName();

		/**
		 * The meta object literal for the '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.QueryErrorFaultTypeImpl <em>Query Error Fault Type</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.QueryErrorFaultTypeImpl
		 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.CmdbfPackageImpl#getQueryErrorFaultType()
		 * @generated
		 */
		EClass QUERY_ERROR_FAULT_TYPE = eINSTANCE.getQueryErrorFaultType();

		/**
		 * The meta object literal for the '<em><b>Any</b></em>' attribute list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute QUERY_ERROR_FAULT_TYPE__ANY = eINSTANCE.getQueryErrorFaultType_Any();

		/**
		 * The meta object literal for the '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.QueryResultTypeImpl <em>Query Result Type</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.QueryResultTypeImpl
		 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.CmdbfPackageImpl#getQueryResultType()
		 * @generated
		 */
		EClass QUERY_RESULT_TYPE = eINSTANCE.getQueryResultType();

		/**
		 * The meta object literal for the '<em><b>Nodes</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference QUERY_RESULT_TYPE__NODES = eINSTANCE.getQueryResultType_Nodes();

		/**
		 * The meta object literal for the '<em><b>Edges</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference QUERY_RESULT_TYPE__EDGES = eINSTANCE.getQueryResultType_Edges();

		/**
		 * The meta object literal for the '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.QueryTypeImpl <em>Query Type</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.QueryTypeImpl
		 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.CmdbfPackageImpl#getQueryType()
		 * @generated
		 */
		EClass QUERY_TYPE = eINSTANCE.getQueryType();

		/**
		 * The meta object literal for the '<em><b>Item Template</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference QUERY_TYPE__ITEM_TEMPLATE = eINSTANCE.getQueryType_ItemTemplate();

		/**
		 * The meta object literal for the '<em><b>Relationship Template</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference QUERY_TYPE__RELATIONSHIP_TEMPLATE = eINSTANCE.getQueryType_RelationshipTemplate();

		/**
		 * The meta object literal for the '<em><b>Mdr Id</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute QUERY_TYPE__MDR_ID = eINSTANCE.getQueryType_MdrId();

		/**
		 * The meta object literal for the '<em><b>Model Metadata</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference QUERY_TYPE__MODEL_METADATA = eINSTANCE.getQueryType_ModelMetadata();

		/**
		 * The meta object literal for the '<em><b>Add Item Template</b></em>' operation.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EOperation QUERY_TYPE___ADD_ITEM_TEMPLATE__STRING = eINSTANCE.getQueryType__AddItemTemplate__String();

		/**
		 * The meta object literal for the '<em><b>Add Relationship Template</b></em>' operation.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EOperation QUERY_TYPE___ADD_RELATIONSHIP_TEMPLATE__STRING = eINSTANCE.getQueryType__AddRelationshipTemplate__String();

		/**
		 * The meta object literal for the '<em><b>Get Namespace</b></em>' operation.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EOperation QUERY_TYPE___GET_NAMESPACE__STRING = eINSTANCE.getQueryType__GetNamespace__String();

		/**
		 * The meta object literal for the '<em><b>Get Local Name</b></em>' operation.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EOperation QUERY_TYPE___GET_LOCAL_NAME__STRING = eINSTANCE.getQueryType__GetLocalName__String();

		/**
		 * The meta object literal for the '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.RecordConstraintTypeImpl <em>Record Constraint Type</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.RecordConstraintTypeImpl
		 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.CmdbfPackageImpl#getRecordConstraintType()
		 * @generated
		 */
		EClass RECORD_CONSTRAINT_TYPE = eINSTANCE.getRecordConstraintType();

		/**
		 * The meta object literal for the '<em><b>Record Type</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference RECORD_CONSTRAINT_TYPE__RECORD_TYPE = eINSTANCE.getRecordConstraintType_RecordType();

		/**
		 * The meta object literal for the '<em><b>Property Value</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference RECORD_CONSTRAINT_TYPE__PROPERTY_VALUE = eINSTANCE.getRecordConstraintType_PropertyValue();

		/**
		 * The meta object literal for the '<em><b>Xpath Constraint</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference RECORD_CONSTRAINT_TYPE__XPATH_CONSTRAINT = eINSTANCE.getRecordConstraintType_XpathConstraint();

		/**
		 * The meta object literal for the '<em><b>Any</b></em>' attribute list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute RECORD_CONSTRAINT_TYPE__ANY = eINSTANCE.getRecordConstraintType_Any();

		/**
		 * The meta object literal for the '<em><b>Parent</b></em>' container reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference RECORD_CONSTRAINT_TYPE__PARENT = eINSTANCE.getRecordConstraintType_Parent();

		/**
		 * The meta object literal for the '<em><b>Add Record Type</b></em>' operation.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EOperation RECORD_CONSTRAINT_TYPE___ADD_RECORD_TYPE__STRING = eINSTANCE.getRecordConstraintType__AddRecordType__String();

		/**
		 * The meta object literal for the '<em><b>Add Record Type</b></em>' operation.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EOperation RECORD_CONSTRAINT_TYPE___ADD_RECORD_TYPE__STRING_STRING = eINSTANCE.getRecordConstraintType__AddRecordType__String_String();

		/**
		 * The meta object literal for the '<em><b>Add Property Value</b></em>' operation.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EOperation RECORD_CONSTRAINT_TYPE___ADD_PROPERTY_VALUE__STRING = eINSTANCE.getRecordConstraintType__AddPropertyValue__String();

		/**
		 * The meta object literal for the '<em><b>Add Property Value</b></em>' operation.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EOperation RECORD_CONSTRAINT_TYPE___ADD_PROPERTY_VALUE__STRING_STRING = eINSTANCE.getRecordConstraintType__AddPropertyValue__String_String();

		/**
		 * The meta object literal for the '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.RecordMetadataTypeImpl <em>Record Metadata Type</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.RecordMetadataTypeImpl
		 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.CmdbfPackageImpl#getRecordMetadataType()
		 * @generated
		 */
		EClass RECORD_METADATA_TYPE = eINSTANCE.getRecordMetadataType();

		/**
		 * The meta object literal for the '<em><b>Record Id</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute RECORD_METADATA_TYPE__RECORD_ID = eINSTANCE.getRecordMetadataType_RecordId();

		/**
		 * The meta object literal for the '<em><b>Last Modified</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute RECORD_METADATA_TYPE__LAST_MODIFIED = eINSTANCE.getRecordMetadataType_LastModified();

		/**
		 * The meta object literal for the '<em><b>Baseline Id</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute RECORD_METADATA_TYPE__BASELINE_ID = eINSTANCE.getRecordMetadataType_BaselineId();

		/**
		 * The meta object literal for the '<em><b>Snapshot Id</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute RECORD_METADATA_TYPE__SNAPSHOT_ID = eINSTANCE.getRecordMetadataType_SnapshotId();

		/**
		 * The meta object literal for the '<em><b>Any</b></em>' attribute list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute RECORD_METADATA_TYPE__ANY = eINSTANCE.getRecordMetadataType_Any();

		/**
		 * The meta object literal for the '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.RecordTypeImpl <em>Record Type</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.RecordTypeImpl
		 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.CmdbfPackageImpl#getRecordType()
		 * @generated
		 */
		EClass RECORD_TYPE = eINSTANCE.getRecordType();

		/**
		 * The meta object literal for the '<em><b>Any</b></em>' attribute list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute RECORD_TYPE__ANY = eINSTANCE.getRecordType_Any();

		/**
		 * The meta object literal for the '<em><b>Property Set</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference RECORD_TYPE__PROPERTY_SET = eINSTANCE.getRecordType_PropertySet();

		/**
		 * The meta object literal for the '<em><b>Record Metadata</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference RECORD_TYPE__RECORD_METADATA = eINSTANCE.getRecordType_RecordMetadata();

		/**
		 * The meta object literal for the '<em><b>Parent</b></em>' container reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference RECORD_TYPE__PARENT = eINSTANCE.getRecordType_Parent();

		/**
		 * The meta object literal for the '<em><b>Template Id</b></em>' attribute list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute RECORD_TYPE__TEMPLATE_ID = eINSTANCE.getRecordType_TemplateId();

		/**
		 * The meta object literal for the '<em><b>Record Id</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute RECORD_TYPE__RECORD_ID = eINSTANCE.getRecordType_RecordId();

		/**
		 * The meta object literal for the '<em><b>Last Modified</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute RECORD_TYPE__LAST_MODIFIED = eINSTANCE.getRecordType_LastModified();

		/**
		 * The meta object literal for the '<em><b>Type</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference RECORD_TYPE__TYPE = eINSTANCE.getRecordType_Type();

		/**
		 * The meta object literal for the '<em><b>Content</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference RECORD_TYPE__CONTENT = eINSTANCE.getRecordType_Content();

		/**
		 * The meta object literal for the '<em><b>Property Name</b></em>' attribute list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute RECORD_TYPE__PROPERTY_NAME = eINSTANCE.getRecordType_PropertyName();

		/**
		 * The meta object literal for the '<em><b>Get</b></em>' operation.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EOperation RECORD_TYPE___GET__STRING = eINSTANCE.getRecordType__Get__String();

		/**
		 * The meta object literal for the '<em><b>Set</b></em>' operation.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EOperation RECORD_TYPE___SET__STRING_OBJECT = eINSTANCE.getRecordType__Set__String_Object();

		/**
		 * The meta object literal for the '<em><b>Unset</b></em>' operation.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EOperation RECORD_TYPE___UNSET__STRING = eINSTANCE.getRecordType__Unset__String();

		/**
		 * The meta object literal for the '<em><b>Is Set</b></em>' operation.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EOperation RECORD_TYPE___IS_SET__STRING = eINSTANCE.getRecordType__IsSet__String();

		/**
		 * The meta object literal for the '<em><b>Has</b></em>' operation.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EOperation RECORD_TYPE___HAS__STRING = eINSTANCE.getRecordType__Has__String();

		/**
		 * The meta object literal for the '<em><b>Instance Of</b></em>' operation.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EOperation RECORD_TYPE___INSTANCE_OF__STRING = eINSTANCE.getRecordType__InstanceOf__String();

		/**
		 * The meta object literal for the '<em><b>Instance Of</b></em>' operation.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EOperation RECORD_TYPE___INSTANCE_OF__STRING_STRING = eINSTANCE.getRecordType__InstanceOf__String_String();

		/**
		 * The meta object literal for the '<em><b>Get As String</b></em>' operation.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EOperation RECORD_TYPE___GET_AS_STRING__STRING = eINSTANCE.getRecordType__GetAsString__String();

		/**
		 * The meta object literal for the '<em><b>Set As String</b></em>' operation.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EOperation RECORD_TYPE___SET_AS_STRING__STRING_STRING = eINSTANCE.getRecordType__SetAsString__String_String();

		/**
		 * The meta object literal for the '<em><b>Instance Of</b></em>' operation.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EOperation RECORD_TYPE___INSTANCE_OF__MODELRECORDTYPE = eINSTANCE.getRecordType__InstanceOf__ModelRecordType();

		/**
		 * The meta object literal for the '<em><b>Merge</b></em>' operation.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EOperation RECORD_TYPE___MERGE__RECORDTYPE = eINSTANCE.getRecordType__Merge__RecordType();

		/**
		 * The meta object literal for the '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.RecordTypeTypeImpl <em>Record Type Type</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.RecordTypeTypeImpl
		 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.CmdbfPackageImpl#getRecordTypeType()
		 * @generated
		 */
		EClass RECORD_TYPE_TYPE = eINSTANCE.getRecordTypeType();

		/**
		 * The meta object literal for the '<em><b>Local Name</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute RECORD_TYPE_TYPE__LOCAL_NAME = eINSTANCE.getRecordTypeType_LocalName();

		/**
		 * The meta object literal for the '<em><b>Namespace</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute RECORD_TYPE_TYPE__NAMESPACE = eINSTANCE.getRecordTypeType_Namespace();

		/**
		 * The meta object literal for the '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.RegisterInstanceResponseTypeImpl <em>Register Instance Response Type</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.RegisterInstanceResponseTypeImpl
		 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.CmdbfPackageImpl#getRegisterInstanceResponseType()
		 * @generated
		 */
		EClass REGISTER_INSTANCE_RESPONSE_TYPE = eINSTANCE.getRegisterInstanceResponseType();

		/**
		 * The meta object literal for the '<em><b>Accepted</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference REGISTER_INSTANCE_RESPONSE_TYPE__ACCEPTED = eINSTANCE.getRegisterInstanceResponseType_Accepted();

		/**
		 * The meta object literal for the '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.RegisterRequestTypeImpl <em>Register Request Type</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.RegisterRequestTypeImpl
		 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.CmdbfPackageImpl#getRegisterRequestType()
		 * @generated
		 */
		EClass REGISTER_REQUEST_TYPE = eINSTANCE.getRegisterRequestType();

		/**
		 * The meta object literal for the '<em><b>Mdr Id</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute REGISTER_REQUEST_TYPE__MDR_ID = eINSTANCE.getRegisterRequestType_MdrId();

		/**
		 * The meta object literal for the '<em><b>Item List</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference REGISTER_REQUEST_TYPE__ITEM_LIST = eINSTANCE.getRegisterRequestType_ItemList();

		/**
		 * The meta object literal for the '<em><b>Relationship List</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference REGISTER_REQUEST_TYPE__RELATIONSHIP_LIST = eINSTANCE.getRegisterRequestType_RelationshipList();

		/**
		 * The meta object literal for the '<em><b>Parent</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference REGISTER_REQUEST_TYPE__PARENT = eINSTANCE.getRegisterRequestType_Parent();

		/**
		 * The meta object literal for the '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.RegisterResponseTypeImpl <em>Register Response Type</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.RegisterResponseTypeImpl
		 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.CmdbfPackageImpl#getRegisterResponseType()
		 * @generated
		 */
		EClass REGISTER_RESPONSE_TYPE = eINSTANCE.getRegisterResponseType();

		/**
		 * The meta object literal for the '<em><b>Register Instance Response</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference REGISTER_RESPONSE_TYPE__REGISTER_INSTANCE_RESPONSE = eINSTANCE.getRegisterResponseType_RegisterInstanceResponse();

		/**
		 * The meta object literal for the '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.RegistrationErrorFaultTypeImpl <em>Registration Error Fault Type</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.RegistrationErrorFaultTypeImpl
		 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.CmdbfPackageImpl#getRegistrationErrorFaultType()
		 * @generated
		 */
		EClass REGISTRATION_ERROR_FAULT_TYPE = eINSTANCE.getRegistrationErrorFaultType();

		/**
		 * The meta object literal for the '<em><b>Record Id</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute REGISTRATION_ERROR_FAULT_TYPE__RECORD_ID = eINSTANCE.getRegistrationErrorFaultType_RecordId();

		/**
		 * The meta object literal for the '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.RelationshipListTypeImpl <em>Relationship List Type</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.RelationshipListTypeImpl
		 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.CmdbfPackageImpl#getRelationshipListType()
		 * @generated
		 */
		EClass RELATIONSHIP_LIST_TYPE = eINSTANCE.getRelationshipListType();

		/**
		 * The meta object literal for the '<em><b>Relationship</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference RELATIONSHIP_LIST_TYPE__RELATIONSHIP = eINSTANCE.getRelationshipListType_Relationship();

		/**
		 * The meta object literal for the '<em><b>Find</b></em>' operation.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EOperation RELATIONSHIP_LIST_TYPE___FIND__MDRSCOPEDIDTYPE = eINSTANCE.getRelationshipListType__Find__MdrScopedIdType();

		/**
		 * The meta object literal for the '<em><b>Find</b></em>' operation.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EOperation RELATIONSHIP_LIST_TYPE___FIND__RELATIONSHIPTYPE = eINSTANCE.getRelationshipListType__Find__RelationshipType();

		/**
		 * The meta object literal for the '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.RelationshipRefTypeImpl <em>Relationship Ref Type</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.RelationshipRefTypeImpl
		 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.CmdbfPackageImpl#getRelationshipRefType()
		 * @generated
		 */
		EClass RELATIONSHIP_REF_TYPE = eINSTANCE.getRelationshipRefType();

		/**
		 * The meta object literal for the '<em><b>Ref</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute RELATIONSHIP_REF_TYPE__REF = eINSTANCE.getRelationshipRefType_Ref();

		/**
		 * The meta object literal for the '<em><b>Minimum</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute RELATIONSHIP_REF_TYPE__MINIMUM = eINSTANCE.getRelationshipRefType_Minimum();

		/**
		 * The meta object literal for the '<em><b>Maximum</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute RELATIONSHIP_REF_TYPE__MAXIMUM = eINSTANCE.getRelationshipRefType_Maximum();

		/**
		 * The meta object literal for the '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.RelationshipTemplateTypeImpl <em>Relationship Template Type</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.RelationshipTemplateTypeImpl
		 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.CmdbfPackageImpl#getRelationshipTemplateType()
		 * @generated
		 */
		EClass RELATIONSHIP_TEMPLATE_TYPE = eINSTANCE.getRelationshipTemplateType();

		/**
		 * The meta object literal for the '<em><b>Source Template</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference RELATIONSHIP_TEMPLATE_TYPE__SOURCE_TEMPLATE = eINSTANCE.getRelationshipTemplateType_SourceTemplate();

		/**
		 * The meta object literal for the '<em><b>Target Template</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference RELATIONSHIP_TEMPLATE_TYPE__TARGET_TEMPLATE = eINSTANCE.getRelationshipTemplateType_TargetTemplate();

		/**
		 * The meta object literal for the '<em><b>Depth Limit</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference RELATIONSHIP_TEMPLATE_TYPE__DEPTH_LIMIT = eINSTANCE.getRelationshipTemplateType_DepthLimit();

		/**
		 * The meta object literal for the '<em><b>Add Source Template</b></em>' operation.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EOperation RELATIONSHIP_TEMPLATE_TYPE___ADD_SOURCE_TEMPLATE__ITEMTEMPLATETYPE = eINSTANCE.getRelationshipTemplateType__AddSourceTemplate__ItemTemplateType();

		/**
		 * The meta object literal for the '<em><b>Add Target Template</b></em>' operation.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EOperation RELATIONSHIP_TEMPLATE_TYPE___ADD_TARGET_TEMPLATE__ITEMTEMPLATETYPE = eINSTANCE.getRelationshipTemplateType__AddTargetTemplate__ItemTemplateType();

		/**
		 * The meta object literal for the '<em><b>Add Depth Limit</b></em>' operation.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EOperation RELATIONSHIP_TEMPLATE_TYPE___ADD_DEPTH_LIMIT__ITEMTEMPLATETYPE = eINSTANCE.getRelationshipTemplateType__AddDepthLimit__ItemTemplateType();

		/**
		 * The meta object literal for the '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.RelationshipTypeImpl <em>Relationship Type</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.RelationshipTypeImpl
		 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.CmdbfPackageImpl#getRelationshipType()
		 * @generated
		 */
		EClass RELATIONSHIP_TYPE = eINSTANCE.getRelationshipType();

		/**
		 * The meta object literal for the '<em><b>Source Item</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference RELATIONSHIP_TYPE__SOURCE_ITEM = eINSTANCE.getRelationshipType_SourceItem();

		/**
		 * The meta object literal for the '<em><b>Target Item</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference RELATIONSHIP_TYPE__TARGET_ITEM = eINSTANCE.getRelationshipType_TargetItem();

		/**
		 * The meta object literal for the '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.SelectedRecordTypeTypeImpl <em>Selected Record Type Type</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.SelectedRecordTypeTypeImpl
		 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.CmdbfPackageImpl#getSelectedRecordTypeType()
		 * @generated
		 */
		EClass SELECTED_RECORD_TYPE_TYPE = eINSTANCE.getSelectedRecordTypeType();

		/**
		 * The meta object literal for the '<em><b>Selected Property</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference SELECTED_RECORD_TYPE_TYPE__SELECTED_PROPERTY = eINSTANCE.getSelectedRecordTypeType_SelectedProperty();

		/**
		 * The meta object literal for the '<em><b>Namespace</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute SELECTED_RECORD_TYPE_TYPE__NAMESPACE = eINSTANCE.getSelectedRecordTypeType_Namespace();

		/**
		 * The meta object literal for the '<em><b>Local Name</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute SELECTED_RECORD_TYPE_TYPE__LOCAL_NAME = eINSTANCE.getSelectedRecordTypeType_LocalName();

		/**
		 * The meta object literal for the '<em><b>Parent</b></em>' container reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference SELECTED_RECORD_TYPE_TYPE__PARENT = eINSTANCE.getSelectedRecordTypeType_Parent();

		/**
		 * The meta object literal for the '<em><b>Add Selected Property</b></em>' operation.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EOperation SELECTED_RECORD_TYPE_TYPE___ADD_SELECTED_PROPERTY__STRING = eINSTANCE.getSelectedRecordTypeType__AddSelectedProperty__String();

		/**
		 * The meta object literal for the '<em><b>Add Selected Property</b></em>' operation.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EOperation SELECTED_RECORD_TYPE_TYPE___ADD_SELECTED_PROPERTY__STRING_STRING = eINSTANCE.getSelectedRecordTypeType__AddSelectedProperty__String_String();

		/**
		 * The meta object literal for the '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.SelectorTypeImpl <em>Selector Type</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.SelectorTypeImpl
		 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.CmdbfPackageImpl#getSelectorType()
		 * @generated
		 */
		EClass SELECTOR_TYPE = eINSTANCE.getSelectorType();

		/**
		 * The meta object literal for the '<em><b>Local Name</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute SELECTOR_TYPE__LOCAL_NAME = eINSTANCE.getSelectorType_LocalName();

		/**
		 * The meta object literal for the '<em><b>Namespace</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute SELECTOR_TYPE__NAMESPACE = eINSTANCE.getSelectorType_Namespace();

		/**
		 * The meta object literal for the '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.StringOperatorTypeImpl <em>String Operator Type</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.StringOperatorTypeImpl
		 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.CmdbfPackageImpl#getStringOperatorType()
		 * @generated
		 */
		EClass STRING_OPERATOR_TYPE = eINSTANCE.getStringOperatorType();

		/**
		 * The meta object literal for the '<em><b>Value</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute STRING_OPERATOR_TYPE__VALUE = eINSTANCE.getStringOperatorType_Value();

		/**
		 * The meta object literal for the '<em><b>Case Sensitive</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute STRING_OPERATOR_TYPE__CASE_SENSITIVE = eINSTANCE.getStringOperatorType_CaseSensitive();

		/**
		 * The meta object literal for the '<em><b>Negate</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute STRING_OPERATOR_TYPE__NEGATE = eINSTANCE.getStringOperatorType_Negate();

		/**
		 * The meta object literal for the '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.UnknownTemplateIDFaultTypeImpl <em>Unknown Template ID Fault Type</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.UnknownTemplateIDFaultTypeImpl
		 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.CmdbfPackageImpl#getUnknownTemplateIDFaultType()
		 * @generated
		 */
		EClass UNKNOWN_TEMPLATE_ID_FAULT_TYPE = eINSTANCE.getUnknownTemplateIDFaultType();

		/**
		 * The meta object literal for the '<em><b>Graph Id</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute UNKNOWN_TEMPLATE_ID_FAULT_TYPE__GRAPH_ID = eINSTANCE.getUnknownTemplateIDFaultType_GraphId();

		/**
		 * The meta object literal for the '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.UnsupportedConstraintFaultTypeImpl <em>Unsupported Constraint Fault Type</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.UnsupportedConstraintFaultTypeImpl
		 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.CmdbfPackageImpl#getUnsupportedConstraintFaultType()
		 * @generated
		 */
		EClass UNSUPPORTED_CONSTRAINT_FAULT_TYPE = eINSTANCE.getUnsupportedConstraintFaultType();

		/**
		 * The meta object literal for the '<em><b>Constraint</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference UNSUPPORTED_CONSTRAINT_FAULT_TYPE__CONSTRAINT = eINSTANCE.getUnsupportedConstraintFaultType_Constraint();

		/**
		 * The meta object literal for the '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.UnsupportedRecordTypeFaultTypeImpl <em>Unsupported Record Type Fault Type</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.UnsupportedRecordTypeFaultTypeImpl
		 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.CmdbfPackageImpl#getUnsupportedRecordTypeFaultType()
		 * @generated
		 */
		EClass UNSUPPORTED_RECORD_TYPE_FAULT_TYPE = eINSTANCE.getUnsupportedRecordTypeFaultType();

		/**
		 * The meta object literal for the '<em><b>Record Type</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference UNSUPPORTED_RECORD_TYPE_FAULT_TYPE__RECORD_TYPE = eINSTANCE.getUnsupportedRecordTypeFaultType_RecordType();

		/**
		 * The meta object literal for the '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.UnsupportedSelectorFaultTypeImpl <em>Unsupported Selector Fault Type</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.UnsupportedSelectorFaultTypeImpl
		 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.CmdbfPackageImpl#getUnsupportedSelectorFaultType()
		 * @generated
		 */
		EClass UNSUPPORTED_SELECTOR_FAULT_TYPE = eINSTANCE.getUnsupportedSelectorFaultType();

		/**
		 * The meta object literal for the '<em><b>Selector</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference UNSUPPORTED_SELECTOR_FAULT_TYPE__SELECTOR = eINSTANCE.getUnsupportedSelectorFaultType_Selector();

		/**
		 * The meta object literal for the '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.XPathErrorFaultTypeImpl <em>XPath Error Fault Type</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.XPathErrorFaultTypeImpl
		 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.CmdbfPackageImpl#getXPathErrorFaultType()
		 * @generated
		 */
		EClass XPATH_ERROR_FAULT_TYPE = eINSTANCE.getXPathErrorFaultType();

		/**
		 * The meta object literal for the '<em><b>Expression</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute XPATH_ERROR_FAULT_TYPE__EXPRESSION = eINSTANCE.getXPathErrorFaultType_Expression();

		/**
		 * The meta object literal for the '<em><b>Xpath Error Code</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute XPATH_ERROR_FAULT_TYPE__XPATH_ERROR_CODE = eINSTANCE.getXPathErrorFaultType_XpathErrorCode();

		/**
		 * The meta object literal for the '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.XPathExpressionTypeImpl <em>XPath Expression Type</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.XPathExpressionTypeImpl
		 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.CmdbfPackageImpl#getXPathExpressionType()
		 * @generated
		 */
		EClass XPATH_EXPRESSION_TYPE = eINSTANCE.getXPathExpressionType();

		/**
		 * The meta object literal for the '<em><b>Prefix Mapping</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference XPATH_EXPRESSION_TYPE__PREFIX_MAPPING = eINSTANCE.getXPathExpressionType_PrefixMapping();

		/**
		 * The meta object literal for the '<em><b>Expression</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute XPATH_EXPRESSION_TYPE__EXPRESSION = eINSTANCE.getXPathExpressionType_Expression();

		/**
		 * The meta object literal for the '<em><b>Dialect</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute XPATH_EXPRESSION_TYPE__DIALECT = eINSTANCE.getXPathExpressionType_Dialect();

		/**
		 * The meta object literal for the '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.ModelElementImpl <em>Model Element</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.ModelElementImpl
		 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.CmdbfPackageImpl#getModelElement()
		 * @generated
		 */
		EClass MODEL_ELEMENT = eINSTANCE.getModelElement();

		/**
		 * The meta object literal for the '<em><b>Record</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference MODEL_ELEMENT__RECORD = eINSTANCE.getModelElement_Record();

		/**
		 * The meta object literal for the '<em><b>Instance Id</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference MODEL_ELEMENT__INSTANCE_ID = eINSTANCE.getModelElement_InstanceId();

		/**
		 * The meta object literal for the '<em><b>Additional Record Type</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference MODEL_ELEMENT__ADDITIONAL_RECORD_TYPE = eINSTANCE.getModelElement_AdditionalRecordType();

		/**
		 * The meta object literal for the '<em><b>Template Id</b></em>' attribute list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute MODEL_ELEMENT__TEMPLATE_ID = eINSTANCE.getModelElement_TemplateId();

		/**
		 * The meta object literal for the '<em><b>Parent</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference MODEL_ELEMENT__PARENT = eINSTANCE.getModelElement_Parent();

		/**
		 * The meta object literal for the '<em><b>Deregister</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute MODEL_ELEMENT__DEREGISTER = eINSTANCE.getModelElement_Deregister();

		/**
		 * The meta object literal for the '<em><b>Find Instance Id</b></em>' operation.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EOperation MODEL_ELEMENT___FIND_INSTANCE_ID = eINSTANCE.getModelElement__FindInstanceId();

		/**
		 * The meta object literal for the '<em><b>Find Instance Id</b></em>' operation.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EOperation MODEL_ELEMENT___FIND_INSTANCE_ID__STRING = eINSTANCE.getModelElement__FindInstanceId__String();

		/**
		 * The meta object literal for the '<em><b>Add Instance Id</b></em>' operation.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EOperation MODEL_ELEMENT___ADD_INSTANCE_ID__STRING = eINSTANCE.getModelElement__AddInstanceId__String();

		/**
		 * The meta object literal for the '<em><b>Add Instance Id</b></em>' operation.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EOperation MODEL_ELEMENT___ADD_INSTANCE_ID__STRING_STRING = eINSTANCE.getModelElement__AddInstanceId__String_String();

		/**
		 * The meta object literal for the '<em><b>Add Additional Record Type</b></em>' operation.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EOperation MODEL_ELEMENT___ADD_ADDITIONAL_RECORD_TYPE__STRING = eINSTANCE.getModelElement__AddAdditionalRecordType__String();

		/**
		 * The meta object literal for the '<em><b>Add Additional Record Type</b></em>' operation.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EOperation MODEL_ELEMENT___ADD_ADDITIONAL_RECORD_TYPE__STRING_STRING = eINSTANCE.getModelElement__AddAdditionalRecordType__String_String();

		/**
		 * The meta object literal for the '<em><b>Add Record</b></em>' operation.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EOperation MODEL_ELEMENT___ADD_RECORD__STRING = eINSTANCE.getModelElement__AddRecord__String();

		/**
		 * The meta object literal for the '<em><b>Add Record</b></em>' operation.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EOperation MODEL_ELEMENT___ADD_RECORD__STRING_STRING = eINSTANCE.getModelElement__AddRecord__String_String();

		/**
		 * The meta object literal for the '<em><b>Add Record</b></em>' operation.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EOperation MODEL_ELEMENT___ADD_RECORD__STRING_BOOLEAN = eINSTANCE.getModelElement__AddRecord__String_boolean();

		/**
		 * The meta object literal for the '<em><b>Add Record</b></em>' operation.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EOperation MODEL_ELEMENT___ADD_RECORD__STRING_STRING_BOOLEAN = eINSTANCE.getModelElement__AddRecord__String_String_boolean();

		/**
		 * The meta object literal for the '<em><b>Find Record</b></em>' operation.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EOperation MODEL_ELEMENT___FIND_RECORD__STRING = eINSTANCE.getModelElement__FindRecord__String();

		/**
		 * The meta object literal for the '<em><b>Find Record</b></em>' operation.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EOperation MODEL_ELEMENT___FIND_RECORD__STRING_STRING = eINSTANCE.getModelElement__FindRecord__String_String();

		/**
		 * The meta object literal for the '<em><b>Find Record By Template</b></em>' operation.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EOperation MODEL_ELEMENT___FIND_RECORD_BY_TEMPLATE__STRING_STRING = eINSTANCE.getModelElement__FindRecordByTemplate__String_String();

		/**
		 * The meta object literal for the '<em><b>Find Record By Template</b></em>' operation.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EOperation MODEL_ELEMENT___FIND_RECORD_BY_TEMPLATE__STRING_STRING_STRING = eINSTANCE.getModelElement__FindRecordByTemplate__String_String_String();

		/**
		 * The meta object literal for the '<em><b>Find Record By Id</b></em>' operation.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EOperation MODEL_ELEMENT___FIND_RECORD_BY_ID__STRING = eINSTANCE.getModelElement__FindRecordById__String();

		/**
		 * The meta object literal for the '<em><b>Merge</b></em>' operation.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EOperation MODEL_ELEMENT___MERGE__MODELELEMENT = eINSTANCE.getModelElement__Merge__ModelElement();

		/**
		 * The meta object literal for the '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.ModelTemplateImpl <em>Model Template</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.ModelTemplateImpl
		 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.CmdbfPackageImpl#getModelTemplate()
		 * @generated
		 */
		EClass MODEL_TEMPLATE = eINSTANCE.getModelTemplate();

		/**
		 * The meta object literal for the '<em><b>Content Selector</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference MODEL_TEMPLATE__CONTENT_SELECTOR = eINSTANCE.getModelTemplate_ContentSelector();

		/**
		 * The meta object literal for the '<em><b>Instance Id Constraint</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference MODEL_TEMPLATE__INSTANCE_ID_CONSTRAINT = eINSTANCE.getModelTemplate_InstanceIdConstraint();

		/**
		 * The meta object literal for the '<em><b>Record Constraint</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference MODEL_TEMPLATE__RECORD_CONSTRAINT = eINSTANCE.getModelTemplate_RecordConstraint();

		/**
		 * The meta object literal for the '<em><b>Any</b></em>' attribute list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute MODEL_TEMPLATE__ANY = eINSTANCE.getModelTemplate_Any();

		/**
		 * The meta object literal for the '<em><b>Id</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute MODEL_TEMPLATE__ID = eINSTANCE.getModelTemplate_Id();

		/**
		 * The meta object literal for the '<em><b>Suppress From Result</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute MODEL_TEMPLATE__SUPPRESS_FROM_RESULT = eINSTANCE.getModelTemplate_SuppressFromResult();

		/**
		 * The meta object literal for the '<em><b>Query</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference MODEL_TEMPLATE__QUERY = eINSTANCE.getModelTemplate_Query();

		/**
		 * The meta object literal for the '<em><b>Add Instance Id Constraint</b></em>' operation.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EOperation MODEL_TEMPLATE___ADD_INSTANCE_ID_CONSTRAINT__STRING = eINSTANCE.getModelTemplate__AddInstanceIdConstraint__String();

		/**
		 * The meta object literal for the '<em><b>Add Instance Id Constraint</b></em>' operation.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EOperation MODEL_TEMPLATE___ADD_INSTANCE_ID_CONSTRAINT__STRING_STRING = eINSTANCE.getModelTemplate__AddInstanceIdConstraint__String_String();

		/**
		 * The meta object literal for the '<em><b>Add Record Constraint</b></em>' operation.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EOperation MODEL_TEMPLATE___ADD_RECORD_CONSTRAINT = eINSTANCE.getModelTemplate__AddRecordConstraint();

		/**
		 * The meta object literal for the '<em><b>Add Content Selector</b></em>' operation.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EOperation MODEL_TEMPLATE___ADD_CONTENT_SELECTOR__STRING = eINSTANCE.getModelTemplate__AddContentSelector__String();

		/**
		 * The meta object literal for the '<em><b>Add Content Selector</b></em>' operation.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EOperation MODEL_TEMPLATE___ADD_CONTENT_SELECTOR__STRING_STRING = eINSTANCE.getModelTemplate__AddContentSelector__String_String();

		/**
		 * The meta object literal for the '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.ModelUpdateInstanceResponseImpl <em>Model Update Instance Response</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.ModelUpdateInstanceResponseImpl
		 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.CmdbfPackageImpl#getModelUpdateInstanceResponse()
		 * @generated
		 */
		EClass MODEL_UPDATE_INSTANCE_RESPONSE = eINSTANCE.getModelUpdateInstanceResponse();

		/**
		 * The meta object literal for the '<em><b>Instance Id</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference MODEL_UPDATE_INSTANCE_RESPONSE__INSTANCE_ID = eINSTANCE.getModelUpdateInstanceResponse_InstanceId();

		/**
		 * The meta object literal for the '<em><b>Declined</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference MODEL_UPDATE_INSTANCE_RESPONSE__DECLINED = eINSTANCE.getModelUpdateInstanceResponse_Declined();

		/**
		 * The meta object literal for the '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.ModelUpdateResponseImpl <em>Model Update Response</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.ModelUpdateResponseImpl
		 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.CmdbfPackageImpl#getModelUpdateResponse()
		 * @generated
		 */
		EClass MODEL_UPDATE_RESPONSE = eINSTANCE.getModelUpdateResponse();

		/**
		 * The meta object literal for the '<em><b>Instance Response</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference MODEL_UPDATE_RESPONSE__INSTANCE_RESPONSE = eINSTANCE.getModelUpdateResponse_InstanceResponse();

		/**
		 * The meta object literal for the '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.ModelRecordTypeImpl <em>Model Record Type</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.ModelRecordTypeImpl
		 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.CmdbfPackageImpl#getModelRecordType()
		 * @generated
		 */
		EClass MODEL_RECORD_TYPE = eINSTANCE.getModelRecordType();

		/**
		 * The meta object literal for the '<em><b>Local Name</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute MODEL_RECORD_TYPE__LOCAL_NAME = eINSTANCE.getModelRecordType_LocalName();

		/**
		 * The meta object literal for the '<em><b>Namespace</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute MODEL_RECORD_TYPE__NAMESPACE = eINSTANCE.getModelRecordType_Namespace();

		/**
		 * The meta object literal for the '<em><b>Applies To Item</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute MODEL_RECORD_TYPE__APPLIES_TO_ITEM = eINSTANCE.getModelRecordType_AppliesToItem();

		/**
		 * The meta object literal for the '<em><b>Applies To Relationship</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute MODEL_RECORD_TYPE__APPLIES_TO_RELATIONSHIP = eINSTANCE.getModelRecordType_AppliesToRelationship();

		/**
		 * The meta object literal for the '<em><b>Super Type</b></em>' reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference MODEL_RECORD_TYPE__SUPER_TYPE = eINSTANCE.getModelRecordType_SuperType();

		/**
		 * The meta object literal for the '<em><b>Is Assignable From</b></em>' operation.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EOperation MODEL_RECORD_TYPE___IS_ASSIGNABLE_FROM__MODELRECORDTYPE = eINSTANCE.getModelRecordType__IsAssignableFrom__ModelRecordType();

		/**
		 * The meta object literal for the '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.ModelImpl <em>Model</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.ModelImpl
		 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.CmdbfPackageImpl#getModel()
		 * @generated
		 */
		EClass MODEL = eINSTANCE.getModel();

		/**
		 * The meta object literal for the '<em><b>Register</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference MODEL__REGISTER = eINSTANCE.getModel_Register();

		/**
		 * The meta object literal for the '<em><b>Deregister</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference MODEL__DEREGISTER = eINSTANCE.getModel_Deregister();

		/**
		 * The meta object literal for the '<em><b>Item</b></em>' reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference MODEL__ITEM = eINSTANCE.getModel_Item();

		/**
		 * The meta object literal for the '<em><b>Relationship</b></em>' reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference MODEL__RELATIONSHIP = eINSTANCE.getModel_Relationship();

		/**
		 * The meta object literal for the '<em><b>Model Metadata</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference MODEL__MODEL_METADATA = eINSTANCE.getModel_ModelMetadata();

		/**
		 * The meta object literal for the '<em><b>Mdr Id</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute MODEL__MDR_ID = eINSTANCE.getModel_MdrId();

		/**
		 * The meta object literal for the '<em><b>Removed Item Id</b></em>' reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference MODEL__REMOVED_ITEM_ID = eINSTANCE.getModel_RemovedItemId();

		/**
		 * The meta object literal for the '<em><b>Removed Relationship Id</b></em>' reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference MODEL__REMOVED_RELATIONSHIP_ID = eINSTANCE.getModel_RemovedRelationshipId();

		/**
		 * The meta object literal for the '<em><b>Add Item</b></em>' operation.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EOperation MODEL___ADD_ITEM = eINSTANCE.getModel__AddItem();

		/**
		 * The meta object literal for the '<em><b>Add Relationship</b></em>' operation.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EOperation MODEL___ADD_RELATIONSHIP = eINSTANCE.getModel__AddRelationship();

		/**
		 * The meta object literal for the '<em><b>Get Item By Template</b></em>' operation.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EOperation MODEL___GET_ITEM_BY_TEMPLATE__STRING = eINSTANCE.getModel__GetItemByTemplate__String();

		/**
		 * The meta object literal for the '<em><b>Get Relationship By Template</b></em>' operation.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EOperation MODEL___GET_RELATIONSHIP_BY_TEMPLATE__STRING = eINSTANCE.getModel__GetRelationshipByTemplate__String();

		/**
		 * The meta object literal for the '<em><b>Find Item</b></em>' operation.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EOperation MODEL___FIND_ITEM__MDRSCOPEDIDTYPE = eINSTANCE.getModel__FindItem__MdrScopedIdType();

		/**
		 * The meta object literal for the '<em><b>Find Item</b></em>' operation.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EOperation MODEL___FIND_ITEM__ITEMTYPE = eINSTANCE.getModel__FindItem__ItemType();

		/**
		 * The meta object literal for the '<em><b>Find Item</b></em>' operation.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EOperation MODEL___FIND_ITEM__STRING_STRING = eINSTANCE.getModel__FindItem__String_String();

		/**
		 * The meta object literal for the '<em><b>Find Relationship</b></em>' operation.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EOperation MODEL___FIND_RELATIONSHIP__MDRSCOPEDIDTYPE = eINSTANCE.getModel__FindRelationship__MdrScopedIdType();

		/**
		 * The meta object literal for the '<em><b>Find Relationship</b></em>' operation.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EOperation MODEL___FIND_RELATIONSHIP__RELATIONSHIPTYPE = eINSTANCE.getModel__FindRelationship__RelationshipType();

		/**
		 * The meta object literal for the '<em><b>Find Relationship</b></em>' operation.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EOperation MODEL___FIND_RELATIONSHIP__STRING_STRING = eINSTANCE.getModel__FindRelationship__String_String();

		/**
		 * The meta object literal for the '<em><b>Remove</b></em>' operation.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EOperation MODEL___REMOVE__ITEMTYPE = eINSTANCE.getModel__Remove__ItemType();

		/**
		 * The meta object literal for the '<em><b>Remove</b></em>' operation.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EOperation MODEL___REMOVE__RELATIONSHIPTYPE = eINSTANCE.getModel__Remove__RelationshipType();

		/**
		 * The meta object literal for the '{@link it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.ModelMetadataImpl <em>Model Metadata</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.ModelMetadataImpl
		 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.impl.CmdbfPackageImpl#getModelMetadata()
		 * @generated
		 */
		EClass MODEL_METADATA = eINSTANCE.getModelMetadata();

		/**
		 * The meta object literal for the '<em><b>Get Element</b></em>' operation.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EOperation MODEL_METADATA___GET_ELEMENT__STRING_STRING = eINSTANCE.getModelMetadata__GetElement__String_String();

		/**
		 * The meta object literal for the '<em><b>Get Namespace</b></em>' operation.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EOperation MODEL_METADATA___GET_NAMESPACE__ECLASSIFIER = eINSTANCE.getModelMetadata__GetNamespace__EClassifier();

		/**
		 * The meta object literal for the '<em><b>Get Local Name</b></em>' operation.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EOperation MODEL_METADATA___GET_LOCAL_NAME__ECLASSIFIER = eINSTANCE.getModelMetadata__GetLocalName__EClassifier();

		/**
		 * The meta object literal for the '<em><b>Get Record Type</b></em>' operation.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EOperation MODEL_METADATA___GET_RECORD_TYPE__STRING_STRING = eINSTANCE.getModelMetadata__GetRecordType__String_String();

		/**
		 * The meta object literal for the '<em><b>Get Namespace</b></em>' operation.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EOperation MODEL_METADATA___GET_NAMESPACE__STRING = eINSTANCE.getModelMetadata__GetNamespace__String();

		/**
		 * The meta object literal for the '<em><b>Get Local Name</b></em>' operation.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EOperation MODEL_METADATA___GET_LOCAL_NAME__STRING = eINSTANCE.getModelMetadata__GetLocalName__String();

	}

} //CmdbfPackage
