/**
 */
package it.unibo.cmdb.cmdbf.client.model.cmdbf.impl;

import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EGenericType;
import org.eclipse.emf.ecore.EOperation;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.EReference;
import org.eclipse.emf.ecore.impl.EPackageImpl;
import org.eclipse.emf.ecore.xml.type.XMLTypePackage;

import it.unibo.cmdb.cmdbf.client.model.cmdbf.AcceptedType;
import it.unibo.cmdb.cmdbf.client.model.cmdbf.CmdbfFactory;
import it.unibo.cmdb.cmdbf.client.model.cmdbf.CmdbfPackage;
import it.unibo.cmdb.cmdbf.client.model.cmdbf.ComparisonOperatorType;
import it.unibo.cmdb.cmdbf.client.model.cmdbf.ConstraintType;
import it.unibo.cmdb.cmdbf.client.model.cmdbf.ContentSelectorType;
import it.unibo.cmdb.cmdbf.client.model.cmdbf.DeclinedType;
import it.unibo.cmdb.cmdbf.client.model.cmdbf.DepthLimitType;
import it.unibo.cmdb.cmdbf.client.model.cmdbf.DeregisterInstanceResponseType;
import it.unibo.cmdb.cmdbf.client.model.cmdbf.DeregisterRequestType;
import it.unibo.cmdb.cmdbf.client.model.cmdbf.DeregisterResponseType;
import it.unibo.cmdb.cmdbf.client.model.cmdbf.DeregistrationErrorFaultType;
import it.unibo.cmdb.cmdbf.client.model.cmdbf.DocumentRoot;
import it.unibo.cmdb.cmdbf.client.model.cmdbf.EdgesType;
import it.unibo.cmdb.cmdbf.client.model.cmdbf.EqualOperatorType;
import it.unibo.cmdb.cmdbf.client.model.cmdbf.ExpensiveQueryErrorFaultType;
import it.unibo.cmdb.cmdbf.client.model.cmdbf.InstanceIdConstraintType;
import it.unibo.cmdb.cmdbf.client.model.cmdbf.InvalidMDRFaultType;
import it.unibo.cmdb.cmdbf.client.model.cmdbf.InvalidPropertyTypeFaultType;
import it.unibo.cmdb.cmdbf.client.model.cmdbf.InvalidRecordFaultType;
import it.unibo.cmdb.cmdbf.client.model.cmdbf.ItemListType;
import it.unibo.cmdb.cmdbf.client.model.cmdbf.ItemTemplateType;
import it.unibo.cmdb.cmdbf.client.model.cmdbf.ItemType;
import it.unibo.cmdb.cmdbf.client.model.cmdbf.MdrScopedIdListType;
import it.unibo.cmdb.cmdbf.client.model.cmdbf.MdrScopedIdType;
import it.unibo.cmdb.cmdbf.client.model.cmdbf.Model;
import it.unibo.cmdb.cmdbf.client.model.cmdbf.ModelElement;
import it.unibo.cmdb.cmdbf.client.model.cmdbf.ModelMetadata;
import it.unibo.cmdb.cmdbf.client.model.cmdbf.ModelRecordType;
import it.unibo.cmdb.cmdbf.client.model.cmdbf.ModelTemplate;
import it.unibo.cmdb.cmdbf.client.model.cmdbf.ModelUpdateInstanceResponse;
import it.unibo.cmdb.cmdbf.client.model.cmdbf.ModelUpdateResponse;
import it.unibo.cmdb.cmdbf.client.model.cmdbf.NodesType;
import it.unibo.cmdb.cmdbf.client.model.cmdbf.NullOperatorType;
import it.unibo.cmdb.cmdbf.client.model.cmdbf.PrefixMappingType;
import it.unibo.cmdb.cmdbf.client.model.cmdbf.PropertyNameType;
import it.unibo.cmdb.cmdbf.client.model.cmdbf.PropertySetType;
import it.unibo.cmdb.cmdbf.client.model.cmdbf.PropertyValueType;
import it.unibo.cmdb.cmdbf.client.model.cmdbf.QNameType;
import it.unibo.cmdb.cmdbf.client.model.cmdbf.QueryErrorFaultType;
import it.unibo.cmdb.cmdbf.client.model.cmdbf.QueryResultType;
import it.unibo.cmdb.cmdbf.client.model.cmdbf.QueryType;
import it.unibo.cmdb.cmdbf.client.model.cmdbf.RecordConstraintType;
import it.unibo.cmdb.cmdbf.client.model.cmdbf.RecordMetadataType;
import it.unibo.cmdb.cmdbf.client.model.cmdbf.RecordType;
import it.unibo.cmdb.cmdbf.client.model.cmdbf.RecordTypeType;
import it.unibo.cmdb.cmdbf.client.model.cmdbf.RegisterInstanceResponseType;
import it.unibo.cmdb.cmdbf.client.model.cmdbf.RegisterRequestType;
import it.unibo.cmdb.cmdbf.client.model.cmdbf.RegisterResponseType;
import it.unibo.cmdb.cmdbf.client.model.cmdbf.RegistrationErrorFaultType;
import it.unibo.cmdb.cmdbf.client.model.cmdbf.RelationshipListType;
import it.unibo.cmdb.cmdbf.client.model.cmdbf.RelationshipRefType;
import it.unibo.cmdb.cmdbf.client.model.cmdbf.RelationshipTemplateType;
import it.unibo.cmdb.cmdbf.client.model.cmdbf.RelationshipType;
import it.unibo.cmdb.cmdbf.client.model.cmdbf.SelectedRecordTypeType;
import it.unibo.cmdb.cmdbf.client.model.cmdbf.SelectorType;
import it.unibo.cmdb.cmdbf.client.model.cmdbf.StringOperatorType;
import it.unibo.cmdb.cmdbf.client.model.cmdbf.UnknownTemplateIDFaultType;
import it.unibo.cmdb.cmdbf.client.model.cmdbf.UnsupportedConstraintFaultType;
import it.unibo.cmdb.cmdbf.client.model.cmdbf.UnsupportedRecordTypeFaultType;
import it.unibo.cmdb.cmdbf.client.model.cmdbf.UnsupportedSelectorFaultType;
import it.unibo.cmdb.cmdbf.client.model.cmdbf.XPathErrorFaultType;
import it.unibo.cmdb.cmdbf.client.model.cmdbf.XPathExpressionType;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model <b>Package</b>.
 * <!-- end-user-doc -->
 * @generated
 */
public class CmdbfPackageImpl extends EPackageImpl implements CmdbfPackage {
	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass acceptedTypeEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass comparisonOperatorTypeEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass constraintTypeEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass contentSelectorTypeEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass declinedTypeEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass depthLimitTypeEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass deregisterInstanceResponseTypeEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass deregisterRequestTypeEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass deregisterResponseTypeEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass deregistrationErrorFaultTypeEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass documentRootEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass edgesTypeEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass equalOperatorTypeEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass expensiveQueryErrorFaultTypeEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass instanceIdConstraintTypeEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass invalidMDRFaultTypeEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass invalidPropertyTypeFaultTypeEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass invalidRecordFaultTypeEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass itemListTypeEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass itemTemplateTypeEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass itemTypeEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass mdrScopedIdListTypeEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass mdrScopedIdTypeEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass nodesTypeEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass nullOperatorTypeEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass prefixMappingTypeEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass propertyNameTypeEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass propertySetTypeEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass propertyValueTypeEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass qNameTypeEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass queryErrorFaultTypeEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass queryResultTypeEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass queryTypeEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass recordConstraintTypeEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass recordMetadataTypeEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass recordTypeEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass recordTypeTypeEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass registerInstanceResponseTypeEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass registerRequestTypeEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass registerResponseTypeEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass registrationErrorFaultTypeEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass relationshipListTypeEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass relationshipRefTypeEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass relationshipTemplateTypeEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass relationshipTypeEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass selectedRecordTypeTypeEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass selectorTypeEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass stringOperatorTypeEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass unknownTemplateIDFaultTypeEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass unsupportedConstraintFaultTypeEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass unsupportedRecordTypeFaultTypeEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass unsupportedSelectorFaultTypeEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass xPathErrorFaultTypeEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass xPathExpressionTypeEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass modelElementEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass modelTemplateEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass modelUpdateInstanceResponseEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass modelUpdateResponseEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass modelRecordTypeEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass modelEClass = null;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private EClass modelMetadataEClass = null;

	/**
	 * Creates an instance of the model <b>Package</b>, registered with
	 * {@link org.eclipse.emf.ecore.EPackage.Registry EPackage.Registry} by the package
	 * package URI value.
	 * <p>Note: the correct way to create the package is via the static
	 * factory method {@link #init init()}, which also performs
	 * initialization of the package, or returns the registered package,
	 * if one already exists.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.emf.ecore.EPackage.Registry
	 * @see it.unibo.cmdb.cmdbf.client.model.cmdbf.CmdbfPackage#eNS_URI
	 * @see #init()
	 * @generated
	 */
	private CmdbfPackageImpl() {
		super(eNS_URI, CmdbfFactory.eINSTANCE);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private static boolean isInited = false;

	/**
	 * Creates, registers, and initializes the <b>Package</b> for this model, and for any others upon which it depends.
	 * 
	 * <p>This method is used to initialize {@link CmdbfPackage#eINSTANCE} when that field is accessed.
	 * Clients should not invoke it directly. Instead, they should simply access that field to obtain the package.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #eNS_URI
	 * @see #createPackageContents()
	 * @see #initializePackageContents()
	 * @generated
	 */
	public static CmdbfPackage init() {
		if (isInited) return (CmdbfPackage)EPackage.Registry.INSTANCE.getEPackage(CmdbfPackage.eNS_URI);

		// Obtain or create and register package
		CmdbfPackageImpl theCmdbfPackage = (CmdbfPackageImpl)(EPackage.Registry.INSTANCE.get(eNS_URI) instanceof CmdbfPackageImpl ? EPackage.Registry.INSTANCE.get(eNS_URI) : new CmdbfPackageImpl());

		isInited = true;

		// Initialize simple dependencies
		XMLTypePackage.eINSTANCE.eClass();

		// Create package meta-data objects
		theCmdbfPackage.createPackageContents();

		// Initialize created meta-data
		theCmdbfPackage.initializePackageContents();

		// Mark meta-data to indicate it can't be changed
		theCmdbfPackage.freeze();

  
		// Update the registry and return the package
		EPackage.Registry.INSTANCE.put(CmdbfPackage.eNS_URI, theCmdbfPackage);
		return theCmdbfPackage;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getAcceptedType() {
		return acceptedTypeEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getAcceptedType_AlternateInstanceId() {
		return (EReference)acceptedTypeEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getComparisonOperatorType() {
		return comparisonOperatorTypeEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getComparisonOperatorType_Value() {
		return (EAttribute)comparisonOperatorTypeEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getComparisonOperatorType_Negate() {
		return (EAttribute)comparisonOperatorTypeEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getConstraintType() {
		return constraintTypeEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getConstraintType_LocalName() {
		return (EAttribute)constraintTypeEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getConstraintType_Namespace() {
		return (EAttribute)constraintTypeEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getContentSelectorType() {
		return contentSelectorTypeEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getContentSelectorType_SelectedRecordType() {
		return (EReference)contentSelectorTypeEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getContentSelectorType_XpathSelector() {
		return (EReference)contentSelectorTypeEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getContentSelectorType_Any() {
		return (EAttribute)contentSelectorTypeEClass.getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getContentSelectorType_Parent() {
		return (EReference)contentSelectorTypeEClass.getEStructuralFeatures().get(3);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getDeclinedType() {
		return declinedTypeEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getDeclinedType_Reason() {
		return (EAttribute)declinedTypeEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getDepthLimitType() {
		return depthLimitTypeEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getDepthLimitType_MaxIntermediateItems() {
		return (EAttribute)depthLimitTypeEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getDepthLimitType_IntermediateItemTemplate() {
		return (EAttribute)depthLimitTypeEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getDeregisterInstanceResponseType() {
		return deregisterInstanceResponseTypeEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getDeregisterInstanceResponseType_Accepted() {
		return (EAttribute)deregisterInstanceResponseTypeEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getDeregisterRequestType() {
		return deregisterRequestTypeEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getDeregisterRequestType_MdrId() {
		return (EAttribute)deregisterRequestTypeEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getDeregisterRequestType_ItemIdList() {
		return (EReference)deregisterRequestTypeEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getDeregisterRequestType_RelationshipIdList() {
		return (EReference)deregisterRequestTypeEClass.getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getDeregisterResponseType() {
		return deregisterResponseTypeEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getDeregisterResponseType_DeregisterInstanceResponse() {
		return (EReference)deregisterResponseTypeEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getDeregistrationErrorFaultType() {
		return deregistrationErrorFaultTypeEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getDeregistrationErrorFaultType_RecordId() {
		return (EAttribute)deregistrationErrorFaultTypeEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getDocumentRoot() {
		return documentRootEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getDocumentRoot_Mixed() {
		return (EAttribute)documentRootEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getDocumentRoot_XMLNSPrefixMap() {
		return (EReference)documentRootEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getDocumentRoot_XSISchemaLocation() {
		return (EReference)documentRootEClass.getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getDocumentRoot_DeregisterRequest() {
		return (EReference)documentRootEClass.getEStructuralFeatures().get(3);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getDocumentRoot_DeregisterResponse() {
		return (EReference)documentRootEClass.getEStructuralFeatures().get(4);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getDocumentRoot_DeregistrationErrorFault() {
		return (EReference)documentRootEClass.getEStructuralFeatures().get(5);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getDocumentRoot_ExpensiveQueryErrorFault() {
		return (EReference)documentRootEClass.getEStructuralFeatures().get(6);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getDocumentRoot_InstanceId() {
		return (EReference)documentRootEClass.getEStructuralFeatures().get(7);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getDocumentRoot_InvalidMDRFault() {
		return (EReference)documentRootEClass.getEStructuralFeatures().get(8);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getDocumentRoot_InvalidPropertyTypeFault() {
		return (EReference)documentRootEClass.getEStructuralFeatures().get(9);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getDocumentRoot_InvalidRecordFault() {
		return (EReference)documentRootEClass.getEStructuralFeatures().get(10);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getDocumentRoot_Item() {
		return (EReference)documentRootEClass.getEStructuralFeatures().get(11);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getDocumentRoot_PropertySet() {
		return (EReference)documentRootEClass.getEStructuralFeatures().get(12);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getDocumentRoot_Query() {
		return (EReference)documentRootEClass.getEStructuralFeatures().get(13);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getDocumentRoot_QueryErrorFault() {
		return (EReference)documentRootEClass.getEStructuralFeatures().get(14);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getDocumentRoot_QueryResult() {
		return (EReference)documentRootEClass.getEStructuralFeatures().get(15);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getDocumentRoot_Record() {
		return (EReference)documentRootEClass.getEStructuralFeatures().get(16);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getDocumentRoot_RegisterRequest() {
		return (EReference)documentRootEClass.getEStructuralFeatures().get(17);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getDocumentRoot_RegisterResponse() {
		return (EReference)documentRootEClass.getEStructuralFeatures().get(18);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getDocumentRoot_RegistrationErrorFault() {
		return (EReference)documentRootEClass.getEStructuralFeatures().get(19);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getDocumentRoot_Relationship() {
		return (EReference)documentRootEClass.getEStructuralFeatures().get(20);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getDocumentRoot_UnknownTemplateIDFault() {
		return (EReference)documentRootEClass.getEStructuralFeatures().get(21);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getDocumentRoot_UnsupportedConstraintFault() {
		return (EReference)documentRootEClass.getEStructuralFeatures().get(22);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getDocumentRoot_UnsupportedRecordTypeFault() {
		return (EReference)documentRootEClass.getEStructuralFeatures().get(23);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getDocumentRoot_UnsupportedSelectorFault() {
		return (EReference)documentRootEClass.getEStructuralFeatures().get(24);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getDocumentRoot_XPathErrorFault() {
		return (EReference)documentRootEClass.getEStructuralFeatures().get(25);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getDocumentRoot_Model() {
		return (EReference)documentRootEClass.getEStructuralFeatures().get(26);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getEdgesType() {
		return edgesTypeEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getEdgesType_Relationship() {
		return (EReference)edgesTypeEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getEdgesType_TemplateId() {
		return (EAttribute)edgesTypeEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getEqualOperatorType() {
		return equalOperatorTypeEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getEqualOperatorType_Value() {
		return (EAttribute)equalOperatorTypeEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getEqualOperatorType_CaseSensitive() {
		return (EAttribute)equalOperatorTypeEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getEqualOperatorType_Negate() {
		return (EAttribute)equalOperatorTypeEClass.getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getExpensiveQueryErrorFaultType() {
		return expensiveQueryErrorFaultTypeEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getExpensiveQueryErrorFaultType_Any() {
		return (EAttribute)expensiveQueryErrorFaultTypeEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getInstanceIdConstraintType() {
		return instanceIdConstraintTypeEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getInstanceIdConstraintType_InstanceId() {
		return (EReference)instanceIdConstraintTypeEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getInvalidMDRFaultType() {
		return invalidMDRFaultTypeEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getInvalidMDRFaultType_MdrId() {
		return (EAttribute)invalidMDRFaultTypeEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getInvalidPropertyTypeFaultType() {
		return invalidPropertyTypeFaultTypeEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getInvalidPropertyTypeFaultType_PropertyName() {
		return (EReference)invalidPropertyTypeFaultTypeEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getInvalidRecordFaultType() {
		return invalidRecordFaultTypeEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getInvalidRecordFaultType_RecordId() {
		return (EAttribute)invalidRecordFaultTypeEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getItemListType() {
		return itemListTypeEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getItemListType_Item() {
		return (EReference)itemListTypeEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EOperation getItemListType__Find__MdrScopedIdType() {
		return itemListTypeEClass.getEOperations().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EOperation getItemListType__Find__ItemType() {
		return itemListTypeEClass.getEOperations().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getItemTemplateType() {
		return itemTemplateTypeEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getItemType() {
		return itemTypeEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getItemType_RelationshipBySource() {
		return (EReference)itemTypeEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getItemType_RelationshipByTarget() {
		return (EReference)itemTypeEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getMdrScopedIdListType() {
		return mdrScopedIdListTypeEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getMdrScopedIdListType_InstanceId() {
		return (EReference)mdrScopedIdListTypeEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getMdrScopedIdType() {
		return mdrScopedIdTypeEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getMdrScopedIdType_MdrId() {
		return (EAttribute)mdrScopedIdTypeEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getMdrScopedIdType_LocalId() {
		return (EAttribute)mdrScopedIdTypeEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EOperation getMdrScopedIdType__Init__String() {
		return mdrScopedIdTypeEClass.getEOperations().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getNodesType() {
		return nodesTypeEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getNodesType_Item() {
		return (EReference)nodesTypeEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getNodesType_TemplateId() {
		return (EAttribute)nodesTypeEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getNullOperatorType() {
		return nullOperatorTypeEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getNullOperatorType_Negate() {
		return (EAttribute)nullOperatorTypeEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getPrefixMappingType() {
		return prefixMappingTypeEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getPrefixMappingType_Prefix() {
		return (EAttribute)prefixMappingTypeEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getPrefixMappingType_Namespace() {
		return (EAttribute)prefixMappingTypeEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getPropertyNameType() {
		return propertyNameTypeEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getPropertyNameType_LocalName() {
		return (EAttribute)propertyNameTypeEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getPropertyNameType_Namespace() {
		return (EAttribute)propertyNameTypeEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getPropertySetType() {
		return propertySetTypeEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getPropertySetType_Any() {
		return (EAttribute)propertySetTypeEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getPropertySetType_Namespace() {
		return (EAttribute)propertySetTypeEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getPropertySetType_LocalName() {
		return (EAttribute)propertySetTypeEClass.getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getPropertyValueType() {
		return propertyValueTypeEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getPropertyValueType_Equal() {
		return (EReference)propertyValueTypeEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getPropertyValueType_Less() {
		return (EReference)propertyValueTypeEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getPropertyValueType_LessOrEqual() {
		return (EReference)propertyValueTypeEClass.getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getPropertyValueType_Greater() {
		return (EReference)propertyValueTypeEClass.getEStructuralFeatures().get(3);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getPropertyValueType_GreaterOrEqual() {
		return (EReference)propertyValueTypeEClass.getEStructuralFeatures().get(4);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getPropertyValueType_Contains() {
		return (EReference)propertyValueTypeEClass.getEStructuralFeatures().get(5);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getPropertyValueType_Like() {
		return (EReference)propertyValueTypeEClass.getEStructuralFeatures().get(6);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getPropertyValueType_IsNull() {
		return (EReference)propertyValueTypeEClass.getEStructuralFeatures().get(7);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getPropertyValueType_Any() {
		return (EAttribute)propertyValueTypeEClass.getEStructuralFeatures().get(8);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getPropertyValueType_Namespace() {
		return (EAttribute)propertyValueTypeEClass.getEStructuralFeatures().get(9);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getPropertyValueType_LocalName() {
		return (EAttribute)propertyValueTypeEClass.getEStructuralFeatures().get(10);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getPropertyValueType_RecordMetadata() {
		return (EAttribute)propertyValueTypeEClass.getEStructuralFeatures().get(11);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getPropertyValueType_MatchAny() {
		return (EAttribute)propertyValueTypeEClass.getEStructuralFeatures().get(12);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getPropertyValueType_Parent() {
		return (EReference)propertyValueTypeEClass.getEStructuralFeatures().get(13);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EOperation getPropertyValueType__AddEqual__Object() {
		return propertyValueTypeEClass.getEOperations().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EOperation getPropertyValueType__AddLess__Object() {
		return propertyValueTypeEClass.getEOperations().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EOperation getPropertyValueType__AddLessOrEqual__Object() {
		return propertyValueTypeEClass.getEOperations().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EOperation getPropertyValueType__AddGreater__Object() {
		return propertyValueTypeEClass.getEOperations().get(3);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EOperation getPropertyValueType__AddGreaterOrEqual__Object() {
		return propertyValueTypeEClass.getEOperations().get(4);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EOperation getPropertyValueType__AddContains__String() {
		return propertyValueTypeEClass.getEOperations().get(5);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EOperation getPropertyValueType__AddLike__String() {
		return propertyValueTypeEClass.getEOperations().get(6);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EOperation getPropertyValueType__AddIsNull() {
		return propertyValueTypeEClass.getEOperations().get(7);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getQNameType() {
		return qNameTypeEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getQNameType_Namespace() {
		return (EAttribute)qNameTypeEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getQNameType_LocalName() {
		return (EAttribute)qNameTypeEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getQueryErrorFaultType() {
		return queryErrorFaultTypeEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getQueryErrorFaultType_Any() {
		return (EAttribute)queryErrorFaultTypeEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getQueryResultType() {
		return queryResultTypeEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getQueryResultType_Nodes() {
		return (EReference)queryResultTypeEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getQueryResultType_Edges() {
		return (EReference)queryResultTypeEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getQueryType() {
		return queryTypeEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getQueryType_ItemTemplate() {
		return (EReference)queryTypeEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getQueryType_RelationshipTemplate() {
		return (EReference)queryTypeEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getQueryType_MdrId() {
		return (EAttribute)queryTypeEClass.getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getQueryType_ModelMetadata() {
		return (EReference)queryTypeEClass.getEStructuralFeatures().get(3);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EOperation getQueryType__AddItemTemplate__String() {
		return queryTypeEClass.getEOperations().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EOperation getQueryType__AddRelationshipTemplate__String() {
		return queryTypeEClass.getEOperations().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EOperation getQueryType__GetNamespace__String() {
		return queryTypeEClass.getEOperations().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EOperation getQueryType__GetLocalName__String() {
		return queryTypeEClass.getEOperations().get(3);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getRecordConstraintType() {
		return recordConstraintTypeEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getRecordConstraintType_RecordType() {
		return (EReference)recordConstraintTypeEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getRecordConstraintType_PropertyValue() {
		return (EReference)recordConstraintTypeEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getRecordConstraintType_XpathConstraint() {
		return (EReference)recordConstraintTypeEClass.getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getRecordConstraintType_Any() {
		return (EAttribute)recordConstraintTypeEClass.getEStructuralFeatures().get(3);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getRecordConstraintType_Parent() {
		return (EReference)recordConstraintTypeEClass.getEStructuralFeatures().get(4);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EOperation getRecordConstraintType__AddRecordType__String() {
		return recordConstraintTypeEClass.getEOperations().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EOperation getRecordConstraintType__AddRecordType__String_String() {
		return recordConstraintTypeEClass.getEOperations().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EOperation getRecordConstraintType__AddPropertyValue__String() {
		return recordConstraintTypeEClass.getEOperations().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EOperation getRecordConstraintType__AddPropertyValue__String_String() {
		return recordConstraintTypeEClass.getEOperations().get(3);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getRecordMetadataType() {
		return recordMetadataTypeEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getRecordMetadataType_RecordId() {
		return (EAttribute)recordMetadataTypeEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getRecordMetadataType_LastModified() {
		return (EAttribute)recordMetadataTypeEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getRecordMetadataType_BaselineId() {
		return (EAttribute)recordMetadataTypeEClass.getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getRecordMetadataType_SnapshotId() {
		return (EAttribute)recordMetadataTypeEClass.getEStructuralFeatures().get(3);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getRecordMetadataType_Any() {
		return (EAttribute)recordMetadataTypeEClass.getEStructuralFeatures().get(4);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getRecordType() {
		return recordTypeEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getRecordType_Any() {
		return (EAttribute)recordTypeEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getRecordType_PropertySet() {
		return (EReference)recordTypeEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getRecordType_RecordMetadata() {
		return (EReference)recordTypeEClass.getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getRecordType_Parent() {
		return (EReference)recordTypeEClass.getEStructuralFeatures().get(3);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getRecordType_TemplateId() {
		return (EAttribute)recordTypeEClass.getEStructuralFeatures().get(4);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getRecordType_RecordId() {
		return (EAttribute)recordTypeEClass.getEStructuralFeatures().get(5);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getRecordType_LastModified() {
		return (EAttribute)recordTypeEClass.getEStructuralFeatures().get(6);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getRecordType_Type() {
		return (EReference)recordTypeEClass.getEStructuralFeatures().get(7);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getRecordType_Content() {
		return (EReference)recordTypeEClass.getEStructuralFeatures().get(8);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getRecordType_PropertyName() {
		return (EAttribute)recordTypeEClass.getEStructuralFeatures().get(9);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EOperation getRecordType__Get__String() {
		return recordTypeEClass.getEOperations().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EOperation getRecordType__Set__String_Object() {
		return recordTypeEClass.getEOperations().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EOperation getRecordType__Unset__String() {
		return recordTypeEClass.getEOperations().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EOperation getRecordType__IsSet__String() {
		return recordTypeEClass.getEOperations().get(3);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EOperation getRecordType__Has__String() {
		return recordTypeEClass.getEOperations().get(4);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EOperation getRecordType__InstanceOf__String() {
		return recordTypeEClass.getEOperations().get(7);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EOperation getRecordType__InstanceOf__String_String() {
		return recordTypeEClass.getEOperations().get(8);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EOperation getRecordType__GetAsString__String() {
		return recordTypeEClass.getEOperations().get(5);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EOperation getRecordType__SetAsString__String_String() {
		return recordTypeEClass.getEOperations().get(6);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EOperation getRecordType__InstanceOf__ModelRecordType() {
		return recordTypeEClass.getEOperations().get(9);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EOperation getRecordType__Merge__RecordType() {
		return recordTypeEClass.getEOperations().get(10);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getRecordTypeType() {
		return recordTypeTypeEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getRecordTypeType_LocalName() {
		return (EAttribute)recordTypeTypeEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getRecordTypeType_Namespace() {
		return (EAttribute)recordTypeTypeEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getRegisterInstanceResponseType() {
		return registerInstanceResponseTypeEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getRegisterInstanceResponseType_Accepted() {
		return (EReference)registerInstanceResponseTypeEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getRegisterRequestType() {
		return registerRequestTypeEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getRegisterRequestType_MdrId() {
		return (EAttribute)registerRequestTypeEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getRegisterRequestType_ItemList() {
		return (EReference)registerRequestTypeEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getRegisterRequestType_RelationshipList() {
		return (EReference)registerRequestTypeEClass.getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getRegisterRequestType_Parent() {
		return (EReference)registerRequestTypeEClass.getEStructuralFeatures().get(3);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getRegisterResponseType() {
		return registerResponseTypeEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getRegisterResponseType_RegisterInstanceResponse() {
		return (EReference)registerResponseTypeEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getRegistrationErrorFaultType() {
		return registrationErrorFaultTypeEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getRegistrationErrorFaultType_RecordId() {
		return (EAttribute)registrationErrorFaultTypeEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getRelationshipListType() {
		return relationshipListTypeEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getRelationshipListType_Relationship() {
		return (EReference)relationshipListTypeEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EOperation getRelationshipListType__Find__MdrScopedIdType() {
		return relationshipListTypeEClass.getEOperations().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EOperation getRelationshipListType__Find__RelationshipType() {
		return relationshipListTypeEClass.getEOperations().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getRelationshipRefType() {
		return relationshipRefTypeEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getRelationshipRefType_Ref() {
		return (EAttribute)relationshipRefTypeEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getRelationshipRefType_Minimum() {
		return (EAttribute)relationshipRefTypeEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getRelationshipRefType_Maximum() {
		return (EAttribute)relationshipRefTypeEClass.getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getRelationshipTemplateType() {
		return relationshipTemplateTypeEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getRelationshipTemplateType_SourceTemplate() {
		return (EReference)relationshipTemplateTypeEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getRelationshipTemplateType_TargetTemplate() {
		return (EReference)relationshipTemplateTypeEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getRelationshipTemplateType_DepthLimit() {
		return (EReference)relationshipTemplateTypeEClass.getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EOperation getRelationshipTemplateType__AddSourceTemplate__ItemTemplateType() {
		return relationshipTemplateTypeEClass.getEOperations().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EOperation getRelationshipTemplateType__AddTargetTemplate__ItemTemplateType() {
		return relationshipTemplateTypeEClass.getEOperations().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EOperation getRelationshipTemplateType__AddDepthLimit__ItemTemplateType() {
		return relationshipTemplateTypeEClass.getEOperations().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getRelationshipType() {
		return relationshipTypeEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getRelationshipType_SourceItem() {
		return (EReference)relationshipTypeEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getRelationshipType_TargetItem() {
		return (EReference)relationshipTypeEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getSelectedRecordTypeType() {
		return selectedRecordTypeTypeEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getSelectedRecordTypeType_SelectedProperty() {
		return (EReference)selectedRecordTypeTypeEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getSelectedRecordTypeType_Namespace() {
		return (EAttribute)selectedRecordTypeTypeEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getSelectedRecordTypeType_LocalName() {
		return (EAttribute)selectedRecordTypeTypeEClass.getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getSelectedRecordTypeType_Parent() {
		return (EReference)selectedRecordTypeTypeEClass.getEStructuralFeatures().get(3);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EOperation getSelectedRecordTypeType__AddSelectedProperty__String() {
		return selectedRecordTypeTypeEClass.getEOperations().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EOperation getSelectedRecordTypeType__AddSelectedProperty__String_String() {
		return selectedRecordTypeTypeEClass.getEOperations().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getSelectorType() {
		return selectorTypeEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getSelectorType_LocalName() {
		return (EAttribute)selectorTypeEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getSelectorType_Namespace() {
		return (EAttribute)selectorTypeEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getStringOperatorType() {
		return stringOperatorTypeEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getStringOperatorType_Value() {
		return (EAttribute)stringOperatorTypeEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getStringOperatorType_CaseSensitive() {
		return (EAttribute)stringOperatorTypeEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getStringOperatorType_Negate() {
		return (EAttribute)stringOperatorTypeEClass.getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getUnknownTemplateIDFaultType() {
		return unknownTemplateIDFaultTypeEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getUnknownTemplateIDFaultType_GraphId() {
		return (EAttribute)unknownTemplateIDFaultTypeEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getUnsupportedConstraintFaultType() {
		return unsupportedConstraintFaultTypeEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getUnsupportedConstraintFaultType_Constraint() {
		return (EReference)unsupportedConstraintFaultTypeEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getUnsupportedRecordTypeFaultType() {
		return unsupportedRecordTypeFaultTypeEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getUnsupportedRecordTypeFaultType_RecordType() {
		return (EReference)unsupportedRecordTypeFaultTypeEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getUnsupportedSelectorFaultType() {
		return unsupportedSelectorFaultTypeEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getUnsupportedSelectorFaultType_Selector() {
		return (EReference)unsupportedSelectorFaultTypeEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getXPathErrorFaultType() {
		return xPathErrorFaultTypeEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getXPathErrorFaultType_Expression() {
		return (EAttribute)xPathErrorFaultTypeEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getXPathErrorFaultType_XpathErrorCode() {
		return (EAttribute)xPathErrorFaultTypeEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getXPathExpressionType() {
		return xPathExpressionTypeEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getXPathExpressionType_PrefixMapping() {
		return (EReference)xPathExpressionTypeEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getXPathExpressionType_Expression() {
		return (EAttribute)xPathExpressionTypeEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getXPathExpressionType_Dialect() {
		return (EAttribute)xPathExpressionTypeEClass.getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getModelElement() {
		return modelElementEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getModelElement_Record() {
		return (EReference)modelElementEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getModelElement_InstanceId() {
		return (EReference)modelElementEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getModelElement_AdditionalRecordType() {
		return (EReference)modelElementEClass.getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getModelElement_TemplateId() {
		return (EAttribute)modelElementEClass.getEStructuralFeatures().get(3);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getModelElement_Parent() {
		return (EReference)modelElementEClass.getEStructuralFeatures().get(4);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getModelElement_Deregister() {
		return (EAttribute)modelElementEClass.getEStructuralFeatures().get(5);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EOperation getModelElement__FindInstanceId() {
		return modelElementEClass.getEOperations().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EOperation getModelElement__FindInstanceId__String() {
		return modelElementEClass.getEOperations().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EOperation getModelElement__AddInstanceId__String() {
		return modelElementEClass.getEOperations().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EOperation getModelElement__AddInstanceId__String_String() {
		return modelElementEClass.getEOperations().get(3);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EOperation getModelElement__AddAdditionalRecordType__String() {
		return modelElementEClass.getEOperations().get(4);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EOperation getModelElement__AddAdditionalRecordType__String_String() {
		return modelElementEClass.getEOperations().get(5);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EOperation getModelElement__AddRecord__String() {
		return modelElementEClass.getEOperations().get(6);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EOperation getModelElement__AddRecord__String_String() {
		return modelElementEClass.getEOperations().get(7);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EOperation getModelElement__AddRecord__String_boolean() {
		return modelElementEClass.getEOperations().get(8);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EOperation getModelElement__AddRecord__String_String_boolean() {
		return modelElementEClass.getEOperations().get(9);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EOperation getModelElement__FindRecord__String() {
		return modelElementEClass.getEOperations().get(10);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EOperation getModelElement__FindRecord__String_String() {
		return modelElementEClass.getEOperations().get(11);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EOperation getModelElement__FindRecordByTemplate__String_String() {
		return modelElementEClass.getEOperations().get(12);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EOperation getModelElement__FindRecordByTemplate__String_String_String() {
		return modelElementEClass.getEOperations().get(13);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EOperation getModelElement__FindRecordById__String() {
		return modelElementEClass.getEOperations().get(14);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EOperation getModelElement__Merge__ModelElement() {
		return modelElementEClass.getEOperations().get(15);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getModelTemplate() {
		return modelTemplateEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getModelTemplate_ContentSelector() {
		return (EReference)modelTemplateEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getModelTemplate_InstanceIdConstraint() {
		return (EReference)modelTemplateEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getModelTemplate_RecordConstraint() {
		return (EReference)modelTemplateEClass.getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getModelTemplate_Any() {
		return (EAttribute)modelTemplateEClass.getEStructuralFeatures().get(3);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getModelTemplate_Id() {
		return (EAttribute)modelTemplateEClass.getEStructuralFeatures().get(4);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getModelTemplate_SuppressFromResult() {
		return (EAttribute)modelTemplateEClass.getEStructuralFeatures().get(5);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getModelTemplate_Query() {
		return (EReference)modelTemplateEClass.getEStructuralFeatures().get(6);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EOperation getModelTemplate__AddInstanceIdConstraint__String() {
		return modelTemplateEClass.getEOperations().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EOperation getModelTemplate__AddInstanceIdConstraint__String_String() {
		return modelTemplateEClass.getEOperations().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EOperation getModelTemplate__AddRecordConstraint() {
		return modelTemplateEClass.getEOperations().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EOperation getModelTemplate__AddContentSelector__String() {
		return modelTemplateEClass.getEOperations().get(3);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EOperation getModelTemplate__AddContentSelector__String_String() {
		return modelTemplateEClass.getEOperations().get(4);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getModelUpdateInstanceResponse() {
		return modelUpdateInstanceResponseEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getModelUpdateInstanceResponse_InstanceId() {
		return (EReference)modelUpdateInstanceResponseEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getModelUpdateInstanceResponse_Declined() {
		return (EReference)modelUpdateInstanceResponseEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getModelUpdateResponse() {
		return modelUpdateResponseEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getModelUpdateResponse_InstanceResponse() {
		return (EReference)modelUpdateResponseEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getModelRecordType() {
		return modelRecordTypeEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getModelRecordType_LocalName() {
		return (EAttribute)modelRecordTypeEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getModelRecordType_Namespace() {
		return (EAttribute)modelRecordTypeEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getModelRecordType_AppliesToItem() {
		return (EAttribute)modelRecordTypeEClass.getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getModelRecordType_AppliesToRelationship() {
		return (EAttribute)modelRecordTypeEClass.getEStructuralFeatures().get(3);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getModelRecordType_SuperType() {
		return (EReference)modelRecordTypeEClass.getEStructuralFeatures().get(4);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EOperation getModelRecordType__IsAssignableFrom__ModelRecordType() {
		return modelRecordTypeEClass.getEOperations().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getModel() {
		return modelEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getModel_Register() {
		return (EReference)modelEClass.getEStructuralFeatures().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getModel_Deregister() {
		return (EReference)modelEClass.getEStructuralFeatures().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getModel_Item() {
		return (EReference)modelEClass.getEStructuralFeatures().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getModel_Relationship() {
		return (EReference)modelEClass.getEStructuralFeatures().get(3);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getModel_ModelMetadata() {
		return (EReference)modelEClass.getEStructuralFeatures().get(4);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EAttribute getModel_MdrId() {
		return (EAttribute)modelEClass.getEStructuralFeatures().get(5);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getModel_RemovedItemId() {
		return (EReference)modelEClass.getEStructuralFeatures().get(6);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EReference getModel_RemovedRelationshipId() {
		return (EReference)modelEClass.getEStructuralFeatures().get(7);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EOperation getModel__AddItem() {
		return modelEClass.getEOperations().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EOperation getModel__AddRelationship() {
		return modelEClass.getEOperations().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EOperation getModel__GetItemByTemplate__String() {
		return modelEClass.getEOperations().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EOperation getModel__GetRelationshipByTemplate__String() {
		return modelEClass.getEOperations().get(3);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EOperation getModel__FindItem__MdrScopedIdType() {
		return modelEClass.getEOperations().get(4);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EOperation getModel__FindItem__ItemType() {
		return modelEClass.getEOperations().get(5);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EOperation getModel__FindItem__String_String() {
		return modelEClass.getEOperations().get(6);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EOperation getModel__FindRelationship__MdrScopedIdType() {
		return modelEClass.getEOperations().get(7);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EOperation getModel__FindRelationship__RelationshipType() {
		return modelEClass.getEOperations().get(8);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EOperation getModel__FindRelationship__String_String() {
		return modelEClass.getEOperations().get(9);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EOperation getModel__Remove__ItemType() {
		return modelEClass.getEOperations().get(10);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EOperation getModel__Remove__RelationshipType() {
		return modelEClass.getEOperations().get(11);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EClass getModelMetadata() {
		return modelMetadataEClass;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EOperation getModelMetadata__GetElement__String_String() {
		return modelMetadataEClass.getEOperations().get(0);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EOperation getModelMetadata__GetNamespace__EClassifier() {
		return modelMetadataEClass.getEOperations().get(1);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EOperation getModelMetadata__GetLocalName__EClassifier() {
		return modelMetadataEClass.getEOperations().get(2);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EOperation getModelMetadata__GetRecordType__String_String() {
		return modelMetadataEClass.getEOperations().get(3);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EOperation getModelMetadata__GetNamespace__String() {
		return modelMetadataEClass.getEOperations().get(4);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EOperation getModelMetadata__GetLocalName__String() {
		return modelMetadataEClass.getEOperations().get(5);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public CmdbfFactory getCmdbfFactory() {
		return (CmdbfFactory)getEFactoryInstance();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private boolean isCreated = false;

	/**
	 * Creates the meta-model objects for the package.  This method is
	 * guarded to have no affect on any invocation but its first.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void createPackageContents() {
		if (isCreated) return;
		isCreated = true;

		// Create classes and their features
		acceptedTypeEClass = createEClass(ACCEPTED_TYPE);
		createEReference(acceptedTypeEClass, ACCEPTED_TYPE__ALTERNATE_INSTANCE_ID);

		comparisonOperatorTypeEClass = createEClass(COMPARISON_OPERATOR_TYPE);
		createEAttribute(comparisonOperatorTypeEClass, COMPARISON_OPERATOR_TYPE__VALUE);
		createEAttribute(comparisonOperatorTypeEClass, COMPARISON_OPERATOR_TYPE__NEGATE);

		constraintTypeEClass = createEClass(CONSTRAINT_TYPE);
		createEAttribute(constraintTypeEClass, CONSTRAINT_TYPE__LOCAL_NAME);
		createEAttribute(constraintTypeEClass, CONSTRAINT_TYPE__NAMESPACE);

		contentSelectorTypeEClass = createEClass(CONTENT_SELECTOR_TYPE);
		createEReference(contentSelectorTypeEClass, CONTENT_SELECTOR_TYPE__SELECTED_RECORD_TYPE);
		createEReference(contentSelectorTypeEClass, CONTENT_SELECTOR_TYPE__XPATH_SELECTOR);
		createEAttribute(contentSelectorTypeEClass, CONTENT_SELECTOR_TYPE__ANY);
		createEReference(contentSelectorTypeEClass, CONTENT_SELECTOR_TYPE__PARENT);

		declinedTypeEClass = createEClass(DECLINED_TYPE);
		createEAttribute(declinedTypeEClass, DECLINED_TYPE__REASON);

		depthLimitTypeEClass = createEClass(DEPTH_LIMIT_TYPE);
		createEAttribute(depthLimitTypeEClass, DEPTH_LIMIT_TYPE__MAX_INTERMEDIATE_ITEMS);
		createEAttribute(depthLimitTypeEClass, DEPTH_LIMIT_TYPE__INTERMEDIATE_ITEM_TEMPLATE);

		deregisterInstanceResponseTypeEClass = createEClass(DEREGISTER_INSTANCE_RESPONSE_TYPE);
		createEAttribute(deregisterInstanceResponseTypeEClass, DEREGISTER_INSTANCE_RESPONSE_TYPE__ACCEPTED);

		deregisterRequestTypeEClass = createEClass(DEREGISTER_REQUEST_TYPE);
		createEAttribute(deregisterRequestTypeEClass, DEREGISTER_REQUEST_TYPE__MDR_ID);
		createEReference(deregisterRequestTypeEClass, DEREGISTER_REQUEST_TYPE__ITEM_ID_LIST);
		createEReference(deregisterRequestTypeEClass, DEREGISTER_REQUEST_TYPE__RELATIONSHIP_ID_LIST);

		deregisterResponseTypeEClass = createEClass(DEREGISTER_RESPONSE_TYPE);
		createEReference(deregisterResponseTypeEClass, DEREGISTER_RESPONSE_TYPE__DEREGISTER_INSTANCE_RESPONSE);

		deregistrationErrorFaultTypeEClass = createEClass(DEREGISTRATION_ERROR_FAULT_TYPE);
		createEAttribute(deregistrationErrorFaultTypeEClass, DEREGISTRATION_ERROR_FAULT_TYPE__RECORD_ID);

		documentRootEClass = createEClass(DOCUMENT_ROOT);
		createEAttribute(documentRootEClass, DOCUMENT_ROOT__MIXED);
		createEReference(documentRootEClass, DOCUMENT_ROOT__XMLNS_PREFIX_MAP);
		createEReference(documentRootEClass, DOCUMENT_ROOT__XSI_SCHEMA_LOCATION);
		createEReference(documentRootEClass, DOCUMENT_ROOT__DEREGISTER_REQUEST);
		createEReference(documentRootEClass, DOCUMENT_ROOT__DEREGISTER_RESPONSE);
		createEReference(documentRootEClass, DOCUMENT_ROOT__DEREGISTRATION_ERROR_FAULT);
		createEReference(documentRootEClass, DOCUMENT_ROOT__EXPENSIVE_QUERY_ERROR_FAULT);
		createEReference(documentRootEClass, DOCUMENT_ROOT__INSTANCE_ID);
		createEReference(documentRootEClass, DOCUMENT_ROOT__INVALID_MDR_FAULT);
		createEReference(documentRootEClass, DOCUMENT_ROOT__INVALID_PROPERTY_TYPE_FAULT);
		createEReference(documentRootEClass, DOCUMENT_ROOT__INVALID_RECORD_FAULT);
		createEReference(documentRootEClass, DOCUMENT_ROOT__ITEM);
		createEReference(documentRootEClass, DOCUMENT_ROOT__PROPERTY_SET);
		createEReference(documentRootEClass, DOCUMENT_ROOT__QUERY);
		createEReference(documentRootEClass, DOCUMENT_ROOT__QUERY_ERROR_FAULT);
		createEReference(documentRootEClass, DOCUMENT_ROOT__QUERY_RESULT);
		createEReference(documentRootEClass, DOCUMENT_ROOT__RECORD);
		createEReference(documentRootEClass, DOCUMENT_ROOT__REGISTER_REQUEST);
		createEReference(documentRootEClass, DOCUMENT_ROOT__REGISTER_RESPONSE);
		createEReference(documentRootEClass, DOCUMENT_ROOT__REGISTRATION_ERROR_FAULT);
		createEReference(documentRootEClass, DOCUMENT_ROOT__RELATIONSHIP);
		createEReference(documentRootEClass, DOCUMENT_ROOT__UNKNOWN_TEMPLATE_ID_FAULT);
		createEReference(documentRootEClass, DOCUMENT_ROOT__UNSUPPORTED_CONSTRAINT_FAULT);
		createEReference(documentRootEClass, DOCUMENT_ROOT__UNSUPPORTED_RECORD_TYPE_FAULT);
		createEReference(documentRootEClass, DOCUMENT_ROOT__UNSUPPORTED_SELECTOR_FAULT);
		createEReference(documentRootEClass, DOCUMENT_ROOT__XPATH_ERROR_FAULT);
		createEReference(documentRootEClass, DOCUMENT_ROOT__MODEL);

		edgesTypeEClass = createEClass(EDGES_TYPE);
		createEReference(edgesTypeEClass, EDGES_TYPE__RELATIONSHIP);
		createEAttribute(edgesTypeEClass, EDGES_TYPE__TEMPLATE_ID);

		equalOperatorTypeEClass = createEClass(EQUAL_OPERATOR_TYPE);
		createEAttribute(equalOperatorTypeEClass, EQUAL_OPERATOR_TYPE__VALUE);
		createEAttribute(equalOperatorTypeEClass, EQUAL_OPERATOR_TYPE__CASE_SENSITIVE);
		createEAttribute(equalOperatorTypeEClass, EQUAL_OPERATOR_TYPE__NEGATE);

		expensiveQueryErrorFaultTypeEClass = createEClass(EXPENSIVE_QUERY_ERROR_FAULT_TYPE);
		createEAttribute(expensiveQueryErrorFaultTypeEClass, EXPENSIVE_QUERY_ERROR_FAULT_TYPE__ANY);

		instanceIdConstraintTypeEClass = createEClass(INSTANCE_ID_CONSTRAINT_TYPE);
		createEReference(instanceIdConstraintTypeEClass, INSTANCE_ID_CONSTRAINT_TYPE__INSTANCE_ID);

		invalidMDRFaultTypeEClass = createEClass(INVALID_MDR_FAULT_TYPE);
		createEAttribute(invalidMDRFaultTypeEClass, INVALID_MDR_FAULT_TYPE__MDR_ID);

		invalidPropertyTypeFaultTypeEClass = createEClass(INVALID_PROPERTY_TYPE_FAULT_TYPE);
		createEReference(invalidPropertyTypeFaultTypeEClass, INVALID_PROPERTY_TYPE_FAULT_TYPE__PROPERTY_NAME);

		invalidRecordFaultTypeEClass = createEClass(INVALID_RECORD_FAULT_TYPE);
		createEAttribute(invalidRecordFaultTypeEClass, INVALID_RECORD_FAULT_TYPE__RECORD_ID);

		itemListTypeEClass = createEClass(ITEM_LIST_TYPE);
		createEReference(itemListTypeEClass, ITEM_LIST_TYPE__ITEM);
		createEOperation(itemListTypeEClass, ITEM_LIST_TYPE___FIND__MDRSCOPEDIDTYPE);
		createEOperation(itemListTypeEClass, ITEM_LIST_TYPE___FIND__ITEMTYPE);

		itemTemplateTypeEClass = createEClass(ITEM_TEMPLATE_TYPE);

		itemTypeEClass = createEClass(ITEM_TYPE);
		createEReference(itemTypeEClass, ITEM_TYPE__RELATIONSHIP_BY_SOURCE);
		createEReference(itemTypeEClass, ITEM_TYPE__RELATIONSHIP_BY_TARGET);

		mdrScopedIdListTypeEClass = createEClass(MDR_SCOPED_ID_LIST_TYPE);
		createEReference(mdrScopedIdListTypeEClass, MDR_SCOPED_ID_LIST_TYPE__INSTANCE_ID);

		mdrScopedIdTypeEClass = createEClass(MDR_SCOPED_ID_TYPE);
		createEAttribute(mdrScopedIdTypeEClass, MDR_SCOPED_ID_TYPE__MDR_ID);
		createEAttribute(mdrScopedIdTypeEClass, MDR_SCOPED_ID_TYPE__LOCAL_ID);
		createEOperation(mdrScopedIdTypeEClass, MDR_SCOPED_ID_TYPE___INIT__STRING);

		nodesTypeEClass = createEClass(NODES_TYPE);
		createEReference(nodesTypeEClass, NODES_TYPE__ITEM);
		createEAttribute(nodesTypeEClass, NODES_TYPE__TEMPLATE_ID);

		nullOperatorTypeEClass = createEClass(NULL_OPERATOR_TYPE);
		createEAttribute(nullOperatorTypeEClass, NULL_OPERATOR_TYPE__NEGATE);

		prefixMappingTypeEClass = createEClass(PREFIX_MAPPING_TYPE);
		createEAttribute(prefixMappingTypeEClass, PREFIX_MAPPING_TYPE__PREFIX);
		createEAttribute(prefixMappingTypeEClass, PREFIX_MAPPING_TYPE__NAMESPACE);

		propertyNameTypeEClass = createEClass(PROPERTY_NAME_TYPE);
		createEAttribute(propertyNameTypeEClass, PROPERTY_NAME_TYPE__LOCAL_NAME);
		createEAttribute(propertyNameTypeEClass, PROPERTY_NAME_TYPE__NAMESPACE);

		propertySetTypeEClass = createEClass(PROPERTY_SET_TYPE);
		createEAttribute(propertySetTypeEClass, PROPERTY_SET_TYPE__ANY);
		createEAttribute(propertySetTypeEClass, PROPERTY_SET_TYPE__NAMESPACE);
		createEAttribute(propertySetTypeEClass, PROPERTY_SET_TYPE__LOCAL_NAME);

		propertyValueTypeEClass = createEClass(PROPERTY_VALUE_TYPE);
		createEReference(propertyValueTypeEClass, PROPERTY_VALUE_TYPE__EQUAL);
		createEReference(propertyValueTypeEClass, PROPERTY_VALUE_TYPE__LESS);
		createEReference(propertyValueTypeEClass, PROPERTY_VALUE_TYPE__LESS_OR_EQUAL);
		createEReference(propertyValueTypeEClass, PROPERTY_VALUE_TYPE__GREATER);
		createEReference(propertyValueTypeEClass, PROPERTY_VALUE_TYPE__GREATER_OR_EQUAL);
		createEReference(propertyValueTypeEClass, PROPERTY_VALUE_TYPE__CONTAINS);
		createEReference(propertyValueTypeEClass, PROPERTY_VALUE_TYPE__LIKE);
		createEReference(propertyValueTypeEClass, PROPERTY_VALUE_TYPE__IS_NULL);
		createEAttribute(propertyValueTypeEClass, PROPERTY_VALUE_TYPE__ANY);
		createEAttribute(propertyValueTypeEClass, PROPERTY_VALUE_TYPE__NAMESPACE);
		createEAttribute(propertyValueTypeEClass, PROPERTY_VALUE_TYPE__LOCAL_NAME);
		createEAttribute(propertyValueTypeEClass, PROPERTY_VALUE_TYPE__RECORD_METADATA);
		createEAttribute(propertyValueTypeEClass, PROPERTY_VALUE_TYPE__MATCH_ANY);
		createEReference(propertyValueTypeEClass, PROPERTY_VALUE_TYPE__PARENT);
		createEOperation(propertyValueTypeEClass, PROPERTY_VALUE_TYPE___ADD_EQUAL__OBJECT);
		createEOperation(propertyValueTypeEClass, PROPERTY_VALUE_TYPE___ADD_LESS__OBJECT);
		createEOperation(propertyValueTypeEClass, PROPERTY_VALUE_TYPE___ADD_LESS_OR_EQUAL__OBJECT);
		createEOperation(propertyValueTypeEClass, PROPERTY_VALUE_TYPE___ADD_GREATER__OBJECT);
		createEOperation(propertyValueTypeEClass, PROPERTY_VALUE_TYPE___ADD_GREATER_OR_EQUAL__OBJECT);
		createEOperation(propertyValueTypeEClass, PROPERTY_VALUE_TYPE___ADD_CONTAINS__STRING);
		createEOperation(propertyValueTypeEClass, PROPERTY_VALUE_TYPE___ADD_LIKE__STRING);
		createEOperation(propertyValueTypeEClass, PROPERTY_VALUE_TYPE___ADD_IS_NULL);

		qNameTypeEClass = createEClass(QNAME_TYPE);
		createEAttribute(qNameTypeEClass, QNAME_TYPE__NAMESPACE);
		createEAttribute(qNameTypeEClass, QNAME_TYPE__LOCAL_NAME);

		queryErrorFaultTypeEClass = createEClass(QUERY_ERROR_FAULT_TYPE);
		createEAttribute(queryErrorFaultTypeEClass, QUERY_ERROR_FAULT_TYPE__ANY);

		queryResultTypeEClass = createEClass(QUERY_RESULT_TYPE);
		createEReference(queryResultTypeEClass, QUERY_RESULT_TYPE__NODES);
		createEReference(queryResultTypeEClass, QUERY_RESULT_TYPE__EDGES);

		queryTypeEClass = createEClass(QUERY_TYPE);
		createEReference(queryTypeEClass, QUERY_TYPE__ITEM_TEMPLATE);
		createEReference(queryTypeEClass, QUERY_TYPE__RELATIONSHIP_TEMPLATE);
		createEAttribute(queryTypeEClass, QUERY_TYPE__MDR_ID);
		createEReference(queryTypeEClass, QUERY_TYPE__MODEL_METADATA);
		createEOperation(queryTypeEClass, QUERY_TYPE___ADD_ITEM_TEMPLATE__STRING);
		createEOperation(queryTypeEClass, QUERY_TYPE___ADD_RELATIONSHIP_TEMPLATE__STRING);
		createEOperation(queryTypeEClass, QUERY_TYPE___GET_NAMESPACE__STRING);
		createEOperation(queryTypeEClass, QUERY_TYPE___GET_LOCAL_NAME__STRING);

		recordConstraintTypeEClass = createEClass(RECORD_CONSTRAINT_TYPE);
		createEReference(recordConstraintTypeEClass, RECORD_CONSTRAINT_TYPE__RECORD_TYPE);
		createEReference(recordConstraintTypeEClass, RECORD_CONSTRAINT_TYPE__PROPERTY_VALUE);
		createEReference(recordConstraintTypeEClass, RECORD_CONSTRAINT_TYPE__XPATH_CONSTRAINT);
		createEAttribute(recordConstraintTypeEClass, RECORD_CONSTRAINT_TYPE__ANY);
		createEReference(recordConstraintTypeEClass, RECORD_CONSTRAINT_TYPE__PARENT);
		createEOperation(recordConstraintTypeEClass, RECORD_CONSTRAINT_TYPE___ADD_RECORD_TYPE__STRING);
		createEOperation(recordConstraintTypeEClass, RECORD_CONSTRAINT_TYPE___ADD_RECORD_TYPE__STRING_STRING);
		createEOperation(recordConstraintTypeEClass, RECORD_CONSTRAINT_TYPE___ADD_PROPERTY_VALUE__STRING);
		createEOperation(recordConstraintTypeEClass, RECORD_CONSTRAINT_TYPE___ADD_PROPERTY_VALUE__STRING_STRING);

		recordMetadataTypeEClass = createEClass(RECORD_METADATA_TYPE);
		createEAttribute(recordMetadataTypeEClass, RECORD_METADATA_TYPE__RECORD_ID);
		createEAttribute(recordMetadataTypeEClass, RECORD_METADATA_TYPE__LAST_MODIFIED);
		createEAttribute(recordMetadataTypeEClass, RECORD_METADATA_TYPE__BASELINE_ID);
		createEAttribute(recordMetadataTypeEClass, RECORD_METADATA_TYPE__SNAPSHOT_ID);
		createEAttribute(recordMetadataTypeEClass, RECORD_METADATA_TYPE__ANY);

		recordTypeEClass = createEClass(RECORD_TYPE);
		createEAttribute(recordTypeEClass, RECORD_TYPE__ANY);
		createEReference(recordTypeEClass, RECORD_TYPE__PROPERTY_SET);
		createEReference(recordTypeEClass, RECORD_TYPE__RECORD_METADATA);
		createEReference(recordTypeEClass, RECORD_TYPE__PARENT);
		createEAttribute(recordTypeEClass, RECORD_TYPE__TEMPLATE_ID);
		createEAttribute(recordTypeEClass, RECORD_TYPE__RECORD_ID);
		createEAttribute(recordTypeEClass, RECORD_TYPE__LAST_MODIFIED);
		createEReference(recordTypeEClass, RECORD_TYPE__TYPE);
		createEReference(recordTypeEClass, RECORD_TYPE__CONTENT);
		createEAttribute(recordTypeEClass, RECORD_TYPE__PROPERTY_NAME);
		createEOperation(recordTypeEClass, RECORD_TYPE___GET__STRING);
		createEOperation(recordTypeEClass, RECORD_TYPE___SET__STRING_OBJECT);
		createEOperation(recordTypeEClass, RECORD_TYPE___UNSET__STRING);
		createEOperation(recordTypeEClass, RECORD_TYPE___IS_SET__STRING);
		createEOperation(recordTypeEClass, RECORD_TYPE___HAS__STRING);
		createEOperation(recordTypeEClass, RECORD_TYPE___GET_AS_STRING__STRING);
		createEOperation(recordTypeEClass, RECORD_TYPE___SET_AS_STRING__STRING_STRING);
		createEOperation(recordTypeEClass, RECORD_TYPE___INSTANCE_OF__STRING);
		createEOperation(recordTypeEClass, RECORD_TYPE___INSTANCE_OF__STRING_STRING);
		createEOperation(recordTypeEClass, RECORD_TYPE___INSTANCE_OF__MODELRECORDTYPE);
		createEOperation(recordTypeEClass, RECORD_TYPE___MERGE__RECORDTYPE);

		recordTypeTypeEClass = createEClass(RECORD_TYPE_TYPE);
		createEAttribute(recordTypeTypeEClass, RECORD_TYPE_TYPE__LOCAL_NAME);
		createEAttribute(recordTypeTypeEClass, RECORD_TYPE_TYPE__NAMESPACE);

		registerInstanceResponseTypeEClass = createEClass(REGISTER_INSTANCE_RESPONSE_TYPE);
		createEReference(registerInstanceResponseTypeEClass, REGISTER_INSTANCE_RESPONSE_TYPE__ACCEPTED);

		registerRequestTypeEClass = createEClass(REGISTER_REQUEST_TYPE);
		createEAttribute(registerRequestTypeEClass, REGISTER_REQUEST_TYPE__MDR_ID);
		createEReference(registerRequestTypeEClass, REGISTER_REQUEST_TYPE__ITEM_LIST);
		createEReference(registerRequestTypeEClass, REGISTER_REQUEST_TYPE__RELATIONSHIP_LIST);
		createEReference(registerRequestTypeEClass, REGISTER_REQUEST_TYPE__PARENT);

		registerResponseTypeEClass = createEClass(REGISTER_RESPONSE_TYPE);
		createEReference(registerResponseTypeEClass, REGISTER_RESPONSE_TYPE__REGISTER_INSTANCE_RESPONSE);

		registrationErrorFaultTypeEClass = createEClass(REGISTRATION_ERROR_FAULT_TYPE);
		createEAttribute(registrationErrorFaultTypeEClass, REGISTRATION_ERROR_FAULT_TYPE__RECORD_ID);

		relationshipListTypeEClass = createEClass(RELATIONSHIP_LIST_TYPE);
		createEReference(relationshipListTypeEClass, RELATIONSHIP_LIST_TYPE__RELATIONSHIP);
		createEOperation(relationshipListTypeEClass, RELATIONSHIP_LIST_TYPE___FIND__MDRSCOPEDIDTYPE);
		createEOperation(relationshipListTypeEClass, RELATIONSHIP_LIST_TYPE___FIND__RELATIONSHIPTYPE);

		relationshipRefTypeEClass = createEClass(RELATIONSHIP_REF_TYPE);
		createEAttribute(relationshipRefTypeEClass, RELATIONSHIP_REF_TYPE__REF);
		createEAttribute(relationshipRefTypeEClass, RELATIONSHIP_REF_TYPE__MINIMUM);
		createEAttribute(relationshipRefTypeEClass, RELATIONSHIP_REF_TYPE__MAXIMUM);

		relationshipTemplateTypeEClass = createEClass(RELATIONSHIP_TEMPLATE_TYPE);
		createEReference(relationshipTemplateTypeEClass, RELATIONSHIP_TEMPLATE_TYPE__SOURCE_TEMPLATE);
		createEReference(relationshipTemplateTypeEClass, RELATIONSHIP_TEMPLATE_TYPE__TARGET_TEMPLATE);
		createEReference(relationshipTemplateTypeEClass, RELATIONSHIP_TEMPLATE_TYPE__DEPTH_LIMIT);
		createEOperation(relationshipTemplateTypeEClass, RELATIONSHIP_TEMPLATE_TYPE___ADD_SOURCE_TEMPLATE__ITEMTEMPLATETYPE);
		createEOperation(relationshipTemplateTypeEClass, RELATIONSHIP_TEMPLATE_TYPE___ADD_TARGET_TEMPLATE__ITEMTEMPLATETYPE);
		createEOperation(relationshipTemplateTypeEClass, RELATIONSHIP_TEMPLATE_TYPE___ADD_DEPTH_LIMIT__ITEMTEMPLATETYPE);

		relationshipTypeEClass = createEClass(RELATIONSHIP_TYPE);
		createEReference(relationshipTypeEClass, RELATIONSHIP_TYPE__SOURCE_ITEM);
		createEReference(relationshipTypeEClass, RELATIONSHIP_TYPE__TARGET_ITEM);

		selectedRecordTypeTypeEClass = createEClass(SELECTED_RECORD_TYPE_TYPE);
		createEReference(selectedRecordTypeTypeEClass, SELECTED_RECORD_TYPE_TYPE__SELECTED_PROPERTY);
		createEAttribute(selectedRecordTypeTypeEClass, SELECTED_RECORD_TYPE_TYPE__NAMESPACE);
		createEAttribute(selectedRecordTypeTypeEClass, SELECTED_RECORD_TYPE_TYPE__LOCAL_NAME);
		createEReference(selectedRecordTypeTypeEClass, SELECTED_RECORD_TYPE_TYPE__PARENT);
		createEOperation(selectedRecordTypeTypeEClass, SELECTED_RECORD_TYPE_TYPE___ADD_SELECTED_PROPERTY__STRING);
		createEOperation(selectedRecordTypeTypeEClass, SELECTED_RECORD_TYPE_TYPE___ADD_SELECTED_PROPERTY__STRING_STRING);

		selectorTypeEClass = createEClass(SELECTOR_TYPE);
		createEAttribute(selectorTypeEClass, SELECTOR_TYPE__LOCAL_NAME);
		createEAttribute(selectorTypeEClass, SELECTOR_TYPE__NAMESPACE);

		stringOperatorTypeEClass = createEClass(STRING_OPERATOR_TYPE);
		createEAttribute(stringOperatorTypeEClass, STRING_OPERATOR_TYPE__VALUE);
		createEAttribute(stringOperatorTypeEClass, STRING_OPERATOR_TYPE__CASE_SENSITIVE);
		createEAttribute(stringOperatorTypeEClass, STRING_OPERATOR_TYPE__NEGATE);

		unknownTemplateIDFaultTypeEClass = createEClass(UNKNOWN_TEMPLATE_ID_FAULT_TYPE);
		createEAttribute(unknownTemplateIDFaultTypeEClass, UNKNOWN_TEMPLATE_ID_FAULT_TYPE__GRAPH_ID);

		unsupportedConstraintFaultTypeEClass = createEClass(UNSUPPORTED_CONSTRAINT_FAULT_TYPE);
		createEReference(unsupportedConstraintFaultTypeEClass, UNSUPPORTED_CONSTRAINT_FAULT_TYPE__CONSTRAINT);

		unsupportedRecordTypeFaultTypeEClass = createEClass(UNSUPPORTED_RECORD_TYPE_FAULT_TYPE);
		createEReference(unsupportedRecordTypeFaultTypeEClass, UNSUPPORTED_RECORD_TYPE_FAULT_TYPE__RECORD_TYPE);

		unsupportedSelectorFaultTypeEClass = createEClass(UNSUPPORTED_SELECTOR_FAULT_TYPE);
		createEReference(unsupportedSelectorFaultTypeEClass, UNSUPPORTED_SELECTOR_FAULT_TYPE__SELECTOR);

		xPathErrorFaultTypeEClass = createEClass(XPATH_ERROR_FAULT_TYPE);
		createEAttribute(xPathErrorFaultTypeEClass, XPATH_ERROR_FAULT_TYPE__EXPRESSION);
		createEAttribute(xPathErrorFaultTypeEClass, XPATH_ERROR_FAULT_TYPE__XPATH_ERROR_CODE);

		xPathExpressionTypeEClass = createEClass(XPATH_EXPRESSION_TYPE);
		createEReference(xPathExpressionTypeEClass, XPATH_EXPRESSION_TYPE__PREFIX_MAPPING);
		createEAttribute(xPathExpressionTypeEClass, XPATH_EXPRESSION_TYPE__EXPRESSION);
		createEAttribute(xPathExpressionTypeEClass, XPATH_EXPRESSION_TYPE__DIALECT);

		modelElementEClass = createEClass(MODEL_ELEMENT);
		createEReference(modelElementEClass, MODEL_ELEMENT__RECORD);
		createEReference(modelElementEClass, MODEL_ELEMENT__INSTANCE_ID);
		createEReference(modelElementEClass, MODEL_ELEMENT__ADDITIONAL_RECORD_TYPE);
		createEAttribute(modelElementEClass, MODEL_ELEMENT__TEMPLATE_ID);
		createEReference(modelElementEClass, MODEL_ELEMENT__PARENT);
		createEAttribute(modelElementEClass, MODEL_ELEMENT__DEREGISTER);
		createEOperation(modelElementEClass, MODEL_ELEMENT___FIND_INSTANCE_ID);
		createEOperation(modelElementEClass, MODEL_ELEMENT___FIND_INSTANCE_ID__STRING);
		createEOperation(modelElementEClass, MODEL_ELEMENT___ADD_INSTANCE_ID__STRING);
		createEOperation(modelElementEClass, MODEL_ELEMENT___ADD_INSTANCE_ID__STRING_STRING);
		createEOperation(modelElementEClass, MODEL_ELEMENT___ADD_ADDITIONAL_RECORD_TYPE__STRING);
		createEOperation(modelElementEClass, MODEL_ELEMENT___ADD_ADDITIONAL_RECORD_TYPE__STRING_STRING);
		createEOperation(modelElementEClass, MODEL_ELEMENT___ADD_RECORD__STRING);
		createEOperation(modelElementEClass, MODEL_ELEMENT___ADD_RECORD__STRING_STRING);
		createEOperation(modelElementEClass, MODEL_ELEMENT___ADD_RECORD__STRING_BOOLEAN);
		createEOperation(modelElementEClass, MODEL_ELEMENT___ADD_RECORD__STRING_STRING_BOOLEAN);
		createEOperation(modelElementEClass, MODEL_ELEMENT___FIND_RECORD__STRING);
		createEOperation(modelElementEClass, MODEL_ELEMENT___FIND_RECORD__STRING_STRING);
		createEOperation(modelElementEClass, MODEL_ELEMENT___FIND_RECORD_BY_TEMPLATE__STRING_STRING);
		createEOperation(modelElementEClass, MODEL_ELEMENT___FIND_RECORD_BY_TEMPLATE__STRING_STRING_STRING);
		createEOperation(modelElementEClass, MODEL_ELEMENT___FIND_RECORD_BY_ID__STRING);
		createEOperation(modelElementEClass, MODEL_ELEMENT___MERGE__MODELELEMENT);

		modelTemplateEClass = createEClass(MODEL_TEMPLATE);
		createEReference(modelTemplateEClass, MODEL_TEMPLATE__CONTENT_SELECTOR);
		createEReference(modelTemplateEClass, MODEL_TEMPLATE__INSTANCE_ID_CONSTRAINT);
		createEReference(modelTemplateEClass, MODEL_TEMPLATE__RECORD_CONSTRAINT);
		createEAttribute(modelTemplateEClass, MODEL_TEMPLATE__ANY);
		createEAttribute(modelTemplateEClass, MODEL_TEMPLATE__ID);
		createEAttribute(modelTemplateEClass, MODEL_TEMPLATE__SUPPRESS_FROM_RESULT);
		createEReference(modelTemplateEClass, MODEL_TEMPLATE__QUERY);
		createEOperation(modelTemplateEClass, MODEL_TEMPLATE___ADD_INSTANCE_ID_CONSTRAINT__STRING);
		createEOperation(modelTemplateEClass, MODEL_TEMPLATE___ADD_INSTANCE_ID_CONSTRAINT__STRING_STRING);
		createEOperation(modelTemplateEClass, MODEL_TEMPLATE___ADD_RECORD_CONSTRAINT);
		createEOperation(modelTemplateEClass, MODEL_TEMPLATE___ADD_CONTENT_SELECTOR__STRING);
		createEOperation(modelTemplateEClass, MODEL_TEMPLATE___ADD_CONTENT_SELECTOR__STRING_STRING);

		modelUpdateInstanceResponseEClass = createEClass(MODEL_UPDATE_INSTANCE_RESPONSE);
		createEReference(modelUpdateInstanceResponseEClass, MODEL_UPDATE_INSTANCE_RESPONSE__INSTANCE_ID);
		createEReference(modelUpdateInstanceResponseEClass, MODEL_UPDATE_INSTANCE_RESPONSE__DECLINED);

		modelUpdateResponseEClass = createEClass(MODEL_UPDATE_RESPONSE);
		createEReference(modelUpdateResponseEClass, MODEL_UPDATE_RESPONSE__INSTANCE_RESPONSE);

		modelRecordTypeEClass = createEClass(MODEL_RECORD_TYPE);
		createEAttribute(modelRecordTypeEClass, MODEL_RECORD_TYPE__LOCAL_NAME);
		createEAttribute(modelRecordTypeEClass, MODEL_RECORD_TYPE__NAMESPACE);
		createEAttribute(modelRecordTypeEClass, MODEL_RECORD_TYPE__APPLIES_TO_ITEM);
		createEAttribute(modelRecordTypeEClass, MODEL_RECORD_TYPE__APPLIES_TO_RELATIONSHIP);
		createEReference(modelRecordTypeEClass, MODEL_RECORD_TYPE__SUPER_TYPE);
		createEOperation(modelRecordTypeEClass, MODEL_RECORD_TYPE___IS_ASSIGNABLE_FROM__MODELRECORDTYPE);

		modelEClass = createEClass(MODEL);
		createEReference(modelEClass, MODEL__REGISTER);
		createEReference(modelEClass, MODEL__DEREGISTER);
		createEReference(modelEClass, MODEL__ITEM);
		createEReference(modelEClass, MODEL__RELATIONSHIP);
		createEReference(modelEClass, MODEL__MODEL_METADATA);
		createEAttribute(modelEClass, MODEL__MDR_ID);
		createEReference(modelEClass, MODEL__REMOVED_ITEM_ID);
		createEReference(modelEClass, MODEL__REMOVED_RELATIONSHIP_ID);
		createEOperation(modelEClass, MODEL___ADD_ITEM);
		createEOperation(modelEClass, MODEL___ADD_RELATIONSHIP);
		createEOperation(modelEClass, MODEL___GET_ITEM_BY_TEMPLATE__STRING);
		createEOperation(modelEClass, MODEL___GET_RELATIONSHIP_BY_TEMPLATE__STRING);
		createEOperation(modelEClass, MODEL___FIND_ITEM__MDRSCOPEDIDTYPE);
		createEOperation(modelEClass, MODEL___FIND_ITEM__ITEMTYPE);
		createEOperation(modelEClass, MODEL___FIND_ITEM__STRING_STRING);
		createEOperation(modelEClass, MODEL___FIND_RELATIONSHIP__MDRSCOPEDIDTYPE);
		createEOperation(modelEClass, MODEL___FIND_RELATIONSHIP__RELATIONSHIPTYPE);
		createEOperation(modelEClass, MODEL___FIND_RELATIONSHIP__STRING_STRING);
		createEOperation(modelEClass, MODEL___REMOVE__ITEMTYPE);
		createEOperation(modelEClass, MODEL___REMOVE__RELATIONSHIPTYPE);

		modelMetadataEClass = createEClass(MODEL_METADATA);
		createEOperation(modelMetadataEClass, MODEL_METADATA___GET_ELEMENT__STRING_STRING);
		createEOperation(modelMetadataEClass, MODEL_METADATA___GET_NAMESPACE__ECLASSIFIER);
		createEOperation(modelMetadataEClass, MODEL_METADATA___GET_LOCAL_NAME__ECLASSIFIER);
		createEOperation(modelMetadataEClass, MODEL_METADATA___GET_RECORD_TYPE__STRING_STRING);
		createEOperation(modelMetadataEClass, MODEL_METADATA___GET_NAMESPACE__STRING);
		createEOperation(modelMetadataEClass, MODEL_METADATA___GET_LOCAL_NAME__STRING);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private boolean isInitialized = false;

	/**
	 * Complete the initialization of the package and its meta-model.  This
	 * method is guarded to have no affect on any invocation but its first.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void initializePackageContents() {
		if (isInitialized) return;
		isInitialized = true;

		// Initialize package
		setName(eNAME);
		setNsPrefix(eNS_PREFIX);
		setNsURI(eNS_URI);

		// Obtain other dependent packages
		XMLTypePackage theXMLTypePackage = (XMLTypePackage)EPackage.Registry.INSTANCE.getEPackage(XMLTypePackage.eNS_URI);

		// Create type parameters

		// Set bounds for type parameters

		// Add supertypes to classes
		deregisterInstanceResponseTypeEClass.getESuperTypes().add(this.getModelUpdateInstanceResponse());
		itemTemplateTypeEClass.getESuperTypes().add(this.getModelTemplate());
		itemTypeEClass.getESuperTypes().add(this.getModelElement());
		registerInstanceResponseTypeEClass.getESuperTypes().add(this.getModelUpdateInstanceResponse());
		relationshipTemplateTypeEClass.getESuperTypes().add(this.getModelTemplate());
		relationshipTypeEClass.getESuperTypes().add(this.getModelElement());

		// Initialize classes, features, and operations; add parameters
		initEClass(acceptedTypeEClass, AcceptedType.class, "AcceptedType", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getAcceptedType_AlternateInstanceId(), this.getMdrScopedIdType(), null, "alternateInstanceId", null, 0, -1, AcceptedType.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(comparisonOperatorTypeEClass, ComparisonOperatorType.class, "ComparisonOperatorType", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getComparisonOperatorType_Value(), theXMLTypePackage.getAnySimpleType(), "value", null, 0, 1, ComparisonOperatorType.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getComparisonOperatorType_Negate(), theXMLTypePackage.getBoolean(), "negate", "false", 0, 1, ComparisonOperatorType.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(constraintTypeEClass, ConstraintType.class, "ConstraintType", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getConstraintType_LocalName(), theXMLTypePackage.getNCName(), "localName", null, 1, 1, ConstraintType.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getConstraintType_Namespace(), theXMLTypePackage.getAnyURI(), "namespace", null, 1, 1, ConstraintType.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(contentSelectorTypeEClass, ContentSelectorType.class, "ContentSelectorType", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getContentSelectorType_SelectedRecordType(), this.getSelectedRecordTypeType(), this.getSelectedRecordTypeType_Parent(), "selectedRecordType", null, 0, -1, ContentSelectorType.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getContentSelectorType_XpathSelector(), this.getXPathExpressionType(), null, "xpathSelector", null, 0, 1, ContentSelectorType.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getContentSelectorType_Any(), ecorePackage.getEFeatureMapEntry(), "any", null, 0, -1, ContentSelectorType.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, !IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getContentSelectorType_Parent(), this.getModelTemplate(), this.getModelTemplate_ContentSelector(), "parent", null, 0, 1, ContentSelectorType.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(declinedTypeEClass, DeclinedType.class, "DeclinedType", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getDeclinedType_Reason(), theXMLTypePackage.getString(), "reason", null, 0, -1, DeclinedType.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, !IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(depthLimitTypeEClass, DepthLimitType.class, "DepthLimitType", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getDepthLimitType_MaxIntermediateItems(), theXMLTypePackage.getPositiveInteger(), "maxIntermediateItems", null, 0, 1, DepthLimitType.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getDepthLimitType_IntermediateItemTemplate(), theXMLTypePackage.getIDREF(), "intermediateItemTemplate", null, 0, 1, DepthLimitType.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(deregisterInstanceResponseTypeEClass, DeregisterInstanceResponseType.class, "DeregisterInstanceResponseType", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getDeregisterInstanceResponseType_Accepted(), theXMLTypePackage.getString(), "accepted", null, 0, 1, DeregisterInstanceResponseType.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(deregisterRequestTypeEClass, DeregisterRequestType.class, "DeregisterRequestType", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getDeregisterRequestType_MdrId(), theXMLTypePackage.getAnyURI(), "mdrId", null, 1, 1, DeregisterRequestType.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getDeregisterRequestType_ItemIdList(), this.getMdrScopedIdListType(), null, "itemIdList", null, 0, 1, DeregisterRequestType.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getDeregisterRequestType_RelationshipIdList(), this.getMdrScopedIdListType(), null, "relationshipIdList", null, 0, 1, DeregisterRequestType.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(deregisterResponseTypeEClass, DeregisterResponseType.class, "DeregisterResponseType", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getDeregisterResponseType_DeregisterInstanceResponse(), this.getDeregisterInstanceResponseType(), null, "deregisterInstanceResponse", null, 0, -1, DeregisterResponseType.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(deregistrationErrorFaultTypeEClass, DeregistrationErrorFaultType.class, "DeregistrationErrorFaultType", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getDeregistrationErrorFaultType_RecordId(), theXMLTypePackage.getAnyURI(), "recordId", null, 1, 1, DeregistrationErrorFaultType.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(documentRootEClass, DocumentRoot.class, "DocumentRoot", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getDocumentRoot_Mixed(), ecorePackage.getEFeatureMapEntry(), "mixed", null, 0, -1, null, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, !IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getDocumentRoot_XMLNSPrefixMap(), ecorePackage.getEStringToStringMapEntry(), null, "xMLNSPrefixMap", null, 0, -1, null, IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getDocumentRoot_XSISchemaLocation(), ecorePackage.getEStringToStringMapEntry(), null, "xSISchemaLocation", null, 0, -1, null, IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getDocumentRoot_DeregisterRequest(), this.getDeregisterRequestType(), null, "deregisterRequest", null, 0, -2, null, IS_TRANSIENT, IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, IS_DERIVED, IS_ORDERED);
		initEReference(getDocumentRoot_DeregisterResponse(), this.getDeregisterResponseType(), null, "deregisterResponse", null, 0, -2, null, IS_TRANSIENT, IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, IS_DERIVED, IS_ORDERED);
		initEReference(getDocumentRoot_DeregistrationErrorFault(), this.getDeregistrationErrorFaultType(), null, "deregistrationErrorFault", null, 0, -2, null, IS_TRANSIENT, IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, IS_DERIVED, IS_ORDERED);
		initEReference(getDocumentRoot_ExpensiveQueryErrorFault(), this.getExpensiveQueryErrorFaultType(), null, "expensiveQueryErrorFault", null, 0, -2, null, IS_TRANSIENT, IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, IS_DERIVED, IS_ORDERED);
		initEReference(getDocumentRoot_InstanceId(), this.getMdrScopedIdType(), null, "instanceId", null, 0, -2, null, IS_TRANSIENT, IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, IS_DERIVED, IS_ORDERED);
		initEReference(getDocumentRoot_InvalidMDRFault(), this.getInvalidMDRFaultType(), null, "invalidMDRFault", null, 0, -2, null, IS_TRANSIENT, IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, IS_DERIVED, IS_ORDERED);
		initEReference(getDocumentRoot_InvalidPropertyTypeFault(), this.getInvalidPropertyTypeFaultType(), null, "invalidPropertyTypeFault", null, 0, -2, null, IS_TRANSIENT, IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, IS_DERIVED, IS_ORDERED);
		initEReference(getDocumentRoot_InvalidRecordFault(), this.getInvalidRecordFaultType(), null, "invalidRecordFault", null, 0, -2, null, IS_TRANSIENT, IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, IS_DERIVED, IS_ORDERED);
		initEReference(getDocumentRoot_Item(), this.getItemType(), null, "item", null, 0, -2, null, IS_TRANSIENT, IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, IS_DERIVED, IS_ORDERED);
		initEReference(getDocumentRoot_PropertySet(), this.getPropertySetType(), null, "propertySet", null, 0, -2, null, IS_TRANSIENT, IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, IS_DERIVED, IS_ORDERED);
		initEReference(getDocumentRoot_Query(), this.getQueryType(), null, "query", null, 0, -2, null, IS_TRANSIENT, IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, IS_DERIVED, IS_ORDERED);
		initEReference(getDocumentRoot_QueryErrorFault(), this.getQueryErrorFaultType(), null, "queryErrorFault", null, 0, -2, null, IS_TRANSIENT, IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, IS_DERIVED, IS_ORDERED);
		initEReference(getDocumentRoot_QueryResult(), this.getQueryResultType(), null, "queryResult", null, 0, -2, null, IS_TRANSIENT, IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, IS_DERIVED, IS_ORDERED);
		initEReference(getDocumentRoot_Record(), this.getRecordType(), null, "record", null, 0, -2, null, IS_TRANSIENT, IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, IS_DERIVED, IS_ORDERED);
		initEReference(getDocumentRoot_RegisterRequest(), this.getRegisterRequestType(), null, "registerRequest", null, 0, -2, null, IS_TRANSIENT, IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, IS_DERIVED, IS_ORDERED);
		initEReference(getDocumentRoot_RegisterResponse(), this.getRegisterResponseType(), null, "registerResponse", null, 0, -2, null, IS_TRANSIENT, IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, IS_DERIVED, IS_ORDERED);
		initEReference(getDocumentRoot_RegistrationErrorFault(), this.getRegistrationErrorFaultType(), null, "registrationErrorFault", null, 0, -2, null, IS_TRANSIENT, IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, IS_DERIVED, IS_ORDERED);
		initEReference(getDocumentRoot_Relationship(), this.getRelationshipType(), null, "relationship", null, 0, -2, null, IS_TRANSIENT, IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, IS_DERIVED, IS_ORDERED);
		initEReference(getDocumentRoot_UnknownTemplateIDFault(), this.getUnknownTemplateIDFaultType(), null, "unknownTemplateIDFault", null, 0, -2, null, IS_TRANSIENT, IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, IS_DERIVED, IS_ORDERED);
		initEReference(getDocumentRoot_UnsupportedConstraintFault(), this.getUnsupportedConstraintFaultType(), null, "unsupportedConstraintFault", null, 0, -2, null, IS_TRANSIENT, IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, IS_DERIVED, IS_ORDERED);
		initEReference(getDocumentRoot_UnsupportedRecordTypeFault(), this.getUnsupportedRecordTypeFaultType(), null, "unsupportedRecordTypeFault", null, 0, -2, null, IS_TRANSIENT, IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, IS_DERIVED, IS_ORDERED);
		initEReference(getDocumentRoot_UnsupportedSelectorFault(), this.getUnsupportedSelectorFaultType(), null, "unsupportedSelectorFault", null, 0, -2, null, IS_TRANSIENT, IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, IS_DERIVED, IS_ORDERED);
		initEReference(getDocumentRoot_XPathErrorFault(), this.getXPathErrorFaultType(), null, "xPathErrorFault", null, 0, -2, null, IS_TRANSIENT, IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, IS_DERIVED, IS_ORDERED);
		initEReference(getDocumentRoot_Model(), this.getModel(), null, "model", null, 0, -2, null, IS_TRANSIENT, IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, IS_DERIVED, IS_ORDERED);

		initEClass(edgesTypeEClass, EdgesType.class, "EdgesType", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getEdgesType_Relationship(), this.getRelationshipType(), null, "relationship", null, 1, -1, EdgesType.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getEdgesType_TemplateId(), theXMLTypePackage.getID(), "templateId", null, 1, 1, EdgesType.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(equalOperatorTypeEClass, EqualOperatorType.class, "EqualOperatorType", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getEqualOperatorType_Value(), theXMLTypePackage.getAnySimpleType(), "value", null, 0, 1, EqualOperatorType.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getEqualOperatorType_CaseSensitive(), theXMLTypePackage.getBoolean(), "caseSensitive", "true", 0, 1, EqualOperatorType.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getEqualOperatorType_Negate(), theXMLTypePackage.getBoolean(), "negate", "false", 0, 1, EqualOperatorType.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(expensiveQueryErrorFaultTypeEClass, ExpensiveQueryErrorFaultType.class, "ExpensiveQueryErrorFaultType", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getExpensiveQueryErrorFaultType_Any(), ecorePackage.getEFeatureMapEntry(), "any", null, 1, 1, ExpensiveQueryErrorFaultType.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(instanceIdConstraintTypeEClass, InstanceIdConstraintType.class, "InstanceIdConstraintType", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getInstanceIdConstraintType_InstanceId(), this.getMdrScopedIdType(), null, "instanceId", null, 1, -1, InstanceIdConstraintType.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(invalidMDRFaultTypeEClass, InvalidMDRFaultType.class, "InvalidMDRFaultType", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getInvalidMDRFaultType_MdrId(), theXMLTypePackage.getAnyURI(), "mdrId", null, 1, 1, InvalidMDRFaultType.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(invalidPropertyTypeFaultTypeEClass, InvalidPropertyTypeFaultType.class, "InvalidPropertyTypeFaultType", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getInvalidPropertyTypeFaultType_PropertyName(), this.getPropertyNameType(), null, "propertyName", null, 1, 1, InvalidPropertyTypeFaultType.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(invalidRecordFaultTypeEClass, InvalidRecordFaultType.class, "InvalidRecordFaultType", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getInvalidRecordFaultType_RecordId(), theXMLTypePackage.getAnyURI(), "recordId", null, 1, 1, InvalidRecordFaultType.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(itemListTypeEClass, ItemListType.class, "ItemListType", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getItemListType_Item(), this.getItemType(), null, "item", null, 1, -1, ItemListType.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		EOperation op = initEOperation(getItemListType__Find__MdrScopedIdType(), this.getItemType(), "find", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, this.getMdrScopedIdType(), "id", 1, 1, IS_UNIQUE, IS_ORDERED);

		op = initEOperation(getItemListType__Find__ItemType(), this.getItemType(), "find", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, this.getItemType(), "item", 1, 1, IS_UNIQUE, IS_ORDERED);

		initEClass(itemTemplateTypeEClass, ItemTemplateType.class, "ItemTemplateType", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		initEClass(itemTypeEClass, ItemType.class, "ItemType", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getItemType_RelationshipBySource(), this.getRelationshipType(), this.getRelationshipType_SourceItem(), "relationshipBySource", null, 0, -1, ItemType.class, IS_TRANSIENT, !IS_VOLATILE, !IS_CHANGEABLE, !IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getItemType_RelationshipByTarget(), this.getRelationshipType(), this.getRelationshipType_TargetItem(), "relationshipByTarget", null, 0, -1, ItemType.class, IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(mdrScopedIdListTypeEClass, MdrScopedIdListType.class, "MdrScopedIdListType", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getMdrScopedIdListType_InstanceId(), this.getMdrScopedIdType(), null, "instanceId", null, 1, -1, MdrScopedIdListType.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(mdrScopedIdTypeEClass, MdrScopedIdType.class, "MdrScopedIdType", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getMdrScopedIdType_MdrId(), theXMLTypePackage.getAnyURI(), "mdrId", null, 1, 1, MdrScopedIdType.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getMdrScopedIdType_LocalId(), theXMLTypePackage.getAnyURI(), "localId", null, 1, 1, MdrScopedIdType.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		op = initEOperation(getMdrScopedIdType__Init__String(), ecorePackage.getEBoolean(), "init", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, ecorePackage.getEString(), "value", 0, 1, IS_UNIQUE, IS_ORDERED);

		initEClass(nodesTypeEClass, NodesType.class, "NodesType", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getNodesType_Item(), this.getItemType(), null, "item", null, 1, -1, NodesType.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getNodesType_TemplateId(), theXMLTypePackage.getID(), "templateId", null, 1, 1, NodesType.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(nullOperatorTypeEClass, NullOperatorType.class, "NullOperatorType", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getNullOperatorType_Negate(), theXMLTypePackage.getBoolean(), "negate", "false", 0, 1, NullOperatorType.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(prefixMappingTypeEClass, PrefixMappingType.class, "PrefixMappingType", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getPrefixMappingType_Prefix(), theXMLTypePackage.getNCName(), "prefix", null, 1, 1, PrefixMappingType.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getPrefixMappingType_Namespace(), theXMLTypePackage.getAnyURI(), "namespace", null, 1, 1, PrefixMappingType.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(propertyNameTypeEClass, PropertyNameType.class, "PropertyNameType", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getPropertyNameType_LocalName(), theXMLTypePackage.getNCName(), "localName", null, 1, 1, PropertyNameType.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getPropertyNameType_Namespace(), theXMLTypePackage.getAnyURI(), "namespace", null, 1, 1, PropertyNameType.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(propertySetTypeEClass, PropertySetType.class, "PropertySetType", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getPropertySetType_Any(), ecorePackage.getEFeatureMapEntry(), "any", null, 0, -1, PropertySetType.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, !IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getPropertySetType_Namespace(), theXMLTypePackage.getAnyURI(), "namespace", null, 1, 1, PropertySetType.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getPropertySetType_LocalName(), theXMLTypePackage.getNCName(), "localName", null, 1, 1, PropertySetType.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(propertyValueTypeEClass, PropertyValueType.class, "PropertyValueType", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getPropertyValueType_Equal(), this.getEqualOperatorType(), null, "equal", null, 0, -1, PropertyValueType.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getPropertyValueType_Less(), this.getComparisonOperatorType(), null, "less", null, 0, 1, PropertyValueType.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getPropertyValueType_LessOrEqual(), this.getComparisonOperatorType(), null, "lessOrEqual", null, 0, 1, PropertyValueType.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getPropertyValueType_Greater(), this.getComparisonOperatorType(), null, "greater", null, 0, 1, PropertyValueType.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getPropertyValueType_GreaterOrEqual(), this.getComparisonOperatorType(), null, "greaterOrEqual", null, 0, 1, PropertyValueType.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getPropertyValueType_Contains(), this.getStringOperatorType(), null, "contains", null, 0, -1, PropertyValueType.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getPropertyValueType_Like(), this.getStringOperatorType(), null, "like", null, 0, -1, PropertyValueType.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getPropertyValueType_IsNull(), this.getNullOperatorType(), null, "isNull", null, 0, 1, PropertyValueType.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getPropertyValueType_Any(), ecorePackage.getEFeatureMapEntry(), "any", null, 0, -1, PropertyValueType.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, !IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getPropertyValueType_Namespace(), theXMLTypePackage.getAnyURI(), "namespace", null, 1, 1, PropertyValueType.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getPropertyValueType_LocalName(), theXMLTypePackage.getNCName(), "localName", null, 1, 1, PropertyValueType.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getPropertyValueType_RecordMetadata(), theXMLTypePackage.getBoolean(), "recordMetadata", "false", 0, 1, PropertyValueType.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getPropertyValueType_MatchAny(), theXMLTypePackage.getBoolean(), "matchAny", "false", 0, 1, PropertyValueType.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getPropertyValueType_Parent(), this.getRecordConstraintType(), this.getRecordConstraintType_PropertyValue(), "parent", null, 0, 1, PropertyValueType.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		op = initEOperation(getPropertyValueType__AddEqual__Object(), this.getEqualOperatorType(), "addEqual", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, theXMLTypePackage.getAnySimpleType(), "value", 1, 1, IS_UNIQUE, IS_ORDERED);

		op = initEOperation(getPropertyValueType__AddLess__Object(), this.getComparisonOperatorType(), "addLess", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, theXMLTypePackage.getAnySimpleType(), "value", 1, 1, IS_UNIQUE, IS_ORDERED);

		op = initEOperation(getPropertyValueType__AddLessOrEqual__Object(), this.getComparisonOperatorType(), "addLessOrEqual", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, theXMLTypePackage.getAnySimpleType(), "value", 1, 1, IS_UNIQUE, IS_ORDERED);

		op = initEOperation(getPropertyValueType__AddGreater__Object(), this.getComparisonOperatorType(), "addGreater", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, theXMLTypePackage.getAnySimpleType(), "value", 1, 1, IS_UNIQUE, IS_ORDERED);

		op = initEOperation(getPropertyValueType__AddGreaterOrEqual__Object(), this.getComparisonOperatorType(), "addGreaterOrEqual", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, theXMLTypePackage.getAnySimpleType(), "value", 1, 1, IS_UNIQUE, IS_ORDERED);

		op = initEOperation(getPropertyValueType__AddContains__String(), this.getStringOperatorType(), "addContains", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, theXMLTypePackage.getString(), "value", 1, 1, IS_UNIQUE, IS_ORDERED);

		op = initEOperation(getPropertyValueType__AddLike__String(), this.getStringOperatorType(), "addLike", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, theXMLTypePackage.getString(), "value", 1, 1, IS_UNIQUE, IS_ORDERED);

		initEOperation(getPropertyValueType__AddIsNull(), this.getNullOperatorType(), "addIsNull", 0, 1, IS_UNIQUE, IS_ORDERED);

		initEClass(qNameTypeEClass, QNameType.class, "QNameType", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getQNameType_Namespace(), theXMLTypePackage.getAnyURI(), "namespace", null, 1, 1, QNameType.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getQNameType_LocalName(), theXMLTypePackage.getNCName(), "localName", null, 1, 1, QNameType.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(queryErrorFaultTypeEClass, QueryErrorFaultType.class, "QueryErrorFaultType", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getQueryErrorFaultType_Any(), ecorePackage.getEFeatureMapEntry(), "any", null, 1, 1, QueryErrorFaultType.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(queryResultTypeEClass, QueryResultType.class, "QueryResultType", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getQueryResultType_Nodes(), this.getNodesType(), null, "nodes", null, 0, -1, QueryResultType.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getQueryResultType_Edges(), this.getEdgesType(), null, "edges", null, 0, -1, QueryResultType.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(queryTypeEClass, QueryType.class, "QueryType", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getQueryType_ItemTemplate(), this.getItemTemplateType(), null, "itemTemplate", null, 0, -1, QueryType.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getQueryType_RelationshipTemplate(), this.getRelationshipTemplateType(), null, "relationshipTemplate", null, 0, -1, QueryType.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getQueryType_MdrId(), theXMLTypePackage.getAnyURI(), "mdrId", null, 1, 1, QueryType.class, IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getQueryType_ModelMetadata(), this.getModelMetadata(), null, "modelMetadata", null, 0, 1, QueryType.class, IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		op = initEOperation(getQueryType__AddItemTemplate__String(), this.getItemTemplateType(), "addItemTemplate", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, theXMLTypePackage.getID(), "id", 1, 1, IS_UNIQUE, IS_ORDERED);

		op = initEOperation(getQueryType__AddRelationshipTemplate__String(), this.getRelationshipTemplateType(), "addRelationshipTemplate", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, theXMLTypePackage.getID(), "id", 1, 1, IS_UNIQUE, IS_ORDERED);

		op = initEOperation(getQueryType__GetNamespace__String(), theXMLTypePackage.getAnyURI(), "getNamespace", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, ecorePackage.getEString(), "name", 1, 1, IS_UNIQUE, IS_ORDERED);

		op = initEOperation(getQueryType__GetLocalName__String(), theXMLTypePackage.getNCName(), "getLocalName", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, ecorePackage.getEString(), "name", 1, 1, IS_UNIQUE, IS_ORDERED);

		initEClass(recordConstraintTypeEClass, RecordConstraintType.class, "RecordConstraintType", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getRecordConstraintType_RecordType(), this.getQNameType(), null, "recordType", null, 0, -1, RecordConstraintType.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getRecordConstraintType_PropertyValue(), this.getPropertyValueType(), this.getPropertyValueType_Parent(), "propertyValue", null, 0, -1, RecordConstraintType.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getRecordConstraintType_XpathConstraint(), this.getXPathExpressionType(), null, "xpathConstraint", null, 0, 1, RecordConstraintType.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getRecordConstraintType_Any(), ecorePackage.getEFeatureMapEntry(), "any", null, 0, -1, RecordConstraintType.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, !IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getRecordConstraintType_Parent(), this.getModelTemplate(), this.getModelTemplate_RecordConstraint(), "parent", null, 0, 1, RecordConstraintType.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		op = initEOperation(getRecordConstraintType__AddRecordType__String(), this.getQNameType(), "addRecordType", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, theXMLTypePackage.getString(), "type", 1, 1, IS_UNIQUE, IS_ORDERED);

		op = initEOperation(getRecordConstraintType__AddRecordType__String_String(), this.getQNameType(), "addRecordType", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, theXMLTypePackage.getAnyURI(), "namespace", 1, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, theXMLTypePackage.getNCName(), "localName", 1, 1, IS_UNIQUE, IS_ORDERED);

		op = initEOperation(getRecordConstraintType__AddPropertyValue__String(), this.getPropertyValueType(), "addPropertyValue", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, theXMLTypePackage.getString(), "type", 1, 1, IS_UNIQUE, IS_ORDERED);

		op = initEOperation(getRecordConstraintType__AddPropertyValue__String_String(), this.getPropertyValueType(), "addPropertyValue", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, theXMLTypePackage.getAnyURI(), "namespace", 1, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, theXMLTypePackage.getNCName(), "localName", 1, 1, IS_UNIQUE, IS_ORDERED);

		initEClass(recordMetadataTypeEClass, RecordMetadataType.class, "RecordMetadataType", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getRecordMetadataType_RecordId(), theXMLTypePackage.getAnyURI(), "recordId", null, 0, 1, RecordMetadataType.class, !IS_TRANSIENT, IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, IS_DERIVED, IS_ORDERED);
		initEAttribute(getRecordMetadataType_LastModified(), theXMLTypePackage.getDateTime(), "lastModified", null, 0, 1, RecordMetadataType.class, !IS_TRANSIENT, IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, IS_DERIVED, IS_ORDERED);
		initEAttribute(getRecordMetadataType_BaselineId(), theXMLTypePackage.getString(), "baselineId", null, 0, 1, RecordMetadataType.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getRecordMetadataType_SnapshotId(), theXMLTypePackage.getString(), "snapshotId", null, 0, 1, RecordMetadataType.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getRecordMetadataType_Any(), ecorePackage.getEFeatureMapEntry(), "any", null, 0, -1, RecordMetadataType.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, !IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(recordTypeEClass, RecordType.class, "RecordType", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getRecordType_Any(), ecorePackage.getEFeatureMapEntry(), "any", null, 0, 1, RecordType.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getRecordType_PropertySet(), this.getPropertySetType(), null, "propertySet", null, 0, 1, RecordType.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getRecordType_RecordMetadata(), this.getRecordMetadataType(), null, "recordMetadata", null, 0, 1, RecordType.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getRecordType_Parent(), this.getModelElement(), this.getModelElement_Record(), "parent", null, 0, 1, RecordType.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getRecordType_TemplateId(), theXMLTypePackage.getID(), "templateId", null, 0, -1, RecordType.class, IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getRecordType_RecordId(), theXMLTypePackage.getAnyURI(), "recordId", "", 0, 1, RecordType.class, IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getRecordType_LastModified(), theXMLTypePackage.getDateTime(), "lastModified", null, 0, 1, RecordType.class, IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getRecordType_Type(), this.getModelRecordType(), null, "type", null, 0, 1, RecordType.class, IS_TRANSIENT, IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, IS_DERIVED, IS_ORDERED);
		initEReference(getRecordType_Content(), ecorePackage.getEObject(), null, "content", null, 0, 1, RecordType.class, IS_TRANSIENT, IS_VOLATILE, !IS_CHANGEABLE, !IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, IS_DERIVED, IS_ORDERED);
		initEAttribute(getRecordType_PropertyName(), ecorePackage.getEString(), "propertyName", null, 0, -1, RecordType.class, IS_TRANSIENT, IS_VOLATILE, !IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, IS_DERIVED, IS_ORDERED);

		op = initEOperation(getRecordType__Get__String(), theXMLTypePackage.getAnySimpleType(), "get", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, theXMLTypePackage.getString(), "name", 1, 1, IS_UNIQUE, IS_ORDERED);

		op = initEOperation(getRecordType__Set__String_Object(), null, "set", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, theXMLTypePackage.getString(), "name", 1, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, theXMLTypePackage.getAnySimpleType(), "value", 1, 1, IS_UNIQUE, IS_ORDERED);

		op = initEOperation(getRecordType__Unset__String(), null, "unset", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, theXMLTypePackage.getString(), "name", 1, 1, IS_UNIQUE, IS_ORDERED);

		op = initEOperation(getRecordType__IsSet__String(), theXMLTypePackage.getBoolean(), "isSet", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, theXMLTypePackage.getString(), "name", 1, 1, IS_UNIQUE, IS_ORDERED);

		op = initEOperation(getRecordType__Has__String(), ecorePackage.getEBoolean(), "has", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, theXMLTypePackage.getString(), "name", 1, 1, IS_UNIQUE, IS_ORDERED);

		op = initEOperation(getRecordType__GetAsString__String(), theXMLTypePackage.getString(), "getAsString", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, theXMLTypePackage.getString(), "name", 1, 1, IS_UNIQUE, IS_ORDERED);

		op = initEOperation(getRecordType__SetAsString__String_String(), null, "setAsString", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, theXMLTypePackage.getString(), "name", 1, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, theXMLTypePackage.getString(), "value", 1, 1, IS_UNIQUE, IS_ORDERED);

		op = initEOperation(getRecordType__InstanceOf__String(), theXMLTypePackage.getBoolean(), "instanceOf", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, theXMLTypePackage.getString(), "type", 1, 1, IS_UNIQUE, IS_ORDERED);

		op = initEOperation(getRecordType__InstanceOf__String_String(), theXMLTypePackage.getBoolean(), "instanceOf", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, theXMLTypePackage.getAnyURI(), "namespace", 1, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, theXMLTypePackage.getNCName(), "localName", 1, 1, IS_UNIQUE, IS_ORDERED);

		op = initEOperation(getRecordType__InstanceOf__ModelRecordType(), theXMLTypePackage.getBoolean(), "instanceOf", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, this.getModelRecordType(), "superType", 1, 1, IS_UNIQUE, IS_ORDERED);

		op = initEOperation(getRecordType__Merge__RecordType(), theXMLTypePackage.getBoolean(), "merge", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, this.getRecordType(), "element", 1, 1, IS_UNIQUE, IS_ORDERED);

		initEClass(recordTypeTypeEClass, RecordTypeType.class, "RecordTypeType", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getRecordTypeType_LocalName(), theXMLTypePackage.getNCName(), "localName", null, 1, 1, RecordTypeType.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getRecordTypeType_Namespace(), theXMLTypePackage.getAnyURI(), "namespace", null, 1, 1, RecordTypeType.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(registerInstanceResponseTypeEClass, RegisterInstanceResponseType.class, "RegisterInstanceResponseType", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getRegisterInstanceResponseType_Accepted(), this.getAcceptedType(), null, "accepted", null, 0, 1, RegisterInstanceResponseType.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(registerRequestTypeEClass, RegisterRequestType.class, "RegisterRequestType", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getRegisterRequestType_MdrId(), theXMLTypePackage.getAnyURI(), "mdrId", null, 1, 1, RegisterRequestType.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getRegisterRequestType_ItemList(), this.getItemListType(), null, "itemList", null, 0, 1, RegisterRequestType.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getRegisterRequestType_RelationshipList(), this.getRelationshipListType(), null, "relationshipList", null, 0, 1, RegisterRequestType.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getRegisterRequestType_Parent(), this.getModel(), null, "parent", null, 0, 1, RegisterRequestType.class, IS_TRANSIENT, IS_VOLATILE, !IS_CHANGEABLE, !IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, IS_DERIVED, IS_ORDERED);

		initEClass(registerResponseTypeEClass, RegisterResponseType.class, "RegisterResponseType", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getRegisterResponseType_RegisterInstanceResponse(), this.getRegisterInstanceResponseType(), null, "registerInstanceResponse", null, 0, -1, RegisterResponseType.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(registrationErrorFaultTypeEClass, RegistrationErrorFaultType.class, "RegistrationErrorFaultType", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getRegistrationErrorFaultType_RecordId(), theXMLTypePackage.getAnyURI(), "recordId", null, 1, 1, RegistrationErrorFaultType.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(relationshipListTypeEClass, RelationshipListType.class, "RelationshipListType", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getRelationshipListType_Relationship(), this.getRelationshipType(), null, "relationship", null, 1, -1, RelationshipListType.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		op = initEOperation(getRelationshipListType__Find__MdrScopedIdType(), this.getRelationshipType(), "find", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, this.getMdrScopedIdType(), "id", 1, 1, IS_UNIQUE, IS_ORDERED);

		op = initEOperation(getRelationshipListType__Find__RelationshipType(), this.getRelationshipType(), "find", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, this.getRelationshipType(), "relationship", 1, 1, IS_UNIQUE, IS_ORDERED);

		initEClass(relationshipRefTypeEClass, RelationshipRefType.class, "RelationshipRefType", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getRelationshipRefType_Ref(), theXMLTypePackage.getIDREF(), "ref", null, 1, 1, RelationshipRefType.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getRelationshipRefType_Minimum(), theXMLTypePackage.getInt(), "minimum", null, 0, 1, RelationshipRefType.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getRelationshipRefType_Maximum(), theXMLTypePackage.getInt(), "maximum", null, 0, 1, RelationshipRefType.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(relationshipTemplateTypeEClass, RelationshipTemplateType.class, "RelationshipTemplateType", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getRelationshipTemplateType_SourceTemplate(), this.getRelationshipRefType(), null, "sourceTemplate", null, 0, 1, RelationshipTemplateType.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getRelationshipTemplateType_TargetTemplate(), this.getRelationshipRefType(), null, "targetTemplate", null, 0, 1, RelationshipTemplateType.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getRelationshipTemplateType_DepthLimit(), this.getDepthLimitType(), null, "depthLimit", null, 0, 1, RelationshipTemplateType.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		op = initEOperation(getRelationshipTemplateType__AddSourceTemplate__ItemTemplateType(), this.getRelationshipRefType(), "addSourceTemplate", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, this.getItemTemplateType(), "template", 1, 1, IS_UNIQUE, IS_ORDERED);

		op = initEOperation(getRelationshipTemplateType__AddTargetTemplate__ItemTemplateType(), this.getRelationshipRefType(), "addTargetTemplate", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, this.getItemTemplateType(), "template", 1, 1, IS_UNIQUE, IS_ORDERED);

		op = initEOperation(getRelationshipTemplateType__AddDepthLimit__ItemTemplateType(), this.getDepthLimitType(), "addDepthLimit", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, this.getItemTemplateType(), "template", 1, 1, IS_UNIQUE, IS_ORDERED);

		initEClass(relationshipTypeEClass, RelationshipType.class, "RelationshipType", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getRelationshipType_SourceItem(), this.getItemType(), this.getItemType_RelationshipBySource(), "sourceItem", null, 1, 1, RelationshipType.class, IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getRelationshipType_TargetItem(), this.getItemType(), this.getItemType_RelationshipByTarget(), "targetItem", null, 1, 1, RelationshipType.class, IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(selectedRecordTypeTypeEClass, SelectedRecordTypeType.class, "SelectedRecordTypeType", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getSelectedRecordTypeType_SelectedProperty(), this.getQNameType(), null, "selectedProperty", null, 0, -1, SelectedRecordTypeType.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getSelectedRecordTypeType_Namespace(), theXMLTypePackage.getAnyURI(), "namespace", null, 1, 1, SelectedRecordTypeType.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getSelectedRecordTypeType_LocalName(), theXMLTypePackage.getNCName(), "localName", null, 1, 1, SelectedRecordTypeType.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getSelectedRecordTypeType_Parent(), this.getContentSelectorType(), this.getContentSelectorType_SelectedRecordType(), "parent", null, 0, 1, SelectedRecordTypeType.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		op = initEOperation(getSelectedRecordTypeType__AddSelectedProperty__String(), this.getQNameType(), "addSelectedProperty", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, theXMLTypePackage.getString(), "type", 1, 1, IS_UNIQUE, IS_ORDERED);

		op = initEOperation(getSelectedRecordTypeType__AddSelectedProperty__String_String(), this.getQNameType(), "addSelectedProperty", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, theXMLTypePackage.getAnyURI(), "namespace", 1, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, theXMLTypePackage.getNCName(), "localName", 1, 1, IS_UNIQUE, IS_ORDERED);

		initEClass(selectorTypeEClass, SelectorType.class, "SelectorType", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getSelectorType_LocalName(), theXMLTypePackage.getNCName(), "localName", null, 1, 1, SelectorType.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getSelectorType_Namespace(), theXMLTypePackage.getAnyURI(), "namespace", null, 1, 1, SelectorType.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(stringOperatorTypeEClass, StringOperatorType.class, "StringOperatorType", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getStringOperatorType_Value(), theXMLTypePackage.getString(), "value", null, 0, 1, StringOperatorType.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getStringOperatorType_CaseSensitive(), theXMLTypePackage.getBoolean(), "caseSensitive", "true", 0, 1, StringOperatorType.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getStringOperatorType_Negate(), theXMLTypePackage.getBoolean(), "negate", "false", 0, 1, StringOperatorType.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(unknownTemplateIDFaultTypeEClass, UnknownTemplateIDFaultType.class, "UnknownTemplateIDFaultType", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getUnknownTemplateIDFaultType_GraphId(), theXMLTypePackage.getID(), "graphId", null, 1, 1, UnknownTemplateIDFaultType.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(unsupportedConstraintFaultTypeEClass, UnsupportedConstraintFaultType.class, "UnsupportedConstraintFaultType", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getUnsupportedConstraintFaultType_Constraint(), this.getConstraintType(), null, "constraint", null, 1, 1, UnsupportedConstraintFaultType.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(unsupportedRecordTypeFaultTypeEClass, UnsupportedRecordTypeFaultType.class, "UnsupportedRecordTypeFaultType", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getUnsupportedRecordTypeFaultType_RecordType(), this.getRecordTypeType(), null, "recordType", null, 1, 1, UnsupportedRecordTypeFaultType.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(unsupportedSelectorFaultTypeEClass, UnsupportedSelectorFaultType.class, "UnsupportedSelectorFaultType", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getUnsupportedSelectorFaultType_Selector(), this.getSelectorType(), null, "selector", null, 1, 1, UnsupportedSelectorFaultType.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(xPathErrorFaultTypeEClass, XPathErrorFaultType.class, "XPathErrorFaultType", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getXPathErrorFaultType_Expression(), theXMLTypePackage.getString(), "expression", null, 1, 1, XPathErrorFaultType.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getXPathErrorFaultType_XpathErrorCode(), theXMLTypePackage.getString(), "xpathErrorCode", null, 1, 1, XPathErrorFaultType.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(xPathExpressionTypeEClass, XPathExpressionType.class, "XPathExpressionType", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getXPathExpressionType_PrefixMapping(), this.getPrefixMappingType(), null, "prefixMapping", null, 1, -1, XPathExpressionType.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getXPathExpressionType_Expression(), theXMLTypePackage.getString(), "expression", null, 1, 1, XPathExpressionType.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getXPathExpressionType_Dialect(), theXMLTypePackage.getAnyURI(), "dialect", null, 1, 1, XPathExpressionType.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(modelElementEClass, ModelElement.class, "ModelElement", IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getModelElement_Record(), this.getRecordType(), this.getRecordType_Parent(), "record", null, 0, -1, ModelElement.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getModelElement_InstanceId(), this.getMdrScopedIdType(), null, "instanceId", null, 1, -1, ModelElement.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getModelElement_AdditionalRecordType(), this.getQNameType(), null, "additionalRecordType", null, 0, -1, ModelElement.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getModelElement_TemplateId(), theXMLTypePackage.getID(), "templateId", null, 0, -1, ModelElement.class, IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getModelElement_Parent(), this.getRegisterRequestType(), null, "parent", null, 0, 1, ModelElement.class, IS_TRANSIENT, IS_VOLATILE, !IS_CHANGEABLE, !IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, IS_DERIVED, IS_ORDERED);
		initEAttribute(getModelElement_Deregister(), theXMLTypePackage.getBoolean(), "deregister", null, 0, 1, ModelElement.class, IS_TRANSIENT, IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, IS_DERIVED, IS_ORDERED);

		initEOperation(getModelElement__FindInstanceId(), this.getMdrScopedIdType(), "findInstanceId", 0, 1, IS_UNIQUE, IS_ORDERED);

		op = initEOperation(getModelElement__FindInstanceId__String(), this.getMdrScopedIdType(), "findInstanceId", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, theXMLTypePackage.getAnyURI(), "mdrId", 1, 1, IS_UNIQUE, IS_ORDERED);

		op = initEOperation(getModelElement__AddInstanceId__String(), this.getMdrScopedIdType(), "addInstanceId", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, theXMLTypePackage.getAnyURI(), "localId", 1, 1, IS_UNIQUE, IS_ORDERED);

		op = initEOperation(getModelElement__AddInstanceId__String_String(), this.getMdrScopedIdType(), "addInstanceId", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, theXMLTypePackage.getAnyURI(), "mdrId", 1, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, theXMLTypePackage.getAnyURI(), "localId", 1, 1, IS_UNIQUE, IS_ORDERED);

		op = initEOperation(getModelElement__AddAdditionalRecordType__String(), this.getQNameType(), "addAdditionalRecordType", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, theXMLTypePackage.getString(), "type", 1, 1, IS_UNIQUE, IS_ORDERED);

		op = initEOperation(getModelElement__AddAdditionalRecordType__String_String(), this.getQNameType(), "addAdditionalRecordType", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, theXMLTypePackage.getAnyURI(), "namespace", 1, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, theXMLTypePackage.getNCName(), "localName", 1, 1, IS_UNIQUE, IS_ORDERED);

		op = initEOperation(getModelElement__AddRecord__String(), this.getRecordType(), "addRecord", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, theXMLTypePackage.getString(), "type", 1, 1, IS_UNIQUE, IS_ORDERED);

		op = initEOperation(getModelElement__AddRecord__String_String(), this.getRecordType(), "addRecord", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, theXMLTypePackage.getAnyURI(), "namespace", 1, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, theXMLTypePackage.getNCName(), "localName", 1, 1, IS_UNIQUE, IS_ORDERED);

		op = initEOperation(getModelElement__AddRecord__String_boolean(), this.getRecordType(), "addRecord", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, theXMLTypePackage.getString(), "type", 1, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, theXMLTypePackage.getBoolean(), "isPropertySet", 1, 1, IS_UNIQUE, IS_ORDERED);

		op = initEOperation(getModelElement__AddRecord__String_String_boolean(), this.getRecordType(), "addRecord", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, theXMLTypePackage.getAnyURI(), "namespace", 1, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, theXMLTypePackage.getNCName(), "localName", 1, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, theXMLTypePackage.getBoolean(), "isPropertySet", 1, 1, IS_UNIQUE, IS_ORDERED);

		op = initEOperation(getModelElement__FindRecord__String(), this.getRecordType(), "findRecord", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, theXMLTypePackage.getString(), "type", 1, 1, IS_UNIQUE, IS_ORDERED);

		op = initEOperation(getModelElement__FindRecord__String_String(), this.getRecordType(), "findRecord", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, theXMLTypePackage.getAnyURI(), "namespace", 1, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, theXMLTypePackage.getNCName(), "localName", 1, 1, IS_UNIQUE, IS_ORDERED);

		op = initEOperation(getModelElement__FindRecordByTemplate__String_String(), this.getRecordType(), "findRecordByTemplate", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, theXMLTypePackage.getID(), "templateId", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, theXMLTypePackage.getString(), "type", 1, 1, IS_UNIQUE, IS_ORDERED);

		op = initEOperation(getModelElement__FindRecordByTemplate__String_String_String(), this.getRecordType(), "findRecordByTemplate", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, theXMLTypePackage.getID(), "templateId", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, theXMLTypePackage.getAnyURI(), "namespace", 1, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, theXMLTypePackage.getNCName(), "localName", 1, 1, IS_UNIQUE, IS_ORDERED);

		op = initEOperation(getModelElement__FindRecordById__String(), this.getRecordType(), "findRecordById", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, theXMLTypePackage.getString(), "id", 0, 1, IS_UNIQUE, IS_ORDERED);

		op = initEOperation(getModelElement__Merge__ModelElement(), theXMLTypePackage.getBoolean(), "merge", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, this.getModelElement(), "element", 1, 1, IS_UNIQUE, IS_ORDERED);

		initEClass(modelTemplateEClass, ModelTemplate.class, "ModelTemplate", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getModelTemplate_ContentSelector(), this.getContentSelectorType(), this.getContentSelectorType_Parent(), "contentSelector", null, 0, 1, ModelTemplate.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getModelTemplate_InstanceIdConstraint(), this.getInstanceIdConstraintType(), null, "instanceIdConstraint", null, 0, 1, ModelTemplate.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getModelTemplate_RecordConstraint(), this.getRecordConstraintType(), this.getRecordConstraintType_Parent(), "recordConstraint", null, 0, -1, ModelTemplate.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getModelTemplate_Any(), ecorePackage.getEFeatureMapEntry(), "any", null, 0, -1, ModelTemplate.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, !IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getModelTemplate_Id(), theXMLTypePackage.getID(), "id", null, 1, 1, ModelTemplate.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getModelTemplate_SuppressFromResult(), theXMLTypePackage.getBoolean(), "suppressFromResult", "false", 0, 1, ModelTemplate.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getModelTemplate_Query(), this.getQueryType(), null, "query", null, 0, 1, ModelTemplate.class, IS_TRANSIENT, IS_VOLATILE, !IS_CHANGEABLE, !IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, IS_DERIVED, IS_ORDERED);

		op = initEOperation(getModelTemplate__AddInstanceIdConstraint__String(), this.getMdrScopedIdType(), "addInstanceIdConstraint", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, theXMLTypePackage.getAnyURI(), "localId", 1, 1, IS_UNIQUE, IS_ORDERED);

		op = initEOperation(getModelTemplate__AddInstanceIdConstraint__String_String(), this.getMdrScopedIdType(), "addInstanceIdConstraint", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, theXMLTypePackage.getAnyURI(), "mdrId", 1, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, theXMLTypePackage.getAnyURI(), "localId", 1, 1, IS_UNIQUE, IS_ORDERED);

		initEOperation(getModelTemplate__AddRecordConstraint(), this.getRecordConstraintType(), "addRecordConstraint", 0, 1, IS_UNIQUE, IS_ORDERED);

		op = initEOperation(getModelTemplate__AddContentSelector__String(), this.getSelectedRecordTypeType(), "addContentSelector", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, theXMLTypePackage.getString(), "type", 1, 1, IS_UNIQUE, IS_ORDERED);

		op = initEOperation(getModelTemplate__AddContentSelector__String_String(), this.getSelectedRecordTypeType(), "addContentSelector", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, theXMLTypePackage.getAnyURI(), "namespace", 1, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, theXMLTypePackage.getNCName(), "localName", 1, 1, IS_UNIQUE, IS_ORDERED);

		initEClass(modelUpdateInstanceResponseEClass, ModelUpdateInstanceResponse.class, "ModelUpdateInstanceResponse", IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getModelUpdateInstanceResponse_InstanceId(), this.getMdrScopedIdType(), null, "instanceId", null, 1, 1, ModelUpdateInstanceResponse.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getModelUpdateInstanceResponse_Declined(), this.getDeclinedType(), null, "declined", null, 0, 1, ModelUpdateInstanceResponse.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(modelUpdateResponseEClass, ModelUpdateResponse.class, "ModelUpdateResponse", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getModelUpdateResponse_InstanceResponse(), this.getModelUpdateInstanceResponse(), null, "instanceResponse", null, 0, -1, ModelUpdateResponse.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		initEClass(modelRecordTypeEClass, ModelRecordType.class, "ModelRecordType", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEAttribute(getModelRecordType_LocalName(), theXMLTypePackage.getNCName(), "localName", null, 1, 1, ModelRecordType.class, IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getModelRecordType_Namespace(), theXMLTypePackage.getAnyURI(), "namespace", null, 1, 1, ModelRecordType.class, IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getModelRecordType_AppliesToItem(), theXMLTypePackage.getBoolean(), "appliesToItem", null, 0, 1, ModelRecordType.class, IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getModelRecordType_AppliesToRelationship(), theXMLTypePackage.getBoolean(), "appliesToRelationship", null, 0, 1, ModelRecordType.class, IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getModelRecordType_SuperType(), this.getModelRecordType(), null, "superType", null, 0, -1, ModelRecordType.class, IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);

		op = initEOperation(getModelRecordType__IsAssignableFrom__ModelRecordType(), theXMLTypePackage.getBoolean(), "isAssignableFrom", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, this.getModelRecordType(), "type", 0, 1, IS_UNIQUE, IS_ORDERED);

		initEClass(modelEClass, Model.class, "Model", !IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);
		initEReference(getModel_Register(), this.getRegisterRequestType(), null, "register", null, 0, 1, Model.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getModel_Deregister(), this.getDeregisterRequestType(), null, "deregister", null, 0, 1, Model.class, !IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEReference(getModel_Item(), this.getItemType(), null, "item", null, 0, -1, Model.class, IS_TRANSIENT, IS_VOLATILE, !IS_CHANGEABLE, !IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, IS_DERIVED, IS_ORDERED);
		initEReference(getModel_Relationship(), this.getRelationshipType(), null, "relationship", null, 0, -1, Model.class, IS_TRANSIENT, IS_VOLATILE, !IS_CHANGEABLE, !IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, IS_DERIVED, IS_ORDERED);
		initEReference(getModel_ModelMetadata(), this.getModelMetadata(), null, "modelMetadata", null, 0, 1, Model.class, IS_TRANSIENT, !IS_VOLATILE, IS_CHANGEABLE, !IS_COMPOSITE, IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, !IS_DERIVED, IS_ORDERED);
		initEAttribute(getModel_MdrId(), theXMLTypePackage.getAnyURI(), "mdrId", null, 1, 1, Model.class, IS_TRANSIENT, IS_VOLATILE, IS_CHANGEABLE, !IS_UNSETTABLE, !IS_ID, IS_UNIQUE, IS_DERIVED, IS_ORDERED);
		initEReference(getModel_RemovedItemId(), this.getMdrScopedIdType(), null, "removedItemId", null, 0, -1, Model.class, IS_TRANSIENT, IS_VOLATILE, !IS_CHANGEABLE, !IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, IS_DERIVED, IS_ORDERED);
		initEReference(getModel_RemovedRelationshipId(), this.getMdrScopedIdType(), null, "removedRelationshipId", null, 0, -1, Model.class, IS_TRANSIENT, IS_VOLATILE, !IS_CHANGEABLE, !IS_COMPOSITE, !IS_RESOLVE_PROXIES, !IS_UNSETTABLE, IS_UNIQUE, IS_DERIVED, IS_ORDERED);

		initEOperation(getModel__AddItem(), this.getItemType(), "addItem", 0, 1, IS_UNIQUE, IS_ORDERED);

		initEOperation(getModel__AddRelationship(), this.getRelationshipType(), "addRelationship", 0, 1, IS_UNIQUE, IS_ORDERED);

		op = initEOperation(getModel__GetItemByTemplate__String(), null, "getItemByTemplate", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, theXMLTypePackage.getID(), "templateId", 1, 1, IS_UNIQUE, IS_ORDERED);
		EGenericType g1 = createEGenericType(ecorePackage.getEEList());
		EGenericType g2 = createEGenericType(this.getItemType());
		g1.getETypeArguments().add(g2);
		initEOperation(op, g1);

		op = initEOperation(getModel__GetRelationshipByTemplate__String(), null, "getRelationshipByTemplate", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, theXMLTypePackage.getID(), "templateId", 1, 1, IS_UNIQUE, IS_ORDERED);
		g1 = createEGenericType(ecorePackage.getEEList());
		g2 = createEGenericType(this.getRelationshipType());
		g1.getETypeArguments().add(g2);
		initEOperation(op, g1);

		op = initEOperation(getModel__FindItem__MdrScopedIdType(), this.getItemType(), "findItem", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, this.getMdrScopedIdType(), "id", 1, 1, IS_UNIQUE, IS_ORDERED);

		op = initEOperation(getModel__FindItem__ItemType(), this.getItemType(), "findItem", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, this.getItemType(), "item", 1, 1, IS_UNIQUE, IS_ORDERED);

		op = initEOperation(getModel__FindItem__String_String(), this.getItemType(), "findItem", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, theXMLTypePackage.getAnyURI(), "mdrId", 1, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, theXMLTypePackage.getAnyURI(), "localId", 1, 1, IS_UNIQUE, IS_ORDERED);

		op = initEOperation(getModel__FindRelationship__MdrScopedIdType(), this.getRelationshipType(), "findRelationship", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, this.getMdrScopedIdType(), "id", 1, 1, IS_UNIQUE, IS_ORDERED);

		op = initEOperation(getModel__FindRelationship__RelationshipType(), this.getRelationshipType(), "findRelationship", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, this.getRelationshipType(), "relationship", 1, 1, IS_UNIQUE, IS_ORDERED);

		op = initEOperation(getModel__FindRelationship__String_String(), this.getRelationshipType(), "findRelationship", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, theXMLTypePackage.getAnyURI(), "mdrId", 1, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, theXMLTypePackage.getAnyURI(), "localId", 1, 1, IS_UNIQUE, IS_ORDERED);

		op = initEOperation(getModel__Remove__ItemType(), ecorePackage.getEBoolean(), "remove", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, this.getItemType(), "item", 1, 1, IS_UNIQUE, IS_ORDERED);

		op = initEOperation(getModel__Remove__RelationshipType(), ecorePackage.getEBoolean(), "remove", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, this.getRelationshipType(), "relationship", 1, 1, IS_UNIQUE, IS_ORDERED);

		initEClass(modelMetadataEClass, ModelMetadata.class, "ModelMetadata", IS_ABSTRACT, !IS_INTERFACE, IS_GENERATED_INSTANCE_CLASS);

		op = initEOperation(getModelMetadata__GetElement__String_String(), ecorePackage.getEStructuralFeature(), "getElement", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, theXMLTypePackage.getAnyURI(), "namespace", 1, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, theXMLTypePackage.getNCName(), "localName", 1, 1, IS_UNIQUE, IS_ORDERED);

		op = initEOperation(getModelMetadata__GetNamespace__EClassifier(), theXMLTypePackage.getAnyURI(), "getNamespace", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, ecorePackage.getEClassifier(), "classifier", 1, 1, IS_UNIQUE, IS_ORDERED);

		op = initEOperation(getModelMetadata__GetLocalName__EClassifier(), theXMLTypePackage.getNCName(), "getLocalName", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, ecorePackage.getEClassifier(), "classifier", 1, 1, IS_UNIQUE, IS_ORDERED);

		op = initEOperation(getModelMetadata__GetRecordType__String_String(), this.getModelRecordType(), "getRecordType", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, theXMLTypePackage.getAnyURI(), "namespace", 1, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, theXMLTypePackage.getNCName(), "localName", 1, 1, IS_UNIQUE, IS_ORDERED);

		op = initEOperation(getModelMetadata__GetNamespace__String(), theXMLTypePackage.getAnyURI(), "getNamespace", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, ecorePackage.getEString(), "name", 1, 1, IS_UNIQUE, IS_ORDERED);

		op = initEOperation(getModelMetadata__GetLocalName__String(), theXMLTypePackage.getNCName(), "getLocalName", 0, 1, IS_UNIQUE, IS_ORDERED);
		addEParameter(op, ecorePackage.getEString(), "name", 1, 1, IS_UNIQUE, IS_ORDERED);

		// Create resource
		createResource(eNS_URI);

		// Create annotations
		// http:///org/eclipse/emf/ecore/util/ExtendedMetaData
		createExtendedMetaDataAnnotations();
	}

	/**
	 * Initializes the annotations for <b>http:///org/eclipse/emf/ecore/util/ExtendedMetaData</b>.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected void createExtendedMetaDataAnnotations() {
		String source = "http:///org/eclipse/emf/ecore/util/ExtendedMetaData";	
		addAnnotation
		  (acceptedTypeEClass, 
		   source, 
		   new String[] {
			 "name", "AcceptedType",
			 "kind", "elementOnly"
		   });	
		addAnnotation
		  (getAcceptedType_AlternateInstanceId(), 
		   source, 
		   new String[] {
			 "kind", "element",
			 "name", "alternateInstanceId",
			 "namespace", "##targetNamespace"
		   });	
		addAnnotation
		  (comparisonOperatorTypeEClass, 
		   source, 
		   new String[] {
			 "name", "ComparisonOperatorType",
			 "kind", "simple"
		   });	
		addAnnotation
		  (getComparisonOperatorType_Value(), 
		   source, 
		   new String[] {
			 "name", ":0",
			 "kind", "simple"
		   });	
		addAnnotation
		  (getComparisonOperatorType_Negate(), 
		   source, 
		   new String[] {
			 "kind", "attribute",
			 "name", "negate"
		   });	
		addAnnotation
		  (constraintTypeEClass, 
		   source, 
		   new String[] {
			 "name", "constraint_._type",
			 "kind", "empty"
		   });	
		addAnnotation
		  (getConstraintType_LocalName(), 
		   source, 
		   new String[] {
			 "kind", "attribute",
			 "name", "localName"
		   });	
		addAnnotation
		  (getConstraintType_Namespace(), 
		   source, 
		   new String[] {
			 "kind", "attribute",
			 "name", "namespace"
		   });	
		addAnnotation
		  (contentSelectorTypeEClass, 
		   source, 
		   new String[] {
			 "name", "ContentSelectorType",
			 "kind", "elementOnly"
		   });	
		addAnnotation
		  (getContentSelectorType_SelectedRecordType(), 
		   source, 
		   new String[] {
			 "kind", "element",
			 "name", "selectedRecordType",
			 "namespace", "##targetNamespace"
		   });	
		addAnnotation
		  (getContentSelectorType_XpathSelector(), 
		   source, 
		   new String[] {
			 "kind", "element",
			 "name", "xpathSelector",
			 "namespace", "##targetNamespace"
		   });	
		addAnnotation
		  (getContentSelectorType_Any(), 
		   source, 
		   new String[] {
			 "kind", "elementWildcard",
			 "wildcards", "##other",
			 "name", ":2",
			 "processing", "lax"
		   });	
		addAnnotation
		  (declinedTypeEClass, 
		   source, 
		   new String[] {
			 "name", "DeclinedType",
			 "kind", "elementOnly"
		   });	
		addAnnotation
		  (getDeclinedType_Reason(), 
		   source, 
		   new String[] {
			 "kind", "element",
			 "name", "reason",
			 "namespace", "##targetNamespace"
		   });	
		addAnnotation
		  (depthLimitTypeEClass, 
		   source, 
		   new String[] {
			 "name", "DepthLimitType",
			 "kind", "empty"
		   });	
		addAnnotation
		  (getDepthLimitType_MaxIntermediateItems(), 
		   source, 
		   new String[] {
			 "kind", "attribute",
			 "name", "maxIntermediateItems"
		   });	
		addAnnotation
		  (getDepthLimitType_IntermediateItemTemplate(), 
		   source, 
		   new String[] {
			 "kind", "attribute",
			 "name", "intermediateItemTemplate"
		   });	
		addAnnotation
		  (deregisterInstanceResponseTypeEClass, 
		   source, 
		   new String[] {
			 "name", "DeregisterInstanceResponseType",
			 "kind", "elementOnly"
		   });	
		addAnnotation
		  (getDeregisterInstanceResponseType_Accepted(), 
		   source, 
		   new String[] {
			 "kind", "element",
			 "name", "accepted",
			 "namespace", "##targetNamespace"
		   });	
		addAnnotation
		  (deregisterRequestTypeEClass, 
		   source, 
		   new String[] {
			 "name", "DeregisterRequestType",
			 "kind", "elementOnly"
		   });	
		addAnnotation
		  (getDeregisterRequestType_MdrId(), 
		   source, 
		   new String[] {
			 "kind", "element",
			 "name", "mdrId",
			 "namespace", "##targetNamespace"
		   });	
		addAnnotation
		  (getDeregisterRequestType_ItemIdList(), 
		   source, 
		   new String[] {
			 "kind", "element",
			 "name", "itemIdList",
			 "namespace", "##targetNamespace"
		   });	
		addAnnotation
		  (getDeregisterRequestType_RelationshipIdList(), 
		   source, 
		   new String[] {
			 "kind", "element",
			 "name", "relationshipIdList",
			 "namespace", "##targetNamespace"
		   });	
		addAnnotation
		  (deregisterResponseTypeEClass, 
		   source, 
		   new String[] {
			 "name", "DeregisterResponseType",
			 "kind", "elementOnly"
		   });	
		addAnnotation
		  (getDeregisterResponseType_DeregisterInstanceResponse(), 
		   source, 
		   new String[] {
			 "kind", "element",
			 "name", "DeregisterInstanceResponse",
			 "namespace", "##targetNamespace"
		   });	
		addAnnotation
		  (deregistrationErrorFaultTypeEClass, 
		   source, 
		   new String[] {
			 "name", "DeregistrationErrorFault_._type",
			 "kind", "elementOnly"
		   });	
		addAnnotation
		  (getDeregistrationErrorFaultType_RecordId(), 
		   source, 
		   new String[] {
			 "kind", "element",
			 "name", "recordId",
			 "namespace", "##targetNamespace"
		   });	
		addAnnotation
		  (documentRootEClass, 
		   source, 
		   new String[] {
			 "name", "",
			 "kind", "mixed"
		   });	
		addAnnotation
		  (getDocumentRoot_Mixed(), 
		   source, 
		   new String[] {
			 "kind", "elementWildcard",
			 "name", ":mixed"
		   });	
		addAnnotation
		  (getDocumentRoot_XMLNSPrefixMap(), 
		   source, 
		   new String[] {
			 "kind", "attribute",
			 "name", "xmlns:prefix"
		   });	
		addAnnotation
		  (getDocumentRoot_XSISchemaLocation(), 
		   source, 
		   new String[] {
			 "kind", "attribute",
			 "name", "xsi:schemaLocation"
		   });	
		addAnnotation
		  (getDocumentRoot_DeregisterRequest(), 
		   source, 
		   new String[] {
			 "kind", "element",
			 "name", "deregisterRequest",
			 "namespace", "##targetNamespace"
		   });	
		addAnnotation
		  (getDocumentRoot_DeregisterResponse(), 
		   source, 
		   new String[] {
			 "kind", "element",
			 "name", "deregisterResponse",
			 "namespace", "##targetNamespace"
		   });	
		addAnnotation
		  (getDocumentRoot_DeregistrationErrorFault(), 
		   source, 
		   new String[] {
			 "kind", "element",
			 "name", "DeregistrationErrorFault",
			 "namespace", "##targetNamespace"
		   });	
		addAnnotation
		  (getDocumentRoot_ExpensiveQueryErrorFault(), 
		   source, 
		   new String[] {
			 "kind", "element",
			 "name", "ExpensiveQueryErrorFault",
			 "namespace", "##targetNamespace"
		   });	
		addAnnotation
		  (getDocumentRoot_InstanceId(), 
		   source, 
		   new String[] {
			 "kind", "element",
			 "name", "instanceId",
			 "namespace", "##targetNamespace"
		   });	
		addAnnotation
		  (getDocumentRoot_InvalidMDRFault(), 
		   source, 
		   new String[] {
			 "kind", "element",
			 "name", "InvalidMDRFault",
			 "namespace", "##targetNamespace"
		   });	
		addAnnotation
		  (getDocumentRoot_InvalidPropertyTypeFault(), 
		   source, 
		   new String[] {
			 "kind", "element",
			 "name", "InvalidPropertyTypeFault",
			 "namespace", "##targetNamespace"
		   });	
		addAnnotation
		  (getDocumentRoot_InvalidRecordFault(), 
		   source, 
		   new String[] {
			 "kind", "element",
			 "name", "InvalidRecordFault",
			 "namespace", "##targetNamespace"
		   });	
		addAnnotation
		  (getDocumentRoot_Item(), 
		   source, 
		   new String[] {
			 "kind", "element",
			 "name", "item",
			 "namespace", "##targetNamespace"
		   });	
		addAnnotation
		  (getDocumentRoot_PropertySet(), 
		   source, 
		   new String[] {
			 "kind", "element",
			 "name", "propertySet",
			 "namespace", "##targetNamespace"
		   });	
		addAnnotation
		  (getDocumentRoot_Query(), 
		   source, 
		   new String[] {
			 "kind", "element",
			 "name", "query",
			 "namespace", "##targetNamespace"
		   });	
		addAnnotation
		  (getDocumentRoot_QueryErrorFault(), 
		   source, 
		   new String[] {
			 "kind", "element",
			 "name", "QueryErrorFault",
			 "namespace", "##targetNamespace"
		   });	
		addAnnotation
		  (getDocumentRoot_QueryResult(), 
		   source, 
		   new String[] {
			 "kind", "element",
			 "name", "queryResult",
			 "namespace", "##targetNamespace"
		   });	
		addAnnotation
		  (getDocumentRoot_Record(), 
		   source, 
		   new String[] {
			 "kind", "element",
			 "name", "record",
			 "namespace", "##targetNamespace"
		   });	
		addAnnotation
		  (getDocumentRoot_RegisterRequest(), 
		   source, 
		   new String[] {
			 "kind", "element",
			 "name", "registerRequest",
			 "namespace", "##targetNamespace"
		   });	
		addAnnotation
		  (getDocumentRoot_RegisterResponse(), 
		   source, 
		   new String[] {
			 "kind", "element",
			 "name", "registerResponse",
			 "namespace", "##targetNamespace"
		   });	
		addAnnotation
		  (getDocumentRoot_RegistrationErrorFault(), 
		   source, 
		   new String[] {
			 "kind", "element",
			 "name", "RegistrationErrorFault",
			 "namespace", "##targetNamespace"
		   });	
		addAnnotation
		  (getDocumentRoot_Relationship(), 
		   source, 
		   new String[] {
			 "kind", "element",
			 "name", "relationship",
			 "namespace", "##targetNamespace"
		   });	
		addAnnotation
		  (getDocumentRoot_UnknownTemplateIDFault(), 
		   source, 
		   new String[] {
			 "kind", "element",
			 "name", "UnknownTemplateIDFault",
			 "namespace", "##targetNamespace"
		   });	
		addAnnotation
		  (getDocumentRoot_UnsupportedConstraintFault(), 
		   source, 
		   new String[] {
			 "kind", "element",
			 "name", "UnsupportedConstraintFault",
			 "namespace", "##targetNamespace"
		   });	
		addAnnotation
		  (getDocumentRoot_UnsupportedRecordTypeFault(), 
		   source, 
		   new String[] {
			 "kind", "element",
			 "name", "UnsupportedRecordTypeFault",
			 "namespace", "##targetNamespace"
		   });	
		addAnnotation
		  (getDocumentRoot_UnsupportedSelectorFault(), 
		   source, 
		   new String[] {
			 "kind", "element",
			 "name", "UnsupportedSelectorFault",
			 "namespace", "##targetNamespace"
		   });	
		addAnnotation
		  (getDocumentRoot_XPathErrorFault(), 
		   source, 
		   new String[] {
			 "kind", "element",
			 "name", "XPathErrorFault",
			 "namespace", "##targetNamespace"
		   });	
		addAnnotation
		  (getDocumentRoot_Model(), 
		   source, 
		   new String[] {
			 "kind", "element",
			 "name", "model",
			 "namespace", "##targetNamespace"
		   });	
		addAnnotation
		  (edgesTypeEClass, 
		   source, 
		   new String[] {
			 "name", "EdgesType",
			 "kind", "elementOnly"
		   });	
		addAnnotation
		  (getEdgesType_Relationship(), 
		   source, 
		   new String[] {
			 "kind", "element",
			 "name", "relationship",
			 "namespace", "##targetNamespace"
		   });	
		addAnnotation
		  (getEdgesType_TemplateId(), 
		   source, 
		   new String[] {
			 "kind", "attribute",
			 "name", "templateId"
		   });	
		addAnnotation
		  (equalOperatorTypeEClass, 
		   source, 
		   new String[] {
			 "name", "EqualOperatorType",
			 "kind", "simple"
		   });	
		addAnnotation
		  (getEqualOperatorType_Value(), 
		   source, 
		   new String[] {
			 "name", ":0",
			 "kind", "simple"
		   });	
		addAnnotation
		  (getEqualOperatorType_CaseSensitive(), 
		   source, 
		   new String[] {
			 "kind", "attribute",
			 "name", "caseSensitive"
		   });	
		addAnnotation
		  (getEqualOperatorType_Negate(), 
		   source, 
		   new String[] {
			 "kind", "attribute",
			 "name", "negate"
		   });	
		addAnnotation
		  (expensiveQueryErrorFaultTypeEClass, 
		   source, 
		   new String[] {
			 "name", "ExpensiveQueryErrorFault_._type",
			 "kind", "elementOnly"
		   });	
		addAnnotation
		  (getExpensiveQueryErrorFaultType_Any(), 
		   source, 
		   new String[] {
			 "kind", "elementWildcard",
			 "wildcards", "##any",
			 "name", ":0",
			 "processing", "lax"
		   });	
		addAnnotation
		  (instanceIdConstraintTypeEClass, 
		   source, 
		   new String[] {
			 "name", "InstanceIdConstraintType",
			 "kind", "elementOnly"
		   });	
		addAnnotation
		  (getInstanceIdConstraintType_InstanceId(), 
		   source, 
		   new String[] {
			 "kind", "element",
			 "name", "instanceId",
			 "namespace", "##targetNamespace"
		   });	
		addAnnotation
		  (invalidMDRFaultTypeEClass, 
		   source, 
		   new String[] {
			 "name", "InvalidMDRFault_._type",
			 "kind", "elementOnly"
		   });	
		addAnnotation
		  (getInvalidMDRFaultType_MdrId(), 
		   source, 
		   new String[] {
			 "kind", "element",
			 "name", "mdrId",
			 "namespace", "##targetNamespace"
		   });	
		addAnnotation
		  (invalidPropertyTypeFaultTypeEClass, 
		   source, 
		   new String[] {
			 "name", "InvalidPropertyTypeFault_._type",
			 "kind", "elementOnly"
		   });	
		addAnnotation
		  (getInvalidPropertyTypeFaultType_PropertyName(), 
		   source, 
		   new String[] {
			 "kind", "element",
			 "name", "propertyName",
			 "namespace", "##targetNamespace"
		   });	
		addAnnotation
		  (invalidRecordFaultTypeEClass, 
		   source, 
		   new String[] {
			 "name", "InvalidRecordFault_._type",
			 "kind", "elementOnly"
		   });	
		addAnnotation
		  (getInvalidRecordFaultType_RecordId(), 
		   source, 
		   new String[] {
			 "kind", "element",
			 "name", "recordId",
			 "namespace", "##targetNamespace"
		   });	
		addAnnotation
		  (itemListTypeEClass, 
		   source, 
		   new String[] {
			 "name", "ItemListType",
			 "kind", "elementOnly"
		   });	
		addAnnotation
		  (getItemListType_Item(), 
		   source, 
		   new String[] {
			 "kind", "element",
			 "name", "item",
			 "namespace", "##targetNamespace"
		   });	
		addAnnotation
		  (itemTemplateTypeEClass, 
		   source, 
		   new String[] {
			 "name", "ItemTemplateType",
			 "kind", "elementOnly"
		   });	
		addAnnotation
		  (itemTypeEClass, 
		   source, 
		   new String[] {
			 "name", "ItemType",
			 "kind", "elementOnly"
		   });	
		addAnnotation
		  (mdrScopedIdListTypeEClass, 
		   source, 
		   new String[] {
			 "name", "MdrScopedIdListType",
			 "kind", "elementOnly"
		   });	
		addAnnotation
		  (getMdrScopedIdListType_InstanceId(), 
		   source, 
		   new String[] {
			 "kind", "element",
			 "name", "instanceId",
			 "namespace", "##targetNamespace"
		   });	
		addAnnotation
		  (mdrScopedIdTypeEClass, 
		   source, 
		   new String[] {
			 "name", "MdrScopedIdType",
			 "kind", "elementOnly"
		   });	
		addAnnotation
		  (getMdrScopedIdType_MdrId(), 
		   source, 
		   new String[] {
			 "kind", "element",
			 "name", "mdrId",
			 "namespace", "##targetNamespace"
		   });	
		addAnnotation
		  (getMdrScopedIdType_LocalId(), 
		   source, 
		   new String[] {
			 "kind", "element",
			 "name", "localId",
			 "namespace", "##targetNamespace"
		   });	
		addAnnotation
		  (nodesTypeEClass, 
		   source, 
		   new String[] {
			 "name", "NodesType",
			 "kind", "elementOnly"
		   });	
		addAnnotation
		  (getNodesType_Item(), 
		   source, 
		   new String[] {
			 "kind", "element",
			 "name", "item",
			 "namespace", "##targetNamespace"
		   });	
		addAnnotation
		  (getNodesType_TemplateId(), 
		   source, 
		   new String[] {
			 "kind", "attribute",
			 "name", "templateId"
		   });	
		addAnnotation
		  (nullOperatorTypeEClass, 
		   source, 
		   new String[] {
			 "name", "NullOperatorType",
			 "kind", "empty"
		   });	
		addAnnotation
		  (getNullOperatorType_Negate(), 
		   source, 
		   new String[] {
			 "kind", "attribute",
			 "name", "negate"
		   });	
		addAnnotation
		  (prefixMappingTypeEClass, 
		   source, 
		   new String[] {
			 "name", "PrefixMappingType",
			 "kind", "empty"
		   });	
		addAnnotation
		  (getPrefixMappingType_Prefix(), 
		   source, 
		   new String[] {
			 "kind", "attribute",
			 "name", "prefix"
		   });	
		addAnnotation
		  (getPrefixMappingType_Namespace(), 
		   source, 
		   new String[] {
			 "kind", "attribute",
			 "name", "namespace"
		   });	
		addAnnotation
		  (propertyNameTypeEClass, 
		   source, 
		   new String[] {
			 "name", "propertyName_._type",
			 "kind", "empty"
		   });	
		addAnnotation
		  (getPropertyNameType_LocalName(), 
		   source, 
		   new String[] {
			 "kind", "attribute",
			 "name", "localName"
		   });	
		addAnnotation
		  (getPropertyNameType_Namespace(), 
		   source, 
		   new String[] {
			 "kind", "attribute",
			 "name", "namespace"
		   });	
		addAnnotation
		  (propertySetTypeEClass, 
		   source, 
		   new String[] {
			 "name", "propertySetType",
			 "kind", "elementOnly"
		   });	
		addAnnotation
		  (getPropertySetType_Any(), 
		   source, 
		   new String[] {
			 "kind", "elementWildcard",
			 "wildcards", "##other",
			 "name", ":0",
			 "processing", "lax"
		   });	
		addAnnotation
		  (getPropertySetType_Namespace(), 
		   source, 
		   new String[] {
			 "kind", "attribute",
			 "name", "namespace"
		   });	
		addAnnotation
		  (getPropertySetType_LocalName(), 
		   source, 
		   new String[] {
			 "kind", "attribute",
			 "name", "localName"
		   });	
		addAnnotation
		  (propertyValueTypeEClass, 
		   source, 
		   new String[] {
			 "name", "PropertyValueType",
			 "kind", "elementOnly"
		   });	
		addAnnotation
		  (getPropertyValueType_Equal(), 
		   source, 
		   new String[] {
			 "kind", "element",
			 "name", "equal",
			 "namespace", "##targetNamespace"
		   });	
		addAnnotation
		  (getPropertyValueType_Less(), 
		   source, 
		   new String[] {
			 "kind", "element",
			 "name", "less",
			 "namespace", "##targetNamespace"
		   });	
		addAnnotation
		  (getPropertyValueType_LessOrEqual(), 
		   source, 
		   new String[] {
			 "kind", "element",
			 "name", "lessOrEqual",
			 "namespace", "##targetNamespace"
		   });	
		addAnnotation
		  (getPropertyValueType_Greater(), 
		   source, 
		   new String[] {
			 "kind", "element",
			 "name", "greater",
			 "namespace", "##targetNamespace"
		   });	
		addAnnotation
		  (getPropertyValueType_GreaterOrEqual(), 
		   source, 
		   new String[] {
			 "kind", "element",
			 "name", "greaterOrEqual",
			 "namespace", "##targetNamespace"
		   });	
		addAnnotation
		  (getPropertyValueType_Contains(), 
		   source, 
		   new String[] {
			 "kind", "element",
			 "name", "contains",
			 "namespace", "##targetNamespace"
		   });	
		addAnnotation
		  (getPropertyValueType_Like(), 
		   source, 
		   new String[] {
			 "kind", "element",
			 "name", "like",
			 "namespace", "##targetNamespace"
		   });	
		addAnnotation
		  (getPropertyValueType_IsNull(), 
		   source, 
		   new String[] {
			 "kind", "element",
			 "name", "isNull",
			 "namespace", "##targetNamespace"
		   });	
		addAnnotation
		  (getPropertyValueType_Any(), 
		   source, 
		   new String[] {
			 "kind", "elementWildcard",
			 "wildcards", "##other",
			 "name", ":8",
			 "processing", "lax"
		   });	
		addAnnotation
		  (getPropertyValueType_Namespace(), 
		   source, 
		   new String[] {
			 "kind", "attribute",
			 "name", "namespace"
		   });	
		addAnnotation
		  (getPropertyValueType_LocalName(), 
		   source, 
		   new String[] {
			 "kind", "attribute",
			 "name", "localName"
		   });	
		addAnnotation
		  (getPropertyValueType_RecordMetadata(), 
		   source, 
		   new String[] {
			 "kind", "attribute",
			 "name", "recordMetadata"
		   });	
		addAnnotation
		  (getPropertyValueType_MatchAny(), 
		   source, 
		   new String[] {
			 "kind", "attribute",
			 "name", "matchAny"
		   });	
		addAnnotation
		  (qNameTypeEClass, 
		   source, 
		   new String[] {
			 "name", "QNameType",
			 "kind", "empty"
		   });	
		addAnnotation
		  (getQNameType_Namespace(), 
		   source, 
		   new String[] {
			 "kind", "attribute",
			 "name", "namespace"
		   });	
		addAnnotation
		  (getQNameType_LocalName(), 
		   source, 
		   new String[] {
			 "kind", "attribute",
			 "name", "localName"
		   });	
		addAnnotation
		  (queryErrorFaultTypeEClass, 
		   source, 
		   new String[] {
			 "name", "QueryErrorFault_._type",
			 "kind", "elementOnly"
		   });	
		addAnnotation
		  (getQueryErrorFaultType_Any(), 
		   source, 
		   new String[] {
			 "kind", "elementWildcard",
			 "wildcards", "##any",
			 "name", ":0",
			 "processing", "lax"
		   });	
		addAnnotation
		  (queryResultTypeEClass, 
		   source, 
		   new String[] {
			 "name", "QueryResultType",
			 "kind", "elementOnly"
		   });	
		addAnnotation
		  (getQueryResultType_Nodes(), 
		   source, 
		   new String[] {
			 "kind", "element",
			 "name", "nodes",
			 "namespace", "##targetNamespace"
		   });	
		addAnnotation
		  (getQueryResultType_Edges(), 
		   source, 
		   new String[] {
			 "kind", "element",
			 "name", "edges",
			 "namespace", "##targetNamespace"
		   });	
		addAnnotation
		  (queryTypeEClass, 
		   source, 
		   new String[] {
			 "name", "QueryType",
			 "kind", "elementOnly"
		   });	
		addAnnotation
		  (getQueryType_ItemTemplate(), 
		   source, 
		   new String[] {
			 "kind", "element",
			 "name", "itemTemplate",
			 "namespace", "##targetNamespace"
		   });	
		addAnnotation
		  (getQueryType_RelationshipTemplate(), 
		   source, 
		   new String[] {
			 "kind", "element",
			 "name", "relationshipTemplate",
			 "namespace", "##targetNamespace"
		   });	
		addAnnotation
		  (recordConstraintTypeEClass, 
		   source, 
		   new String[] {
			 "name", "RecordConstraintType",
			 "kind", "elementOnly"
		   });	
		addAnnotation
		  (getRecordConstraintType_RecordType(), 
		   source, 
		   new String[] {
			 "kind", "element",
			 "name", "recordType",
			 "namespace", "##targetNamespace"
		   });	
		addAnnotation
		  (getRecordConstraintType_PropertyValue(), 
		   source, 
		   new String[] {
			 "kind", "element",
			 "name", "propertyValue",
			 "namespace", "##targetNamespace"
		   });	
		addAnnotation
		  (getRecordConstraintType_XpathConstraint(), 
		   source, 
		   new String[] {
			 "kind", "element",
			 "name", "xpathConstraint",
			 "namespace", "##targetNamespace"
		   });	
		addAnnotation
		  (getRecordConstraintType_Any(), 
		   source, 
		   new String[] {
			 "kind", "elementWildcard",
			 "wildcards", "##other",
			 "name", ":3",
			 "processing", "lax"
		   });	
		addAnnotation
		  (recordMetadataTypeEClass, 
		   source, 
		   new String[] {
			 "name", "recordMetadata_._type",
			 "kind", "elementOnly"
		   });	
		addAnnotation
		  (getRecordMetadataType_RecordId(), 
		   source, 
		   new String[] {
			 "kind", "element",
			 "name", "recordId",
			 "namespace", "##targetNamespace"
		   });	
		addAnnotation
		  (getRecordMetadataType_LastModified(), 
		   source, 
		   new String[] {
			 "kind", "element",
			 "name", "lastModified",
			 "namespace", "##targetNamespace"
		   });	
		addAnnotation
		  (getRecordMetadataType_BaselineId(), 
		   source, 
		   new String[] {
			 "kind", "element",
			 "name", "baselineId",
			 "namespace", "##targetNamespace"
		   });	
		addAnnotation
		  (getRecordMetadataType_SnapshotId(), 
		   source, 
		   new String[] {
			 "kind", "element",
			 "name", "snapshotId",
			 "namespace", "##targetNamespace"
		   });	
		addAnnotation
		  (getRecordMetadataType_Any(), 
		   source, 
		   new String[] {
			 "kind", "elementWildcard",
			 "wildcards", "##other",
			 "name", ":4",
			 "processing", "lax"
		   });	
		addAnnotation
		  (recordTypeEClass, 
		   source, 
		   new String[] {
			 "name", "RecordType",
			 "kind", "elementOnly"
		   });	
		addAnnotation
		  (getRecordType_Any(), 
		   source, 
		   new String[] {
			 "kind", "elementWildcard",
			 "wildcards", "##other",
			 "name", ":0",
			 "processing", "skip"
		   });	
		addAnnotation
		  (getRecordType_PropertySet(), 
		   source, 
		   new String[] {
			 "kind", "element",
			 "name", "propertySet",
			 "namespace", "##targetNamespace"
		   });	
		addAnnotation
		  (getRecordType_RecordMetadata(), 
		   source, 
		   new String[] {
			 "kind", "element",
			 "name", "recordMetadata",
			 "namespace", "##targetNamespace"
		   });	
		addAnnotation
		  (recordTypeTypeEClass, 
		   source, 
		   new String[] {
			 "name", "recordType_._type",
			 "kind", "empty"
		   });	
		addAnnotation
		  (getRecordTypeType_LocalName(), 
		   source, 
		   new String[] {
			 "kind", "attribute",
			 "name", "localName"
		   });	
		addAnnotation
		  (getRecordTypeType_Namespace(), 
		   source, 
		   new String[] {
			 "kind", "attribute",
			 "name", "namespace"
		   });	
		addAnnotation
		  (registerInstanceResponseTypeEClass, 
		   source, 
		   new String[] {
			 "name", "RegisterInstanceResponseType",
			 "kind", "elementOnly"
		   });	
		addAnnotation
		  (getRegisterInstanceResponseType_Accepted(), 
		   source, 
		   new String[] {
			 "kind", "element",
			 "name", "accepted",
			 "namespace", "##targetNamespace"
		   });	
		addAnnotation
		  (registerRequestTypeEClass, 
		   source, 
		   new String[] {
			 "name", "RegisterRequestType",
			 "kind", "elementOnly"
		   });	
		addAnnotation
		  (getRegisterRequestType_MdrId(), 
		   source, 
		   new String[] {
			 "kind", "element",
			 "name", "mdrId",
			 "namespace", "##targetNamespace"
		   });	
		addAnnotation
		  (getRegisterRequestType_ItemList(), 
		   source, 
		   new String[] {
			 "kind", "element",
			 "name", "itemList",
			 "namespace", "##targetNamespace"
		   });	
		addAnnotation
		  (getRegisterRequestType_RelationshipList(), 
		   source, 
		   new String[] {
			 "kind", "element",
			 "name", "relationshipList",
			 "namespace", "##targetNamespace"
		   });	
		addAnnotation
		  (registerResponseTypeEClass, 
		   source, 
		   new String[] {
			 "name", "RegisterResponseType",
			 "kind", "elementOnly"
		   });	
		addAnnotation
		  (getRegisterResponseType_RegisterInstanceResponse(), 
		   source, 
		   new String[] {
			 "kind", "element",
			 "name", "RegisterInstanceResponse",
			 "namespace", "##targetNamespace"
		   });	
		addAnnotation
		  (registrationErrorFaultTypeEClass, 
		   source, 
		   new String[] {
			 "name", "RegistrationErrorFault_._type",
			 "kind", "elementOnly"
		   });	
		addAnnotation
		  (getRegistrationErrorFaultType_RecordId(), 
		   source, 
		   new String[] {
			 "kind", "element",
			 "name", "recordId",
			 "namespace", "##targetNamespace"
		   });	
		addAnnotation
		  (relationshipListTypeEClass, 
		   source, 
		   new String[] {
			 "name", "RelationshipListType",
			 "kind", "elementOnly"
		   });	
		addAnnotation
		  (getRelationshipListType_Relationship(), 
		   source, 
		   new String[] {
			 "kind", "element",
			 "name", "relationship",
			 "namespace", "##targetNamespace"
		   });	
		addAnnotation
		  (relationshipRefTypeEClass, 
		   source, 
		   new String[] {
			 "name", "RelationshipRefType",
			 "kind", "empty"
		   });	
		addAnnotation
		  (getRelationshipRefType_Ref(), 
		   source, 
		   new String[] {
			 "kind", "attribute",
			 "name", "ref"
		   });	
		addAnnotation
		  (getRelationshipRefType_Minimum(), 
		   source, 
		   new String[] {
			 "kind", "attribute",
			 "name", "minimum"
		   });	
		addAnnotation
		  (getRelationshipRefType_Maximum(), 
		   source, 
		   new String[] {
			 "kind", "attribute",
			 "name", "maximum"
		   });	
		addAnnotation
		  (relationshipTemplateTypeEClass, 
		   source, 
		   new String[] {
			 "name", "RelationshipTemplateType",
			 "kind", "elementOnly"
		   });	
		addAnnotation
		  (getRelationshipTemplateType_SourceTemplate(), 
		   source, 
		   new String[] {
			 "kind", "element",
			 "name", "sourceTemplate",
			 "namespace", "##targetNamespace"
		   });	
		addAnnotation
		  (getRelationshipTemplateType_TargetTemplate(), 
		   source, 
		   new String[] {
			 "kind", "element",
			 "name", "targetTemplate",
			 "namespace", "##targetNamespace"
		   });	
		addAnnotation
		  (getRelationshipTemplateType_DepthLimit(), 
		   source, 
		   new String[] {
			 "kind", "element",
			 "name", "depthLimit",
			 "namespace", "##targetNamespace"
		   });	
		addAnnotation
		  (relationshipTypeEClass, 
		   source, 
		   new String[] {
			 "name", "RelationshipType",
			 "kind", "elementOnly"
		   });	
		addAnnotation
		  (selectedRecordTypeTypeEClass, 
		   source, 
		   new String[] {
			 "name", "SelectedRecordTypeType",
			 "kind", "elementOnly"
		   });	
		addAnnotation
		  (getSelectedRecordTypeType_SelectedProperty(), 
		   source, 
		   new String[] {
			 "kind", "element",
			 "name", "selectedProperty",
			 "namespace", "##targetNamespace"
		   });	
		addAnnotation
		  (getSelectedRecordTypeType_Namespace(), 
		   source, 
		   new String[] {
			 "kind", "attribute",
			 "name", "namespace"
		   });	
		addAnnotation
		  (getSelectedRecordTypeType_LocalName(), 
		   source, 
		   new String[] {
			 "kind", "attribute",
			 "name", "localName"
		   });	
		addAnnotation
		  (selectorTypeEClass, 
		   source, 
		   new String[] {
			 "name", "selector_._type",
			 "kind", "empty"
		   });	
		addAnnotation
		  (getSelectorType_LocalName(), 
		   source, 
		   new String[] {
			 "kind", "attribute",
			 "name", "localName"
		   });	
		addAnnotation
		  (getSelectorType_Namespace(), 
		   source, 
		   new String[] {
			 "kind", "attribute",
			 "name", "namespace"
		   });	
		addAnnotation
		  (stringOperatorTypeEClass, 
		   source, 
		   new String[] {
			 "name", "StringOperatorType",
			 "kind", "simple"
		   });	
		addAnnotation
		  (getStringOperatorType_Value(), 
		   source, 
		   new String[] {
			 "name", ":0",
			 "kind", "simple"
		   });	
		addAnnotation
		  (getStringOperatorType_CaseSensitive(), 
		   source, 
		   new String[] {
			 "kind", "attribute",
			 "name", "caseSensitive"
		   });	
		addAnnotation
		  (getStringOperatorType_Negate(), 
		   source, 
		   new String[] {
			 "kind", "attribute",
			 "name", "negate"
		   });	
		addAnnotation
		  (unknownTemplateIDFaultTypeEClass, 
		   source, 
		   new String[] {
			 "name", "UnknownTemplateIDFault_._type",
			 "kind", "elementOnly"
		   });	
		addAnnotation
		  (getUnknownTemplateIDFaultType_GraphId(), 
		   source, 
		   new String[] {
			 "kind", "element",
			 "name", "graphId",
			 "namespace", "##targetNamespace"
		   });	
		addAnnotation
		  (unsupportedConstraintFaultTypeEClass, 
		   source, 
		   new String[] {
			 "name", "UnsupportedConstraintFault_._type",
			 "kind", "elementOnly"
		   });	
		addAnnotation
		  (getUnsupportedConstraintFaultType_Constraint(), 
		   source, 
		   new String[] {
			 "kind", "element",
			 "name", "constraint",
			 "namespace", "##targetNamespace"
		   });	
		addAnnotation
		  (unsupportedRecordTypeFaultTypeEClass, 
		   source, 
		   new String[] {
			 "name", "UnsupportedRecordTypeFault_._type",
			 "kind", "elementOnly"
		   });	
		addAnnotation
		  (getUnsupportedRecordTypeFaultType_RecordType(), 
		   source, 
		   new String[] {
			 "kind", "element",
			 "name", "recordType",
			 "namespace", "##targetNamespace"
		   });	
		addAnnotation
		  (unsupportedSelectorFaultTypeEClass, 
		   source, 
		   new String[] {
			 "name", "UnsupportedSelectorFault_._type",
			 "kind", "elementOnly"
		   });	
		addAnnotation
		  (getUnsupportedSelectorFaultType_Selector(), 
		   source, 
		   new String[] {
			 "kind", "element",
			 "name", "selector",
			 "namespace", "##targetNamespace"
		   });	
		addAnnotation
		  (xPathErrorFaultTypeEClass, 
		   source, 
		   new String[] {
			 "name", "XPathErrorFault_._type",
			 "kind", "elementOnly"
		   });	
		addAnnotation
		  (getXPathErrorFaultType_Expression(), 
		   source, 
		   new String[] {
			 "kind", "element",
			 "name", "expression",
			 "namespace", "##targetNamespace"
		   });	
		addAnnotation
		  (getXPathErrorFaultType_XpathErrorCode(), 
		   source, 
		   new String[] {
			 "kind", "element",
			 "name", "xpathErrorCode",
			 "namespace", "##targetNamespace"
		   });	
		addAnnotation
		  (xPathExpressionTypeEClass, 
		   source, 
		   new String[] {
			 "name", "XPathExpressionType",
			 "kind", "elementOnly"
		   });	
		addAnnotation
		  (getXPathExpressionType_PrefixMapping(), 
		   source, 
		   new String[] {
			 "kind", "element",
			 "name", "prefixMapping",
			 "namespace", "##targetNamespace"
		   });	
		addAnnotation
		  (getXPathExpressionType_Expression(), 
		   source, 
		   new String[] {
			 "kind", "element",
			 "name", "expression",
			 "namespace", "##targetNamespace"
		   });	
		addAnnotation
		  (getXPathExpressionType_Dialect(), 
		   source, 
		   new String[] {
			 "kind", "attribute",
			 "name", "dialect"
		   });	
		addAnnotation
		  (getModelElement_Record(), 
		   source, 
		   new String[] {
			 "kind", "element",
			 "name", "record",
			 "namespace", "##targetNamespace"
		   });	
		addAnnotation
		  (getModelElement_InstanceId(), 
		   source, 
		   new String[] {
			 "kind", "element",
			 "name", "instanceId",
			 "namespace", "##targetNamespace"
		   });	
		addAnnotation
		  (getModelElement_AdditionalRecordType(), 
		   source, 
		   new String[] {
			 "kind", "element",
			 "name", "additionalRecordType",
			 "namespace", "##targetNamespace"
		   });	
		addAnnotation
		  (getModelTemplate_ContentSelector(), 
		   source, 
		   new String[] {
			 "kind", "element",
			 "name", "contentSelector",
			 "namespace", "##targetNamespace"
		   });	
		addAnnotation
		  (getModelTemplate_InstanceIdConstraint(), 
		   source, 
		   new String[] {
			 "kind", "element",
			 "name", "instanceIdConstraint",
			 "namespace", "##targetNamespace"
		   });	
		addAnnotation
		  (getModelTemplate_RecordConstraint(), 
		   source, 
		   new String[] {
			 "kind", "element",
			 "name", "recordConstraint",
			 "namespace", "##targetNamespace"
		   });	
		addAnnotation
		  (getModelTemplate_Any(), 
		   source, 
		   new String[] {
			 "kind", "elementWildcard",
			 "wildcards", "##other",
			 "name", ":3",
			 "processing", "lax"
		   });	
		addAnnotation
		  (getModelTemplate_Id(), 
		   source, 
		   new String[] {
			 "kind", "attribute",
			 "name", "id"
		   });	
		addAnnotation
		  (getModelTemplate_SuppressFromResult(), 
		   source, 
		   new String[] {
			 "kind", "attribute",
			 "name", "suppressFromResult"
		   });	
		addAnnotation
		  (getModelUpdateInstanceResponse_InstanceId(), 
		   source, 
		   new String[] {
			 "kind", "element",
			 "name", "instanceId",
			 "namespace", "##targetNamespace"
		   });	
		addAnnotation
		  (getModelUpdateInstanceResponse_Declined(), 
		   source, 
		   new String[] {
			 "kind", "element",
			 "name", "declined",
			 "namespace", "##targetNamespace"
		   });	
		addAnnotation
		  (modelEClass, 
		   source, 
		   new String[] {
			 "name", "Model",
			 "kind", "elementOnly"
		   });	
		addAnnotation
		  (getModel_MdrId(), 
		   source, 
		   new String[] {
			 "kind", "element",
			 "name", "mdrId",
			 "namespace", "##targetNamespace"
		   });
	}

} //CmdbfPackageImpl
